<?php 
require_once("dll.php");
$eshop = new eshop();
$variables->getSafeVars(array_keys($_REQUEST));
$id = (int)$_REQUEST['id'];
$order = $content->getContentByID("orders", $id, "*", "*", $langID);
if(!$order) $messages->addError("System error: Order not found");
if(!$messages->hasErrors){
	$order_products = $content->getContent("order_products", " order_products.orderID='$id' ", "*", "*", $langID, " content_order_products.title");
	if(!count($order_products)) $messages->addError("System error: No associated products found for this order");
}
$currency = $eshop->getCurrency();
$currency_sign = $currency->sign;
$currency_code = $currency->code;
$currency_start_position = $currency->start_position;
$currency_decimal = $currency->decimal;
$currency_decimal_seperator = $currency->decimal_seperator;
$currency_thousands_seperator = $currency->thousands_seperator;
?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link rel="shortcut icon" href="favicon.ico">
<title>Admin Panel - Edit Order Details</title>
<link href="css/admin.css" rel="stylesheet" type="text/css">
<link href="css/pagination.css" rel="stylesheet" type="text/css">
<link type="text/css" href="css/select2/select2.css" rel="stylesheet">
<link rel="stylesheet" media="all" type="text/css" href="css/jquery-impromptu.css">

<script type="text/javascript" src="js/jquery.js"></script>
<script type="text/javascript" src="js/admin.js"></script>
<script type="text/javascript" src="js/select2.min.js"></script>
<script type="text/javascript" src="../js/noty/noty.min.js"></script>
<script type="text/javascript" src="js/jquery-impromptu.js"></script>
<!--[if IE 8]><script type="text/javascript" src="js/respond.min.js"></script><![endif]-->
<script type="text/javascript">
odyshop.currency = {
	sign:"<?php echo $currency_sign;?>",
	code:"<?php echo $currency_code;?>",
	start_position:"<?php echo $currency_start_position;?>",
	decimal:"<?php echo $currency_decimal;?>",
	decimal_seperator:"<?php echo $currency_decimal_seperator;?>",
	thousands_seperator:"<?php echo $currency_thousands_seperator;?>"
};
var doc_type_names = [];
var payment_methods = [];
var shipping_methods = [];
<?php
$cod = (float)$parameters->getParameter("cod"); // cash on delivery cost
if(empty($cod)) $cod = 0;
$doc_type_names = array("invoice"=>t("Τιμολόγιο"), "receipt"=>t("Απόδειξη λιανικής"));
foreach($doc_type_names as $key=>$value){
?>
doc_type_names['<?php echo $key;?>'] = "<?php echo $value;?>";
<?php	
}
$pmethods = $eshop->getPaymentMethods();
foreach($pmethods as $pmethod){
?>
payment_methods['<?php echo $pmethod->paymentMethodSystemName;?>'] = "<?php echo $pmethod->paymentMethodTitle;?>";
<?php
}
$hasShipping = ($order->shipping == "yes");
$smethods = array("yes"=>t("Αποστολή με υπηρεσία Courier"), "no"=>t("Παραλαβή από το κατάστημα"));
foreach($smethods as $key=>$value){
?>
shipping_methods['<?php echo $key;?>'] = "<?php echo $value;?>";
<?php	
}
?>
var cod = <?php echo $cod;?>;

jQuery(function($){
    $(".admin_order_status").each(function(){
		$(this).on('focus', function(){
			previous = this.value;
		}).change(function(){
			updateOrderStatus(this, previous);
			previous = this.value;
		});
	});
	
	$('.edit_content').each(function(){
		var id = $(this).attr("id");
		var type = $(this).data("type");
		var editID = "edit_" + id;
		$(this).on("click", function(e){
			e.stopPropagation();
			var $this = $(this);
			var edit = $('#' + editID);
			$(this).hide();
			edit.show().focus();
			odyshop.editBefore = edit.val();
			edit.unbind('change blur').on('change blur', function(e){
				// update any changes to DOM
				$(this).unbind('change blur');
				odyshop.editAfter = edit.val();
				var content = edit.val().replace(/(?:\r\n|\r|\n)/g, "<br>");
				content = content.replace(/\[Στοιχεία τιμολόγησης\]/g, "<?php echo t("Στοιχεία τιμολόγησης");?>");
				if(id == "discount"){
					var prev_discount = getAmount('discount');
					var total = getAmount('total') + prev_discount; // restore total without discount
					var value = parseFloat(odyshop.editAfter);
					total = total - value;
					edit.hide();					
					$this.html(formatPrice(value, odyshop.currency)).show();	
					$('#total').html(formatPrice(total, odyshop.currency));
				}else if(id == "shipping_cost"){
					edit.hide();
					$this.html(formatPrice(odyshop.editAfter, odyshop.currency)).show();
					var prev_shipping_cost = getAmount('shipping_cost_amount');
					var total = getAmount('total');
					total-=prev_shipping_cost; // first substruct the previous shipping cost
					total+= parseFloat(odyshop.editAfter);
					$('#shipping_cost_amount').html(formatPrice(odyshop.editAfter, odyshop.currency));
					$('#total').html(formatPrice(total, odyshop.currency));					
				}else if(type == "select"){
					edit.hide();
					if(id == "doc_type"){
						$this.html(doc_type_names[odyshop.editAfter]).show();	
					}					
					if(id == "payment_method"){
						$this.html(payment_methods[odyshop.editAfter]).show();	
						if(odyshop.editAfter == "cod"){
							$('#cod_details').show();
							$('#cod_amount').parents('tr').show();
							if(odyshop.editBefore != odyshop.editAfter){
								var total = getAmount('total');
								total+= cod;
								$('#total').html(formatPrice(total, odyshop.currency));
							}
						}else if(odyshop.editBefore == "cod"){
							$('#cod_details').hide();
							$('#cod_amount').parents('tr').hide();
							if(odyshop.editBefore != odyshop.editAfter){
								var total = getAmount('total');
								total-= cod;
								$('#total').html(formatPrice(total, odyshop.currency));	
							}
						}
					}
					if(id == "shipping"){
						$this.html(shipping_methods[odyshop.editAfter]).show();
						if(odyshop.editAfter == "yes"){
							$('#shipping_cost_details').show();
							$('#shipping_cost_amount').parents('tr').show();
							if(odyshop.editBefore != odyshop.editAfter){
								var total = getAmount('total');
								var shipping_cost = getAmount('shipping_cost_amount');
								total+= shipping_cost;	
								$('#total').html(formatPrice(total, odyshop.currency));	
							}
						}else if(odyshop.editAfter == "no"){
							$('#shipping_cost_details').hide();
							$('#shipping_cost_amount').parents('tr').hide();
							if(odyshop.editBefore != odyshop.editAfter){
								var total = getAmount('total');
								var shipping_cost = getAmount('shipping_cost_amount');
								total-= shipping_cost;	
								$('#total').html(formatPrice(total, odyshop.currency));	
							}
						}
					}
				}else{
					$this.html(content).show();	
					edit.hide();
				}
				if(odyshop.editBefore != odyshop.editAfter){ // modifications detected, so save the changes
					saveChanges(id, odyshop.editAfter);
				}
			});
		});
	});
	
	$('.edit_element:not(textarea)').each(function(){
		$(this).on('keydown', function(e){
			var key = e.which;
			if(key == 13) {
				$(this).change();
			}
		});
	});
	
	$('.numeric').each(function(){
		$(this).on('keydown', function(e){
			var key = e.which;
			if((key == 110 || key == 190) && /\./g.test($(this).val())) return false; // there is one period already
			if((key >= 48 && key <= 57) || (key >= 96 && key <= 105) || (key == 8 || key == 46 || key == 110 || key == 190)) return true;
			return false;
		}).on('change', function(){
			var v = parseFloat($(this).val());
			if(isNaN(v)) v = 0;
			$(this).val(v);
		}).focus(function(){
			$(this).select();
		});
	});
	
	$('[data-type="textarea"]').each(function(){
		$(this).attr('title','<?php echo t("Προσοχή! Το περιεχόμενο περιέχει HTML κώδικα");?>')
	});
	
	$('#shipping_cost_amount').on('click', function(e){
		e.stopPropagation();
		goto("shipping_cost");
		$('#shipping_cost').click();
	});
	
	$('#order_products_list').on('click', function(e){
				console.log(e.target);

		msg("<?php echo t("Αυτά τα δεδομένα της παραγγελίας δεν είναι επεξεργάσιμα");?>", "warning", 3000);
	});
});

function getAmount(id){
	var elm = $('#' + id);
	var amount = elm.find('.amount').html().replace(".", "");
	amount = amount.replace(",", ".");
	return parseFloat(amount);
}

function saveChanges(id, value){
	var type = $('#' + id).data("type");
	if(type == "textarea") value = value.replace(/(?:\r\n|\r|\n)/g, "<br>");
	jQuery.ajax({
		type: "POST",
		url: "ajax_save_order_details.php",
		data: "orderID=<?php echo $id;?>&field=" + id + "&value=" + encodeURIComponent(value),
		async: false,
		success: function(response){
			response = response.trim();
			//console.log(response);
			if(response == "ok"){
				msg("<?php echo t("Οι αλλαγές αποθηκεύτηκαν με επιτυχία");?>", "success");
			}else{
				msg("<?php echo t("Παρουσιάστηκε σφάλμα");?><br>" + response, "error", 5000);
			}

		}
	});	
	
}

function msg(content, type, timeout, selector){ // requires noty jquery plugin
	if(!content) return false;
	type = (type) ? type : 'information';
	timeout = (timeout) ? timeout : 1000;
	selector = ($(selector).length) ? selector : false;
	if(selector){
		$(selector).noty({
			text: content,
			type: type,
			timeout: timeout,
			theme: 'relax',
			dismissQueue: true
		});		
	}else{
		var n = noty({
			text: content,
			type: type,
			timeout: timeout
		});	
	}
}

function updateOrderStatus(elm, previous){
	elm = $(elm);
	var orderID = "<?php echo $id;?>";
	var status = elm.val();
	var color = elm.find('option:selected').data("color");
	var email = elm.data("email");	
	var notify = (getCookie('doNotNotifyCustomer') == "true") ? false : confirm(unescapeQuotes("<?php echo t("Θέλετε να ενημερωθεί με e-mail αυτόματα γι' αυτή την αλλαγή ο πελάτης;");?>"));
	notify = Number(notify);
	$('#ajax_loading').show();
	jQuery.ajax({
		type: "POST",
		url: "ajax_orders.php",
		data: "action=update_status&notify="+notify+"&email="+email+"&id="+orderID+"&status="+status+"&langID=<?php echo $langID;?>",
		async: false,
		success: function(response){
			response = response.trim();
			//console.log(response);
			if(response == "ok"){
				elm.css("background-color", "#" + color);
				var value = elm.val();
				parent.$('#admin_order_status<?php echo $id;?>').css("background-color", "#" + color);
				parent.odyshop.doNotNotifyCustomer = true; // prevent duplicate notificaton in auto change event				
				parent.$('#admin_order_status<?php echo $id;?>').val(value).change();
			}else{
				elm.val(previous); // error so restore previous value in status select
				popup(response, "error", 5000);				
			}
			$('#ajax_loading').hide();
		}
	});	
}

function unescapeQuotes(safe) {
    return safe.replace(/&amp;/g, '&')
        .replace(/&quot;/g, '"')
		.replace(/&#034;/g, "'")
        .replace(/&#039;/g, "'");
}

function closeOrder(){
	parent.$.fancybox.close();	
}

</script>
<style type="text/css">
body{ height:auto; 	background: #ededed;}
.container{	max-width: 1104px !important;}
.order_details_grid{	padding: 5px;}
.order_details_left{	background-color: #383838; color: silver; margin-bottom: 10px;}
.order_details_left h3,
.remarks_heading{ background-color: #B90046;	color: #fff;	padding: 3px 10px;	font-size: 105%;	margin-top: 0;}
.remarks_heading{ margin-top: 20px}
.remarks{ padding: 0 10px 30px; min-height: 100px}
.order_details_left h4{	color: #fff;	font-size: 115%;	margin-bottom: -5px; font-style: italic;}
.order_details_left p{ margin-left: 15px;}
.order_details_left a{ color: #EB0B60; text-decoration: none;}
.order_details_left a:hover{ text-decoration: underline;}
.order_details_right{ background-color: #E1E1E1; color: #000; margin-bottom: 10px; border: 1px solid silver; }
.order_details_right label{ margin-bottom: 3px; display: inline-table; font-size:92%; font-style: italic; color: #656565;}
.customer_comments{ font-size: 95%; padding: 0 8px 30px; font-style: italic; }
#order_products_list input,
#order_products_list select,
#order_products_list select option{ text-align: center;}
#order_products_list{ display: table;	margin: 0 auto; border-spacing: 0;	width: 100%; cursor: default; padding-right: 20px}
#order_products_list th{ font-family: Arial;	font-size: 75%; font-style: italic; color: #B40044; border-bottom: 2px solid #fff;	padding: 5px;	text-align:left;}	
#order_products_list tr:hover{ background-color: #E0E0E0;}
#order_products_list td{ padding: 5px; text-align:left;	vertical-align: top; font-size: 85%; border-bottom: 1px solid #A8A8A8;}
.order_details_right_block{ margin: 30px 0; padding-bottom: 30px; border-bottom: 1px dotted grey; }
.order_details_right_block:first-child{ cursor: no-drop; }
.payment_details{ padding-left: 15px; background: url(images/list_icon.png) left center no-repeat; font-size: 85%; color: #B40044; font-style: italic;}
.left, .center, .right{ display: table; width: 100%;}
.left{ text-align: left !important; } 
.center{ text-align: center !important; } 
.right{ text-align: right !important; } 
.numeric{ max-width: 65px; text-align: right !important; padding: 0 3px;}
select.edit_element{ font-size: 80% !important; }
.prod_thumb_wrapper img { max-height: 44px !important; max-width: 44px !important;	border: 1px solid #ABA6A6;}
.prod_thumb_wrapper{	min-width: 44px;	margin-right: 10px;	float: left;}
.combination{	font-style: italic;	color: #AD5476;}
.code_title{ color: #808080;}
tr.no_border td{ border: none !important;	}
.totals{ padding-top: 20px !important; font-family: Arial; 	font-size: 80% !important; font-style: italic; font-weight: bold; color: #B40044;	text-align: right !important;}
.final_total{ font-size: 1.2em !important; margin-top: -7px; color: black; font-weight: normal;}
.edit_bottom{ text-align: right; margin: 20px 0; border-top: 1px solid grey; padding-top: 3px; }
.admin_order_status{ width: 100%; max-width: 300px; color: #fff; }
#admin_order_shipping,
#admin_order_payment_method,
#shipping_cost{ display: inline-block; }
.container{ padding: 0; }
.group .grid-3 { width: 25%; }
.edit_content, #shipping_cost_amount{ cursor: url(images/edit.png),alias; padding-right: 25px; background: url(images/editable.png) right top no-repeat}
.edit_element{ display: none; border: 2px solid #B90046 !important; }
.edit_textarea{ width: 93%; min-height: 150px; font-size: 80% !important; margin: 10px auto; padding: 7px; border: none; }
.edit_brown{ background-color: #383838; color: #C0C0C0; }
.edit_grey{ background-color: #E1E1E1; color: #000; }
.edit_silver{ background-color: #EDEDED; color: #000; };	
@media screen and (max-width: 550px){
    #order_products_list,
    #order_products_list tbody{ display: table; margin: 0 auto; min-width: 0; }
	#order_products_list thead{ display: none; }
    #order_products_list tr,
	#order_products_list th,
    #order_products_list td{ display: block; padding: 0; text-align: right; }	
    #order_products_list tr{ border-bottom: 1px solid #8e8e8e; padding-bottom: 11px; margin-bottom: 11px; }
    #order_products_list th[data-title]:before,
    #order_products_list td[data-title]:before{ font-family: Arial;font-size: .8em;content: attr(data-title) ":\00A0";color: grey;font-style: italic;font-weight: bold;}	
    #order_products_list td{ border: none; margin-bottom: 6px; color: #444; }
	#order_products_list td:empty{display: none;	}
    #order_products_list tr:last-child{border: none;}
	.left, .center, .right { display: inline-block; margin: auto; }	
	.prod_thumb_wrapper { float: none; margin: 5px 0; }
	.no_image{ display:none;	}
	.code_title{ font-family: Arial; font-size: 0.8em; font-style: italic; font-weight: bold; }
	.center{ text-align: right !important; }	
	.left, .center, .right { width: auto; }
	.total_amount{ padding-bottom: 0 !important; margin-bottom: 0 !important;}
	.total_amount td{ display: inline-block !important;}
	.final_total{ margin-top: -3px; }
	.no_border {border: none !important}
	.totals { padding-top: 12px !important;}
}
@media only screen and (max-width: 960px) {
	body { padding: 0; }
	.container { width: auto; padding:0;}
	.group{ display:table; width: 100%; max-width: 600px; margin: 0px auto; }
	[class*="grid-"] { display: block; margin-left: 0px; margin-right: 0px; }
	.group .grid-3,
	.group .grid-6 { width: 100%; float:none;  }
	.group .offset-3, 
	.group .offset-6 { padding-left: 0; }
	.group .grid-6 { display: table-header-group;}
	.group .grid-3:last-child { display: table-footer-group; }	
	
}
</style>
</head>
<body id="inner_page">
<div id="ajax_loading"></div>
<div class="section_title" style="margin-top: 15px;position: relative">
	<?php echo t("Επεξεργασία παραγγελίας");?>
	<input type="button" value="<?php echo t("Κλείσιμο");?>" onclick="closeOrder()" class="btn btn-inverse close_modal">			
</div>
<?php
function getProductIndex($productID){
	global $order_products;
	$counter = 0;
	foreach($order_products as $item){
		if($item->productID == $productID) return $counter;
		$counter++;
	}
	return false;
}
$payment_method = $order->payment_method;
$doc_type_name = $doc_type_names[$order->doc_type];
$retailCustomer = $content->getValue("users_types", 4, "title", $langID);
$wholesaleCustomer = $content->getValue("users_types", 5, "title", $langID);
$customerType = ($order->catID == 5) ? $wholesaleCustomer : $retailCustomer;
$total = $order->total;
$total_vat = $order->total_vat;
$comments = $order->comments;
$remarks = $order->remarks;
$discount = $order->discount;
$include_vat = (int)$parameters->getParameter("include_vat");
$items = unserialize(base64_decode($order->cart));
if(!$items) $messages->addError("System error: Cannot get the order's products");
if($messages->hasErrors){
	$messages->printErrorMessages();
}else{
	$userID = $order->userID;
	foreach($items as $item){
		if(!empty($userID)){ // registered user
			$productID = $item->productID;
			$combination = $item->combination;
			$quantity = $item->quantity;				
		}else{ // session basket
			list($uid, $productID, $quantity, $combination) = explode("~|~", $item);
		}
		$index = getProductIndex($productID);
		$image = $eshop->getProductImage($productID, $combination);
		$image = ($image) ? $image : "";
		$code = $content->getValue("products", $productID, "code", $langID);
		$order_products[$index]->image =  $image;
		$order_products[$index]->quantity =  $quantity;
		$order_products[$index]->code =  $code;
	}
?>
<section class="container" id="order_details">
	<div class="group">
		<div class="grid-3">
			<div class="order_details_grid order_details_left">
				<h3><?php echo t("ΠΛΗΡΟΦΟΡΙΕΣ ΠΕΛΑΤΗ");?></h3>
				<h4>&nbsp;<?php echo t("Στοιχεία χρέωσης");?></h4>
				<p id="billing_details" data-type="textarea" class="edit_content"><?php echo str_replace("[Στοιχεία τιμολόγησης]", t("Στοιχεία τιμολόγησης"), $order->billing_details); ?></p>
				<textarea id="edit_billing_details" class="edit_element edit_textarea edit_brown"><?php echo htmlspecialchars(stripslashes(trim(str_replace("<br>", PHP_EOL, $order->billing_details))));?></textarea>
				<hr>
				<h4>&nbsp;<?php echo t("Στοιχεία αποστολής");?></h4>
				<p id="shipping_details" data-type="textarea" class="edit_content"><?php echo $order->shipping_details; ?></p>
				<textarea id="edit_shipping_details" class="edit_element edit_textarea edit_brown"><?php echo htmlspecialchars(stripslashes(trim(str_replace("<br>", PHP_EOL, $order->shipping_details))));?></textarea>	
				<h4>&nbsp;<?php echo t("Κατηγορία");?></h4>
				<p><?php echo $customerType; ?></p>				
				
				<?php
				if($comments){
				?>
				<br>
				<h3><?php echo t("ΣΧΟΛΙΑ ΠΕΛΑΤΗ");?></h3>
				<div id="comments" data-type="textarea" class="customer_comments edit_content"><?php echo nl2br($comments); ?></div>
				<textarea id="edit_comments" class="edit_element edit_textarea edit_brown"><?php echo htmlspecialchars(stripslashes(trim($comments)));?></textarea>
				<?php
				}
				?>
			</div>	
		</div>
		<div class="grid-6">
			<div class="order_details_grid">
				<table id="order_products_list">
					<thead>
						<tr>
							<th><?php echo t("Προϊόν");?></th>
							<th><span class="center"><?php echo t("Τιμή");?></span></th>
							<th><span class="center"><?php echo t("Ποσότητα");?></span></th>
							<th><span class="center"><?php echo t("Μερικό σύνολο");?></span></th>
						</tr>
					</thead>
					<?php
					foreach($order_products as $product){
						list($title, $combination) = explode(" | ", $product->title);
						$price = $product->price;
						$quantity = $product->quantity;
						$subtotal = $eshop->formatPrice($price * $quantity);
						$image = $product->image;
						$image = (empty($image)) ? "images/no_product_image.png" : "../mediabank/thumbs/small_".$image;
						$code = $product->code;
						$weight = $product->weight;
					?>
					<tr>
						<td data-title="<?php echo t("Προϊόν");?>">	
							<div class="prod_thumb_wrapper<?php if($image == "images/no_product_image.png") echo " no_image";?>">
								<img src="<?php echo $image;?>">
							</div>																		
							<?php  
							echo $title;
							if($combination) echo '<div class="combination">'.$combination.'</div>';
							if($code) echo '<div class="code"><span class="code_title">'.t("Κωδικός")." : </span>".$code.'</div>';
							?>							
						</td>
						<td data-title="<?php echo t("Τιμή");?>">
							<span class="right"><?php  echo $eshop->formatPrice($price); ?></span>
						</td>
						<td data-title="<?php echo t("Ποσότητα");?>">
							<span class="center"><?php  echo $quantity; ?></span>
						</td>
						<td data-title="<?php echo t("Μερικό σύνολο");?>">
							<span class="right"><?php  echo $subtotal; ?></span>
						</td>																		
					</tr> 
					<?php
					}
					$discount
					?>
					<tr class="no_border total_amount">
					<td colspan="4" class="totals"><?php echo t("Σύνολα");?></td>
					</tr>						
					<tr class="no_border total_amount">
					<td colspan="3" style="text-align: right;"><?php echo t("Αξία παραγγελίας");?> :</td>
					<td><span class="right"><?php  echo $eshop->formatPrice($total); ?></span></td>
					</tr>	
					<tr class="no_border total_amount">
					<td colspan="3" style="text-align: right;"><?php echo t("Συνολικό ΦΠΑ")." (".t("συμπεριλαμβάνεται").")";?> :</td>
					<td><span class="right"><?php  echo $eshop->formatPrice($total_vat); ?></span></td>
					</tr>	
					<?php
					$final_total = (float)$total;
					if($hasShipping) $final_total+= (float)$order->shipping_cost;
					?>	
					<tr class="no_border total_amount"<?php if(!$hasShipping) echo " style='display:none'";?>>
					<td colspan="3" style="text-align: right;"><?php echo t("Έξοδα αποστολής");?> :</td>
					<td><span class="right" id="shipping_cost_amount"><?php echo $eshop->formatPrice($order->shipping_cost); ?></span></td>
					</tr>						
					<?php
					if($order->payment_method == "cod") $final_total+= (float)$cod;
					?>	
					<tr class="no_border total_amount"<?php if($order->payment_method != "cod") echo " style='display:none'";?>>
					<td colspan="3" style="text-align: right;"><?php echo t("Έξοδα αντικαταβολής");?> :</td>
					<td><span class="right" id="cod_amount"><?php  echo $eshop->formatPrice($cod); ?></span></td>
					</tr>						
					<tr class="no_border total_amount">
					<td colspan="3" style="text-align: right;"><?php echo t("Έκπτωση");?> :</td>
					<td style="text-align: right;">
						<span class="right edit_content" data-type="textfield" id="discount"><?php  echo $eshop->formatPrice($discount); ?></span>
						<input type="text" id="edit_discount" class="edit_element edit_textfield edit_silver numeric" value="<?php  echo $discount; ?>">
					</td>
					</tr>
					<tr class="total_amount"><td colspan="4"></td></tr>
					<?php
					$discounted_total = $final_total - (float)$discount;
					?>														
					<tr class="no_border total_amount">
					<td colspan="3" style="text-align: right;" class="totals"><?php echo t("Τελικό σύνολο");?> :</td>
					<td><span class="right totals final_total" id="total"><?php  echo $eshop->formatPrice($discounted_total); ?></span></td>
					</tr>					
				</table>
				<h3 class="remarks_heading"><?php echo t("ΠΑΡΑΤΗΡΗΣΕΙΣ");?></h3>
				<div id="remarks" data-type="textarea" class="remarks edit_content">
					<?php
					if(empty($remarks)){
						echo "Add any additional info here...";
					}
					echo nl2br($remarks);
					?>					
				</div>
				<textarea id="edit_remarks" class="edit_element edit_textarea edit_silver"><?php echo htmlspecialchars(stripslashes(trim($remarks)));?></textarea>	
				<script>
					$('#edit_remarks').on('focus', function(){
						var text = $('#remarks').html();
						if(text == "Add any additional info here...") $('#remarks').html("");
					});
				</script>				
			</div>		
		</div>
		<?php
		$order_statuses = $content->getContent("order_statuses", NULL, array('f_color', 'b_color'), array('title'), $langID, " order_statuses.sort");
		$order_status = $content->getValue("order_statuses", $order->status, "title", $langID);
		$color = $content->getValue("order_statuses", $order->status, "f_color", $langID);
		$bgcolor = $content->getValue("order_statuses", $order->status, "b_color", $langID);	
		$payment_method_title = $eshop->getPaymentMethodProperty("title", $payment_method, $langID);
		$email = $order->email;
		?>
		<div class="grid-3">
			<div class="order_details_grid order_details_right">
				<div class="order_details_right_block">
					<label for "admin_order_date">
						<?php echo t("Ημερομηνία παραγγελίας");?>
					</label>
					<br>
					<span id="admin_order_date"><?php echo $dates->makeDatefromTimestamp($order->order_date, true); ?></span>
				</div>			
				<div class="order_details_right_block">
					<label for "admin_order_status">
						<?php echo t("Κατάσταση παραγγελίας");?>
					</label>
					<br>
					<select 
					data-email="<?php echo $email;?>"
					class="listbox admin_order_status" 
					id="admin_order_status" 
					style="background-color: #<?php echo $bgcolor;?>">
					<?php
					
					foreach($order_statuses as $thisStatus){
						$selected = ($thisStatus->id == $order->status) ? ' selected="selected"' : NULL;
					?>
					<option 
					data-color="<?php echo $thisStatus->b_color;?>" 
					value="<?php echo $thisStatus->id;?>" 
					style="background-color: #fff; color: #<?php echo $thisStatus->b_color;?>"<?php echo $selected;?>>
					<?php echo $thisStatus->title;?>
					</option>
					<?php
					}
					?>
					</select>
				</div>
				<div class="order_details_right_block">
					<label for "doc_type">
						<?php echo t("Είδος παραστατικού");?> 
					</label>
					<br>
					<span id="doc_type" class="edit_content" data-type="select"><?php echo $doc_type_name; ?></span>
					<select id="edit_doc_type" class="edit_element edit_textfield edit_grey">
					<?php
					foreach($doc_type_names as $key=>$value){
					?>
						<option value="<?php echo $key;?>"<?php if($order->doc_type == $key) echo " selected";?>><?php echo $value;?></option>
					<?php
					}
					?>
					</select>
				</div>			
				
				<div class="order_details_right_block">
					<label for "payment_method">
						<?php echo t("Μέθοδος πληρωμής");?> 
					</label>
					<br>
					<span id="payment_method" class="edit_content" data-type="select"><?php echo $payment_method_title;?></span>
					<select id="edit_payment_method" class="edit_element edit_textfield edit_grey">
					<?php
					foreach($pmethods as $pmethod){
					?>
						<option value="<?php echo $pmethod->paymentMethodSystemName;?>"<?php if($order->payment_method == $pmethod->paymentMethodSystemName) echo " selected";?>><?php echo $pmethod->paymentMethodTitle;?></option>
					<?php
					}
					?>
					</select>					
					<div class='payment_details' id="cod_details"<?php if($order->payment_method != "cod") echo " style='display:none'";?>>
						<?php echo t("Έξοδα αντικαταβολής")." : ".$eshop->formatPrice($cod);?>
					</div>
				</div>
				<div class="order_details_right_block">
					<label for "shipping">
						<?php echo t("Τρόπος παραλαβής προϊόντων");?>
					</label>
					<br>
					<span id="shipping" class="edit_content" data-type="select"><?php echo $smethods[$order->shipping];?></span>
					<select id="edit_shipping" class="edit_element edit_textfield edit_grey">
					<?php
					foreach($smethods as $key=>$value){
					?>
						<option value="<?php echo $key;?>"<?php if($order->shipping == $key) echo " selected";?>><?php echo $value;?></option>
					<?php
					}
					?>
					</select>					
					<div class='payment_details' id="shipping_cost_details"<?php if(!$hasShipping) echo "style='display:none'";?>><?php echo t("Έξοδα αποστολής")." : ";?>
						<span id="shipping_cost" class="edit_content" data-type="textfield">
							<?php echo $eshop->formatPrice($order->shipping_cost);?>
						</span>
						<input type="text" id="edit_shipping_cost" class="edit_element edit_textfield edit_grey numeric" value="<?php  echo $order->shipping_cost; ?>">
					</div>				
				</div>				
			</div>			
		</div>				
	</div>
</section>
<?php
}
?>
</body>
</html>
