<?php
class Module extends document
{

    public $modulesPath = "modules/";
    public $adminPath = "../";
    public $cssFilePath = "css/";
    public $jsFilePath = "js/";
    public $loadedFiles = array();

    function __construct($module) {
        parent::__construct(NULL, NULL, true);
        $this->load($module);
    }

    function load($module) {
        global $system;
        $moduleName = $system->getExtensionName($module->moduleID);
        $moduleID = $module->id;
        $filename = $moduleName . ".php";
        $systemPath = $this->adminPath . $this->modulesPath . $moduleName;
        $templateModulePath = $this->adminPath . $this->getTemplatePath() . $this->modulesPath . $moduleName;
        $moduleFile = (is_file($templateModulePath . "/" . $filename)) ? $templateModulePath . "/" . $filename : $systemPath . "/" . $filename;
        $loadedFiles = $this->loadAdminModule($moduleName);
        foreach ($loadedFiles as $key => $files) {
            if ($key == 'js'){
                foreach($files as $file) {
                    echo '<script type="text/javascript" src="' . $file . '"></script>';
                }
            }
            if ($key == 'css'){
                foreach($files as $file) {
                    echo '<link href="' . $file . '" rel="stylesheet" type="text/css">';
                }
            }
        }
        $currentModuleID = $moduleID; // for use inside module scope
        include($moduleFile);
        @include((is_file($templateModulePath . "/actions.php")) ? $templateModulePath . "/actions.php" : $systemPath . "/actions.php");
    }

    function loadAdminModule($moduleName) {
        global $messages;
        $xmlFile = $this->adminPath . $this->modulesPath . $moduleName . "_install.xml";
        if (!is_file($xmlFile)) {
            $messages->addError(t("Module «" . $moduleName . "» not found!"));
            return;
        }
        $xml = simplexml_load_file($xmlFile); // open the module's install xml file
        $installType = $xml->attributes()->type;
        $protected = strval($xml->protected);
        $modulesDir = (!empty($protected)) ? $this->adminPath . $this->modulesPath . $moduleName . "/" : $this->adminPath . $this->getTemplatePath() . $this->modulesPath . $moduleName . "/";
        if ($installType == "module") { // make sure its the correct xml
            foreach ($xml->files->file as $node) {
                if (strval($node)) { // ignore empty xml tags
                    $type = $node->attributes()->type;
                    $thisFile = strval($node);
                    if ($type == "js") {
                        $thisFile = $modulesDir . $this->jsFilePath . $thisFile;
                        if ($thisFile && !in_array($thisFile, $this->loadedFiles)) {
                            $this->loadedFiles['js'][] = $thisFile;
                        }
                    }
                    if ($type == "css") {
                        $thisFile = $modulesDir . $this->cssFilePath . $thisFile;
                        if ($thisFile && !in_array($thisFile, $this->loadedFiles)) {
                            $this->loadedFiles['css'][] = $thisFile;
                        }
                    }
                }
            }
        }
        return $this->loadedFiles;
    }

    function getTemplatePath($template) {
        $template = (empty($template)) ? $this->getDefaultTemplate() : $template;
        $templateID = $this->getTemplateID($template);
        $template = ($templateID) ? $template : $this->getDefaultTemplate(); // active template if no other specified
        return "templates/" . $template . "/";
    }

    function getTemplateID($template) {
        global $db;
        $template = ($template) ? $template : $this->getDefaultTemplate(); // active template if no other specified
        $templateID = $db->getRecord("select id from templates where name='$template'")->id;
        return $templateID;
    }

    function getDefaultTemplate() {
        global $db;
        $q = "select `name` from `templates` where active=1 LIMIT 1";
        $template = $db->getRecord($q)->name;
        if (!$template) die(t("Δεν βρέθηκε ενεργό πρότυπο εμφάνισης"));
        return $template;
    }
} // end Module Class

function includeAdminModules($slot) {
    global $system;
    global $db;
    global $langID;

    if (!$slot) return false;
    $modules = getAdminModules($slot);
    foreach ($modules as $module) {
        $excludedLanguages = explode("|", $module->excludedLanguages);
        if (in_array($langID, $excludedLanguages)) continue;
        $moduleID = $module->id;
        $moduleName = $system->getExtensionName($module->moduleID);
        $SL_sectionID = $system->getTableSectionID("modules");
        $SL_fieldID = $system->getFieldID("sectionID", $SL_sectionID);
        $SL_itemID = $moduleID;
        $SL_query = "select id from selectlists 
			where sectionID='$SL_sectionID' 
			and fieldID='$SL_fieldID' 
			and itemID='$SL_itemID' ";
        $displayThisModule = $db->getRecord($SL_query);


        if ($displayThisModule) {
            $theModule = new Module($module);
        }
    }
}

function getAdminModules($slot) {
    global $db;
    if (!(int)$slot && $slot) $slot = getSlotID($slot);
    if (!$slot) return false;
    $q = "select modules.* from modules, slots 
				where modules.active=1 
				and slots.id='$slot' 
				and modules.slotID=slots.id 
				and slots.active=1 order by sort";
    $modules = $db->getRecords($q);
    return $modules;
}

function getSlotID($slot) {
    global $db;
    $q = "select id from slots where name='$slot'";
    return $db->getRecord($q)->id;
}