<?php 
require_once("dll.php");
$variables->getSafeVars(array_keys($_POST));
$category = (int)$_REQUEST['category'];
$messages->importSessionMessages();
$document = new document(NULL, NULL, true); 
$sectionID = $system->getTableSectionID("products");
$category_section = "products_categories";
$importLangID = $language->getDefaultLanguage(true);
$iconResize = new iconResize();
$langExt = $language->getLanguageExtension($importLangID);
$defaultPermissions = array(2, 4, 5);
$parameters->importParameters();
$sefAdmin = new sef(); // overidde the $sef parameter from the last command
$_SESSION['iconType'] = "icons";
unset($_SESSION['sef']); // reset sef urls cache (it will be recreated by the sef class at first call)
$path="../";
$delimiter = ',';
$enclosure = '"';									


function getCategoryImages($product){
	$index = 0;
	foreach($_POST['mapping'] as $field){
		$index++;
		$value = $product[$index-1];
		if(empty($field)) continue; // ignore inactive fields
		if($field == "category_images"){
			$categoryImages = array_filter(preg_split('/\r\n|[\r\n]/', $value));
			return $categoryImages;
		}
	}
	return false; // No category images for this entry
}	

?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link rel="shortcut icon" href="favicon.ico">
<title>Admin Panel</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<link href="css/admin.css" rel="stylesheet" type="text/css">
<link href="css/pagination.css" rel="stylesheet" type="text/css">
<link type="text/css" href="css/ui/jquery-ui-odyshop.css" rel="stylesheet">
<link rel="stylesheet" type="text/css" href="js/fancybox2/fancybox.css">
<link rel="stylesheet" media="all" type="text/css" href="css/jquery-impromptu.css">

<script type="text/javascript" src="js/jquery.js"></script>
<script type="text/javascript" src="js/admin.js"></script>
<script type="text/javascript" src="js/cookies.js"></script>
<script type="text/javascript" src="js/jquery-ui-All.min.js"></script>
<script type="text/javascript" src="js/fancybox2/fancybox.js"></script>
<script type="text/javascript" src="js/jquery-impromptu.js"></script>
<script>
jQuery(function($){
	$('#loading').css("display", "none");
	$('a[rel="open_sections"]').fancybox({
		width : 500,
		maxHeight : 500,
		type : 'iframe',
		arrows: false,
		helpers : {
			overlay : {
				css : {
					'background' : 'rgba(0, 0, 0, 0.8)'
				}
			},
			title: null
		}
	});	
});

</script>
<style type="text/css">
#importProducts{
	padding-bottom: 20px;
}
#catID optgroup[label]{
color: #9A2A54;
}
#catID option, #catID optgroup{
	font-family: "Ubuntu Condensed",sans-serif !important;
	font-size: 1em !important;
	color: black;
}
.mapping_pairs{
	clear:both; 
	border-bottom: 1px solid silver;
	padding-bottom: 10px;
	margin-bottom: 10px;
}
.csv_header{
	margin-right: 10px; 
	min-width: 150px; 
	color: #9A2A54;
}
.import_step{
	text-align: center;
	float:left;
	background-color: #9A2A54;
	color: white;
	padding: 5px;
	height: 58px;
}
.import_step_number{
	font-size: 2em;
	font-weight: bold;
}
.arrow-right {
	float: left;
	width: 0; 
	height: 0; 
	border-top: 34px solid transparent;
	border-bottom: 34px solid transparent;
	border-left: 34px solid #9A2A54;
	margin-right: 10px;
}
.import_step_description{
	display: table-cell;
	vertical-align: middle;
	height: 68px;
}
.import_field_descriptions{
	list-style-image: url(images/list_icon.png);
	padding-bottom: 30px;
}
.import_field_descriptions li{
	padding-top: 15px;
}
.import_field_descriptions li strong{
	color: #9A2A54;
}
.import_field_description{
	font-style: italic;
}
.import_required_field{
	color: #C01B00;
	padding-left: 42px;
	background: url(images/warning-icon.png) left center no-repeat;
	height: 38px;
	display: table-cell;
	vertical-align: middle;
}

</style>
</head>
<body>
<div id="backend">
<?php include("includes/loading.php"); ?>
<section class="container">

<?php  include("header.php");?>
    <div class="group">
        <aside class="grid-4">  
			<?php include("menu.php");?>
            &nbsp;
        </aside>
		
		<?php
		if($_REQUEST['submitedData']){
			if($step == "1"){
				unlink("uploads/import.zip"); // clean up just in case
				$zip = $_FILES['zipFile']['tmp_name'];
				copy($_FILES['zipFile']['tmp_name'], "uploads/import.zip");
			}
			if($step == "2"){
				$zip = "uploads/import.zip";
			}
			if($zip){
				// proceed to extract zip file
				$unziped = $fileSystem->unzip($zip, true); // true stands for admin version of unzip method
				if($unziped){
					$mapping = is_array($_POST['mapping']);
					$foundCSV = false;
					$products = array();	
					foreach($unziped as $unzipedFile){
						if($unzipedFile == "products.csv") {	
							$foundCSV = true;
							$csvFile = $path.$document->unzipPath.$unzipedFile;
							if(($handle = fopen($csvFile, "r")) !== FALSE) {
								$headers = fgetcsv($handle, 0, $delimiter, $enclosure); //read the first line and get headers as array in $data
								$row = 0;
								while (($data = fgetcsv($handle, 0, $delimiter, $enclosure)) !== FALSE) {
									$row++;
									$products[] = $data;
								}
								fclose($handle);
							}
							if(!$mapping){ // start mapping fields
								$productFields = $db->getRecords("select fieldVarName, fieldDescription from `fields` where active=1 and tableSectionID='$sectionID' order by sort");
								?>
		<article class="grid-8">
			<div class="section_title"><?php echo t("ΕΙΣΑΓΩΓΗ ΠΡΟΪΟΝΤΩΝ"); ?></div>
			<?php $messages->printSystemMessages();?>
			<div style="text-align:left; border-bottom:1px solid silver; padding-bottom: 30px; margin: 30px 0;">
				<div class="import_step"><?php echo t("Βήμα");?><div class="import_step_number">2</div></div>
				<div class="arrow-right"></div>	
				<div class="import_step_description">		
				<?php 
				echo t("Αντιστοιχήστε κάθε πεδίο του csv αρχείου με τα πεδία του πίνακα των προϊόντων του Odyshop").". ";
				echo t("Όσα πεδία του csv αρχείου δεν θέλετε να χρησιμοποιηθούν, αντιστοιχήστε τα με την επιλογή [Ανενεργό πεδίο]").". ";
				?>
				</div>
			</div>				
			<form id="mappingForm" action="importProducts.php" method="post" class="admin_form form_centerd visible">
			<?php
			$counter = 0;
			foreach($headers as $header){
				$counter++;
			?>
			
				<div class="mapping_pairs">
					<div class="admin_form_element" style="clear: none !important; float:left">
						<div class="admin_label">
							<p><?php echo t("Το csv πεδίο");?> : </p>
						</div>
						<div class="csv_header">
							<?php
							echo $header;
							?>
						</div>
					</div>				
					<div class="admin_form_element" style="clear: none !important;float:right">
						<div class="admin_label">
							<p><?php echo t("Αντιστοιχεί στο πεδίο");?> : </p>
						</div>
						<div>
							<select name="mapping[csv_<?php echo $counter;?>]" class="listbox" style="min-width: 150px">
								<option value=""> -- <?php echo t("Ανενεργό πεδίο");?> -- </option>
								<?php
								foreach($productFields as $productField){
								?>
								<option value="<?php echo $productField->fieldVarName;?>"<?php if($header == t($productField->fieldDescription)) echo " selected";?>>
									<?php echo t($productField->fieldDescription);?>
								</option>
								<?php
								}
								?>
								<option value="brand_name"<?php if($header == "Brand Name") echo " selected";?>>Brand Name</option>
								<option value="brand_logo"<?php if($header == "Brand Logo") echo " selected";?>>Brand Logo</option>
								<option value="brand_url"<?php if($header == "Brand URL") echo " selected";?>>Brand URL</option>
								<option value="product_images"<?php if($header == "Product Images") echo " selected";?>>Product Images</option>
								<option value="category_images"<?php if($header == "Category Images") echo " selected";?>>Category Images</option>
							</select>
						</div>
					</div>				
							
				</div>											
			<?php
			}
			?>
                <div class="admin_form_element">
                    <input name="submitedData" type="submit" class="btn btn-success" id="submitedData" value="<?php echo t("Εισαγωγή");?>" onclick="submitForm('export_products')">
                    <input name="category" type="hidden" id="category" value="<?php  echo $_REQUEST['category'];?>">
					<input name="step" type="hidden" value="2">
                </div>
				
			</form>
		</article>								
							<?php
							}
						}
					}
					if(!$foundCSV){
						$messages->addError(t("Δεν βρέθηκε το αρχείο εισαγωγής προϊόντων [ products.csv ]"));
					}else{
						// starting import process
						$log = array();
						$brandLogos = array();
						foreach($products as $product){
							$counter = 0;
							$foundTitle = false;
							$brand = array();	
							foreach($_POST['mapping'] as $field){
								$counter++;
								$value = $product[$counter-1];
								if(empty($field)) continue; // ignore inactive fields
								if($field == "title"){
									$foundTitle = true;
									$productTitle = $variables->odyssey_real_escape_string($value);
									$productTitle = $content->remove_html_comments($productTitle);
								}elseif($field == "description"){
									$productDescription = $variables->odyssey_real_escape_string($value);
									$productDescription = $content->remove_html_comments($productDescription);
								}elseif($field == "promo_text"){
									$promo_text = $variables->odyssey_real_escape_string($value);
									$promo_text = $content->remove_html_comments($promo_text);
								}elseif($field == "catID"){
									$catPaths = array_filter(preg_split('/\r\n|[\r\n]/', $value));
									$categoryImages = getCategoryImages($product);
									$catIndex = 0;
									$productCategories = array();
									foreach($catPaths as $catPath){
										$level = 0;
										$parentLevel = 0;
										$cats =  array_filter(explode("///", $catPath));
										foreach($cats as $cat){
											$leaf = ($level == count($cats)-1); // final category node		
											$catRecord = $db->getRecord("select pc.id, pc.parent from products_categories as pc, content_products_categories as cpc 
																						where pc.id=cpc.catID 
																						and pc.parent='$parentLevel' 
																						and cpc.title='$cat' 
																						and cpc.langID='$importLangID'");
											$catID = $catRecord->id;
											if(!$catID && !empty($cat)){
												// --------------------------------------------------------------------------------------------------------------------------------------------------
												// create the category
												// --------------------------------------------------------------------------------------------------------------------------------------------------
												$catImage = ($leaf) ? $categoryImages[$catIndex] : NULL;	
												$q = "select MAX(sort) as sort from ".$category_section;
												$row = $db->getRecord($q);
												$sort = $row->sort;
												$sort++;
												$alias = $variables->toLatin($cat);
												$basicAlias = $alias;
												if($categories->isPreorderTreeTraversal($category_section)){
													$q = "select R from $category_section where id='$parentLevel'";
													$limits = $db->getRecord($q);
													$R = $limits->R;
													$leftValue = $R+1;
													$rightValue = $R+2;	
													$db->query("UPDATE $category_section SET R=R+2 WHERE R>$R");
													$db->query("UPDATE $category_section SET L=L+2 WHERE L>$R");
													$q = "INSERT INTO ".$category_section." VALUES('','$parentLevel','_self','$sort','0','$alias','0','0','0','0','', '$leftValue', '$rightValue')";
												}else{
													$q = "INSERT INTO ".$category_section." VALUES('','$parentLevel','$_self','$sort','0','$alias','0','0','0','0','')";
												}
												$db->query($q);
												$catID=$db->lastID();
												foreach($defaultPermissions as $account_type){
													$db->query("insert into cat_access values('$catID', '$account_type')");
												}
												// add the alias
												$aliasIndex = NULL;	
												$aliases = $sefAdmin->isAliasExists($basicAlias, $catID, $sectionID);
												while($aliases){
													$aliasIndex = (int)$aliasIndex;
													$aliasIndex++;
													$aliasToTest = $basicAlias."_".$aliasIndex;
													$aliases = $sefAdmin->isAliasExists($aliasToTest, $catID, $sectionID);
												}	
												$basicAlias = ($aliasToTest) ? $aliasToTest : $basicAlias;
												$keys="`id`, `active`, `private`, `alias`, `sectionID`, `itemID`, `isCategory`";
												$values="'', '1', '1', '".$basicAlias."', '".$sectionID."', '".$catID."', '1'";
												$q = "INSERT INTO aliases (".$keys.") VALUES(".$values.")";
												$db->query($q);
												$aliasID = $db->lastID();								
												$content_table = "content_".$category_section;
												$Lresult = $db->getRecords("SELECT * FROM languages WHERE active=1 ");
												foreach($Lresult as $Lrow) {
													$keys="id, catID, langID, title, minitext, link";			
													$alias = $variables->toLatin($cat);	
													list($part1, $part2) = explode("_", $basicAlias);
													if($part2) $alias=$alias."_".$part2;
													$languageID = $Lrow->id;
													$values="'','".$catID."','".$languageID."','".$cat."','',''";
													$q = "INSERT INTO content_".$category_section." (".$keys.") VALUES(".$values.")";
													$db->query($q);
													// add the multilingual alias
													$keys="`id`, `mainID`, `langID`, `title`";
													$values="'', '".$aliasID."', '".$languageID."', '".$alias."'";
													$q = "INSERT INTO content_aliases (".$keys.") VALUES(".$values.")";
													$db->query($q);			
												}
												
												// upload category image
												if($catImage){
													$ext = $fileSystem->getExtensionByFileName($catImage);
													$filetypeID = $fileSystem->isValidExtension($ext);
													if($filetypeID){
														if($fileSystem->isImageExtension($ext)){
															$newFileName="../mediabank/cat".$sectionID."_".$catID.".".$ext;
															if(copy($path.$document->unzipPath.$catImage, $newFileName)){
																// set dimentions according to saved parameters
																$imgDim = GetImageSize($newFileName);
																$originalWidth = $imgDim[0];
																$originalHeight = $imgDim[1];
																$cat_icon_width = $parameters->getParameter("cat_icon_width");
																$cat_icon_height = $parameters->getParameter("cat_icon_height");											
																if($ext=="png"){
																	$src_img = imagecreatefrompng($newFileName);
																	$dst_img = imagecreatetruecolor($cat_icon_width, $cat_icon_height);
																	imagecolortransparent($dst_img, imagecolorallocate($dst_img, 0, 0, 0));
																	imagealphablending($dst_img, false);
																	imagesavealpha($dst_img, true);
																	imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $cat_icon_width, $cat_icon_height, $originalWidth, $originalHeight); 
																	imagepng($dst_img, $newFileName);
																	imagedestroy ($src_img);
																	imagedestroy ($dst_img);
																}
																if($ext=="gif"){
																	$src_img = imagecreatefromgif($newFileName);
																	$dst_img = imagecreate($cat_icon_width, $cat_icon_height);
																	imagecolortransparent($dst_img, imagecolorallocate($dst_img, 0, 0, 0));
																	imagealphablending($dst_img, false);
																	imagesavealpha($dst_img, true);
																	imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $cat_icon_width, $cat_icon_height, $originalWidth, $originalHeight); 
																	imagegif($dst_img, $newFileName);
																	imagedestroy ($src_img);
																	imagedestroy ($dst_img);
																	die("ok");
																}
																if($ext=="jpg" || $ext =="jpeg"){
																	$src_img = imagecreatefromjpeg($newFileName);
																	$dst_img = imagecreatetruecolor($cat_icon_width, $cat_icon_height);
																	imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $cat_icon_width, $cat_icon_height, $originalWidth, $originalHeight); 
																	imagejpeg($dst_img, $newFileName, 70);
																	imagedestroy ($src_img);
																	imagedestroy ($dst_img);
																}
															}
														}
													}
												}		
												// --------------------------------------------------------------------------------------------------------------------------------------------------
												// end of the category creation
												// --------------------------------------------------------------------------------------------------------------------------------------------------
											}
											if($leaf) $productCategories[] = $catID; // this is a leaf category that need to be assigned to product
											$parentLevel = $catID;
											$level++;
										}
										$catIndex++;
									}
								}elseif($field == "list_price"){
									$list_price = (!empty($value)) ? (float)$value : 0;
								}elseif($field == "price"){
									$price = (!empty($value)) ? (float)$value : 0;
								}elseif($field == "price_description"){
									$price_description = $variables->odyssey_real_escape_string($value);
									$price_description = $content->remove_html_comments($price_description);
								}elseif($field == "vat"){
									$vat = (int)$value;
									$vat = (!empty($vat)) ? $vat : 1;
								}elseif($field == "code"){
									$code = $value;
								}elseif($field == "inventory_type"){
									$inventory_type = (int)$value;
									$inventory_type = (!empty($inventory_type)) ? $inventory_type : 1;
								}elseif($field == "instock"){
									$instock = (int)$value;
								}elseif($field == "min_order"){
									$min_order = (int)$value;
									$min_order = (!empty($min_order)) ? $min_order : 1;
								}elseif($field == "views"){
									$views = (int)$value;
								}elseif($field == "access_type" || $field == "show_price"){
									${$field} = 0;
								}elseif($field == "weight" || $field == "width" || $field == "height" || $field == "depth"){
									${$field} = (float)$value;
								}elseif($field == "free_shipping"){
									$free_shipping = (int)$value;
									$free_shipping = (!empty($free_shipping)) ? 1 : 0;
								}elseif($field == "brandID"){
									$brand['id'] = (int)$value;
								}elseif($field == "brand_name"){
									$brand['name'] = $variables->odyssey_real_escape_string($value);
								}elseif($field == "brand_logo"){
									$brand['logo'] = $value;
								}elseif($field == "brand_url"){
									$brand['url'] = $variables->makeURL($value);
								}elseif($field == "product_images"){
									$images = array_filter(preg_split('/\r\n|[\r\n]/', $value));
								}elseif($field == "category_images"){
									continue; // category images have been processed by catID field
								}
							}
							// start importing the product
							if(empty($foundTitle) || empty($productTitle)) continue; // ignore products without title
							if(!count($productCategories)) continue; // ignore uncategorized products
							//add brand
							if(count($brand)){
								if($brand['name']){
									$brandName = $brand['name'];
									if($brand['id']){
										$brandID = $brand['id'];
										$q = "select cm.mainID as brandID from content_manufacturers as cm where cm.mainID='$brandID' and cm.title='$brandName'";
										$brandID = $db->getRecord($q)->brandID;
										if(!$brandID && !in_array($brandName, $brandsImported)){ // add manufacturer
											$brandsImported[] = $brandName;
											$alias = $variables->toLatin($brandName);
											$basicAlias = $alias;
											$brandURL = $brand['url'];
											$title = $brandName;
											$keys="`active`, `private`, `sort`, `alias`, `url`";
											$values="'1', '1', '0', '".$alias."', '".$brandURL."'";
											$q = "INSERT INTO manufacturers (".$keys.") VALUES(".$values.")";
											$db->query($q);
											$brandID = $db->lastID();
											$manufacturersSectionID = $system->getTableSectionID("manufacturers");
											// add the manufacturer alias
											$aliasIndex = NULL;	
											$aliases = $sefAdmin->isAliasExists($basicAlias, $brandID, $manufacturersSectionID);
											while($aliases){
												$aliasIndex = (int)$aliasIndex;
												$aliasIndex++;
												$aliasToTest = $basicAlias."_".$aliasIndex;
												$aliases = $sefAdmin->isAliasExists($aliasToTest, $brandID, $manufacturersSectionID);
											}	
											$basicAlias = ($aliasToTest) ? $aliasToTest : $basicAlias;			
											$keys="`id`, `active`, `private`, `alias`, `sectionID`, `itemID`, `isCategory`";
											$values="'', '1', '1', '".$basicAlias."', '".$manufacturersSectionID."', '".$brandID."', '0'";
											$q = "INSERT INTO aliases (".$keys.") VALUES(".$values.")";
											$db->query($q);
											$aliasID = $db->lastID();	
											$Lresult = $db->getRecords("SELECT * FROM languages WHERE active=1 ");
											foreach($Lresult as $Lrow) {
												$languageID = $Lrow->id;
												$keys="id ,mainID, langID, title";
												$values="'', '$brandID', '$languageID', '$title'";
												$foundTitle = false;
												$alias = $variables->toLatin($brandName);	
												list($part1, $part2) = explode("_", $basicAlias);
												if($part2) $alias=$alias."_".$part2;	
												$q = "INSERT INTO content_manufacturers (".$keys.") VALUES(".$values.")";
												$db->query($q);
												// add the multilingual alias
												$keys="`id`, `mainID`, `langID`, `title`";
												$values="'', '".$aliasID."', '".$languageID."', '".$alias."'";
												$q = "INSERT INTO content_aliases (".$keys.") VALUES(".$values.")";
												$db->query($q);
											}
											$brandLogo = $path.$document->unzipPath.$brand['logo'];
											if(is_file($brandLogo)){
												
												$ext = $fileSystem->getExtensionByFileName($brandLogo);
												$filetypeID = $fileSystem->isValidExtension($ext);
												if($filetypeID){ 
													// add the brand's logo image to mediabank
													$title = $brandName." logo";
													$title = $variables->filterQuotes($title);
													$userID = 1; // Odyshop System User
													$db->query("INSERT INTO mediabank VALUES('','$title','','$filetypeID','$userID')");
													$id = $db->lastID();
													$path2 = "uploads/";
													$currentFile = $path2.$id.".".$ext;
													if($fileSystem->isImageExtension($ext)){
														if(copy($brandLogo, $currentFile)){
															$imageResize = new imageResize($id, $ext, $path2);
															$fileSystem->deleteUploadedFiles($id, $path2);
															$bankID = $id;
															$sort = 0;		
															$default = 1;
															$slider = 0;
															$logo = 0;
															if($fileSystem->isImage($bankID)){ //it is image so proceed to attach
																$db->query("INSERT INTO images VALUES('','$bankID','$manufacturersSectionID','$brandID','$default', '$slider', '$logo', '$sort')");
																$imgID = $db->lastID();
																$Lresult = $db->query("SELECT * FROM languages WHERE active=1 ");
																$LRecords = $db->getRows($Lresult);
																foreach($LRecords as $Lrow) {
																	$languageID = $Lrow->id;
																	$title = $fileSystem->getMediabankTitle($bankID);	
																	$description = "";			
																	$keys = "id,imgID,langID,title,description";
																	$values = "'','$imgID','$languageID','$title','$description'";			
																	$query = "INSERT INTO content_images (".$keys.") VALUES(".$values.")";
																	$db->query($query);
																}
															}
														}
													}
												}														
											}																							
										} // end add manufacturer																																
									}
								}
							}else{
								$brandID = 0; // No manufacturer
							}
							// proceed to create the product
							$keys="`active`, `private`, `sort`, `alias`, `catID`, `price`, `list_price`, `code`, `instock`, `min_order`, `vat`, `views`, `show_price`, `used`, `inventory_type`, `product_type`, `weight`, `width`, `height`, `depth`, `brandID`, `access_type`, `free_shipping`";
							$alias = $variables->toLatin($productTitle);
							$basicAlias = $alias;
							$values="'1', '1', '0', '".$alias."', '0', '".$price."', '".$list_price."', '".$code."', '".$instock."', '".$min_order."', '".$vat."', '".$views."', '0', '0', '".$inventory_type."', '', '".$weight."', '".$width."', '".$height."', '".$depth."', '".$brandID."', '0', '".$free_shipping."'";
							$q = "INSERT INTO `products` (".$keys.") VALUES(".$values.")";
							if($db->query($q)){ // successful product add
								$productID = $db->lastID();	
								// add the product alias
								$aliasIndex = 0;	
								$aliasToTest = "";
								$aliases = $sefAdmin->isAliasExists($basicAlias, $productID, $sectionID);
								while($aliases){
									$aliasIndex++;
									$aliasToTest = $basicAlias."_".$aliasIndex;
									$aliases = $sefAdmin->isAliasExists($aliasToTest, $productID, $sectionID);
								}	
								$basicAlias = ($aliasToTest) ? $aliasToTest : $basicAlias;
								$keys="`id`, `active`, `private`, `alias`, `sectionID`, `itemID`, `isCategory`";
								$values="'', '1', '1', '".$basicAlias."', '".$sectionID."', '".$productID."', '0'";
								$q = "INSERT INTO aliases (".$keys.") VALUES(".$values.")";
								$db->query($q);
								$aliasID = $db->lastID();		
								$Lresult = $db->getRecords("SELECT * FROM languages WHERE active=1 ");
								foreach($Lresult as $Lrow) {
									$languageID = $Lrow->id;
									$title = ($languageID != $langID) ? $productTitle." (en)" : $productTitle;
									$keys="id, mainID, langID, title, minitext, description, promo_text, price_description";
									$values="'', '$productID', '$languageID', '$title', '', '$productDescription', '$promo_text', '$price_description'";
									$alias = $variables->toLatin($title);	
									list($part1, $part2) = explode("_", $basicAlias);
									if($part2) $alias=$alias."_".$part2;	
									$q = "INSERT INTO content_products (".$keys.") VALUES(".$values.")";
									$db->query($q);
									// add the multilingual alias
									$keys="`id`, `mainID`, `langID`, `title`";
									$values="'', '".$aliasID."', '".$languageID."', '".$alias."'";
									$q = "INSERT INTO content_aliases (".$keys.") VALUES(".$values.")";
									$db->query($q);
								}
								// assign categories to this product
								foreach($productCategories as $optionID){
									$fieldID = $system->getFieldID("catID", $sectionID);
									$q = "INSERT INTO `selectlists` VALUES ('', '$sectionID', '$fieldID', '$productID', '$optionID')";
									$db->query($q); // assign the category									
								}
								// add access type and show price permissions
								$access_type_fieldID = $system->getFieldID("access_type", $sectionID);
								$show_price_fieldID = $system->getFieldID("show_price", $sectionID);
								foreach($defaultPermissions as $optionID){
									$q = "INSERT INTO `selectlists` VALUES ('', '$sectionID', '$access_type_fieldID', '$productID', '$optionID')";
									$db->query($q); // access type added
									$q = "INSERT INTO `selectlists` VALUES ('', '$sectionID', '$show_price_fieldID', '$productID', '$optionID')";
									$db->query($q);	// show price added								
								}
								if(count($images)){ // we have images to add and attach for this product
									$default = true;
									foreach($images as $image){
										$file=$path.$document->unzipPath.$image;
										$ext = $fileSystem->getExtensionByFileName($file);
										$filetypeID = $fileSystem->isValidExtension($ext);
										if($filetypeID){
											$title = "imported image ".$image;
											$title = $variables->filterQuotes($title);
											$userID = 1; // Odyshop System User
											$db->query("INSERT INTO mediabank VALUES('','$title','','$filetypeID','$userID')");
											$id = $db->lastID();
											$path2 = "uploads/";
											$currentFile = $path2.$id.".".$ext;
											if($fileSystem->isImageExtension($ext)){
												if(copy($file, $currentFile)){
													$imageResize = new imageResize($id, $ext, $path2);
													$fileSystem->deleteUploadedFiles($id, $path2);
													$bankID = $id;
													$sort = 0;		
													$slider = 0;
													$logo = 0;
													if($fileSystem->isImage($bankID)){ //it is image so proceed to attach
														$db->query("INSERT INTO images VALUES('','$bankID','$sectionID','$productID','$default', '$slider', '$logo', '$sort')");
														$imgID = $db->lastID();
														$Lresult = $db->query("SELECT * FROM languages WHERE active=1 ");
														$LRecords = $db->getRows($Lresult);
														foreach($LRecords as $Lrow) {
															$languageID = $Lrow->id;
															$title = $fileSystem->getMediabankTitle($bankID);	
															$description = "";			
															$keys = "id,imgID,langID,title,description";
															$values = "'','$imgID','$languageID','$title','$description'";			
															$query = "INSERT INTO content_images (".$keys.") VALUES(".$values.")";
															$db->query($query);
														}
													}
												}
											}
										}
										$default = false;	 // only the first image must be flaged as default image							
									}
								}								
							}// end of successful product add
						}
						if(!$messages->hasErrors && $step == "2"){
							$messages->addMessage(t("Η εισαγωγή των προϊόντων ολοκληρώθηκε με επιτυχία"));			
						?>
		<article class="grid-8">
			<div class="section_title"><?php echo t("ΕΙΣΑΓΩΓΗ ΠΡΟΪΟΝΤΩΝ"); ?></div>
			<?php $messages->printSystemMessages();?>	
		</article>		
					<?php						
						}						
					}
				}else{
					$messages->addError(t("Παρουσιάστηκε κάποιο σφάλμα κατά την εξαγωγή των δεδομένων του αρχείου"), true);	
				}
				if($step == "2") unlink("uploads/import.zip");
			}else{
				$messages->addError(t("Παρακαλούμε επιλέξτε ένα zip αρχείο που να περιέχει τα προς εισαγωγή προϊόντα"), true);
			}
			if($messages->hasErrors){
				?>
		<article class="grid-8">
			<div class="section_title"><?php echo t("ΕΙΣΑΓΩΓΗ ΠΡΟΪΟΝΤΩΝ"); ?></div>
			<?php $messages->printSystemMessages();?>	
		</article>
				<?php				
			}
		}else{
		?>		
        
		<article class="grid-8">
			<div class="section_title"><?php echo t("ΕΙΣΑΓΩΓΗ ΠΡΟΪΟΝΤΩΝ"); ?></div>
			<?php $messages->printSystemMessages();?>
			<div style="text-align:left; border-bottom:1px solid silver; padding-bottom: 30px; margin: 30px 0;">
			<div class="import_step"><?php echo t("Βήμα");?><div class="import_step_number">1</div></div>
			<div class="arrow-right"></div>
			<?php 
			echo t("Επιλέξτε το zip αρχείο που περιέχει το csv αρχείο των προϊόντων, με τις αντίστοιχες εικόνες προϊόντων, κατηγοριών και κατασκευαστών αν υπάρχουν").". ";
			echo t("Το συγκεκριμένο csv αρχείο θα πρέπει στην πρώτη γραμμή να περιέχει τις επικεφαλίδες που περιγράφουν τα πεδία").". ";
			?>
			</div>				
			<form id="importProducts" action="importProducts.php" method="post" class="admin_form form_centerd visible" enctype="multipart/form-data">
				<div class="admin_form_element" style="display: table; margin: 0 auto;">
					<div class="admin_label">
						<p>Zip file : </p>
					</div>
					<div>
						<input name="zipFile" type="file" class="listbox" id="zipFile">
					</div>
				</div>					
	
                <div class="admin_form_element">
                    <input name="submitedData" type="submit" class="btn btn-success" id="submitedData" value="<?php echo t("Επόμενο βήμα");?>" onclick="submitForm('export_products')">
                    <input name="category" type="hidden" id="category" value="<?php  echo $_REQUEST['category'];?>">
					<input name="step" type="hidden" value="1">
                </div>
			</form>
			<?php echo t("Τα πεδία που δύναται να περιέχει το csv αρχείο με τις αντίστοιχες προτεινόμενες επικεφαλίδες της πρώτης γραμμής είναι τα ακόλουθα").":"; ?>
			<ul class="import_field_descriptions">
				<li>
					<strong><?php echo t("Ονομασία προϊόντος");?></strong>
					<div class="import_field_description">
					<?php 
					echo t("Το πεδίο αυτό πρέπει να περιέχει την ονομασία του προϊόντος όπως θα εμφανίζεται στο e-shop");
					?>
					</div>
					<div class="import_required_field"><?php echo t("Απαραίτητο πεδίο! Χωρίς τίτλο το προϊόν θα αγνοηθεί κατά τη διαδικασία της μαζικής εισαγωγής");?></div>
				</li>
				<li>
					<strong><?php echo t("Περιγραφή");?></strong>
					<div class="import_field_description">
					<?php echo t("Το πεδίο αυτό πρέπει να περιέχει την αναλυτική περιγραφή του προϊόντος");?>
					</div>
				</li>	
				<li>
					<strong><?php echo t("Κατηγορίες");?></strong>
					<div class="import_field_description">
					<?php 
					echo t("Το πεδίο αυτό πρέπει να περιέχει την κατηγορία του προϊόντος συμπεριλαμβανομένων όλων των γονικών κατηγοριών σε μία γραμμή").". ";
					echo t("Οι κατηγορίες σε αυτή τη γραμμή πρέπει να είναι χωρισμένες με ///").". ";
					echo t("Αν το προϊόν ανήκει σε περισσότερες από μία κατηγορίες, κάθε διαδρομή της κατηγορίας πρέπει να βρίσκεται σε ξεχωριστή γραμμή στο csv αρχείο").". ";
					echo t("Παράδειγμα δύο κατηγοριών με τις αντίστοιχες διαδρομές").": <br>";
					echo t("Πρώτη γραμμή").": ".t("Βιβλία///Ιστορία")."<br>";
					echo t("Δεύτερη γραμμή").": ".t("Βιβλία///Αυτοβιογρφίες");
					?>
					</div>
					<div class="import_required_field"><?php echo t("Απαραίτητο πεδίο! Χωρίς έστω μία κατηγορία το προϊόν θα αγνοηθεί κατά τη διαδικασία της μαζικής εισαγωγής");?></div>
				</li>	
				<li>
					<strong><?php echo t("Αρχική τιμή λιανικής");?></strong>
					<div class="import_field_description">
					<?php echo t("Σε περίπτωση έκπτωσης το πεδίο αυτό πρέπει να περιέχει την τιμή του προϊόντος πριν εφαρμοστεί η έκπτωση");?>
					</div>
				</li>	
				<li>
					<strong><?php echo t("Τελική τιμή");?></strong>
					<div class="import_field_description">
					<?php echo t("Η τελική τιμή του προϊόντος πρό φόρων");?>
					</div>
				</li>	
				<li>
					<strong><?php echo t("Κωδικός");?></strong>
					<div class="import_field_description">
					<?php echo t("Στο πεδίο αυτό μπορούμε να συμπεριλάβουμε τον κωδικό που έχει το προϊόν στο φυσικό κατάστημα");?>
					</div>
				</li>	
				<li>
					<strong><?php echo t("Απόθεμα");?></strong>
					<div class="import_field_description">
					<?php echo t("Ο αριθμός των διαθέσιμων τεμαχίων για το συγκεκριμένο προϊόν");?>
					</div>
				</li>	
				<li>
					<strong><?php echo t("Βάρος σε kg");?></strong>
					<div class="import_field_description">
					<?php echo t("Το βάρος του προϊόντος σε κιλά");?>
					</div>
				</li>	
				<li>
					<strong><?php echo t("Πλάτος σε cm");?></strong>
					<div class="import_field_description">
					<?php echo t("Το πλάτος της συσκευασίας σε εκατοστά");?>
					</div>
				</li>	
				<li>
					<strong><?php echo t("Ύψος σε cm");?></strong>
					<div class="import_field_description">
					<?php echo t("Το ύψος της συσκευασίας σε εκατοστά");?>
					</div>
				</li>	
				<li>
					<strong><?php echo t("Βάθος σε cm");?></strong>
					<div class="import_field_description">
					<?php echo t("Το βάθος της συσκευασίας σε εκατοστά");?>
					</div>
				</li>	
				<li>
					<strong><?php echo "Brand Name";?></strong>
					<div class="import_field_description">
					<?php echo t("Η μάρκα του προϊόντος (ονομασία κατασκευαστή)");?>
					</div>
				</li>	
				<li>
					<strong><?php echo "Brand Logo";?></strong>
					<div class="import_field_description">
					<?php echo t("Το όνομα του αρχείου εικόνας που περιέχει το λογότυπο του κατασκευαστή σε διάσταση 195 Χ 195 pixels");?>
					</div>
				</li>	
				<li>
					<strong><?php echo "Brand URL";?></strong>
					<div class="import_field_description">
					<?php echo t("Η ηλεκτρονική διεύθυνση του ιστότοπου του κατασκευαστή");?>
					</div>
				</li>	
				<li>
					<strong><?php echo "Product Images";?></strong>
					<div class="import_field_description">
					<?php echo t("Τα ονόματα των αρχείων εικόνας του προϊόντος, κάθε ένα σε ξεχωριστή γραμμή");?>
					</div>
				</li>		
				<li>
					<strong><?php echo "Category Images";?></strong>
					<div class="import_field_description">
					<?php echo t("Τα ονόματα των αρχείων εικόνας των κατηγοριών του προϊόντος, κάθε ένα σε ξεχωριστή γραμμή");?>
					</div>
				</li>																																																							
			</ul>
			<?php echo t("Όσες εικόνες αναφέρονται στο csv αρχείο πρέπει να συμπεριλαμβάνονται με το ίδιο όνομα στο zip αρχείο της μαζικής εισαγωγής προϊόντων"); ?>			
		</article>
		<?php
		}
		?>
	</div>
<?php include("footer.php");?>
</section>
</div>
</body>
</html>
