<?php 
require_once("dll.php");

$langID = $language->getDefaultLanguage();
$parameters->importParameters();
$category = (int)$_REQUEST['category'];

// base language for translation is by default the greek language
// add a $translationKeyLangID variable in your config/odyssey.ini.php if you need other base language
global $translationKeyLangID;
$translationKeyLangID = ((int)$translationKeyLangID) ? (int)$translationKeyLangID : 1;  // default greek if no other defined

?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link rel="shortcut icon" href="favicon.ico">
<title>Admin Panel</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<link href="css/admin.css" rel="stylesheet" type="text/css">
<link href="css/pagination.css" rel="stylesheet" type="text/css">
<link rel="stylesheet" type="text/css" href="js/fancybox2/fancybox.css">
<link type="text/css" href="css/ui/jquery-ui-odyshop.css" rel="stylesheet">
<link rel="stylesheet" media="all" type="text/css" href="css/jquery-impromptu.css">

<script type="text/javascript" src="js/jquery.js"></script>
<script type="text/javascript" src="js/admin.js"></script>
<script type="text/javascript" src="js/cookies.js"></script>
<script type="text/javascript" src="js/jquery-ui-All.min.js"></script>
<script type="text/javascript" src="js/fancybox2/fancybox.js"></script>
<script type="text/javascript" src="js/jquery-impromptu.js"></script>
<script>
jQuery(function($){
	$('#loading').css("display", "none");
	$('a[rel="open_sections"]').fancybox({
		width : 500,
		maxHeight : 500,
		type : 'iframe',
		arrows: false,
		helpers : {
			overlay : {
				css : {
					'background' : 'rgba(0, 0, 0, 0.8)'
				}
			},
			title: null
		}
	});	
});
</script>
<script type="text/javascript">
function warning(elm){
	setTimeout(function(){
		if(!elm.checked){ return true;}
		if(confirm(t("Είστε σίγουροι πως θέλετε να διαγραφούν όλα τα περιεχόμενα των μεταφράσεων που υπάρχουν ήδη καταχωρημένα;"))){
			return true;
		}else{
			elm.checked=false;
			return false;
		}
	},100);
}
</script>
</head>
<body>
<div id="backend">
<?php include("includes/loading.php"); ?>
<section class="container">
    <?php  include("header.php");?>
    <div class="group">
        <aside class="grid-4">
            <?php include("menu.php");?>
            &nbsp; 
        </aside>
        <article class="grid-8">
<?php 
if($_REQUEST['action'] == "import" && $_REQUEST['submitedData']){
	$txt = $_FILES['txt']['tmp_name'];
	$translationLang = (int)$_REQUEST['translationLang'];
	$delete = (int)$_REQUEST['delete'];
	if($delete) {
		$db->query("delete from `keys`");
		$db->query("delete from `translations`");
		$db->query("alter table `keys` AUTO_INCREMENT = 1");
		$db->query("alter table `translations` AUTO_INCREMENT = 1");
		$messages->addMessage(t("Όσες μεταφράσεις υπήρχαν αφαιρέθηκαν επιτυχώς"));
	}
	if(!$translationLang){
		$messages->addError(t("Δεν προσδιορίσατε γλώσσα μεταφράσεων"));
		unset($txt); // no need to procceed
	}
	if($txt){
		if(!mb_check_encoding(file_get_contents($txt), 'UTF-8')){
			$messages->addError(t("Παρακαλούμε επιλέξτε ένα txt αρχείο με κωδικοποίηση κειμένου UTF-8"));
		}else{
			$system->importTranslations($txt, $translationLang);
		}
	}else{
		if(!$messages->hasErrors) $messages->addError(t("Παρακαλούμε επιλέξτε ένα txt αρχείο που να περιέχει επιτρεπτή δομή μεταφράσεων"));
	}
}

$messages->printSystemMessages();

?>
            <div class="section_title"><?php echo t("ΕΠΙΛΟΓΗ TXT ΑΡΧΕΙΟΥ ΜΕΤΑΦΡΑΣΕΩΝ ΓΙΑ ΕΙΣΑΓΩΓΗ"); ?></div>
            
			<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post" enctype="multipart/form-data" class="admin_form form_centered">
                <div style="max-width:500px; padding: 0 20px;">
	<?php 
    $q="select * from languages where id <> '$translationKeyLangID'";
    $results=$db->query($q);
    $rows=$db->getNumRows($results);
    if(!$rows){
        $messages->addError(t("Δεν βρέθηκαν καταχωρημένες γλώσσες"));
        $messages->printSystemMessages(true); // print errors formated in html
    }else{
    ?>
                    <div style="text-align:center;">
                        <p style="text-align:left; line-height:18px;"> <?php echo t("Επιλέξτε κάποιο txt αρχείο που να περιέχει εκφράσεις και τις μεταφράσεις τους");?><br>
                            <br>
                            <?php echo t("Μπορείτε να");?> <a class="footer_link" href="../exportTranslationKeys.php"><?php echo t("δημιουργήσετε");?>*</a> <?php echo t("ένα txt αρχείο που να περιέχει όλες τις φράσεις του site και να προσθέσετε σε αυτό τις μεταφράσεις");?>. <br>
                            <?php echo t("Εναλλακτικά μπορείτε να");?> <a class="footer_link" href="../exportTranslationKeys.php?mode=ignoreExisting"><?php echo t("δημιουργήσετε");?>*</a> <?php echo t("ένα txt αρχείο που να περιέχει μόνο όσες φράσεις του site δεν έχουν καταχωρημένη μετάφραση και αφού προσθέσετε τις μεταφράσεις να το εισάγετε στο σύστημα διατηρώντας τις παλαιές μεταφράσεις, προσθέτοντας μόνο τις νέες");?>.
                        <div style="color:grey; text-align:left"><i>* <?php echo t("Η διαδικασία αυτή ίσως διαρκέσει αρκετά δευτερόλεπτα");?></i></div>
                        <br>
                        <br>
                        </p>
                        <input name="txt" type="file" class="listbox" id="txtFile">
 
                         </div>
                    <div style="margin: 20px 0"><?php echo t("και ορίστε την γλώσσα της μετάφρασης που εισάγετε");?></div>
		<?php
        $records = $db->getRecords($q);
        foreach($records as $row){	
            $extension = ($row->extension) ? $row->extension : "_gr";
            $path = $domainPath.getFPath()."mediabank/flags/";
            $filename = $path."flag".$extension.".png";
            if(@fopen($filename, "r")) $flag = $filename;
            $langTitle = ((int)$langID == 1) ? $row->title : $row->title_translated;
            ?>
                    
                
                    <div class="admin_form_element">
                        <div class="admin_checkbox_wrapper">
                            <input name="translationLang" type="radio" value="<?php  echo $row->id;?>" <?php if($extension=="_en"){ echo (' checked');}?>>
                            <p>
								<img src="<?php echo $flag; ?>" 
                                alt="<?php  echo $langTitle;?>" 
                                align="absmiddle" 
                                style="padding:1px; border:1px solid black; margin-right:10px">
                                <?php  echo $langTitle;?>
                            </p>
                        </div>
                    </div>
		<?php 
        }
        ?>
                    <div class="admin_form_element" style="margin-top: 30px;">
                        <div class="admin_checkbox_wrapper">
                            <input name="delete" type="checkbox" value="1" onclick="return warning(this)">
                            <p><?php echo t("Να διαγραφούν πρώτα όλες οι υπάρχουσες μεταφράσεις");?></p>
                        </div>
                    </div>
                    <div class="admin_form_element">
                        <input name="submitedData" type="submit" class="btn btn-success" id="submitedData" value="<?php echo t("Εισαγωγή");?>">
                        <input name="action" type="hidden" id="action" value="import">
                        <input name="category" type="hidden" id="category" value="<?php  echo $_REQUEST['category'];?>">
                    </div>
	<?php 
    }
	?>
                </div>
            </form>
		</article>
	</div>
<?php include("footer.php");?>
</section>
</div>
</body>
</html>
