<?php 
require_once("dll.php");
$langID = $language->getDefaultLanguage();
$variables->getSafeVars(array_keys($_REQUEST));

$uploads_txt = "uploads/uploads.txt";

if($_REQUEST['action'] != "edit"){
	if(!is_file($uploads_txt)){
		$messages->addError(t("Δεν βρέθηκε το αρχείο καταγραφής των uploads"));
	}else{
		$uploads = file($uploads_txt);
		if(!count($uploads)) $messages->addError(t("Δεν βρέθηκαν εγγραφές στο αρχείο καταγραφής των uploads"));
	}
}



if(!$messages->hasErrors){
	$uploadedIDs = array();
	foreach($uploads as $upload){
		$upload = trim($upload);
		if(empty($upload)) continue;
		$path_parts = pathinfo($upload);
		$filename = trim($path_parts['basename']);
		$filename = mb_strtolower($filename, 'UTF-8');
		$ext = mb_strtolower(trim($path_parts['extension']), 'UTF-8');
		$filetypeID = $fileSystem->isValidExtension($ext);
		$userID=$db->getRecord("select min(id) as id from users where active=1")->id;
		if(empty($userID)) die (t("Δεν βρέθηκε καταχωρημένος χρήστης στο σύστημα! Επικοινωνήστε με τον διαχειριστή του συστήματος"));
		if($filetypeID){
			$hasUploads = false;
			$title = $variables->toLatin($filename);
			$title = $variables->filterQuotes($title);
			$title = str_replace($ext, NULL, $title);	
			$tags = NULL;
			$db->query("INSERT INTO mediabank VALUES(null,'$title','$tags','$filetypeID','$userID')");
			$id=$db->lastID();
			$path= "uploads/";
			$currentFile = $path.$id.".".$ext;
			if(is_file($currentFile)) unlink($currentFile);
			if(copy($upload, $currentFile)){
				$uploadedIDs[] = $id;
				if($fileSystem->isImageExtension($ext)){
					$imageResize = new imageResize($id, $ext, $path);
				}else{ // it's a non-image valid file, Just upload it!
					$destinationFile =$id.".".$ext;
					$fileSystem->copyToMediabank($upload, $destinationFile );			
				}
				$fileSystem->deleteUploadedFiles($id, $path);
				@unlink($upload); // delete multi upload file
				$thumb = $path."thumbnails/".$filename;
				@unlink($thumb); // delete multi upload thumbnail
			}else{
				$messages->addError(t("Δεν ήταν δυνατή η αντιγραφή του αρχείου")." ".$filename);
			}
		}else{
			$messages->addError(t("Ο τύπος αρχείου")." [".$ext."] ".t("δεν υποστηρίζεται")."!");
		}		
	}
	if(is_file($uploads_txt)) unlink($uploads_txt); // remove txt
	
	
	
		
	if($_REQUEST['action'] == "edit" && (!empty($_REQUEST['writedata']))){
		$fileIDs = explode("|", $_POST['fileIDs']);
		$userIDs = $_POST['userIDs'];
		$titles = $_POST['titles'];
		$tags = $_POST['tags'];
		if(is_array($fileIDs) && is_array($userIDs) && is_array($titles) && is_array($tags)){
			$index = 0;
			foreach($fileIDs as $fileID){
				$filetypeID = $fileSystem->getFileTypeID($fileID);
				$title = trim($titles[$index]);
				$thisTags = trim($tags[$index]);
				$title = $variables->filterQuotes($title);
				$tags = $variables->filterQuotes($tags);					
				$userID = $userIDs[$index];
				if(!empty($title)) $db->query( "UPDATE mediabank SET title='$title', tags='$thisTags', filetypeID='$filetypeID', userID='$userID' where id='$fileID'");
				$index++;
			}
		}
	}
}
?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="css/admin.css" rel="stylesheet" type="text/css">
<script type="text/javascript" src="js/jquery.js"></script>
</head>
<body id="inner_page" style="background:#ededed">
<noscript>
<br>
<br>
<p align="center">
	<img src="images/warning_big.png" alt="warning" width="35" height="40">
</p>
<p style="color: #CC0000"><?php echo t("Πρέπει να ενεργοποιήσετε την Javascript για να λειτουργήσει σωστά αυτή η σελίδα");?>!</p>
</noscript>
<?php 
$messages->printSystemMessages(); 
if($_REQUEST['action'] == "edit" && (!empty($_REQUEST['writedata']))){
	?>
	<script>
	parent.location.href="mediabank.php?action=edit&category=11";
	</script>
	<?php
}


if(!$_REQUEST['action'] && count($uploadedIDs)){
	?>
    <div class="section_title"><?php echo t("ΣΥΜΠΛΗΡΩΜΑΤΙΚΑ ΣΤΟΙΧΕΙΑ ΤΩΝ ΑΡΧΕΙΩΝ"); ?></div>
<form action="" method="post">
	<div  style="display:table; margin: 0 auto">
		<?php
	foreach($uploadedIDs as $fileID){
		$results = $db->query("select * from mediabank where id='$fileID' ");
		$row = $db->getRow($results);
		$ext = $fileSystem->getExtensionByFileTypeID($row->filetypeID);
		?>
        <div class="admin_form_element">
            <div class="admin_label">&nbsp;</div>
            <div class="normal_wrapper">
            <table class="admin_thumb_wrapper single_thumb">
            <tr>
                <td class="admin_thumb_image">
                <?php 
                if($fileSystem->isImage($row->id)){
                    ?>
                    <img src="../mediabank/thumbs/small_<?php  echo $row->id.'.'.$ext;?>" alt="selected file" title="<?php  echo t($row->title);?>" border="0" style="max-height: 112px;">
                    <?php 
                }else{
                    ?>
                    <img src="../mediabank/icons/filetype_<?php  echo $ext;?>.gif" alt="selected file"  title="<?php  echo t($row->title);?>" border="0">
                    <?php 
                }
                ?></td>
            </tr>
            </table>
            </div>            
        </div> 
        
        <div class="admin_form_element">
            <div class="admin_label">
            <?php echo t("Τίτλος (προαιρετικά)");?> : 
            </div>
            <div class="normal_wrapper">
                <input name="titles[]" type="text" class="listbox" value="<?php  echo t($row->title);?>">
            </div>            
        </div>
                
        
        <div class="admin_form_element">
            <div class="admin_label">
            <p><?php echo t("Ιδιοκτήτης");?> : </p>
            </div>
            <div>
                <select name="userIDs[]" class="listbox">
                <?php
				$flatTableName = "users";
				$q = "select ".$flatTableName.".id as id, content_".$flatTableName.".title as title 
											   from ".$flatTableName.", content_".$flatTableName." 
											   where content_".$flatTableName.".mainID=".$flatTableName.".id 
											   and content_".$flatTableName.".langID=".$langID." order by ".$flatTableName.".sort, content_".$flatTableName.".title"; 
				$tempRecords = $db->getRecords($q);
				foreach($tempRecords as $temprow){
					?>
					<option value="<?php  echo $temprow->id?>" <?php  if($row->userID == $temprow->id){echo(' selected="selected"');}?> style="padding-right:20px">
					<?php 
					echo $temprow->title;
					?>
					</option>
					<?php 
				}
				?>
				</select>
            </div>
        </div>
        
        <div class="admin_form_element">
            <div class="admin_label<?php echo $flag_class;?>">
                <?php echo t("Λέξεις-ετικέτες (tags) που χαρακτηρίζουν το αρχείο σας");?> : 
                <div class="definition">(<?php echo t("Οι λέξεις πρέπει να είναι χωρισμένες με κενά");?>)</div>
            </div>
            <div>
                <textarea name="tags[]" rows="5" class="listbox" style="max-width: 258px !important;"><?php  echo stripslashes($row->tags);?></textarea>
                <hr style="margin: 40px 0 20px;">
            </div>            
        </div>               

		<?php
	}
	?>

        <div class="admin_form_element">
            <input name="writedata" type="submit" class="btn btn-success" value="<?php echo t("Αποθήκευση");?>">&nbsp;&nbsp;
            <input type="hidden" name="action" value="edit">
            <input name="fileIDs" type="hidden" id="fileID" value="<?php echo implode("|", $uploadedIDs);?>">
        </div>

	</div>
</form>
<?php
}
?>
</body>
</html>
