<?php
global $system;
global $db;
global $content;

// add admin menu items for import / export products
$title = "ΕΙΣΑΓΩΓΗ / ΕΞΑΓΩΓΗ ΠΡΟΪΟΝΤΩΝ";
$title_en = "IMPORT / EXPORT PRODUCTS";
$menuParent = 1262; // ΚΑΤΑΛΟΓΟΣ ΠΡΟΪΟΝΤΩΝ
$target = "_self";
$access = 0; // only Master Admin
$link = "javascript:void(0)";
$name = "import_export_products";
if(!$system->isMenuExists($title, $menuParent, $link)){
  $menuID = $system->addMenu($title, $title_en, $menuParent, $target, $access, $link, $link, $name);

  // add the children menu items
  $menuParent = $menuID; // the parent that just created
  
  $link = "importProducts.php";
  if(!$system->isMenuExists("ΜΑΖΙΚΗ ΕΙΣΑΓΩΓΗ ΠΡΟΪΟΝΤΩΝ", $menuParent, $link)){
    $system->addMenu("ΜΑΖΙΚΗ ΕΙΣΑΓΩΓΗ ΠΡΟΪΟΝΤΩΝ", "BULK PRODUCT IMPORT", $menuParent, $target, $access, $link, $link, $name);
  }
  
  $link = "exportProducts.php";  
  if(!$system->isMenuExists("ΕΞΑΓΩΓΗ ΠΡΟΪΟΝΤΩΝ", $menuParent, $link)){
    $system->addMenu("ΕΞΑΓΩΓΗ ΠΡΟΪΟΝΤΩΝ", "EXPORT PRODUCTS", $menuParent, $target, $access, $link, $link, $name);
  }
  
}

// create required slots
$slots['admin_apps'] = 'Admin Apps';
$slots['admin_forbidden_combinations'] = 'Admin Forbidden Combinations';
$slots['payments'] = 'Payments';
if(empty($document)) $document = new document(NULL, NULL, true);
$templateID = $document->getTemplateID();

foreach($slots as $key=>$value){
  $slot = $key;
  $title = $value;
  $exist = $db->getRecord("select `name` from `slots` where `name`='$slot'");
  if(!$exist){
    $q = "insert into `slots` (active, private, sort, alias, name, templateID) VALUES('1', '1', '0', '', '$slot', '$templateID')";
    $db->query($q);
    $mainID = $db->lastID();
    $q = "insert into `content_slots` (mainID, langID, title) VALUES('$mainID', '1', '$title')";
    $db->query($q);
  }
}

// create `options_exceptions` db table
$sql="CREATE TABLE IF NOT EXISTS `options_exceptions` (
	`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
	`productID` INT(10) UNSIGNED NOT NULL,
	`combination` TEXT NOT NULL,
	PRIMARY KEY (`id`)
) COLLATE='utf8mb4_general_ci' ENGINE=MyISAM;";
$db->query($sql);

// create `keys_extensions` db table
$sql = "CREATE TABLE IF NOT EXISTS `keys_extensions` (
	`keyID` INT(10) UNSIGNED NOT NULL DEFAULT '0',
	`extensionID` INT(10) UNSIGNED NOT NULL DEFAULT '0'
) COLLATE='utf8mb4_general_ci' ENGINE=MyISAM;";
$db->query($sql);

// Create section `admin_product_modules` if not exists
$sql = "CREATE TABLE IF NOT EXISTS `admin_product_modules` (
	`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
	`active` TINYINT(3) UNSIGNED NOT NULL DEFAULT '0',
	`private` TINYINT(3) UNSIGNED NOT NULL DEFAULT '0',
	`sort` INT(11) UNSIGNED NOT NULL DEFAULT '0',
	`alias` VARCHAR(255) NULL DEFAULT NULL,
	`slotID` INT(11) NULL DEFAULT NULL,
	PRIMARY KEY (`id`)
) COLLATE='utf8mb4_general_ci' ENGINE=MyISAM;

REPLACE INTO `admin_product_modules` (`id`, `active`, `private`, `sort`, `alias`, `slotID`) VALUES
	(1, 1, 1, 1, 'epiloges-proiontos', 2766),
	(2, 1, 1, 2, 'syndyasmoi-apothema', 2765),
	(3, 1, 1, 4, 'xaraktiristika-proiontos', 2762),
	(4, 1, 1, 5, 'posotikes-ekptoseis', 2763),
	(5, 1, 1, 6, 'sxetizomena-proionta', 2764),
	(6, 0, 1, 7, 'arxeio-pros-polisi', 2761),
	(7, 1, 1, 3, 'apagoreymenoi-syndyasmoi', 2784);

CREATE TABLE IF NOT EXISTS `content_admin_product_modules` (
	`id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
	`mainID` INT(11) UNSIGNED NOT NULL DEFAULT '0',
	`langID` TINYINT(3) UNSIGNED NOT NULL DEFAULT '0',
	`title` VARCHAR(255) NULL DEFAULT NULL,
	PRIMARY KEY (`id`)
)
COLLATE='utf8mb4_general_ci'
ENGINE=MyISAM
;

REPLACE INTO `content_admin_product_modules` (`id`, `mainID`, `langID`, `title`) VALUES
	(1, 1, 1, 'Επιλογές προϊόντος'),
	(2, 1, 2, 'Product options'),
	(3, 2, 1, 'Συνδυασμοί & απόθεμα'),
	(4, 2, 2, 'Combinations & inventory'),
	(5, 3, 1, 'Χαρακτηριστικά προϊόντος'),
	(6, 3, 2, 'Product features'),
	(7, 4, 1, 'Ποσοτικές εκπτώσεις'),
	(8, 4, 2, 'Quantity discounts'),
	(9, 5, 1, 'Σχετιζόμενα προϊόντα'),
	(10, 5, 2, 'Related products'),
	(11, 6, 1, 'Αρχείο προς πώληση'),
	(12, 6, 2, 'File to sell (Downloadable)'),
	(13, 7, 1, 'Απαγορευμένοι συνδυασμοί'),
	(14, 7, 2, 'Forbidden Combinations');";
$db->query($sql);
$q = "select name from sections where name='admin_product_modules'";
$exists = $db->getRecord($q);
if(!$exists){
  $q = "INSERT INTO `sections` (`id`, `active`, `private`, `alias`, `sort`, `name`, `menuParent`, `access`, `hasAttachments`, `isSearchable`, `hasCategory`, `sortType`, `isMenu`, `hasGoogleMaps`, `systemProtected`, `jsFiles`, `cssFiles`) VALUES
    ('', 1, 1, 'admin_product_modules', 0, 'admin_product_modules', 26, 0, 0, 0, 0, 1, 0, 0, 1, '', '')";
  $db->query($q);
  $sectionID = $db->lastID();
  $q="INSERT INTO `content_sections` (`id`, `mainID`, `langID`, `title`) VALUES
    ('', '".$sectionID."', 1, 'ADMIN PRODUCT MODULES'),
    ('', '".$sectionID."', 2, 'ADMIN PRODUCT MODULES');";
  // add fields for this section
  $q="INSERT INTO `fields` (`id`, `tableSectionID`, `fieldVarName`, `fieldDescription`, `fieldType`, `selectType`, `selectTableSectionName`, `isMainTitle`, `isMultilingual`, `isSearchable`, `required`, `active`, `access`, `sort`, `autoView`, `hiddenInPublicAdmin`, `autofillField`, `autofillLabel`, `fieldsetID`) VALUES
    ('', '".$sectionID."', 'title', 'Τίτλος', 'textfield', '', '', 1, 1, 0, 1, 1, 0, 0, 0, 0, '', '', 0),
    ('', '".$sectionID."', 'slotID', 'Slot', 'selectMenu', 'flat', 'slots', 0, 0, 0, 1, 1, 0, 0, 0, 0, '', '', 0)";

  // add admin menu items for admin_product_modules section
  $title = "ADMIN PRODUCT MODULES";
  $title_en = "ADMIN PRODUCT MODULES";
  $menuParent = 26; // ΠΙΝΑΚΕΣ ΣΥΣΤΗΜΑΤΟΣ
  $target = "_self";
  $access = 0; // only Master Admin
  $link = "javascript:void(0)";
  $name = "admin_product_modules"; // section system name
  if(!$system->isMenuExists($title, $menuParent, $link)){
    $menuID = $system->addMenu($title, $title_en, $menuParent, $target, $access, $link, $link, $name);
    // add the children menu items
    $menuParent = $menuID; // the parent that just created
    $add_link = "sections.php?section=".$name."&action=form";
    if(!$system->isMenuExists("ΠΡΟΣΘΗΚΗ", $menuParent, $add_link)){ // create only if this menu not exists
      $add = $system->addMenu("ΠΡΟΣΘΗΚΗ", "ADD", $menuParent, $target, $access, $add_link, $add_link, $name);
    }
    $edit_link = "sections.php?section=".$name."&action=list"; 
    if(!$system->isMenuExists("ΕΠΕΞΕΡΓΑΣΙΑ", $menuParent, $edit_link)){ // create only if this menu not exists  
      $edit = $system->addMenu("ΕΠΕΞΕΡΓΑΣΙΑ", "EDIT", $menuParent, $target, $access, $edit_link, $edit_link, $name);
    }
    $sort_link = "sections.php?section=".$name."&action=sort";  
    if(!$system->isMenuExists("ΤΑΞΙΝΟΜΗΣΗ", $menuParent, $sort_link)){ // create only if this menu not exists    
      $sort = $system->addMenu("ΤΑΞΙΝΟΜΗΣΗ", "SORT", $menuParent, $target, $access, $sort_link, $sort_link, $name);
    }  
  }		
}

// Restore Odyssey Forms as main menu
$q="REPLACE INTO `menu_options_categories` (`id`, `parent`, `target`, `sort`, `access`, `alias`, `posX`, `posY`, `stepX`, `stepY`, `sprite`) VALUES	(1042, 0, '_self', 7, 0, 'diaxeirisi-formon', 0, -256, 32, 32, 'odyssey_admin_menu')";
$db->query($q);

$old_file = "../controller/_products.php";
if(is_file($old_file)){
  $new_file = "../controller/_productsCopy.php";
  rename ($old_file, $new_file);
}
$old_file = "../controller/override_products.php";
if(is_file($old_file)){
  $new_file = "../controller/override_productsCopy.php";
  rename ($old_file, $new_file);
}

// add parameter access_prices
if(!$system->isMysqlFieldExists("access_prices", "system_settings")){ // add only if it does not exists
	$fieldID = $db->getNextID("fields");
	$query = "REPLACE INTO `fields` VALUES (".$fieldID.", 2378, 'access_prices', 'Να βλέπουν τις τιμές', 'selectList', 'flat', 'users_types', 0, 0, 0, 0, 1, 0, 0, 0, 0, '', '', 17)";
	$db->query($query);
	$system->createMysqlField($fieldID);
  // add new filedset named "Τιμές"
  $q = "REPLACE INTO `fieldsets` VALUES (17, 2, 1, 1, 2378, 'Τιμές', 'Prices')";
  $db->query($q);
  // change filedset for various financial settings fields
  $q = "update `fields` SET `fieldsetID`='17' WHERE id='10096' AND `fieldVarName`='default_vat' ";
  $db->query($q);
  $q = "update `fields` SET `fieldsetID`='17' WHERE id='10097' AND `fieldVarName`='include_vat' ";
  $db->query($q);
  $q = "update `fields` SET `fieldsetID`='17' WHERE id='10091' AND `fieldVarName`='currency' ";
  $db->query($q);	
  // insert default values for access_price parameter
  $q = "INSERT INTO `selectlists` (id, sectionID, fieldID, itemID, optionID) values ('', '2378', '$fieldID', '1', '2')";
  $db->query($q);	
  $q = "INSERT INTO `selectlists` (id, sectionID, fieldID, itemID, optionID) values ('', '2378', '$fieldID', '1', '4')";
  $db->query($q);	
      $q = "INSERT INTO `selectlists` (id, sectionID, fieldID, itemID, optionID) values ('', '2378', '$fieldID', '1', '5')";
  $db->query($q);	
}

// remove paypal related system settings
// First remove the system settings PayPal fieldset
$q = "delete from `fieldsets` where id=16 and title='PayPal'";
$db->query($q);
//Proceed to remove the paypal related system settings fields
$sectionID = $system->getTableSectionID("system_settings");
$fieldID = $system->getFieldID("test_paypal", $sectionID);
$system->removeField($fieldID);
$fieldID = $system->getFieldID("paypal_email", $sectionID);
$system->removeField($fieldID);

// remove section "payment_methods"
$sectionID = $system->getTableSectionID("payment_methods");
if($sectionID) $system->deleteSection($sectionID);

// convert database to UTF8mb4
$system->convertDatabaseToUTF8mb4();


?>