<?php 
require_once("dll.php");
$db->query("SET NAMES 'utf8mb4'");
$variables->getSafeVars(array('productID'));
$langID = (int)$_POST['langID'];
$langID = ($langID) ? $langID : $language->getDefaultLanguage();
if(!$productID) die("Product ID is missing");
$product = $content->getContentByID("products", $productID, "*", "*", $langID);
if(!$product) die("Product not found");
$data = stripslashes($_POST['selectedOptions']);
$data = json_decode($data);

if(!count($data)) die("Selected Options are missing");
$selectedOptions = array();
foreach($data as $item){
	list($part1, $optionID, $part3) = explode("_", $item->name);
	$selectedOptions[$optionID] = $item->value;
}
$vat = $content->getValue("fpa_cat", $product->vat, "percent", $langID);
$include_vat = (int)$parameters->getParameter("include_vat");
$price = (float)$product->price;	
if($include_vat) $price = $eshop->includeVat($price, $vat);
$exceptions = $eshop->getProductExeptionsIDs($productID, $langID);
$excludedVariants = $eshop->getProductExclusions($productID, $selectedOptions, $exceptions);
$options = $eshop->getProductOptions($productID);
$return = array();
foreach($options as $option){
	$optionID = $option->id;
	$variants = $eshop->getProductOptionVariants($productID, $optionID, $langID);
	foreach($variants as $variant){
		$optionVariantID = $variant->variantID;
		$isVariantExcluded = $eshop->isVariantExcluded($optionVariantID, $excludedVariants);
		if(!$isVariantExcluded){
			$selected = in_array($optionVariantID, $selectedOptions) ? " selected" : NULL;
			$title = $variant->title;
			$modifier = (float)$variant->modifier;
			$type = $variant->type;
			$modifier_text = NULL;
			if($modifier){
				if($type == "A"){
					if($include_vat) $modifier = $eshop->includeVat($modifier, $vat);
					$modified_price = $modifier;
					$modifier_text = " (+".$eshop->formatPrice($modified_price).")";
				}
				if($type == "P"){
					$modified_price = $modifier * ((float)$price / 100);
					$modifier_text = " (+".$eshop->formatPrice($modified_price).")";
				}							
			}					
			
			$option = '<option value="'.$optionVariantID.'"'.$selected.'>'.$title.$modifier_text.'</option>';
			$return[$optionID][] = $option;
		}
	}
}
echo(json_encode($return));
?>