<?php 
require_once("dll.php");
$db->query("SET NAMES 'utf8mb4'");
$variables->getSafeVars(array('countryID', 'cityID', 'total_weight', 'total_cost', 'silent', 'check_country', 'langID'));
if(!$countryID) die("error: No country defined");
$free_shipping_order = (float)$parameters->getParameter("free_shipping_order");
$isGreekDestination = isGreekDestination($countryID);
if($check_country && $isGreekDestination) die("ok_");
$total_cost = (float)$total_cost;
if(!$isGreekDestination){ // calculate international destination
	$countries = $eshop->getShippingCountries();
	if(!in_array($countryID, $countries)){
		$queryLangID = ($langID != 1) ? 2 : $langID;
		$country = $content->getValue("countries", $countryID, "title", $queryLangID);
		$error = ($silent) ? "" : t("Δεν υποστηρίζονται αποστολές προς την συγκεκριμένη χώρα")." (".$country.")";
		die($error);
	}
	if($check_country) die("ok_"); // country is supported, end script if checking is activated
	if((float)$total_weight > 50){
		$error = ($silent) ? "" : t("Το βάρος είναι υπερβολικό για την αποστολή της παραγγελίας");
		die($error);
	}
	$q = "select c.delivery, z.zone, z.id as zoneID from izones_countries as c, izones as z where 
			z.id=c.izoneID and c.countryID='$countryID'";
	$country = $db->getRecord($q);
	$zone = $country->zone;
	$zoneID = $country->zoneID;
	$delivery = $country->delivery;
	$weight = $eshop->roundToNextHalf($total_weight);
	$q = "select price from izones_weights where izoneID='$zoneID' and weight='$weight'";
	$price = $db->getRecord($q)->price;
	if($weight > 25){ // calculate price raise
		$overweight = ceil($weight - 25);
		$q = "select over25 from izones where zone='$zone'";
		$over25 = $db->getRecord($q)->over25;
		$raise = $overweight * (float)$over25;
		$price += $raise;
	}
	require("shipping_international_rules.php");
	$price = $eshop->applyShippingDiscount($price);
	$total_weight = (!$total_weight) ? 1 : $total_weight; // do not permit zero total weight
	if(($free_shipping_order && $total_cost > $free_shipping_order) || !$total_weight) $price = "free";
	echo "ok_".$price."_".$delivery;
}else{ // calculate greek destination
	$shipping_type = $parameters->getParameter("shipping_type");
	$field_name = $content->getValue("shipping_types", $shipping_type, "field_name", $langID);
	$inaccessible = !$cityID;
	if($inaccessible){
		echo calculatePrice("inaccessible");
	}else{ // find the given destination
		$queryLangID = ($langID != 1) ? 2 : $langID;
		$city = $content->getContentByID("cities", $cityID, "*", "*", $queryLangID);
		if(!$city) die("error: city not found");
		$company_cityID = $parameters->getParameter("company_city");
		$countyID = $city->countyID;
		$queryLangID = ($langID != 1) ? 2 : $langID;
		$acs_regionID = $content->getValue("counties", $countyID, "acs_regionID", $queryLangID);
		$company_countyID = $content->getValue("cities", $company_cityID, "countyID", $queryLangID);
		$company_acs_regionID = $content->getValue("counties", $company_countyID, "acs_regionID", $queryLangID);
		$same_region = ($company_acs_regionID == $acs_regionID);
		$dx = $city->dx;
		$same_city = ($company_countyID == $countyID && ($countyID == 13 || $countyID == 30)); // same city in salonica and attica except inaccessible areas
		if(!empty($city->dp)){ // inaccessible
			echo calculatePrice("inaccessible");
			exit;
		}
		if(($cityID == $company_cityID) || $same_city){ // same city
			echo calculatePrice("same_city", $dx);			
			exit;
		}		
		if($same_region){// same acs region
			echo calculatePrice("same_region", $dx);			
			exit;			
		}
		if(!empty($city->np)){ // island
			echo calculatePrice("island", $dx);			
			exit;			
		}
		// calculate land destination
		echo calculatePrice("land", $dx);			
	}
}

function calculatePrice($gzone, $dx=false){
	global $db;
	global $field_name;
	global $free_shipping_order;
	global $total_cost;
	global $total_weight;
	global $parameters;
	global $eshop;
	if(!empty($dx)) $field_name = "dd_price";
	$q = "select `$field_name` as price, `delivery`, `price_per_kg` from `gzones` where `gzone`='$gzone'";
	$data = $db->getRecord($q);
	$price = $data->price;
	$delivery = $data->delivery;
	$price_per_kg = $data->price_per_kg;
	$price+= calculateMoreWeight($total_weight, $price_per_kg);
	$price = $eshop->applyShippingDiscount($price);
	$fixed_shipping_cost = (float)$parameters->getParameter("fixed_shipping_cost");	
	$price = (!empty($fixed_shipping_cost)) ? $fixed_shipping_cost : $price;
	require("shipping_rules.php");
	$total_weight = (!$total_weight) ? 1 : $total_weight; // do not permit zero total weight
	if(($free_shipping_order && $total_cost > $free_shipping_order) || !$total_weight) $price = "free";
	return "ok_".$price."_".$delivery;
}

function calculateMoreWeight($total_weight, $price_per_kg){
	if($total_weight <= 2) return 0; // no any price raising
	$more_weight = ceil($total_weight - 2);
	$more_price = $price_per_kg * $more_weight;
	return $more_price;
}

function isGreekDestination($countryID){
	global $db;
	$greeceID = $db->getRecord("select id from countries where alias='ellada'")->id;
	return ($greeceID == $countryID);
}

?>