<?php
/*
Odyssey auto controller file
$this is a reference to $document
*/


include("config/odyssey.ini.php");
global $library;
foreach($library as $class) global ${$class}; // import library classes
global $langID;
$sectionID = $this->sectionID;
$_SESSION['sectionCssFile'] = $this->getTemplatePath().$this->cssFilePath.$this->section.".css";
$sectionJsFile = $this->getTemplatePath().$this->jsFilePath.$this->section.".js";
$sectionJsReadyFile = $this->getTemplatePath().$this->jsFilePath.$this->section."_ready.js";

// get js & css files from db for this section
$record = $db->getRecord("select jsFiles, cssFiles from sections where id='$sectionID'");
$registeredJsFiles = explode(PHP_EOL, $record->jsFiles);
$registeredCssFiles = explode(PHP_EOL, $record->cssFiles);

// add any other scripts that have been registered for this section
$jsFiles = array();
foreach($registeredJsFiles as $jsFile){
	list($prefix, $filename) = explode("|", $jsFile);
	if($prefix=="system") $jsFile = $this->jsFilePath.$filename;
	if($prefix=="template") $jsFile = $this->getTemplatePath().$this->jsFilePath.$filename;
	$jsFiles[] = $jsFile;
}
$jsFiles = $variables->removeEmptyRows($jsFiles);


// add any other css files that have been registered for this section
$cssFiles = array();
foreach($registeredCssFiles as $cssFile){
	list($prefix, $filename) = explode("|", $cssFile);
	if($prefix=="system") $cssFile = $this->cssFilePath.$filename;
	if($prefix=="template") $cssFile = $this->getTemplatePath().$this->cssFilePath.$filename;
	$cssFiles[] = $cssFile;	
}
$cssFiles = $variables->removeEmptyRows($cssFiles);




// start auto controller

$thisView = $this->view;
$auth = new authentication(false);
$login = $auth->getLoginStatus() != 2;
global $order;
$order[$this->defaultIndex] = $this->defaultIndex.".sort";
if($system->getSectionProperty($this->section, "sortType") && empty($order[$this->section])) $order[$this->section] = $this->section.".sort";

if(in_array($thisView, array('list', 'search', $this->defaultIndex))){

	$doNotPassData = false;
	$submitExists = false;

	foreach($safeRequest as $key=>$value){
		if(preg_match('/_from$/i', $key) || preg_match('/_to$/i', $key)) ${$key} = urldecode(${$key});
		if($thisView == "search") {
			if(preg_match('/submit/i', $key)) $submitExists = true;
			if(preg_match('/submit/i', $key) && empty(${$key}))	$doNotPassData = true; // do not proceed searching if no submit value is present
		}
	}
	if($thisView == "search" && !$submitExists) $doNotPassData = true; // do not proceed searching if no submit action is present
	$frecords = $db->getRecords("select fieldVarName, fieldDescription, fieldType, selectType, selectTableSectionName, isMainTitle 
												from `fields` 
												where tableSectionID='$sectionID' 
												and access='0' 
												order by sort");		
	if(!count($frecords)){
		$messages->addError(t("Δεν βρέθηκαν καταχωρημένα πεδία σε αυτή την ενότητα"));
		$doNotPassData = true;
	}	

	// start building the query...
	$statuses = array();
	$cityExists = false;
	$countyExists = false;

	foreach($frecords as $field){
		$fieldVarName = $field->fieldVarName;
		$fieldDescription = $field->fieldDescription;
		$fieldType = $field->fieldType;
		$selectType = $field->selectType;
		$selectTableSectionName = $field->selectTableSectionName;
		$isMainTitle = $field->isMainTitle;
		if($field->fieldVarName == "cityID") $cityExists = true;
		if($field->fieldVarName == "countyID") $countyExists = true;
		$status = $system->getFieldStatus($fieldVarName, $sectionID)->status;
		$multi = ($fieldType=="selectList") ? "_multi" : null;
		if($status) $statuses[$fieldVarName] = $status.$multi;
	}
	
	

	
	
	$selectlists = null;
	$searchForCategories = array();	
	$searchForNumbers = array();
	$searchForDates = array();
	$searchForFlags = array();
	$searchForSections = array();
	
	foreach($statuses as $key=>$value){  // search for categories
		if(preg_match('/^category/', $value)) $searchForCategories[] = $key;
		if(isset(${$key})){
			if(preg_match('/^category/', $value)){ // category
				if(!($thisView == "search" && empty(${$key}))){ // in case of search without category criteria don not include category value
					if(preg_match('/_multi$/', $value)){ // one to many relation
						$selectlists = true;
						$fieldID = $system->getFieldID($key, $sectionID);
						$q.="and (selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=$section.id and selectlists.optionID='".${$key}."') ";
					}else{ // one to one relation
						$q.="and $section.".$key."='".${$key}."' ";
					}
				}
			}	
		}
	}
	

	$keyword = (preg_match('/^'.t("Αναζήτηση").'/', $keyword)) ? NULL : $keyword;
	if($keyword){
		$foundKeyword = false;
		foreach($statuses as $key=>$value){ // search for keywords
			if($value == "keyword"){
				$q.= (!$foundKeyword) ? "and (" : "or ";
				$isMultilingual = $system->isMultilingualField($key, $sectionID);
				$sectionName = ($isMultilingual == "1") ? "content_".$section : $section;
				$q.=$sectionName.".".$key." like '%".$keyword."%' ";
				$foundKeyword = true;
			}
		}
		if($foundKeyword) $q.=") ";
	}
	
	$isNumRange = false;
	foreach($statuses as $key=>$value){  // search for numbers
		if($value == "number") $searchForNumbers[] = $key;
		if(isset(${$key}) || isset(${$key."_from"}) || isset(${$key."_to"})){
			if($value == "number"){
				if(${$key."_from"}){ // starting limit value of a range
					$q.="and $section.".$key." >= ".${$key."_from"}." ";	
					$isNumRange = true;					
				}
				if(${$key."_to"}){ // ending limit value of a range
					$q.="and $section.".$key." <= ".${$key."_to"}." ";	
					$isNumRange = true;						
				}
				if(${$key."_from"} &&  ${$key."_to"}){ // check for valid range values
					$fieldDescription = $system->getFieldDescription($key, $sectionID);
					if(${$key."_from"} > ${$key."_to"}) {
						$messages->addError(sprintf(t("Σφάλμα στο πεδίο")." [%s]:", $fieldDescription));	
						$messages->addError(t("Η τιμή «από» πρέπει να είναι μικρότερη ή ίση της τιμής «έως»"));	
					}
				}					
				if(!$isNumRange && !empty(${$key})){ // just return equality
					$q.="and $section.".$key." = ".${$key}." ";	
				}
			}
		}
	}		
	
	$isDateRange = false;
	foreach($statuses as $key=>$value){  // search for dates
		if($value == "date") $searchForDates[] = $key;
		if(isset(${$key}) || isset(${$key."_from"}) || isset(${$key."_to"})){
			if($value == "date"){
				
				if(${$key."_from"}){ // starting limit value of a range
					${$key."_from"} = $dates->makeTimestamp(${$key."_from"});
					$q.="and $section.".$key." >= ".${$key."_from"}." ";	
					$isDateRange = true;					
				}
				if(${$key."_to"}){ // ending limit value of a range
					${$key."_to"} = $dates->makeTimestamp(${$key."_to"});
					$q.="and $section.".$key." <= ".${$key."_to"}." ";	
					$isDateRange = true;						
				}
				if(${$key."_from"} &&  ${$key."_to"}){ // check for valid range values
					$fieldDescription = $system->getFieldDescription($key, $sectionID);
					if(${$key."_from"} > ${$key."_to"}) {
						$messages->addError(sprintf(t("Σφάλμα στο πεδίο")." [%s]:", $fieldDescription));
						$messages->addError(t("Η ημερομηνία «από» πρέπει να είναι προγενέστερη ή ίση της ημερομηνίας «έως»"));
					}
				}					
				if(!$isDateRange && !empty(${$key})){ // just return equality
					${$key} = $dates->makeTimestamp(${$key});
					$q.="and $section.".$key." = ".${$key}." ";	
				}
			}
		}
	}	

	foreach($statuses as $key=>$value){  // search for flags (checkboxes)
		if($value == "flag") $searchForFlags[] = $key;
		if(isset(${$key})){
			if($value == "flag" && !empty(${$key}))	{
				$q.="and $section.".$key." = 1 ";	
			}
		}
	}
	
	foreach($statuses as $key=>$value){  // search for section releations
		if($value == "section" || $value == "section_multi") $searchForSections[] = $key;
		if(isset(${$key}) && !empty(${$key})){
			if($value == "section" || $value == "section_multi") {
				if(preg_match('/_multi$/', $value)){ // one to many relation
					$selectlists = true;
					$fieldID = $system->getFieldID($key, $sectionID);
					$q.="and (selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=$section.id and selectlists.optionID='".${$key}."') ";						
				}else{ // one to one relation
					$q.="and $section.".$key."='".${$key}."' ";
				}
			}
		}
	}
	
	// if the current user is unregistered or the loged user has level One permissions (just commenting and viewing only public content) exclude private content from query
	if(!$login || $login==1) $q.=" and $section.private=1 "; // private=1 equals to public records		
	
	$masterQuery="select distinct count($section.id) as total from $section, content_$section";
	if($selectlists) $masterQuery.=", selectlists";
	if($countyID){
		$doNotPassData = false;
		$submitExists = true;
		if($cityExists){
			$masterQuery.=", cities";
			$q.="and cities.id=$section.cityID and cities.countyID='$countyID' ";
		}elseif($countyExists){
			
		}		
	}
	
	$masterQuery.= " where $section.id=content_$section.mainID and $section.active=1 and content_$section.title <> '' and content_$section.langID='$langID' ";	
	$masterQuery.=$q; // apend the rest generated subquery
	$numOfAllItems = $db->getRecord($masterQuery)->total;

	if((preg_match('/catID=/', $masterQuery) || $selectlists) && !$numOfAllItems){ // let's see if its a subcategories listing
		$catQuery = "select distinct ".$section."_categories.*, content_".$section."_categories.title, content_".$section."_categories.minitext 
							from ".$section."_categories, content_".$section."_categories 
							where ".$section."_categories.parent='$catID' 
							and content_".$section."_categories.catID=".$section."_categories.id 
							and content_".$section."_categories.langID='$langID'";
		$catItems = $db->getRecords($catQuery);
		$hasSubcategories = count($catItems);	
	}
	
	if(!$numOfAllItems && !$hasSubcategories) $messages->addError(t("Δεν βρέθηκαν καταχωρημένες εγγραφές"));
	
	if($numOfAllItems){
		$presults = $system->getPresults($section);
		$page = (int)$_GET['ppage'];
		$maxrows = $numOfAllItems;
		$page = ($page > 0) ? $page : 1;
		$startrecord=($page * $presults) - $presults;
		$startrecord=($startrecord < 0) ? 0 : $startrecord;

		$masterQuery="select distinct $section.* "; // start building the final query
		foreach($frecords as $frecord){
				$isMultilingual = $system->isMultilingualField($frecord->fieldVarName, $sectionID);
				if($isMultilingual) $masterQuery.=", content_".$section.".".$frecord->fieldVarName;
		}
		$masterQuery.=" from ".$section.", content_".$section;
		if($selectlists) $masterQuery.=", selectlists";		
		if($countyID){
			if($cityExists){
				$masterQuery.=", cities";
			}elseif($countyExists){
				
			}
			
		}				
		$masterQuery.= " where $section.id=content_$section.mainID and $section.active=1 and content_$section.langID='$langID' ";
		$masterQuery.=$q; // apend the rest generated subquery
		$orderby = (!empty($order[$section])) ? $order[$section] : $section.".id DESC, content_".$section.".title";
		$masterQuery.=" order by ".$orderby." LIMIT $startrecord, $presults";
		if($numOfAllItems == 1){
			$item = $db->getRecord($masterQuery);
			$id = $item->id;
			$url = $sef->url("index.php?section=".$section."&view=node&id=".$id, false);
			global $protocol;
			$url = $protocol."://".$domain_name."/".$url;
			?>
            <script type="text/javascript">document.location.href="<?php echo $url;?>";</script>
            <?php
			exit;
		}
		$items = $db->getRecords($masterQuery);
	}else{
		$items = $catItems; // return the subcategories object
	}
}


$views = array();
$viewsFiles =  $this->getTemplatePath().'view_'.$this->section.'_*.php';
foreach(glob($viewsFiles) as $viewFile){
	if(is_file($viewFile)){
		if(!preg_match('/_list.php$/', $viewFile) && !preg_match('/_search.php$/', $viewFile)){
			$baseName = explode("_", $fileSystem->getFileBaseName($viewFile));
			$views[] = end($baseName);
		}
	}
}

if(in_array($thisView, $views)){
	$id = (int)$id;
	$item = $content->getContentByID($this->section, $id, "*", "*", $langID);
	$multi_categories = $categories->getMultiCategories($this->sectionID, $id);
	if(!$item) $messages->addError(t("Η συγκεκριμένη εγγραφή δεν βρέθηκε"));
}
  

// seo settings
$seoNotFound = true;
if($id){
	$seoQuery = "select * from `seo` where sectionID='$this->sectionID' and itemId='$id' and langID='$langID'";
	$seo = $db->getRecord($seoQuery);
	if(!$seo){
		$seoNotFound = true;
	}else{
		$seoNotFound = (empty($seo->title) && empty($seo->description) && empty($seo->keywords) && empty($seo->meta));
	}
	if(!$seoNotFound){ // specific seo settings found
		if($seo->title) $this->setHtmlTitle($seo->title, !$seo->overwrite_title); // in case of true in second argument, the append behavior will be activated
		$meta = array(
		'<meta name="description" content="'.$seo->description.'">',
		'<meta name="keywords" content="'.$seo->keywords.'">'
		);	
		$meta_entries = explode(PHP_EOL, $seo->meta);
		$meta = array_merge($meta, $meta_entries);
		$this->setMeta($meta);	
	}
}
if($seoNotFound){ // general settings
$words = "";
// add a description for this section
if($catID){
	$catPath = $categories->getPath($catID, $section.'_categories');
	$breadcrumb = array();
	foreach($catPath as $node){
		$breadcrumb[] = $categories->getCategoryName($node, "content_".$section."_categories", $langID);
	}
	$keywords = implode(", ", $breadcrumb);
	$separator = $this->appendMark;
	$breadcrumb = implode($separator, $breadcrumb);
	if($breadcrumb) $breadcrumb.=$separator;
	$sectionDescription = $breadcrumb.$categories->getCategoryName($catID, "content_".$section."_categories", $langID);
	$keywords.= ", ".$categories->getCategoryName($catID, "content_".$section."_categories", $langID);
}
if($breadcrumb) $words.= $keywords.", ";
if($id) $sectionDescription = $item->title;
// add general meta tags
$words.= t($parameters->getParameter('keywords'));
$meta = array(
'<meta name="description" content="'.$sectionDescription.'">',
'<meta name="keywords" content="'.$words.'">'
);
$theTitle = ($thisView == "search") ? t("Αναζήτηση") : $sectionDescription;
$this->setHtmlTitle($theTitle, true); // true to activate the append behavior
$this->setMeta($meta);
}


// add js and css files for this section
$this->setStyles($cssFiles);
$this->setJsFiles($sectionJsFile);
$this->setJsFiles($jsFiles);
$this->setJsReady(is_file($sectionJsReadyFile) ? file_get_contents($sectionJsReadyFile) : NULL);

if($doNotPassData){
	unset($items, $numOfAllItems, $maxrows);
}

$controllerVars = array('controllerVars',  'keyword', 'items', 'item', 'numOfAllItems', 'maxrows', 'page', 'presults', 'doNotPassData', 'searchForCategories', 'searchForNumbers', 'searchForDates', 'searchForFlags', 'searchForSections', 'countyID', 'hasSubcategories', 'multi_categories', 'breadcrumb'); // standard controller variables  passing to the view
foreach($safeRequest as $key=>$value){ // check if there are specific variables that must pass to the view
	if(preg_match('/ID$/', $key)) $controllerVars[]=$key; // any ID vars
	if(preg_match('/_from$/i', $key) || preg_match('/_to$/', $key)) $controllerVars[]=$key; // any limits vars
	if(preg_match('/submit/i', $key)) $controllerVars[]=$key;	 // any submits vars
	if(in_array($key, array_keys($statuses))) $controllerVars[]=$key; // vars that been set as search criteria
}
$controllerVars = array_unique($controllerVars);
// pass the selected vars to the current view
foreach($controllerVars as $var){
	$this->$var = ${$var};
	$this->setData($this->$var);
}
?>