<?php
/*
Odyssey auto controller file
$this is a reference to $document
*/


include("config/odyssey.ini.php");
global $library;
foreach($library as $class) global ${$class}; // import library classes
global $langID;
$sectionID = $this->sectionID;
$_SESSION['sectionCssFile'] = $this->getTemplatePath().$this->cssFilePath.$this->section.".css";
$sectionJsFile = $this->getTemplatePath().$this->jsFilePath.$this->section.".js";
$sectionJsReadyFile = $this->getTemplatePath().$this->jsFilePath.$this->section."_ready.js";

// get js & css files from db for this section
$record = $db->getRecord("select jsFiles, cssFiles from sections where id='$sectionID'");
$registeredJsFiles = explode(PHP_EOL, $record->jsFiles);
$registeredCssFiles = explode(PHP_EOL, $record->cssFiles);

// add any other scripts that have been registered for this section
$jsFiles = array();
foreach($registeredJsFiles as $jsFile){
	list($prefix, $filename) = explode("|", $jsFile);
	if($prefix=="system") $jsFile = $this->jsFilePath.$filename;
	if($prefix=="template") $jsFile = $this->getTemplatePath().$this->jsFilePath.$filename;
	$jsFiles[] = $jsFile;
}
$jsFiles = $variables->removeEmptyRows($jsFiles);


// add any other css files that have been registered for this section
$cssFiles = array();
foreach($registeredCssFiles as $cssFile){
	list($prefix, $filename) = explode("|", $cssFile);
	if($prefix=="system") $cssFile = $this->cssFilePath.$filename;
	if($prefix=="template") $cssFile = $this->getTemplatePath().$this->cssFilePath.$filename;
	$cssFiles[] = $cssFile;	
}
$cssFiles = $variables->removeEmptyRows($cssFiles);




// start auto controller

$thisView = $this->view;
$auth = new authentication(false);
$login = $auth->getLoginStatus() != 2;
$order[$this->defaultIndex] = "sort";
if($system->getSectionProperty($this->section, "sortType")) $order[$this->section] = "sort";
if($_REQUEST['custom_order'] == 1) $custom_order = "products.id DESC";
if($_REQUEST['custom_order'] == 2) $custom_order = "content_products.title ASC"; // alphabetically
if($_REQUEST['custom_order'] == 3) $custom_order = "products.price ASC";
if($_REQUEST['custom_order'] == 4) $custom_order = "products.price DESC";
if($_REQUEST['custom_order'] == 5) $custom_order = "products.views ASC, products.id DESC";

if(in_array($thisView, array('list', 'search', $this->defaultIndex))){


	$doNotPassData = false;
	$submitExists = false;

	foreach($safeRequest as $key=>$value){
		if(preg_match('/_from$/i', $key) || preg_match('/_to$/i', $key)) ${$key} = urldecode(${$key});
		if($thisView == "search") {
			if(preg_match('/submit/i', $key)) $submitExists = true;
			if(preg_match('/submit/i', $key) && empty(${$key}))	$doNotPassData = true; // do not proceed searching if no submit value is present
		}
	}
	if($thisView == "search" && !$submitExists) $doNotPassData = true; // do not proceed searching if no submit action is present
	$frecords = $db->getRecords("select fieldVarName, fieldDescription, fieldType, selectType, selectTableSectionName, isMainTitle 
												from `fields` 
												where tableSectionID='$sectionID' 
												and access='0' 
												order by sort");		
	if(!count($frecords)){
		$messages->addError(t("Δεν βρέθηκαν καταχωρημένα πεδία σε αυτή την ενότητα"));
		$doNotPassData = true;
	}	

	// start building the query...
	$statuses = array();
	$cityExists = false;
	$countyExists = false;
	if(isset($catID) && empty($catID)) unset($catID);

	foreach($frecords as $field){
		$fieldVarName = $field->fieldVarName;
		$fieldDescription = $field->fieldDescription;
		$fieldType = $field->fieldType;
		$selectType = $field->selectType;
		$selectTableSectionName = $field->selectTableSectionName;
		$isMainTitle = $field->isMainTitle;
		if($field->fieldVarName == "cityID") $cityExists = true;
		if($field->fieldVarName == "countyID") $countyExists = true;
		$status = $system->getFieldStatus($fieldVarName, $sectionID)->status;
		$multi = ($fieldType=="selectList") ? "_multi" : NULL;
		if($status) $statuses[$fieldVarName] = $status.$multi;
	}
	
	$searchForCategories = array();	
	$searchForNumbers = array();
	$searchForDates = array();
	$searchForFlags = array();
	$searchForSections = array();
	$brands_array = array();
	$variants_array = array();
	$queries = array();	
	$joins = array("content_products");
	$join_selectlists = array();
	//$join_features = array();
	$join_content_products = array();

	
	foreach($statuses as $key=>$value){  // search for categories
		if(preg_match('/^category/', $value)) $searchForCategories[] = $key;
		if(isset(${$key})){
			if(preg_match('/^category/', $value)){ // category
				if(!($thisView == "search" && empty(${$key}))){ // in case of search without category criteria don not include category value
					if(preg_match('/_multi$/', $value)){ // one to many relation
						if(!in_array("selectlists", $joins)) $joins[] = "selectlists";
						$fieldID = $system->getFieldID($key, $sectionID);
						$join_selectlists[] = "(selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=$section.id and selectlists.optionID='".${$key}."')";
					}else{ // one to one relation
						$queries[] = "products.".$key."='".${$key}."'";
					}
				}
			}	
		}
	}
	


	$keyword = (preg_match('/^'.t("Αναζήτηση").'/', $keyword)) ? NULL : $keyword;
	if($keyword){
		$foundKeyword = false;
		$foundMLKeyword = false;
		$q = "";
		$qML = "";
		foreach($statuses as $key=>$value){ // search for keywords
			if($value == "keyword"){
				$isMultilingual = $system->isMultilingualField($key, $sectionID);		
				
				if($isMultilingual == "1" || $key == "code"){
					$concat = (!$foundMLKeyword) ? "(" : " or ";
					if($key != "code"){					
						$qML.= $concat."content_products.".$key." like '%".$keyword."%'";
					}else{
						$qML.= $concat."products.".$key." like '%".$keyword."%'";
					}
					$foundMLKeyword = true;
					
				}else{
					if($key != "code"){
						$concat = (!$foundKeyword) ? "(" : " or ";
						$q.= $concat."products.".$key." like '%".$keyword."%'";
						$foundKeyword = true;	
					}
				}
			}
		}
		if($foundKeyword){
			$q.=")";
			$queries[] = $q;
		}
		if($foundMLKeyword){
			$qML.=")";
			$join_content_products[] = $qML;
		}
	}
		
	if($prices){
		list($price_from, $price_to) = explode("|", $prices);
		$include_vat = (int)$parameters->getParameter("include_vat");
		if($include_vat){
			$vat = $content->getValue("fpa_cat", $parameters->getParameter("default_vat"), "percent", $langID);
			$factor = 1 + (float)($vat/100);
			$price_from = round($price_from / $factor);
			$price_to = round($price_to / $factor);
		}
	}
	if($brands){
		$brands_array = explode("|", $brands);
		$brandIDs = implode(",", $brands_array);
	}
	if($variants){
		$variants_array = explode("|", $variants);
		$variantIDs = implode(",", $variants_array);
	}
	
	
	$isNumRange = false;
	foreach($statuses as $key=>$value){  // search for numbers
		if($value == "number") $searchForNumbers[] = $key;
		if(isset(${$key}) || isset(${$key."_from"}) || isset(${$key."_to"})){
			if($value == "number"){
				if(${$key."_from"}){ // starting limit value of a range
					$queries[] = "products.".$key." >= ".${$key."_from"};	
					$isNumRange = true;					
				}
				if(${$key."_to"}){ // ending limit value of a range
					$queries[] = "products.".$key." <= ".${$key."_to"};	
					$isNumRange = true;						
				}
				if(${$key."_from"} &&  ${$key."_to"}){ // check for valid range values
					$fieldDescription = $system->getFieldDescription($key, $sectionID);
					if(${$key."_from"} > ${$key."_to"}) {
						$messages->addError(sprintf(t("Σφάλμα στο πεδίο")." [%s]:", $fieldDescription));	
						$messages->addError(t("Η τιμή «από» πρέπει να είναι μικρότερη ή ίση της τιμής «έως»"));	
					}
				}					
				if(!$isNumRange && !empty(${$key})){ // just return equality
					$queries[] = "products.".$key." = ".${$key};	
				}
			}
		}
	}
	
	if($isNumRange) $queries[] = "products.price > 0";		
	
	foreach($statuses as $key=>$value){  // search for flags (checkboxes)
		if($value == "flag") $searchForFlags[] = $key;
		if(isset(${$key})){
			if($value == "flag" && !empty(${$key}))	{
				$queries[] = "products.".$key." = 1";	
			}
		}
	}
	
	foreach($statuses as $key=>$value){  // search for section releations
		if($value == "section" || $value == "section_multi") $searchForSections[] = $key;
		if(isset(${$key}) && !empty(${$key})){
			if($value == "section" || $value == "section_multi") {
				if(preg_match('/_multi$/', $value)){ // one to many relation
					if(!in_array("selectlists", $joins)) $joins[] = "selectlists";
					$fieldID = $system->getFieldID($key, $sectionID);
					$join_selectlists[] = "(selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=$section.id and selectlists.optionID='".${$key}."')";
				}else{ // one to one relation
					$queries[] = "products.".$key."='".${$key}."' ";
				}
			}
		}
	}
	
	if($brandIDs) $queries[] = "products.brandID IN (".$brandIDs.")";
	if($variantIDs) $productIDs = $eshop->getProductsByFilters($variantIDs);
	
	// if the current user is unregistered or the loged user has level One permissions (just commenting and viewing only public content) exclude private content from query
	if(!$login || $login==1) $queries[] ="products.private=1"; // private=1 equals to public records		
	
	$masterQuery = "select distinct products.id from products";
	foreach($joins as $join){
		$masterQuery.= " join ".$join." on ";
		if($join == "content_products") $masterQuery.= "content_products.mainID=products.id and content_products.title <> '' and content_products.langID='".$langID."'";
		$index = 0;
		$count = count(${"join_".$join});
		foreach(${"join_".$join} as $join_query){
			if($join == "content_products") $masterQuery.= " and ";				
			$masterQuery.= $join_query;
			if(($index + 1) < $count){
				$masterQuery.= " and ";
			}
			$index++;
		}
	}
	
	$masterQuery.= " where products.active=1 ";	
	foreach($queries as $query){
		$masterQuery.= " and ".$query." ";
	}
	
	if($productIDs) $masterQuery.= "and products.id IN (".$productIDs.")";	
		
	
	$pIDs = $db->getRecords($masterQuery);
	// exclude IDs
	$excludedIDs = array();
	$IDs = array();
	foreach($pIDs as $record){
		$hasAccess = $eshop->hasAccess($record->id);
		//$hasPriceAccess = (empty($prices)) ? true : $eshop->hasAccess($record->id, "show_price");
		if(!$hasAccess){
			$excludedIDs[] = $record->id;
		}else{
			$IDs[] = $record->id;
		}
	}
	
	//debug($masterQuery);
	
	$numOfAllItems = count($pIDs) - count($excludedIDs);
	$excludedIDs = implode(",", $excludedIDs);
	$IDs = implode(",", $IDs);

	
	if($catID && !$numOfAllItems){ // let's see if its a subcategories listing
		$fieldID = $system->getFieldID("catID", $sectionID);	
		$catQuery = "select distinct ".$section."_categories.*, content_".$section."_categories.title, content_".$section."_categories.minitext 
							from ".$section."_categories, content_".$section."_categories, selectlists  
							WHERE ".$section."_categories.id=selectlists.optionID 
							and ".$section."_categories.parent='$catID' 
							and selectlists.sectionID=".$sectionID."  
							and selectlists.fieldID=".$fieldID." 							
							and content_".$section."_categories.catID=".$section."_categories.id 
							and content_".$section."_categories.langID='$langID' 
							order by ".$section."_categories.sort, content_".$section."_categories.title";
									
		$catItems = $db->getRecords($catQuery);
		$hasSubcategories = count($catItems);	
	}
	
	if($variantIDs && !$productIDs) $numOfAllItems = 0;
	
	if($numOfAllItems){
		$queries = array();	
		$joins = array("content_products");
		$join_selectlists = array();
		$join_features = array();
		$join_content_products = array();
		
		foreach($statuses as $key=>$value){  // search for categories
			if(preg_match('/^category/', $value)) $searchForCategories[] = $key;
			if(isset(${$key})){
				if(preg_match('/^category/', $value)){ // category
					if(!($thisView == "search" && empty(${$key}))){ // in case of search without category criteria don not include category value
						if(preg_match('/_multi$/', $value)){ // one to many relation
							if(!in_array("selectlists", $joins)) $joins[] = "selectlists";
							$fieldID = $system->getFieldID($key, $sectionID);
							$join_selectlists[] = "(selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=$section.id and selectlists.optionID='".${$key}."')";
						}else{ // one to one relation
							$queries[] = "products.".$key."='".${$key}."'";
						}
					}
				}	
			}
		}
		
	
		$keyword = (preg_match('/^'.t("Αναζήτηση").'/', $keyword)) ? NULL : $keyword;
		if($keyword){
			$foundKeyword = false;
			$foundMLKeyword = false;
			$q = "";
			$qML = "";
			foreach($statuses as $key=>$value){ // search for keywords
				if($value == "keyword"){
					$isMultilingual = $system->isMultilingualField($key, $sectionID);		
					
					if($isMultilingual == "1" || $key == "code"){
						$concat = (!$foundMLKeyword) ? "(" : " or ";
						if($key != "code"){					
							$qML.= $concat."content_products.".$key." like '%".$keyword."%'";
						}else{
							$qML.= $concat."products.".$key." like '%".$keyword."%'";
						}
						$foundMLKeyword = true;
						
					}else{
						if($key != "code"){
							$concat = (!$foundKeyword) ? "(" : " or ";
							$q.= $concat."products.".$key." like '%".$keyword."%'";
							$foundKeyword = true;	
						}
					}
				}
			}
			if($foundKeyword){
				$q.=")";
				$queries[] = $q;
			}
			if($foundMLKeyword){
				$qML.=")";
				$join_content_products[] = $qML;
			}
			
		}
			
		if($prices){
			list($price_from, $price_to) = explode("|", $prices);
			$include_vat = (int)$parameters->getParameter("include_vat");
			if($include_vat){
				$vat = $content->getValue("fpa_cat", $parameters->getParameter("default_vat"), "percent", $langID);
				$factor = 1 + (float)($vat/100);
				$price_from = round($price_from / $factor);
				$price_to = round($price_to / $factor);
			}
		}
		if($brands){
			$brands_array = explode("|", $brands);
			$brandIDs = implode(",", $brands_array);
		}
		if($variants){
			$variants_array = explode("|", $variants);
			$variantIDs = implode(",", $variants_array);
		}
		
		
		$isNumRange = false;
		foreach($statuses as $key=>$value){  // search for numbers
			if($value == "number") $searchForNumbers[] = $key;
			if(isset(${$key}) || isset(${$key."_from"}) || isset(${$key."_to"})){
				if($value == "number"){
					if(${$key."_from"}){ // starting limit value of a range
						$queries[] = "products.".$key." >= ".${$key."_from"};	
						$isNumRange = true;					
					}
					if(${$key."_to"}){ // ending limit value of a range
						$queries[] = "products.".$key." <= ".${$key."_to"};	
						$isNumRange = true;						
					}
					if(${$key."_from"} &&  ${$key."_to"}){ // check for valid range values
						$fieldDescription = $system->getFieldDescription($key, $sectionID);
						if(${$key."_from"} > ${$key."_to"}) {
							$messages->addError(sprintf(t("Σφάλμα στο πεδίο")." [%s]:", $fieldDescription));	
							$messages->addError(t("Η τιμή «από» πρέπει να είναι μικρότερη ή ίση της τιμής «έως»"));	
						}
					}					
					if(!$isNumRange && !empty(${$key})){ // just return equality
						$queries[] = "products.".$key." = ".${$key};	
					}
				}
			}
		}
		
		if($isNumRange) $queries[] = "products.price > 0";		
		
		foreach($statuses as $key=>$value){  // search for flags (checkboxes)
			if($value == "flag") $searchForFlags[] = $key;
			if(isset(${$key})){
				if($value == "flag" && !empty(${$key}))	{
					$queries[] = "products.".$key." = 1";	
				}
			}
		}
		
		foreach($statuses as $key=>$value){  // search for section releations
			if($value == "section" || $value == "section_multi") $searchForSections[] = $key;
			if(isset(${$key}) && !empty(${$key})){
				if($value == "section" || $value == "section_multi") {
					if(preg_match('/_multi$/', $value)){ // one to many relation
						if(!in_array("selectlists", $joins)) $joins[] = "selectlists";
						$fieldID = $system->getFieldID($key, $sectionID);
						$join_selectlists[] = "(selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=$section.id and selectlists.optionID='".${$key}."')";
					}else{ // one to one relation
						$queries[] = "products.".$key."='".${$key}."' ";
					}
				}
			}
		}
		
		if($brandIDs) $queries[] = "products.brandID IN (".$brandIDs.")";
			
		
		// if the current user is unregistered or the loged user has level One permissions (just commenting and viewing only public content) exclude private content from query
		if(!$login || $login==1) $queries[] ="products.private=1 "; // private=1 equals to public records	
		
		$q2 = "select min(products.price) as min_price, max(products.price) as max_price from products, selectlists where price > 0 ";
		if($catID){
			$fieldID = $system->getFieldID("catID", $sectionID);
			$q2.="and (selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=products.id and selectlists.optionID='".$catID."') ";			
		}
		if($excludedIDs) $q2.="and products.id NOT IN (".$excludedIDs.")";
		$price_limits = $db->getRecord($q2);
		$min_price = $price_limits->min_price;
		$max_price = $price_limits->max_price;
		$presults = $system->getPresults($section);
		$page = (int)$_GET['ppage'];
		$maxrows = $numOfAllItems;
		$page = ($page > 0) ? $page : 1;
		$startrecord=($page * $presults) - $presults;
		$startrecord=($startrecord < 0) ? 0 : $startrecord;
				
		$masterQuery="select distinct products.* "; // start building the final query
		foreach($frecords as $frecord){
				$isMultilingual = $system->isMultilingualField($frecord->fieldVarName, $sectionID);
				if($isMultilingual) $masterQuery.=", content_".$section.".".$frecord->fieldVarName;
		}
		$masterQuery.= " from products ";
		if(!$hasSubcategories && $excludedIDs) $queries[] = "products.id NOT IN (".$excludedIDs.") ";
		
		foreach($joins as $join){
			$masterQuery.= " join ".$join." on ";
			if($join == "content_products") $masterQuery.= "content_products.mainID=products.id and content_products.title <> '' and content_products.langID='".$langID."'";
			$index = 0;
			$count = count(${"join_".$join});
			foreach(${"join_".$join} as $join_query){
				if($join == "content_products") $masterQuery.= " and ";				
				$masterQuery.= $join_query;
				if(($index + 1) < $count){
					$masterQuery.= " and ";
				}
				$index++;
			}
		}
		$masterQuery.= " where products.active=1 ";	
		foreach($queries as $query){
			$masterQuery.= " and ".$query." ";
		}
		
		if($productIDs) $masterQuery.= "and products.id IN (".$productIDs.")";
				
		$order = (!empty($order[$section])) ? $section.".".$order[$section] : $section.".id DESC, content_".$section.".title";
		$order = ($custom_order) ? $custom_order : $order;
		$masterQuery.=" order by ".$order." LIMIT $startrecord, $presults";
		
		//debug($masterQuery);	
			
		$items = $db->getRecords($masterQuery);
	}else{
		$items = $catItems; // return the subcategories object
	}
	if(!$numOfAllItems && !$hasSubcategories) $messages->addError(t("Δεν βρέθηκαν καταχωρημένα προϊόντα"));	
}





$views = array();
$viewsFiles =  $this->getTemplatePath().'view_'.$this->section.'_*.php';
foreach(glob($viewsFiles) as $viewFile){
	if(is_file($viewFile)){
		if(!preg_match('/_list.php$/', $viewFile) && !preg_match('/_search.php$/', $viewFile)){
			$baseName = explode("_", $fileSystem->getFileBaseName($viewFile));
			$views[] = end($baseName);
		}
	}
}


if(in_array($thisView, $views)){
	$id = (int)$id;
	$item = $content->getContentByID($this->section, $id, "*", "*", $langID);
	$multi_categories = $categories->getMultiCategories($this->sectionID, $id);
	if(!$item) $messages->addError(t("Η συγκεκριμένη εγγραφή δεν βρέθηκε"));
}


// seo settings
$seoNotFound = true;
if($id){
	$seoQuery = "select * from `seo` where sectionID='$this->sectionID' and itemId='$id' and langID='$langID'";
	$seo = $db->getRecord($seoQuery);
	if(!$seo){
		$seoNotFound = true;
	}else{
		$seoNotFound = (empty($seo->title) && empty($seo->description) && empty($seo->keywords) && empty($seo->meta));
	}
	if(!$seoNotFound){ // specific seo settings found
		if($seo->title) $this->setHtmlTitle($seo->title, !$seo->overwrite_title); // in case of true in second argument, the append behavior will be activated
		$meta = array(
		'<meta name="description" content="'.$seo->description.'">',
		'<meta name="keywords" content="'.$seo->keywords.'">'
		);	
		$meta_entries = explode(PHP_EOL, $seo->meta);
		$meta = array_merge($meta, $meta_entries);
		$this->setMeta($meta);	
	}
}
if($seoNotFound){ // general settings
$words = "";
// add a description for this section
if($catID){
	$catPath = $categories->getPath($catID, $section.'_categories');
	$breadcrumb = array();
	foreach($catPath as $node){
		$breadcrumb[] = $categories->getCategoryName($node, "content_".$section."_categories", $langID);
	}
	$keywords = implode(", ", $breadcrumb);
	$separator = $this->appendMark;
	$breadcrumb = implode($separator, $breadcrumb);
	if($breadcrumb) $breadcrumb.=$separator;
	$sectionDescription = $breadcrumb.$categories->getCategoryName($catID, "content_".$section."_categories", $langID);
	$keywords.= ", ".$categories->getCategoryName($catID, "content_".$section."_categories", $langID);
}
if($breadcrumb) $words.= $keywords.", ";
if($id) $sectionDescription = $item->title;
// add general meta tags
$words.= t($parameters->getParameter('keywords'));
$meta = array(
'<meta name="description" content="'.$sectionDescription.'">',
'<meta name="keywords" content="'.$words.'">'
);
$theTitle = ($thisView == "search") ? t("Αναζήτηση") : $sectionDescription;
$this->setHtmlTitle($theTitle, true); // true to activate the append behavior
$this->setMeta($meta);
}


// add js and css files for this section
$this->setStyles($cssFiles);
$this->setJsFiles($sectionJsFile);
$this->setJsFiles($jsFiles);
$this->setJsReady(is_file($sectionJsReadyFile) ? file_get_contents($sectionJsReadyFile) : NULL);

if($doNotPassData){
	unset($items, $numOfAllItems, $maxrows);
}

$controllerVars = array('controllerVars',  'keyword', 'items', 'item', 'numOfAllItems', 'maxrows', 'page', 'presults', 'doNotPassData', 'searchForCategories', 'searchForNumbers', 'searchForDates', 'searchForFlags', 'searchForSections', 'countyID', 'hasSubcategories', 'multi_categories', 'breadcrumb', 'IDs', 'min_price', 'max_price'); // standard controller variables  passing to the view
foreach($safeRequest as $key=>$value){ // check if there are specific variables that must pass to the view
	if(preg_match('/ID$/', $key)) $controllerVars[]=$key; // any ID vars
	if(preg_match('/_from$/i', $key) || preg_match('/_to$/', $key)) $controllerVars[]=$key; // any limits vars
	if(preg_match('/submit/i', $key)) $controllerVars[]=$key;	 // any submits vars
	if(in_array($key, array_keys($statuses))) $controllerVars[]=$key; // vars that been set as search criteria
}
$controllerVars = array_unique($controllerVars);
// pass the selected vars to the current view
foreach($controllerVars as $var){
	$this->$var = ${$var};
	$this->setData($this->$var);
}
?>