<?php
define("CMS", "korCMS");
error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING ^ E_DEPRECATED); 
$rootPath = "../../";
function getFPath(){
	$parts = explode("/", $_SERVER["PHP_SELF"]);
	array_shift($parts); // the first element will be empty to we get rid of it
	array_pop($parts); // get rid of script name
	$fPath =implode("/", $parts);
	if(substr($fPath, -1) != "/") $fPath.="/";
	$fPath = ($fPath == "/") ? null : $fPath;	
	return $fPath;	
}	
function getBase(){
	global $domainPath;
	$www = preg_match('/^www/', $_SERVER['SERVER_NAME']) ? 'www.' : null;
	$parts = explode("/", $_SERVER["PHP_SELF"]);
	array_shift($parts); // the first element will be empty to we get rid of it
	array_pop($parts); // get rid of script name
	$fPath =implode("/", $parts);
	$newPath = $domainPath.$fPath;
	if(substr($newPath, -1) != "/") $newPath.="/";
	return $newPath; // for sef urls, must be a base tag in html HEAD with this value
}
function t($key, $langID=NULL, $context=NULL){ // shortcut of $language->getText($key, $langID=NULL, $context=NULL)
	global $language;
	return $language->getText($key, $langID, $context);
}
function debug($var){
	echo "<pre>";
	var_dump($var);
	echo "</pre>".PHP_EOL;
}
include($rootPath."config/odyssey.ini.php");
include($rootPath."library/db.php");
include($rootPath."library/system.php");
include($rootPath."library/messages.php");
include($rootPath."library/variables.php");
include($rootPath."library/language.php");
include($rootPath."library/parameters.php");
include($rootPath."library/content.php");
include($rootPath."library/fileSystem.php");
include($rootPath."library/imageResize.php");
include($rootPath."library/authentication.php");
include($rootPath."library/document.php");
include($rootPath."library/sef.php");
$sef = new sef();
$db = new db();
$system = new system();
$messages = new messages();
$variables = new variables();
$language = new language();
$parameters = new parameters();
$content = new content();
$fileSystem = new fileSystem();
$imageResize = new imageResize();
$authentication = new authentication(false, true);
$document = new document(null, null, true);
$db->query("SET NAMES 'utf8mb4'");

// an admin user must be authenticated in order to access this settings page
if($authentication->getAdminLevel() == -100){ 
	die("Only an admin can access this page");
}
// end authentication


$templateSystemName = $document->getDefaultTemplate();
$templateID = $document->getTemplateID($templateSystemName);
$templateName = $content->getValue("templates", $templateID, "title", $langID);
$dbTable = "template_settings_".$templateSystemName;

if($action == "remove" && $saveSettings){
	$defaultTemplate = $document->template;

	if($templateToRemove && $templateToRemove != $defaultTemplate){
		$dbTable = "template_settings_".$templateToRemove;
		$sql="DROP TABLE IF EXISTS $dbTable";
		$db->query($sql);
	}
	?>
    <script type="text/javascript">
	parent.$.fancybox.close();
    </script>
    <?php
	exit;
}

$xmlFile = "settings.xml";
if(!is_file($xmlFile)) die("Settings XML not found!");
$data = simplexml_load_file($xmlFile);
$xmlTemplateName = $data->attributes()->template;
if($templateToRemove) $templateSystemName = $templateToRemove;
if($templateSystemName != $xmlTemplateName) die("Settings XML refers to other template");
$xmlSettings = array();
$fieldsTypes = array();
$default_values = array("id"=>"1");
foreach($data->sql->field as $node){
	if(strval($node) != ""){ // ignore empty xml tags
		$name = strval($node->attributes()->name);
		$type = strval($node->attributes()->type);
		$default_value = strval($node);
		$xmlSettings[] = $name."~|~".$type;
		$fieldsTypes[$name] = $type;
		$default_values[$name] = $default_value;
	}
}
		




$sql = "CREATE TABLE IF NOT EXISTS `$dbTable` (`id` int(11) unsigned NOT NULL AUTO_INCREMENT";
foreach($xmlSettings as $node){
	list($name, $type) = explode("~|~", $node);
	$sql .= ", `".$name."` ".$type;
}
$numOfSettings = count($xmlSettings);
$sql .= ", PRIMARY KEY (`id`)) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;";
$db->query($sql);
$sql = "SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS  
WHERE table_name = '$dbTable' 
AND table_schema = '$dbName' 
AND column_name <> 'id'";
$settings_fields = $db->getRecords($sql);
$numOfFields = count($settings_fields);
$record = $db->getRecord("select * from $dbTable");
if($record){
	foreach($xmlSettings as $node){
		list($name, $type) = explode("~|~", $node);
		if($record->{$name} == NULL){ // a new field added to XML (from update)
			${$name} = $default_values[$name]; // for the form in the template's [settings.php ]
			$type = $fieldsTypes[$name];
			$q = "ALTER TABLE `".$dbTable."` ADD `".$name."` ".$type.";";
			$db->query($q); // add the new field in database table
		}
	}
}
if(!$record || ($numOfSettings > $numOfFields)){ // add settings record with default values, only if there are no values or a new setting field just added
	$sql = "
	REPLACE INTO `$dbTable` 
	(`".implode('`, `', array_keys($default_values))."`) 
	VALUES
	('".implode("', '", $default_values)."')
	;";
	$db->query($sql);
}
$record = $db->getRecord("select * from $dbTable"); // again, in case of new inserted data
$id = 1;
if($saveSettings){
	$vars = array();
	foreach($settings_fields as $sf){
		$var = $sf->COLUMN_NAME;
		if(isset($_POST[$var])) $vars[] = $var;
		if(${$var} == "" && isset($_POST[$var])) $messages->addError("The ".$var." field's value is required");
	}
	if(!$messages->hasErrors){
		if($db->updateRecord($dbTable, $id, $vars)){
			$messages->addMessage("Settings saved successfully");
		}else{
			$messages->addError("An error occured while saving settings");
		}
	}
}
$settings = $db->getRecord("select * from $dbTable where id='$id'");
foreach($settings_fields as $sf){
	$var = $sf->COLUMN_NAME;
	${$var} = $settings->$var;
}

if($saveSettings){
	?>
    <script type="text/javascript">
	parent.$.fancybox.close();
    </script>
    <?php
	exit;
}
?>
