<?php
/*
Odyssey controller file
$this is a reference to $document
*/

global $library;
global $langID;
global $protocol;
include("config/odyssey.ini.php");
foreach($library as $class){global ${$class};} // import library classes
$sectionCssFile = $this->getTemplatePath().$this->cssFilePath.$this->section.".css";
$sectionJsFile = $this->getTemplatePath().$this->jsFilePath.$this->section.".js";
$sectionJsReadyFile = $this->getTemplatePath().$this->jsFilePath.$this->section."_ready.js";
// add any other styles you may need in the following array
$cssFiles = array(
	$this->getTemplatePath().$this->cssFilePath."pagination.css"
);
// add any other scripts you may need in the following array
$jsFiles = array(

);

$auth = new authentication(false);

// manage ready javascript for this section
$this->javascript_ready = NULL;
ob_start();
// javascript ready code will be included in js ready section below
?>
$('.sc_btn').fancybox({
	afterClose : function(){ 
		var shipping_data = $('#shipping_data').val();
		var parts = shipping_data.split("|");
		var shipping_cost = parts[4]; 
		if(shipping_cost){
			if(shipping_cost == t("Δωρεάν") || !parseFloat(shipping_cost)){
				$('#shipping_cost').html(t("Δωρεάν"));
			}else{
				$('#shipping_cost').html(formatPrice(shipping_cost, odyshop.currency));
				var total = parseFloat(calculateBasket()) + parseFloat(shipping_cost);
				$('#total_cost').html(formatPrice(total, odyshop.currency));			
			}
			$('#change_shipping_cost').show();			
		}

	},
	width : 500,
	height : 400,
	maxHeight : 400,
	type : 'iframe',
	arrows : false,
	modal : true,
	openEffect : 'none',
	closeEffect : 'none',
	helpers : {
		overlay : {
			css : {
				'background' : 'rgba(0, 0, 0, 0.8)'
			}
		},
		title : null
	}
});

$('#selectCity').fancybox({
	width : 500,
	height : 300,
	maxHeight : 300,
	type : 'iframe',
	arrows : false,
	modal : true,
	openEffect : 'none',
	closeEffect : 'none',
	helpers : {
		overlay : {
			css : {
				'background' : 'rgba(0, 0, 0, 0.8)'
			}
		},
		title : null
	}
});
<?php

$this->javascript_ready = ob_get_clean();

// manage javascript for each view
$this->javascript = NULL;
ob_start();

switch ($this->view){
	
case "login":
	if($submitedData){
		$login = $auth->login($enteredUserUsername, $enteredUserPassword);
		if(!$login) {
			$messages->addError(t("Τα στοιχεία αυτά δεν ήταν δυνατόν να ταυτοποιηθούν σωστά"));
			$messages->addError(t("Παρακαλούμε δοκιμάστε ξανά..."));
		}else{
			$userID = $_SESSION['userID'];
			if(!preg_match('/^localhost/', $domain_name)){
				$isUserLogenIn = $db->getRecord("select userID from connected_users where userID='$userID'")->userID;
			}else{
				$isUserLogenIn = false;
			}
			if($isUserLogenIn){
				// logout
				$auth->logout();
				$login = $auth->getLoginStatus() != 2;	// needed for login view file
				$messages->addError(t("Ο συγκεκριμένος χρήστης είναι ήδη συνδεδεμένος"));
				$messages->addError(t("Αν έχετε πρόσφατα αποσυνδεθεί, περιμένετε ένα λεπτό και προσπαθήστε ξανά"));
			}else{ // successfull login,
				?>
				<script>clearInterval(cleanUp);</script>
				<?php			
				$basket->clearBasket(); // clear any previous stored basket for registered user
				$basket->importSessionBasket();  // import any current session basket items
				?>
				<script>document.location.href="<?php echo getBase().$sef->url("index.php", false);?>"; </script>
                <?php
				exit;					
			}
		}
	}else{
		if($auth->getLoginStatus() != 2){ // already loged in, redirecting to home page
		?>
		<script>document.location.href="<?php echo getBase().$sef->url("index.php", false);?>"; </script>
		<?php	
		exit;
		}
	}
	break;
	
case "restore":
	if($submitedData){
		if(!$email) $messages->addError(t("Πρέπει να συμπληρώσετε την e-mail διεύθυνσή σας"));
		if(!validEmail($email) && !empty($email)){
			$messages->addError(t("Η διεύθυνση e-mail που πληκτρολογήσατε δεν είναι υπαρκτή"));
		}
		$q="select id, username, password, email from `users` where email='$email'";	
		$foundEmail = $db->getRecord($q)->email;
		$username = $db->getRecord($q)->username;
		$password = $db->getRecord($q)->password;
		$userID = $db->getRecord($q)->id;
		if(!$foundEmail && !empty($email) && !$messages->hasErrors) $messages->addError(t("Η διεύθυνση e-mail που πληκτρολογήσατε δεν ανήκει σε εγγεγραμμένο μέλος"));
		if($foundEmail && !$messages->hasErrors){
			$password = $variables->generatePassword();
			$q = "UPDATE `users` SET password='".$password."' where id='".$userID."'";
			$db->query($q);
	
			// mail headers
			$header = "Reply-To: $domain_name <".$email_address.">\n"; 
			$header .= "Return-Path: $domain_name <".$email_address.">\n"; 
			$header .= "From: $domain_name <".$email_address.">\n";
			$header .= "Organization: $domain_name\n"; 
			$header .= "Content-Type: text; charset=utf-8\n";
	
			$subject="Login Credentials Request";
			$msg=t("Έγινε η ακόλουθη αίτηση στοιχείων πρόσβασης για το")." ".$domain_name.":\n\n";
			$msg.="e-mail: ".$email."\n\n";
			$msg.="username: ".$username."\n\n";;		
			$msg.="password: ".$password."\n";
			if(!mail($email, $subject, $msg, $header)) {
				$messages->addError(t("Πρόβλημα στην αποστολή δεδομένων"));
				$messages->addError(t("Παρακαλούμε δοκιμάστε αργότερα"));
			}
		}
		$restore = !$messages->hasErrors;
	}
	break;
	
case "register":
	if($auth->getLoginStatus() != 2){ // access denied for loged in user, redirecting to index page
	?>
	<script>document.location.href="<?php echo getBase().$sef->url("index.php", false);?>"; </script>
	<?php
	exit;	
	}	
	
	$recordAdded = false;
	if($_REQUEST['submitedData']){
		if($_REQUEST['info']){
			header("location:index.php"); // spam detected
			exit;
		}
		/*
		$_POST['security_code'] = mb_strtoupper( $_POST['security_code']); // μονο κεφαλαια στο capcha
		if($_SESSION['security_code'] == $_POST['security_code'] && !empty($_SESSION['security_code'])){
			unset($_SESSION['security_code']); // ολα ok με το captcha image
		}else{
			$messages->addError(t("Ο κωδικός ταυτοποίησης που πληκτρολογήσατε δεν είναι σωστός"));
		}
		*/
		if(isset($_POST['g-recaptcha-response'])) $captcha = $_POST['g-recaptcha-response'];
		if(!$captcha){
			$messages->addError(t("Πρέπει να αποδείξετε πως δεν είστε ρομπότ"));
		}else{
			$secretKey = "6LesLCATAAAAADWqbi8Uro_z_OLzekDuxdAkdzX4";
			$ip = $_SERVER['REMOTE_ADDR'];
			$response=file_get_contents("https://www.google.com/recaptcha/api/siteverify?secret=".$secretKey."&response=".$captcha."&remoteip=".$ip);
			$responseKeys = json_decode($response,true);
			$hostname = str_replace("www.", NULL, $responseKeys["hostname"]);
			$domainValidated = (strpos($domain_name, $hostname) !== false);
			if(!$domainValidated || intval($responseKeys["success"]) !== 1){
				$messages->addError(t("Πρέπει να αποδείξετε πως δεν είστε ρομπότ"));
			}
		}
		
		
		// auto validation
		$requiredVars = $variables->getRequiredVars($this->sectionID);
		foreach($requiredVars as $var){
			$var->fieldVarName = str_replace("username", "userUsername", $var->fieldVarName);
			$var->fieldVarName = str_replace("password", "userPassword", $var->fieldVarName);
			$requestVar = ${$var->fieldVarName};
			if(!$requestVar) $messages->addError(t("Το πεδίο", $langID, "field validation")." &nbsp;[ ".t($var->fieldDescription, $langID)." ]&nbsp; ".t("είναι απαραίτητο", $langID));
			if(preg_match('/email/', $var->fieldVarName)){
				if(!validEmail($requestVar) && !empty($requestVar)){
					$messages->addError(t("Η διεύθυνση e-mail που πληκτρολογήσατε δεν είναι υπαρκτή"));
				}
				if($parameters->isUserParameterExists(0, 'email', $requestVar)) $messages->addError(t("Η διεύθυνση e-mail που πληκτρολογήσατε υπάρχει ήδη καταχωρημένη"));
			}	
			if(preg_match('/username/i', $var->fieldVarName)){
				if($parameters->isUserParameterExists(0, 'username', $requestVar)) $messages->addError(t("Το username που επιλέξατε χρησιμοποιείται από άλλον χρήστη"));
			}
		}
		if(!$system->isFieldNameExists("account_type", $this->sectionID)) die("System Error: The [ account_type ] field is missing from users section");
		
		$hasErrors = $messages->hasErrors;
		$username = $userUsername;	
		$password = $userPassword;
		
		if(!$hasErrors){
			$id = NULL;
			$active=1;
			$private=0;
			$sort=0;
			$alias = $variables->toLatin($title);
			$account_type = ($account_type) ? $account_type : 4; // set default το ΠΕΛΑΤΕΣ ΛΙΑΝΙΚΗΣ;
			//if($system->isFieldNameExists("confirmCode", $this->sectionID)) $confirmCode = md5(time());
			// create fields auto array
			$fields = $db->getRecords("select * from `fields` where tableSectionID='$this->sectionID' and active=1 order by sort");
			$users_vars = array();
			foreach($fields as $field){
				if($field->fieldVarName != "title")	$users_vars[] = $field->fieldVarName;
			}
			$system_vars = array('id', 'active', 'private', 'alias', 'sort');
			$vars = array_merge($system_vars, $users_vars);			
			
			foreach($vars as $var){ // pass variables to document
				$this->$var = ${$var};
				$this->setData($this->$var);
			}
			$db->addRecord('users', $vars, false, $this);
			$mainID = $db->lastID();
			$vars = array('title');
			foreach($vars as $var){ // pass variables to document
				$this->$var = ${$var};
				$this->setData($this->$var);
			}
			for($lang=1; $lang <=2; $lang++){	// add user in admin languages
				$q="insert into content_users (id, mainID, langID, title) values ('', '$mainID', '$lang', '$title')";
				$db->query($q);
			}
			$recordAdded = true;
			
			
			// mail headers
			$header = "Reply-To: $domain_name <".$email_address.">\n"; 
			$header .= "Return-Path: $domain_name <".$email_address.">\n"; 
			$header .= "From: $domain_name <".$email_address.">\n";
			$header .= "Organization: $domain_name\n"; 
			$header .= "Content-Type: text; charset=utf-8\n";
			
			$msg = NULL;
			
			// mail to webmaster
			$subject="New member @ $domain_name - ".$title;
			$msg=t("Έγινε η ακόλουθη αίτηση εγγραφή μέλους").":\n\n";
			$msg.=t("Ονοματεπώνυμο").": ".$title."\n\n";
			$msg.="Username: ".$username."\n\n";
			$msg.=t("Κωδικός πρόσβασης").": ".$password."\n\n";
			$msg.="e-mail: ".$email."\n\n";
			$msg.=t("Link στον πίνακα διαχείρισης").": ".$protocol."://".$domain_name."/admin/sections.php?action=form&category=41&section=users&itemID=".$mainID."\n";
			mail($email_address, $subject, $msg, $header);
			
			$msg = NULL;
			/*
			// mail to Client
			$subject="Activation Code - ".$webmasterName;	
			$msg.=t("Σας ευχαριστούμε για την εγγραφή σας")."\n\n";
			$msg.=t("Επισκεφθείτε τον σύνδεσμο που ακολουθεί για να ενεργοποιήσετε αυτόματα το λογαριασμό σας")."\n\nhttp://www.".$domain_name."/activate.php?confirmCode=".$confirmCode."\n\n";
			$msg.=t("Παρακαλούμε, αποθηκεύστε το παρόν μήνυμα με τα στοιχεία του λογαριασμού σας").":\n\n";
			$msg.=t("Ονοματεπώνυμο").": ".$title."\n\n";
			$msg.="Username: ".$username."\n\n";
			$msg.=t("Κωδικός πρόσβασης").": ".$password."\n\n";
			$msg.="e-mail: ".$email."\n\n";
			mail($email, $subject, $msg, $header);
			*/
		}
	}
	
	$this->user_fields = $db->getRecords("select * from `fields` where tableSectionID='$this->sectionID' and active=1 and hiddenInPublicAdmin=0 order by sort");
			
	?>
	<script type="text/javascript">
	function changeCountry(elm){
		$('#invalid_zip_code').css('visibility', 'hidden');
		$('#zip_code').val('');
		$('#city').val('');
		$('#cityID').val('');
		$('#address').val('');
	}
	
	function checkZipCode(elm){
		if($('#countryID').val() == '44'){ // only for Greece
			var zip_code = $(elm).val();
			if(!zip_code) return;
			$('#ajax_loading').show();
			jQuery.ajax({
				type: "GET",
				url: "ajax_zip_code.php",
				async: false,
				data: "zip_code="+zip_code+"&action=validate&langID=<?php echo $langID;?>",
				success: function(response){
					//console.log(response);
					if(response == "ok"){
						$('#invalid_zip_code').css('visibility', 'hidden');
					}else{	
						$('#invalid_zip_code').css('visibility', 'visible');
						$('#city').val('');
					}
					$('#ajax_loading').hide();
				}
			});		
		}
	}
	
	function checkCity(elm){
		validateCity();
		if($('#countryID').val() == '44'){ // only for Greece
			var zip_code = $('#zip_code').val();
			var area_name = ($('#city').attr("data-inaccessible")) ? $('#city').val() : "";
			var cityID = $('#cityID').val();
			if($('#invalid_zip_code').css('visibility') == "visible" || !zip_code){
				$(elm).blur();
				$('#zip_code').focus();
				return;
			}
			$('#selectCity').attr("href", "getCitiesByZipCode.php?langID=<?php echo $langID;?>&cityID=" + cityID + "&area_name=" + area_name + "&zip_code=" + zip_code).click();
		}
	}
	
	function validateCity(){
		if($('#countryID').val() == '44'){ // only for Greece
			var zip_code = $('#zip_code').val();
			if(!zip_code || $('#invalid_zip_code').css('visibility') == "visible"){
				$('#city').addClass("error_field").val("<?php echo t("Πρέπει πρώτα να εισάγετε έναν ισχύοντα ταχυδρομικό κώδικα");?>");
				setTimeout(function(){
					$('#city').removeClass("error_field");
					$('#city').val("");
				}, 3000);
				return false;
			}
		}
	}
	</script>
	
	<?php	
	
			
	
	break;

case "profile":
	$login = $auth->getLoginStatus() != 2;
	if(!$login) {
		?>
		<script type="text/javascript">
		document.location.href="<?php echo $protocol."://".$domain_name."/".$sef->url('index.php?section=users&view=login', false);?>";
		</script>
		<?php
		exit;	
	}
	$userID = $_SESSION['userID'];
	if($_REQUEST["submitedData"]){
		if($userID == 1) $messages->addError("Cannot modify the System User Account");
		$hasErrors = $messages->hasErrors;
		if(!$hasErrors){
		// auto validation
		$requiredVars = $variables->getRequiredVars($this->sectionID);
		foreach($requiredVars as $var){
			$var->fieldVarName = str_replace("username", "userUsername", $var->fieldVarName);
			$var->fieldVarName = str_replace("password", "userPassword", $var->fieldVarName);
			$requestVar = ${$var->fieldVarName};
			if(empty($var->hiddenInPublicAdmin)){			
				if(!$requestVar) $messages->addError(t("Το πεδίο", $langID, "field validation")." &nbsp;[ ".t($var->fieldDescription, $langID)." ]&nbsp; ".t("είναι απαραίτητο", $langID));
				if(preg_match('/email/', $var->fieldVarName)){
					if(!validEmail($requestVar) && !empty($requestVar)){
						$messages->addError(t("Η διεύθυνση e-mail που πληκτρολογήσατε δεν είναι υπαρκτή"));
					}
					if($parameters->isUserParameterExists($userID, 'email', $requestVar)) $messages->addError(t("Η διεύθυνση e-mail που πληκτρολογήσατε υπάρχει ήδη καταχωρημένη"));
				}	
				if(preg_match('/username/i', $var->fieldVarName)){
					if($parameters->isUserParameterExists($userID, 'username', $requestVar)) $messages->addError(t("Το username που επιλέξατε χρησιμοποιείται από άλλον χρήστη"));
				}
			}
		}
		if(!$system->isFieldNameExists("account_type", $this->sectionID)) die("System Error: The [ account_type ] field is missing from users section");
		}
		$hasErrors = $messages->hasErrors;
		$username = $userUsername;
		$password = $userPassword;		
		if(!$hasErrors){
			// create fields auto array
			$fields = $db->getRecords("select * from `fields` where tableSectionID='$this->sectionID' and hiddenInPublicAdmin=0 and active=1 order by sort");
			$vars = array();
			foreach($fields as $field){
				if($field->fieldVarName != "title")	$vars[] = $field->fieldVarName;
			}
			foreach($vars as $var){ // pass variables to document
				$this->$var = ${$var};
				$this->setData($this->$var);
			}				
			$db->updateRecord('users', $userID, $vars, false, $this);
			$mainID = $userID;
			$langID=1;
			$vars = array('mainID', 'langID', 'title');
			$values="SET ";
			foreach($vars as $var){
			$values.="`".$var."`='".${$var}."', ";
			}
			$values = substr($values ,0 ,-2);
			$q = "UPDATE `content_users` ".$values." where langID=".$langID." and mainID='".$userID."'";
			$db->query($q);
			$messages->addMessage(t("Οι αλλαγές αποθηκεύτηκαν με επιτυχία"));	
			
		} // end error free
	}else{ // load user's details
		$row = $content->getContentByID("users", $userID, "*", array("title"), 1);
		$fields = $db->getRecords("select * from `fields` where tableSectionID='$this->sectionID' and hiddenInPublicAdmin=0 and active=1 order by sort");
		$this->user_fields = $fields;
		foreach($fields as $field){
			$field->fieldVarName = str_replace("username", "userUsername", $field->fieldVarName);
			$field->fieldVarName = str_replace("password", "userPassword", $field->fieldVarName);
			$requestVar = ${$field->fieldVarName};
			$field->fieldVarName = str_replace("userUsername", "username", $field->fieldVarName);
			$field->fieldVarName = str_replace("userPassword", "password", $field->fieldVarName);
			${$field->fieldVarName} = (${$field->fieldVarName}) ? ${$field->fieldVarName} : $row->{$field->fieldVarName};
		}
		
				
		?>
		<script type="text/javascript">
		function changeCountry(elm){
			$('#invalid_zip_code').css('visibility', 'hidden');
			$('#zip_code').val('');
			$('#city').val('');
			$('#cityID').val('');
			$('#address').val('');
		}
		
		function checkZipCode(elm){
			if($('#countryID').val() == '44'){ // only for Greece
				var zip_code = $(elm).val();
				if(!zip_code) return;
				$('#ajax_loading').show();
				jQuery.ajax({
					type: "GET",
					url: "ajax_zip_code.php",
					async: false,
					data: "zip_code="+zip_code+"&action=validate&langID=<?php echo $langID;?>",
					success: function(response){
						//console.log(response);
						if(response == "ok"){
							$('#invalid_zip_code').css('visibility', 'hidden');
						}else{	
							$('#invalid_zip_code').css('visibility', 'visible');
							$('#city').val('');
						}
						$('#ajax_loading').hide();
					}
				});		
			}
		}
		
		function checkCity(elm){
			validateCity();
			if($('#countryID').val() == '44'){ // only for Greece
				var zip_code = $('#zip_code').val();
				var area_name = ($('#city').attr("data-inaccessible")) ? $('#city').val() : "";
				var cityID = $('#cityID').val();
				if($('#invalid_zip_code').css('visibility') == "visible" || !zip_code){
					$(elm).blur();
					$('#zip_code').focus();
					return;
				}
				$('#selectCity').attr("href", "getCitiesByZipCode.php?langID=<?php echo $langID;?>&cityID=" + cityID + "&area_name=" + area_name + "&zip_code=" + zip_code).click();
			}
		}
		
		function validateCity(){
			if($('#countryID').val() == '44'){ // only for Greece
				var zip_code = $('#zip_code').val();
				if(!zip_code || $('#invalid_zip_code').css('visibility') == "visible"){
					$('#city').addClass("error_field").val("<?php echo t("Πρέπει πρώτα να εισάγετε έναν ισχύοντα ταχυδρομικό κώδικα");?>");
					setTimeout(function(){
						$('#city').removeClass("error_field");
						$('#city').val("");
					}, 3000);
					return false;
				}
			}
		}
		</script>		
		<?php	
		
				
	}
	break;
	
case "wishlist":
	$this->hasWishList = false; // initialize
	$this->userLoged = $auth->getLoginStatus() != 2;
	if($this->userLoged){
		$userID = $_SESSION['userID'];
		$basketTypeID = $basket->getBasketTypeID("wishlist");
		$q = "select p.id as productID, p.price, p.vat, p.show_price, cp.title, b.id as basketID, b.combination 
				from products as p, content_products as cp, basket as b 
				where p.id=cp.mainID and cp.langID='$langID' and b.productID=p.id and b.userID='$userID' and b.basket_type='$basketTypeID'";
		$records = $db->getRecords($q);
		$this->hasWishList = count($records);
		if($this->hasWishList){	
		
				
			?>
			<script type="text/javascript">
			jQuery(document).ready(function($) {
				$('.product_wrapper').on("mouseover", function(){
					$(this).find(".quick_view").show();
				}).on("mouseout", function(){
					$(this).find(".quick_view").hide();
				});
				
				$('.quick_view').fancybox({
					width : 800,
					height: 700,
					maxHeight : 700,
					type : 'iframe',
					arrows: false,
					modal: true,
					helpers : {
						overlay : {
							css : {
								'background' : 'rgba(0, 0, 0, 0.8)'
							}
						},
						title: null
					}
				});		
			});
			
			function removeWishlistItem(uid){
				if(!uid) return false;
				var action = 'remove';
				var basketTypeName = 'wishlist';
				$('#ajax_loading').show();			
				jQuery.ajax({
					type: "GET",
					url: "ajax_basket.php",
					data: "uid="+uid+"&action="+action+"&langID=<?php echo $langID;?>",
					async: false,
					success: function(response){
						//console.log(response);
						if(response.indexOf("ok~|~") != -1){
							var response = response.replace("ok~|~", "");
							var notifications = response.split("~|~");
							var timeout = notifications.length-1;
							if(notifications.length){
								notifications = notifications.join("<br>");
								popup(notifications, "success", (5000 + (1000 * (timeout))));
							}
							$('div[data-uid="'+uid+'"]').remove();
							var numOfProducts = $('.product_wrapper').length;
							if(!numOfProducts){
								$('.wishlistContents').append($('<div class="no_wishlist_items"><?php echo t("Δεν βρέθηκαν καταχωρημένα προϊόντα");?></div>'));
							}
						}else if(response.indexOf("error~|~") != -1){
							var response = response.replace("error~|~", "");
							if(!response){
								popup("Error removing item from the wishlist", "error", 5000); // unspecified error
							}else{
								var errors = response.split("~|~");
								var timeout = errors.length-1;
								if(errors.length){
									errors = errors.join("<br>");
									popup(errors, "error", (5000 + (1000 * (timeout))));
								}					
							}
						}else{
							popup(response, "error", 5000);
						}
						$('#ajax_loading').hide();
					}
				});	
			}				
			</script>		
			<?php
			
				
			
			$products = array();
			$IDs = array();
			foreach($records as $record){
				$hasAccess = $eshop->hasAccess($record->productID);
				if($hasAccess){
					$products[] = $record;
					$IDs[] = $record->productID;
				}
			}
			$this->IDs = implode(",", $IDs);
			$this->products = $products;

		}
	}
	break;	
	
case "basket":
	if(!$parameters->getParameter("basket_enabled")){
		?>
		<script type="text/javascript">document.location.href="index.php";</script>
		<?php
		exit;
	}
	$currency = $eshop->getCurrency();
	$currency_sign = $currency->sign;
	$currency_code = $currency->code;
	$currency_start_position = $currency->start_position;
	$currency_decimal = $currency->decimal;
	$currency_decimal_seperator = $currency->decimal_seperator;
	$currency_thousands_seperator = $currency->thousands_seperator;
	$userLoged = $auth->getLoginStatus() != 2;
	$userID = ($userLoged) ? $_SESSION['userID'] : NULL;	
	$basketTypeID = ($userID) ? $basket->getBasketTypeID("basket") : $basket->getBasketTypeID("session");
	$basketTypeName = $basket->getBasketTypeName($basketTypeID);	
	if($userID){ // registered client
		$basketItems = $content->getContent("basket", " active=1 and userID='".$userID."' and basket_type='".$basketTypeID."'", "*", false, $language->getDefaultLanguage(), "content_basket.title");
	}else{ // visitor
		$basketItems = $basket->sessionBasket;
	}
	$this->userID = $userID;
	$this->basketItems = $basketItems;	
	
		
	?>
	<script type="text/javascript">
		odyshop.currency = {
			sign:"<?php echo $currency_sign;?>",
			code:"<?php echo $currency_code;?>",
			start_position:"<?php echo $currency_start_position;?>",
			decimal:"<?php echo $currency_decimal;?>",
			decimal_seperator:"<?php echo $currency_decimal_seperator;?>",
			thousands_seperator:"<?php echo $currency_thousands_seperator;?>"
		};
		jQuery(document).ready(function($) {
			$('.interactive_option').each(function(idx){
				$(this).on('focus', function () {
					// Store the current value on focus before change
					odyshop.previousSelect = this;
					odyshop.previousValue = this.value;
				}).on("change", function(){
					var id = $(this).attr('id').replace("option_", "");
					var parts = id.split("_");
					var optionID = parts[0];
					var productID = parts[1];
					var variantID = $(this).val();
					var uid = $(this).attr('data-uid');
					var combination = getCombination(uid);
					updateOptionSelects(productID, uid);	
					$('#ajax_loading').show();					
					jQuery.ajax({
						type: "GET",
						url: "ajax_options.php",
						data: "productID="+productID+"&optionID="+optionID+"&variantID="+variantID+"&combination="+combination+"&langID=<?php echo $langID;?>",
						async: false,
						success: function(response){
							//console.log(response);
							if(response.indexOf("ok_") != -1){
								var response = response.replace("ok_", "");
								if(response == "empty") return; // do nothing
								var parts = response.split("_");
								var include_vat = parseInt($('#include_vat').val());
								var vat = parseFloat($('#vat_' + uid).val());								
								var amount;
								var type;
								var prices = parts[0];
								var image = parts[1];
								var code = parts[2];
								code = (code) ? code : $('#code_' + uid).attr('data-code');
								$('#code_' + uid).html(code);
								prices = prices.split("~");
								var basePrice = parseFloat($('#price_' + uid).attr('data-baseprice'));
								var modified_price = 0;
								for(i in prices){
									var price_parts = prices[i].split("|");
									amount = parseFloat(price_parts[0]);
									type = price_parts[1];
									if(amount){ // price actions
											if(type == "A"){
												if(include_vat) amount = includeVat(amount, vat);
												modified_price += amount;
												var price = parseFloat(basePrice + modified_price);
												$('#price_' + uid).html(formatPrice(price, odyshop.currency)).attr('data-price', price);
											}
											if(type == "P"){
												modified_price += amount * (basePrice / 100);
												var price = parseFloat(basePrice + modified_price);
												$('#price_' + uid).html(formatPrice(price, odyshop.currency)).attr('data-price', price);
											}							
									}else{ // restore original price
										$('#price_' + uid).html(formatPrice(basePrice, odyshop.currency)).attr('data-price', basePrice);								
									}
								}
								if(image){ // manage image
									odyshop.optionImage = image;
									image = "mediabank/medium/medium_" + image;
									$('#image_' + uid).attr("src", image);
								}else{
									if(!odyshop.optionImage){ // restore basic image								
										var defaultImage = $('#image_' + uid).attr("data-image");
										image = "mediabank/medium/medium_" + defaultImage;
										$('#image_' + uid).attr("src", image);									
									}
								}
								calculatePrice(uid);
							}else{
								popup(response, "error", 5000);
							}
							$('#ajax_loading').hide();
						}
					});	
				});
			});
		});	
		
		function updateOptionSelects(productID, uid){
			var selectedOptions = $('[data-uid="' + uid + '"]').serializeArray();
			if(!selectedOptions.length) return;
			var selectedOptions = JSON.stringify(selectedOptions);
			$('#ajax_loading').show();
			jQuery.ajax({
				type: "POST",
				url: "ajax_exceptions.php",
				data: "productID="+productID+"&selectedOptions="+selectedOptions+"&langID=<?php echo $langID;?>",
				async: false,
				success: function(response){
					//console.log(response);
					response = jQuery.parseJSON(response);
					if(typeof(response) == "object"){
						for(optionID in response){
							var thisOptions = response[optionID];
							var elm = $('#option_'+optionID+'_'+productID);
							elm.html(''); // empty existing options from select element
							for(i in thisOptions){
								elm.append(thisOptions[i]);
							}
						}
					}else{
						alert("Error in AJAX call: " + response); // ajax error
					}	
					$('#ajax_loading').hide();		
				}
			});
		}			
		
		function updateBasket(uid){
			if(!uid) return false;
			var productID = $('.product_row[data-uid="'+uid+'"]').attr('data-productID');
			var combination = $('#combination_'+uid).val();
			var quantity = $('#quantity_'+uid).val();
			var basketTypeName = '<?php echo $basketTypeName;?>';
			var action = 'change';
			$('#ajax_loading').show();
			jQuery.ajax({
				type: "GET",
				url: "ajax_basket.php",
				data: "uid="+uid+"&quantity="+quantity+"&action="+action+"&combination="+combination+"&basketTypeName="+basketTypeName+"&langID=<?php echo $langID;?>",
				async: false,
				success: function(response){
					//console.log(response);
					if(response == "ok"){
						calculatePrices();						
						calculateBasket(uid);
					}else{
						popup(response, "error", 5000);
						var elm = odyshop.previousSelect;
						var value = odyshop.previousValue;
						setTimeout(function(){
							$(elm).val(value);
							$(elm).trigger("change");
						}, 1000);
					}
					$('#ajax_loading').hide();
				}
			});	
		}
		
		function removeBasketItem(uid){
			if(!uid) return false;
			var action = 'remove';
			var basketTypeName = '<?php echo $basketTypeName;?>';
			$('#ajax_loading').show();			
			jQuery.ajax({
				type: "GET",
				url: "ajax_basket.php",
				data: "uid="+uid+"&action="+action+"&langID=<?php echo $langID;?>",
				async: false,
				success: function(response){
					//console.log(response);
					if(response.indexOf("ok~|~") != -1){
						var response = response.replace("ok~|~", "");
						var notifications = response.split("~|~");
						var timeout = notifications.length-1;
						if(notifications.length){
							notifications = notifications.join("<br>");
							popup(notifications, "success", (5000 + (1000 * (timeout))));
						}
						$('tr[data-uid="'+uid+'"]').remove();												
						calculatePrices();						
						calculateBasket(uid);
					}else if(response.indexOf("error~|~") != -1){
						var response = response.replace("error~|~", "");
						if(!response){
							popup("Error removing item from the cart", "error", 5000); // unspecified error
						}else{
							var errors = response.split("~|~");
							var timeout = errors.length-1;
							if(errors.length){
								errors = errors.join("<br>");
								popup(errors, "error", (5000 + (1000 * (timeout))));
							}					
						}
					}else{
						popup(response, "error", 5000);
					}
					$('#ajax_loading').hide();
				}
			});	
		}
		
		function getCombination(uid){
			var value = "";
			$('select[data-uid="' + uid + '"]').each(function(){
				var id = $(this).attr('id').replace("option_", "");
				var parts = id.split("_");
				var optionID = parts[0];
				var variantID = $(this).val();
				value += optionID + "|" + variantID + "_";
			});
			var hasUnderscore = new RegExp('(_)$');
			if(hasUnderscore.test(value)){
				value = value.substring(0, value.length-1);
			}
			if(value) $('#combination_' + uid).val(value);
			return value;
		} 
		
		function calculatePrice(uid){
			var productID = $('tr[data-uid='+uid+']').attr('data-productid');
			var combination = $('#combination_'+uid).val();
			var vat = $('#vat_'+uid).val();
			var quantity = parseInt($('#quantity_' + uid).val());
			jQuery.ajax({
				type: "GET",
				url: "ajax_price.php",
				data: "productID="+productID+"&quantity="+quantity+"&combination="+combination+"&vat="+vat,
				async: false,
				success: function(response){
					//console.log(response);
					var price =  parseFloat(response);
					$('#price_' + uid).html(formatPrice(price, odyshop.currency)).attr('data-price', price);
					var subtotal = (price * quantity).toFixed(2);
					$('#subtotal_' + uid).html(formatPrice(subtotal, odyshop.currency)).attr('data-subtotal', parseFloat(subtotal).toFixed(2));
					updateBasket(uid);					
				}
			});
		}		  
		
		function calculatePrices(){
			var uid;
			var price;
			var quantity;
			var subtotal;
			var total = 0;
			$('.product_row').each(function(){
				uid = $(this).attr('data-uid');
				price = parseFloat($('#price_' + uid).attr('data-price'));
				quantity = parseInt($('#quantity_' + uid).val());
				subtotal = (price * quantity).toFixed(2);
				total+= subtotal;
				$('#subtotal_' + uid).html(formatPrice(subtotal, odyshop.currency)).attr('data-subtotal', parseFloat(subtotal).toFixed(2));
			});
			if(!total) document.location.reload();
		}
		
		function calculateBasket(){
			var total = 0;
			var subtotal;
			var uid;
			var vat_percent;
			var vat_total = 0;
			var include_vat = parseInt($('#include_vat').val());
			$('span[data-subtotal]').each(function(){
				subtotal = parseFloat($(this).attr('data-subtotal'));
				uid = $(this).attr('id').replace("subtotal_", "");
				vat_percent = parseFloat($('#vat_' + uid).val());
				if(include_vat){
					vat_total+= getVat(removeVat(subtotal, vat_percent), vat_percent);
				}else{
					vat_total+= getVat(subtotal, vat_percent);
				}
				total+= subtotal;
			});
			$('#total_price').html(formatPrice(total, odyshop.currency));
			$('#total_vat').html(formatPrice(vat_total, odyshop.currency));
			if(include_vat){
				$('#total_cost').html(formatPrice(total, odyshop.currency));
				return total;
			}else{
				$('#total_cost').html(formatPrice(total + vat_total, odyshop.currency));
				return total + vat_total;
			}			
		}
		
		function clearBasket(){
			if(confirm(t("Είστε σίγουροι πως θέλετε να αφαιρέσετε αυτά τα επιλεγμένα προϊόντα;"))){
				var action = 'clear';
				var basketTypeID = '<?php echo $basketTypeID;?>';
				$('#ajax_loading').show();			
				jQuery.ajax({
					type: "GET",
					url: "ajax_basket.php",
					data: "basketTypeID="+basketTypeID+"&action="+action+"&langID=<?php echo $langID;?>",
					async: false,
					success: function(response){
						//console.log(response);
						$('#ajax_loading').hide();
						if(response == "ok"){
							$('.cartMenu').html('<div class="empty_basket_text menu_content"><?php echo t("Το καλάθι είναι άδειο");?></div>');							
							popup(t("Η ενέργεια ολοκληρώθηκε με επιτυχία"), "success", 10000);
							setTimeout(function(){
								document.location.href = document.location.href;
							}, 2000);
						}else{
							popup(response, "error", 5000);
						}
					}
				});	
			}
		}
		
		function checkOut(){
			$('#basket_form').submit();
		}
	</script>

	<?php
	break;
	
case "checkout":
	if(!$parameters->getParameter("basket_enabled")){
		?>
		<script type="text/javascript">document.location.href="index.php";</script>
		<?php
		exit;
	}
	$currency = $eshop->getCurrency();
	$currency_sign = $currency->sign;
	$currency_code = $currency->code;
	$currency_start_position = $currency->start_position;
	$currency_decimal = $currency->decimal;
	$currency_decimal_seperator = $currency->decimal_seperator;
	$currency_thousands_seperator = $currency->thousands_seperator;
	$userLoged = $auth->getLoginStatus() != 2;
	$userID = ($userLoged) ? $_SESSION['userID'] : NULL;	
	$basketTypeID = ($userID) ? $basket->getBasketTypeID("basket") : $basket->getBasketTypeID("session");
	$basketTypeName = $basket->getBasketTypeName($basketTypeID);	
	if($userID){ // registered client
		$basketItems = $content->getContent("basket", " active=1 and userID='".$userID."' and basket_type='".$basketTypeID."'", "*", false, $language->getDefaultLanguage(), "content_basket.title");
	}else{ // visitor
		$basketItems = $basket->sessionBasket;
	}
	if(!count($basketItems)){
		?>
		<script type="text/javascript">document.location.href="index.php";</script>
		<?php
		exit;
	}
	$fixed_shipping_cost = (float)$parameters->getParameter("fixed_shipping_cost");
	$complete = $_SESSION['checkout']['complete'];
	$step = (int)$_GET['step'];
	if($userID && !$complete) $complete = 1;
	if($complete){
		$complete = (int)$complete;
		$complete = ($complete > 3) ? 3 : $complete;
		$step = ($step > $complete + 1) ? $complete + 1 : $step;
		if(!$step) $step = $complete+1;
	}else{
		if($step) $complete = $step-1;
	}
	$step = !$step ? "1" : $step;
	$this->userID = $userID;
	$this->basketItems = $basketItems;
	$this->terms_enabled = $parameters->getParameter("terms");
	$this->shippingCost = ($fixed_shipping_cost) ? $fixed_shipping_cost : 0;
	$this->step = $step;
	$this->complete = $complete;
	$this->userLoged = $userLoged;
		
		
	?>
	<script type="text/javascript">
		odyshop.currency = {
			sign:"<?php echo $currency_sign;?>",
			code:"<?php echo $currency_code;?>",
			start_position:"<?php echo $currency_start_position;?>",
			decimal:"<?php echo $currency_decimal;?>",
			decimal_seperator:"<?php echo $currency_decimal_seperator;?>",
			thousands_seperator:"<?php echo $currency_thousands_seperator;?>"
		};
		jQuery(document).ready(function($) {
			setSteps();
			<?php
			if($userID){
			?>
			logedIn();
			<?php
			}
			if($complete > 1){
			?>
			calculateShippingCost();
			<?php
			}	
			?>	
			calculateTotal();
			$('#submitLogin').on('click', function(){
				var username = $('#enteredUserUsername').val();
				var password = $('#enteredUserPassword').val();
				$('#ajax_loading').show();
				jQuery.ajax({
					type: "GET",
					url: "ajax_login.php",
					data: "enteredUserUsername="+username+"&enteredUserPassword="+password+"&langID=<?php echo $langID;?>",
					async: false,
					success: function(response){
						//console.log(response);
						if(response == "ok"){
							refreshBasket(2, 1);
						}else{
							$('#ajax_loading').hide();
							popup(response, "error", 5000);
						}
					}
				});
			});
			
			$('input[type=radio][name=checkout_shipping]').change(function() {
				if(this.value == 'no') {
					var isCodEnabled = $("input[type='radio'][name='payment_method']:checked").val() == "cod";
					if(isCodEnabled){
						$('#payment_method_cod').prop("checked", false);
						$('#cod_wrapper').hide();
						calculateShippingCost();				
						popup("<?php echo t("Η μέθοδος της αντικαταβολής απενεργοποιήθηκε αυτόματα");?>", "warning");
					}
					$('#checkout_shipping_cost').attr("data-amount", 0);	
					$('#shipping_amount').html("");
					$('#checkout_order_results').attr('data-shipping_cost', 0);
					$('#shipping_amount_wrapper').hide();	
					calculateTotal();		
				}
				if(this.value == 'yes') {
					calculateShippingCost();
				}
			});
			
			$('input[type=radio][name=payment_method]').change(function() {
				if($(this).val() == "cod"){
					var isCourierEnabled = $("input[type='radio'][name='checkout_shipping']:checked").val() == "yes";
					if(!isCourierEnabled){
						$('#checkout_shipping_yes').prop("checked", true);
						calculateShippingCost();
						popup("<?php echo t("Η μέθοδος της αντικαταβολής ενεργοποίησε αυτόματα ως μέθοδο αποστολής την υπηρεσία Courier");?>", "warning");
					}
					var cod = $('#checkout_order_results').attr('data-cod');
					if(cod) cod = parseFloat(cod);
					$('#cod_wrapper').show();
					calculateTotal(cod);
					popup("<?php echo t("Το κόστος της αντικαταβολής προστέθηκε στο σύνολο της παραγγελίας σας");?>", "success");
				}else{ // reset cod price
					$('#cod_wrapper').hide();
					calculateTotal();
				}
			});
			
		});
		
		function logout(){
			$('#ajax_loading').show();
			jQuery.ajax({
				type: "GET",
				url: "ajax_logout.php",
				async: false,
				success: function(response){
					//console.log(response);
					if(response == "ok"){
						refreshBasket(1, "");
					}else{
						$('#ajax_loading').hide();				
						popup(response, "error", 5000);
					}
				}
			});	
		}
		
		function refreshBasket(step, complete){
			document.location.href = "index.php?section=users&view=basket&checkout=auto&step=" + step + "&complete=" + complete + "&langID=<?php echo $langID;?>";
		}
		
		function logedIn(){
			$('#step_1_login').hide();
			$('#step_1_loged').show();
		}
		
		function setSteps(){
			var step = "<?php echo $step;?>";
			step = parseInt(step);
			<?php
			if($complete){
			?>
			var complete = <?php echo $complete;?>;
			<?php	
			}else{
			?>
			var complete = 0;
			<?php	
			}
			?>
			var id;
			var elm;
			var isCompleted;
			var isActiveStep;
			for(var n=1; n <=4; n++){
				id = "checkout_step_" + n;
				elm = $('#'+id);
				isCompleted = elm.attr("data-complete");
				isActiveStep = elm.attr("data-active");
				if(isCompleted || n < step || n == (complete + 1)) {
					elm.find('a.checkout_tab_change').show();
					elm.find('.step_title').addClass('step_title_active');
					elm.find('.step_title_wrapper').removeClass('step_active');
					elm.find('.step_icon').removeClass('step_icon_' + n).addClass((isCompleted) ? 'step_icon_completed' : 'step_icon_' + n);	
					setClick(n);
				}
				if(isActiveStep) {
					elm.attr("data-active", "true");
					elm.find('a.checkout_tab_change').hide();
					elm.find('.step_title').removeClass('step_title_active');
					elm.find('.step_title_wrapper').addClass('step_active');
					elm.find('.step_icon').removeClass('step_icon_' + n).addClass('step_icon_' + n + '_active');	
					removeClick(n);
					$('#step_content_' + n).show();			
				}else{
					elm.attr("data-active", "");
					$('#step_content_' + n).hide();
				}
			}
		}
		
		function setClick(step){
			var id = "checkout_step_" + step;
			var elm = $('#'+id);
			elm.find('.step_title').on('click', function(){
				setStep(step);
			});
		}
		
		function removeClick(step){
			var id = "checkout_step_" + step;
			var elm = $('#'+id);
			elm.find('.step_title').unbind("click");
		}
		
		function setStep(step){
			odyshop.step = step;
			if(step > 2){
				if(!saveAddresses()){ // in case we have changed addresses on step backwards. true to prevent setStep recursion
					setStep(2);
					return false;
				}		
			}
			if(step == 3) calculateShippingCost();	
			<?php
			if($complete){
			?>
			var complete = <?php echo $complete;?>;
			<?php	
			}else{
			?>
			var complete = 0;
			<?php	
			}
			?>	
			var id;
			var elm;
			var isCompleted;
			var isActiveStep;	
			for(var n=1; n <=4; n++){
				id = "checkout_step_" + n;
				elm = $('#'+id);
				isCompleted = elm.attr("data-complete");
				if(isCompleted) complete = n;
				isActiveStep = elm.attr("data-active");
				$('#step_content_' + n).hide();
				if(step == n){
					elm.attr("data-active", "true");
					elm.find('.step_icon').removeClass('step_icon_' + n).addClass('step_icon_' + n + '_active');			
					elm.find('a.checkout_tab_change').hide();
					elm.find('.step_title').removeClass('step_title_active');
					elm.find('.step_title_wrapper').addClass('step_active');
					removeClick(n);
					$('#step_content_' + n).show();	
				}else if(isCompleted || n == (complete + 1)){
					setClick(n);
					elm.attr("data-active", "");
					$('#step_content_' + n).hide();
					elm.find('.step_icon').removeClass('step_icon_' + n + '_active').addClass((isCompleted) ? 'step_icon_completed' : 'step_icon_' + n);	
					elm.find('a.checkout_tab_change').show();
					elm.find('.step_title').addClass('step_title_active');
					elm.find('.step_title_wrapper').removeClass('step_active');
				}
			}
			goto('checkout_step_' + step);
		}
		
		function showButtons(type){
			if(type == "register"){
				$('#submitRegister').show();
				$('#submitGuest').hide();
			}
			if(type == "guest"){
				$('#submitRegister').hide();
				$('#submitGuest').show();
			}	
		}
		
		function proceedRegister(){
			$('#step_1_login').hide();
			$('#step_1_loged').hide();
			$('#step_1_register').show();
			goto('checkout_step_1');	
		}
		
		function proceedGuest(){
			setStep(2);
		}
		
		function cancelRegister(){
			$('#step_1_login').show();
			$('#step_1_loged').hide();
			$('#step_1_register').hide();
			goto('checkout_step_1');	
		}
		
		function doRegister(){
			var info = $('#info').val();
			var title = $('#title').val();
			var userUsername = $('#userUsername').val();
			var userPassword = $('#userPassword').val();
			var email = $('#email').val();
			var address = $('#address').val();
			var city = $('#city').val();
			var zip_code = $('#zip_code').val();
			var countryID = $('#countryID').val();
			var phone = $('#phone').val();
			var account_type = $('#account_type').val();
			var security_code = $('#security_code').val();
			$('#ajax_loading').show();
			jQuery.ajax({
				type: "GET",
				url: "ajax_register.php",
				async: false,
				data: "info="+info+"&title="+title+"&langID=<?php echo $langID;?>&userUsername="+userUsername+"&userPassword="+userPassword+"&email="+email+"&address="+address+"&city="+city+"&zip_code="+zip_code+"&countryID="+countryID+"&phone="+phone+"&account_type="+account_type+"&security_code="+security_code+"&submitedData=1",
				success: function(response){
					//console.log(response);
					if(response == "ok"){
						refreshBasket(2, 1);
						// do not hide ajax loading until the basket refresh
					}else{
						var r = Math.random();
						$('#captcha_image').attr("src", "CaptchaSecurityImages.php?width=100&height=40&characters=5&r=" + r); // refresh the captcha	
						$('#security_code').val("");	
						$('#ajax_loading').hide();					
						popup(response, "error", 5000);
					}
				}
			});	
		}
		
		function setInvoiceStatus(elm){
			if($(elm).val() == "invoice"){
				$('#invoice_details').show('fast');
			}else{
				$('#invoice_details').hide('fast');
			}
		}
		
		function setSameAddress(elm){
			if($(elm).val() == "yes"){
				$('#shipping_address_wrapper').hide('fast');
			}else{
				$('#shipping_address_wrapper').show('fast');
			}
		}
		
		function identificationCompleted(){
			$('#checkout_step_1').attr("data-complete", "true");
			setStep(2);	
		}
		
		function addressesCompleted(){
			if(saveAddresses()){
				$('#checkout_step_2').attr("data-complete", "true");
				setStep(3);
			}
		}
		
		function shippingCompleted(){
			var byCourier = $('input[name=checkout_shipping]:checked').val() == "yes";
			var shipping_cost = $('#checkout_order_results').attr('data-shipping_cost');
			if(!byCourier || shipping_cost != ""){
				if(saveShipping()){
					$('#checkout_step_3').attr("data-complete", "true");
					setStep(4);
				}
			}
		}
		
		function saveAddresses(){
			odyshop.success = false;
			var billing_fullname = $('#billing_fullname').val();
			var billing_email = $('#billing_email').val();
			var billing_phone = $('#billing_phone').val();
			var billing_address = $('#billing_address').val();
			var billing_city = $('#billing_city').val();
			var billing_cityID = $('#billing_cityID').val();
			var billing_zip_code = $('#billing_zip_code').val();
			var billing_countryID = $('#billing_countryID').val();
			var doc_type = $('#doc_type').val();
			var invoice = (doc_type == "invoice");
			var billing_compName = (invoice) ? $('#billing_compName').val() : "";
			var billing_occupation = (invoice) ? $('#billing_occupation').val() : "";
			var billing_afm = (invoice) ? $('#billing_afm').val() : "";
			var billing_doy = (invoice) ? $('#billing_doy').val() : "";
			var isSameAddress = $("input[type='radio'][name='same_address']:checked").val() == "yes";
			isSameAddress = (isSameAddress) ? 1 : "";
			var shipping_fullname = (!isSameAddress) ? $('#shipping_fullname').val() : "";
			var shipping_email = (!isSameAddress) ? $('#shipping_email').val() : "";
			var shipping_phone = (!isSameAddress) ? $('#shipping_phone').val() : "";
			var shipping_address = (!isSameAddress) ? $('#shipping_address').val() : "";
			var shipping_city = (!isSameAddress) ? $('#shipping_city').val() : "";
			var shipping_cityID = (!isSameAddress) ? $('#shipping_cityID').val() : "";
			var shipping_zip_code = (!isSameAddress) ? $('#shipping_zip_code').val() : "";
			var shipping_countryID = (!isSameAddress) ?  $('#shipping_countryID').val() : "";		
			$('#ajax_loading').show();
			jQuery.ajax({
				type: "GET",
				url: "ajax_save_addresses.php",
				async: false,
				data: "billing_fullname="+billing_fullname+"&billing_email="+billing_email+"&langID=<?php echo $langID;?>&billing_phone="+billing_phone+"&billing_address="+billing_address+"&billing_city="+billing_city+"&billing_cityID="+billing_cityID+"&billing_zip_code="+billing_zip_code+"&billing_countryID="+billing_countryID+"&doc_type="+doc_type+"&billing_compName="+billing_compName+"&billing_occupation="+billing_occupation+"&billing_afm="+billing_afm+"&billing_doy="+billing_doy+"&isSameAddress="+isSameAddress+"&shipping_fullname="+shipping_fullname+"&shipping_email="+shipping_email+"&shipping_phone="+shipping_phone+"&shipping_address="+shipping_address+"&shipping_city="+shipping_city+"&shipping_cityID="+shipping_cityID+"&shipping_zip_code="+shipping_zip_code+"&shipping_countryID="+shipping_countryID,
				success: function(response){
					//console.log(response);
					if(response == "ok"){
						odyshop.success = true;
					}else{	
						popup(response, "error", 5000);
					}
					$('#ajax_loading').hide();
				}
			});
			return odyshop.success;	
		}
		
		function saveShipping(){
			odyshop.success = false;
			var by_courier = $('input[name=checkout_shipping]:checked').val();
			$('#ajax_loading').show();
			jQuery.ajax({
				type: "GET",
				url: "ajax_save_shipping.php",
				async: false,
				data: "by_courier="+by_courier+"&langID=<?php echo $langID;?>",
				success: function(response){
					//console.log(response);
					if(response == "ok"){
						odyshop.success = true;
					}else{	
						popup(response, "error", 5000);
					}
					$('#ajax_loading').hide();
				}
			});
			return odyshop.success;	
		}
		
		function removeBasketItem(uid){
			if(!uid) return false;
			var basketTypeName = '<?php echo $basketTypeName;?>';
			$('#ajax_loading').show();			
			jQuery.ajax({
				type: "GET",
				url: "ajax_basket.php",
				data: "uid="+uid+"&action=remove&langID=<?php echo $langID;?>",
				async: false,
				success: function(response){
					console.log(response);
					if(response.indexOf("ok~|~") != -1){
						var step = (odyshop.step) ? odyshop.step : 1;
						refreshBasket(step, "");
					}else if(response.indexOf("error~|~") != -1){
						$('#ajax_loading').hide();
						var response = response.replace("error~|~", "");
						if(!response){
							popup("Error removing item from the cart", "error", 5000); // unspecified error
						}else{
							var errors = response.split("~|~");
							var timeout = errors.length-1;
							if(errors.length){
								errors = errors.join("<br>");
								popup(errors, "error", (5000 + (1000 * (timeout))));
							}					
						}
					}else{
						$('#ajax_loading').hide();
						popup(response, "error", 5000);
					}
				}
			});	
		}
		
		function changeCountry(elm, prefix){
			var countryID = $(elm).val();
			var isSameAddress = $("input[type='radio'][name='same_address']:checked").val() == "yes";
			var isShippingField = (isSameAddress || prefix == "shipping_");
			var isCourierEnabled = $("input[type='radio'][name='checkout_shipping']:checked").val() == "yes";
			if(!isShippingField || countryID == "44"){
				resetFields(prefix);
				return;
			}
			if(isCourierEnabled || isShippingField){
				typeOfPopup = (isCourierEnabled) ? "error" : "warning";
				if(isCountrySupported(countryID, typeOfPopup)){
					resetFields(prefix);
				}
			}
		}
		
		function resetFields(prefix){
			$('#invalid_'+prefix+'zip_code').css('visibility', 'hidden');
			$('#'+prefix+'zip_code').val('');
			$('#'+prefix+'city').val('');
			$('#'+prefix+'cityID').val('');
			$('#'+prefix+'address').val('');	
		}
		
		function isCountrySupported(countryID, typeOfPopup){
			odyshop.success = false;
			$('#ajax_loading').show();
			jQuery.ajax({
				type: "GET",
				url: "ajax_shipping_cost.php",
				data: "countryID="+countryID+"&check_country=1&langID=<?php echo $langID;?>",
				async: false,
				success: function(response){
					//console.log(response);
					if(response.indexOf("ok_") != -1){
						odyshop.success = true;
					}else{
						if(typeOfPopup == "error" || !typeOfPopup){
							popup(response, "error", 5000);
						}else{
							popup(response, "warning", 5000);
						}
						cancelShippingCost(response);
					}
					$('#ajax_loading').hide();
				}
			});
			return odyshop.success;		
		}
		
		function checkZipCode(elm, prefix){
			if($('#'+prefix+'countryID').val() == '44'){ // only for Greece
				var zip_code = $(elm).val();
				if(!zip_code) return;
				$('#ajax_loading').show();
				jQuery.ajax({
					type: "GET",
					url: "ajax_zip_code.php",
					async: false,
					data: "zip_code="+zip_code+"&action=validate&langID=<?php echo $langID;?>",
					success: function(response){
						//console.log(response);
						if(response == "ok"){
							$('#invalid_'+prefix+'zip_code').css('visibility', 'hidden');
						}else{	
							$('#invalid_'+prefix+'zip_code').css('visibility', 'visible');
							$('#'+prefix+'city').val('');
						}
						$('#ajax_loading').hide();
					}
				});		
			}
		}
		
		function checkCity(elm, prefix){
			validateCity(prefix);
			if($('#'+prefix+'countryID').val() == '44'){ // only for Greece
				var zip_code = $('#'+prefix+'zip_code').val();
				var area_name = ($('#'+prefix+'city').attr("data-inaccessible")) ? $('#'+prefix+'city').val() : "";
				var cityID = $('#'+prefix+'cityID').val();
				if($('#invalid_'+prefix+'zip_code').css('visibility') == "visible" || !zip_code){
					$(elm).blur();
					$('#'+prefix+'zip_code').focus();
					return;
				}
				$('#selectCity').attr("href", "getCitiesByZipCode.php?langID=<?php echo $langID;?>&prefix=" + prefix + "&cityID=" + cityID + "&area_name=" + area_name + "&zip_code=" + zip_code).click();
			}
		}
		
		function validateCity(prefix){
			if($('#'+prefix+'countryID').val() == '44'){ // only for Greece
				var zip_code = $('#'+prefix+'zip_code').val();
				if(!zip_code || $('#invalid_'+prefix+'zip_code').css('visibility') == "visible"){
					$('#'+prefix+'city').addClass("error_field").val("<?php echo t("Πρέπει πρώτα να εισάγετε έναν ισχύοντα ταχυδρομικό κώδικα");?>");
					setTimeout(function(){
						$('#'+prefix+'city').removeClass("error_field");
						$('#'+prefix+'city').val("");
					}, 3000);
					return false;
				}
			}
		}
		
		function calculateShippingCost(){
			var isSameAddress = $("input[type='radio'][name='same_address']:checked").val() == "yes";
			var isCourierEnabled = $("input[type='radio'][name='checkout_shipping']:checked").val() == "yes";
			var silent = (!isCourierEnabled) ? 1 : "";
			if(isSameAddress){
				var countryID = $('#billing_countryID').val();
				var cityID = $('#billing_cityID').val();
			}else{
				var countryID = $('#shipping_countryID').val();
				var cityID = $('#shipping_cityID').val();		
			}
			var total_weight = $('#checkout_order_results').attr('data-weight');
			var total_cost = $('#checkout_order_results').attr('data-total');
			$('#ajax_loading').show();
			jQuery.ajax({
				type: "GET",
				url: "ajax_shipping_cost.php",
				data: "countryID="+countryID+"&silent="+silent+"&cityID="+cityID+"&total_weight="+total_weight+"&total_cost="+total_cost+"&langID=<?php echo $langID;?>",
				async: false,
				success: function(response){
					//console.log(response);
					if(response.indexOf("ok_") != -1){
						var parts = response.split("_");
						var shipping_cost = parts[1];
						var delivery = parts[2];
						var daysText = (delivery == "1") ? t('μέρα') : t('μέρες');	
						var byCourier = $('input[name=checkout_shipping]:checked').val() == "yes";
						if(byCourier) $('#shipping_amount_wrapper').show();
						if(shipping_cost == "free"){
							$('#checkout_shipping_cost').html("<?php echo t("Δωρεάν");?>&nbsp;&nbsp;&nbsp;<span class='checkout_shipping_delivery'>(<?php echo t("παράδοση σε");?> " + delivery + " " + daysText + ")</span>");
							$('#checkout_shipping_cost').attr("data-amount", 0);
							if(byCourier){
								$('#shipping_amount').html(0);
								$('#checkout_order_results').attr('data-shipping_cost', 0);	
							}					
						}else{
							$('#checkout_shipping_cost').html(formatPrice(shipping_cost, odyshop.currency) + "&nbsp;&nbsp;&nbsp;<span class='checkout_shipping_delivery'>(<?php echo t("παράδοση σε");?> " + delivery + " " + daysText + ")</span>");
							$('#checkout_shipping_cost').attr("data-amount", shipping_cost);	
							if(byCourier){
								$('#shipping_amount').html(formatPrice(shipping_cost, odyshop.currency));
								$('#checkout_order_results').attr('data-shipping_cost', shipping_cost);	
							}
						}
						calculateTotal();				
					}else{
						if(response){
							popup(response, "error", 5000);
							cancelShippingCost(response);
						}
					}
					$('#ajax_loading').hide();
				}
			});	
		}
		
		function calculateTotal(cod){
			cod = (cod) ? cod : 0;
			var total = $('#checkout_order_results').attr('data-total');
			var shipping_cost = $('#checkout_order_results').attr('data-shipping_cost');
			total = (total) ? parseFloat(total) : 0;
			shipping_cost = (shipping_cost) ? parseFloat(shipping_cost) : 0;
			total+= (shipping_cost + cod);
			$('#checkout_total').html(formatPrice(total, odyshop.currency));
		}
		
		function cancelShippingCost(msg){
			$('input:radio[name=checkout_shipping]').filter('[value=no]').prop('checked', true); // cancel courier method and set pick up in the store
			$('#checkout_shipping_cost').html(msg).attr('data-amount', 0);
			$('#shipping_amount_wrapper').hide();
			$('#checkout_order_results').attr('data-shipping_cost', '0');
			calculateTotal();	
			return;	
		}
		
		function submitOrder(){	
			var payment_method = $("input[name='payment_method']:checked").val();
			if(payment_method == undefined) {
			   popup("<?php echo t("Πρέπει να επιλέξετε μια μέθοδο πληρωμής");?>", "error");
			   return false;
			}
			<?php
			if(!empty($this->terms_enabled)){
			?>		
			if(!$('#terms').prop("checked")){
				popup("<?php echo t("Πρέπει να συμφωνήσετε με τους όρους συναλλαγών");?>", "error");
				return false;
			}
			<?php
			}
			?>
			$('#shipping_cost').val($('#checkout_order_results').attr('data-shipping_cost'));
			$('#cod').val($('#checkout_order_results').attr('data-cod'));
			$('#order_form').submit();
		}

	</script>

	<?php
	break;
	
case "orders":
	if(!$parameters->getParameter("basket_enabled")){
		?>
		<script type="text/javascript">document.location.href="index.php";</script>
		<?php
		exit;
	}
	$userLoged = $auth->getLoginStatus() != 2;
	$userID = ($userLoged) ? $_SESSION['userID'] : NULL;	
	$this->userID = $userID;
	if($id) $this->order = $content->getContentByID("orders", $id, "*", "*", $langID);
	if($this->order){
		$this->order_products = $content->getContent("order_products", " order_products.orderID='$id' ", "*", "*", $langID, " content_order_products.title");
		$this->id = $id;
		if(!count($this->order_products)) $messages->addError("System error: No associated products found for this order");
	}
	$this->userLoged = $userLoged;
	$this->date_from = $date_from;
	$this->date_to = $date_to;
	$this->price_from = $price_from;
	$this->price_to = $price_to;
	?>
	<script type="text/javascript">
		jQuery(function($){
			$('.price_box').each(function(){
				$(this).on('change', function(){
					var price_from = Number($('#price_from').val());
					var price_to = Number($('#price_to').val());
					if(price_from > 0 && price_to > 0){
						if(price_from > price_to){
							$('#price_from').val(price_to);
							$('#price_to').val(price_from);
						}
					}
				}).on('keydown', function(e){
					var key = e.which;
					if((key >= 48 && key <= 57) || (key >= 96 && key <= 105) || (key == 8 || key == 46)) return true;
					return false;
				});
			});
				
			$('#date_from').datepicker({
				onClose: function(selectedDate){
					$('#date_to').datepicker("option", "minDate", selectedDate);
				}
			});
			$('#date_to').datepicker({
				onClose: function(selectedDate){
					$('#date_from').datepicker("option", "maxDate", selectedDate);
				}
			});
		});
		function resetOrdersSearch(){
			$('#date_from').val("");
			$('#date_to').val("");
			$('#price_from').val("");
			$('#price_to').val("");
			$('#find').submit();
		}
	</script>

	<?php
	break;
	
case "order":
	if(!$parameters->getParameter("basket_enabled")){
		?>
		<script type="text/javascript">document.location.href="index.php";</script>
		<?php
		exit;
	}
	$include_vat = (int)$parameters->getParameter("include_vat");
	$fixed_shipping_cost = (float)$parameters->getParameter("fixed_shipping_cost");
	$shippingCost = ($fixed_shipping_cost) ? $fixed_shipping_cost : 0;
	$userLoged = $auth->getLoginStatus() != 2;
	$userID = ($userLoged) ? $_SESSION['userID'] : NULL;	
	$basketTypeID = ($userID) ? $basket->getBasketTypeID("basket") : $basket->getBasketTypeID("session");
	$basketTypeName = $basket->getBasketTypeName($basketTypeID);	
	if($userID){ // registered client
		$basketItems = $content->getContent("basket", " active=1 and userID='".$userID."' and basket_type='".$basketTypeID."'", array('productID', 'quantity', 'combination'), false, $language->getDefaultLanguage(), "content_basket.title");
	}else{ // visitor
		$basketItems = $basket->sessionBasket;
	}
	if(!count($basketItems) && !$action){
		?>
		<script type="text/javascript">document.location.href="index.php";</script>
		<?php
		exit;
	}	
	$totalBasketItems = 0;
	global $totalPrice;
	$totalPrice = 0;
	$totalVat = 0;
	$isInstock = true;
	foreach($basketItems as $basketItem){
		if($userID){ // registered client
			$productID = $basketItem->productID;
			$combination = $basketItem->combination;
			$quantity = $basketItem->quantity;			
		}else{ // session basket
			list($uid, $productID, $quantity, $combination) = explode("~|~", $basketItem);
		}
		$product = $content->getContentByID("products", $productID, array('id', 'price', 'vat', 'instock'), array('title'), $langID);
		$instock = $product->instock;
		if(!$instock) $isInstock = false;
		$vat = ($product->vat) ? $content->getValue("fpa_cat", $product->vat, "percent", $langID) : 0;
		$price = $eshop->getProductPrice($productID, $combination, $quantity);
		if($include_vat) $price = $eshop->includeVat($price, $vat);
		$totalBasketItems += $quantity;
		if(empty($include_vat)){
			$totalPrice+= ($eshop->includeVat($price, $vat) * $quantity);
		}else{
			$totalPrice+= ($price * $quantity);
		}				
	}
	// import all safe request variables to global scope
	foreach($safeRequest as $key=>$val) global ${$key};
	$document->shippingCost = ($shippingCost) ? $shippingCost : $safeRequest->shipping_cost;
	$cod = $safeRequest->cod;
	$_SESSION['order'] = $safeRequest;
	$_SESSION['order']->isInstock = $isInstock;
	$_SESSION['order']->basketItems = $basketItems;
	$_SESSION['order']->userID = $userID;
	$_SESSION['order']->total = $totalPrice;
	$_SESSION['order_errors'] = array(); // clear any previous order error	
	$this->payment = ($payment_method) ? $payment_method:  $payment;
	$this->action = $action;	
	break;	
			
}

$this->javascript = ob_get_clean();


// seo settings
$thisPage = getBase()."index.php?section=".$section."&view=".$view."&id=".$id."&r=".rand();
$seoNotFound = true;
if($id){
	$seoQuery = "select * from `seo` where sectionID='$this->sectionID' and itemId='$id' and langID='$langID'";
	$seo = $db->getRecord($seoQuery);
	if(!$seo){
		$seoNotFound = true;
	}else{
		$seoNotFound = (empty($seo->title) && empty($seo->description) && empty($seo->keywords) && empty($seo->meta));
	}
	if(!$seoNotFound){ // specific seo settings found
		if($seo->title) $this->setHtmlTitle($seo->title, !$seo->overwrite_title); // in case of true in second argument, the append behavior will be activated
		$meta = array(
		'<meta name="description" content="'.$seo->description.'">',
		'<meta name="keywords" content="'.$seo->keywords.'">',
		'<meta property="og:title" content="'.$seo->title.'">',
		'<meta property="og:type" content="article">',
		'<meta property="og:url" content="'.$thisPage.'">',
		'<meta property="og:description" content="'.$seo->description.'">',
		'<meta property="og:image" content="'.getBase().$this->getTemplatePath().'images/fb_default.jpg">'		
		);	
		$meta_entries = explode(PHP_EOL, $seo->meta);
		$meta = array_merge($meta, $meta_entries);
		$this->setMeta($meta);	
	}
}
if($seoNotFound){ // general settings
// add general meta tags
$theTitle =t("Περιοχή μελών");

$meta = array(
'<meta name="description" content="'.$parameters->getParameter('description').'">',
'<meta name="keywords" content="'.$parameters->getParameter('keywords').'">',
'<meta property="og:title" content="'.$theTitle.'">',
'<meta property="og:type" content="article">',
'<meta property="og:url" content="'.$thisPage.'">',
'<meta property="og:description" content="'.$parameters->getParameter('description').'">',
'<meta property="og:image" content="'.getBase().$this->getTemplatePath().'images/fb_default.jpg">'	
);
$this->setHtmlTitle($theTitle, true); // true to activate the append behavior
$this->setMeta($meta);
}


$this->setStyles($sectionCssFile);
$this->setStyles($cssFiles);
$this->setJsFiles($sectionJsFile);
$this->setJsFiles($jsFiles);
$this->setJsReady(is_file($sectionJsReadyFile) ? file_get_contents($sectionJsReadyFile).$this->javascript_ready : $this->javascript_ready);



// *************************************************************************
// include all controller vars that need to be passed to view in order to encapsulate them
$controllerVars = array('login', 'restore', 'recordAdded', 'row', 'title', 'username', 'password', 'address', 'city', 'cityID', 'zip_code', 'email', 'phone', 'countryID');
foreach($controllerVars as $var){
	$this->$var = ${$var};
	$this->setData($this->$var);
}

// *************************************************************************
?>