<?php 
define("CMS", "korCMS");
require_once("functions.php");
require_once("config/odyssey.ini.php");	// access from root folder

checkInstallation();
filterInvalidRequest();
setErrorReporting();
getHeaders();
importSession();
cleanUpUploads();

$protocol = getProtocol();
$imports = array();
$library = array();
$phrases = array();
import("library.*"); // load all Odyshop classes
$messages = new messages();
$auth = new authentication(false);
$db = new db();
$categories = new categories();
$content = new content();
$dates = new dates();
$fileSystem = new fileSystem();
$language = new language();
$menu = new menu();
$parameters = new parameters();
$system = new system();
$variables = new variables();
$basket = new basket();
$timer = new timer();
$banners = new banners();
$sef = new sef();
$eshop = new eshop();
$cache = $parameters->getParameter("cache"); // if DB caching is enabled or not
$is_uc = $parameters->getParameter("uc"); // if this website is under construction
if($is_uc) $auth = new authentication(true, true); // only admin allowed to view the website in under construction mode
$system->clearLog();
unset($_SESSION['currentLanguage']);
$language->setCurrentLanguage((int)$_REQUEST['langID']);
$langID = $language->getCurrentLanguage();
$langExtension = $language->getLanguageExtension($langID);
$urlExtension = ($langExtension == "_gr") ? NULL : $langExtension;
$domainPath = $protocol."://".$_SERVER['HTTP_HOST']."/";
$email_address = $parameters->getParameter("email"); // main email for this e-shop
if(!$email_address) die("No registered email address found in system settings");
$fieldTypes = array("textfield", "checkbox", "select", "section", "date", "colorpicker", "sprite", "textarea"); // for module parameters fields		
$spritePath = "mediabank/icons/";
$spriteExt = "png";
$system_fields = array('id', 'active', 'private', 'sort', 'alias', 'parent', 'target', 'access', 'lat', 'lng', 'zoom', 'mainID', 'langID');
$singleModulesCss = array('tabs.css');
$singleModulesJs = array('tabs.js');
$singleModulesCssLoaded = array();
$singleModulesJsLoaded = array();

manageLogout();
manageMultilingual();
cleanUpConnectedUsers();
?>
