<?php  
require_once("dll.php");
$db->query("SET NAMES 'utf8mb4'");
$document = new document();
$variables->getSafeVars(array_keys($_REQUEST));
$template = $document->getDefaultTemplate();
$templatePath = $document->getTemplatePath();
$login = $auth->getLoginStatus() != 2;

$sc_countryID = ($_SESSION['sc_countryID']) ? $_SESSION['sc_countryID'] : $eshop->getGreeceID();
$isGreekDestination = $eshop->isGreekDestination($sc_countryID);
if($isGreekDestination){
	$sc_countyID = $_SESSION['sc_countyID'];
	$sc_cityID = $_SESSION['sc_cityID'];
	$sc_inaccessible = $_SESSION['sc_inaccessible'];
}
$currency = $eshop->getCurrency();
$currency_sign = $currency->sign;
$currency_code = $currency->code;
$currency_start_position = $currency->start_position;
$currency_decimal = $currency->decimal;
$currency_decimal_seperator = $currency->decimal_seperator;
$currency_thousands_seperator = $currency->thousands_seperator;
?>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link rel="shortcut icon" href="favicon.ico">
<?php loadGlobalFiles("css"); ?>
<link href="templates/<?php echo $template;?>/css/styles.css" rel="stylesheet" type="text/css">
<link href="templates/<?php echo $template;?>/css/forms.css" rel="stylesheet" type="text/css">
<style type="text/css">
body {
	background-color: #ECECEC;
}
</style>
<script type="text/javascript" src="js/jquery.js"></script>
<script type="text/javascript" src="js/common.js.php?langID=<?php echo $langID;?>"></script>
<?php loadGlobalFiles("js"); ?>
<script type="text/javascript">
odyshop.currency = {
	sign:"<?php echo $currency_sign;?>",
	code:"<?php echo $currency_code;?>",
	start_position:"<?php echo $currency_start_position;?>",
	decimal:"<?php echo $currency_decimal;?>",
	decimal_seperator:"<?php echo $currency_decimal_seperator;?>",
	thousands_seperator:"<?php echo $currency_thousands_seperator;?>"
};
jQuery(document).ready(function($) {	

	displayWeight();
	$('#countryID').change();
	<?php
	if($sc_countyID){
	?>
	setTimeout(function(){
		$('#countyID').change();
		$('#cityID').change();
	},100);
	<?php	
	}
	if($sc_inaccessible){
	?>
	setTimeout(function(){
		$('#inaccessible').click();
		$('#inaccessible').prop("checked", true);
	},200);	
	<?php	
	}
	if(!$isGreekDestination){
	?>
	setTimeout(function(){
		$('#countryID').change();
	},100);	
	<?php	
	}
	?>
	
	$('#accept_shipping_cost').on("click", acceptShippingCost);
	$('#inaccessible').on("click", function(){
		if($(this).prop("checked")){
			$('#get_shipping_cost').show();
			$('#accept_shipping_cost').hide();
			$('#cityID').val("");
			getShippingCost();			
		}else{
			if(!$('#cityID').val()){
				$('#get_shipping_cost').hide();
				$('#accept_shipping_cost').hide();
				$('#shipping_cost').hide();				
			}
		}
	});
	
	$('#countryID').on("change", function(){
		var countryID = $(this).val();
		var greeceID = '<?php echo $eshop->getGreeceID();?>';
		$('#inaccessible').prop("checked", false);	
		if(countryID == greeceID){
			$('#counties').show();
			$('#amount').html("");
			$('#amount').attr("data-amount", "");
			$('#shipping_cost').hide();
			if($('#countyID').val()){
				$('#cities').show();
				$('#countyID').change();			
			}else{
				$('#accept_shipping_cost').hide();				
			}
		}else{
			$('#counties').hide();
			$('#cities').hide();
			if(countryID) getShippingCost();
		}
	});
	
	$('#countyID').on("change", function(){
		var countyID = $(this).val();
		var selectedCityID = $('#selectedCityID').val();
		$('#amount').html("");
		$('#amount').attr("data-amount", "");
		$('#shipping_cost').hide();
		$('#inaccessible').prop("checked", false);	
		if(!countyID){
			$('#cityID').val("");
			$('#selectedCityID').val("");
			$('#cities').hide();
			$('#amount').html("");
			$('#amount').attr("data-amount", "");
			$('#shipping_cost').hide();	
			$('#accept_shipping_cost').hide();			
			return false;
		}
		$('#ajax_loading').show();
		jQuery.ajax({
			type: "GET",
			url: "ajax_geo.php",
			data: "countyID="+countyID+"&langID=<?php echo $langID;?>&selectedCityID=" + selectedCityID,
			async: true,
			success: function(response){
				//console.log(response);
				if(response != "error"){
					$('#cities').show();
					$('#cityID').html(response);
					$('#cityID').change();
				}else{
					popup(response, "Error loaging cities", 5000);
				}
				$('#ajax_loading').hide();
			}
		});		
	});
	
	$('#cityID').on("change", function(){
		var cityID = $(this).val();
		if(!cityID){
			if(!$('#inaccessible').prop("checked")){
				$('#amount').html("");
				$('#amount').attr("data-amount", "");
				$('#shipping_cost').hide();	
				//$('#get_shipping_cost').hide();
				$('#accept_shipping_cost').hide();				
			}
			return false;
		}
		$('#inaccessible').prop("checked", false);		
		getShippingCost();
	});		

<?php
// detect rainbow color themes
if(is_file($templatePath."css/themes/steel_blue.css")){
?>	
	var user_color_palete = getCookie('colors');
	var current_theme = (user_color_palete) ? user_color_palete : parent.current_theme;
	current_theme = (current_theme) ? current_theme : "steel_blue";	
	if(current_theme){
		$("<link/>", {
		   rel: "stylesheet",
		   type: "text/css",
		   href: "<?php echo $templatePath."css/themes/";?>" + current_theme + ".css"
		}).appendTo("head");
	}
<?php
}
?>
});

function getShippingCost(){
	var countryID = $('#countryID').val();
	var countyID = $('#countyID').val();
	var cityID = $('#cityID').val();
	var total_weight = parseFloat(parent.$('#total_weight').val());
	var total_cost = parent.calculateBasket();
	var inaccessible = ($('#inaccessible').prop("checked")) ? 1 : 0;
	$('#selectedCityID').val(cityID);		
	$('#ajax_loading').show();
	jQuery.ajax({
		type: "GET",
		url: "ajax_shipping_cost.php",
		data: "countryID="+countryID+"&countyID="+countyID+"&cityID="+cityID+"&total_weight="+total_weight+"&total_cost="+total_cost+"&inaccessible="+inaccessible+"&langID=<?php echo $langID;?>",
		async: true,
		success: function(response){
			//console.log(response);
			//$('#get_shipping_cost').show();
			if(response != "error"){
				if(response.indexOf("ok_") != -1){ // we have amount or free
					var response = response.replace("ok_", "");
					var parts = response.split("_");
					var price = parts[0];
					var delivery = parts[1];	
					var daysText = (delivery == "1") ? t('μέρα') : t('μέρες');	
					$('#shipping_cost').show();
					//$('#get_shipping_cost').show();
					$('#accept_shipping_cost').show();
					if(price == "free"){
						$('#amount').html("<?php echo t("Δωρεάν");?>&nbsp;&nbsp;&nbsp;(<?php echo t("παράδοση σε");?> " + delivery + " " + daysText + ")");
						$('#amount').attr("data-amount", 0);
					}else{
						$('#amount').html(formatPrice(price, odyshop.currency) + '&nbsp;&nbsp;&nbsp;(<?php echo t("παράδοση σε");?> ' + delivery + ' ' + daysText + ')');
						$('#amount').attr("data-amount", price);							
					}
					$('#delivery').val(delivery);
				}else{
					$('#accept_shipping_cost').hide();
					if(response == "not supported"){
						popup("<?php echo t("Δεν μπορεί να γίνει αποστολή στην χώρα που επιλέξατε");?>", "error", 5000);
					}
					if(response == "overweight"){
						popup("<?php echo t("Δεν μπορεί να γίνει αποστολή στο εξωτερικό με βάρος μεγαλύτερο των 50 κιλών");?>", "error", 5000);
					}						
				}
			}else{
				popup("Error getting shipping cost", "error", 5000);
			}
			$('#ajax_loading').hide();
		}
	});						
}

function acceptShippingCost(){
	var countryID = $('#countryID').val();
	var countyID = $('#countyID').val();
	var cityID = $('#cityID').val();
	var inaccessible = ($('#inaccessible').prop("checked")) ? 1 : 0;
	var shipping_cost = $('#amount').attr("data-amount");
	var delivery = $('#delivery').val();
	if(!countryID){
		popup("countryID is missing", "error");
		return false;
	}
	if(!shipping_cost){
		popup("shipping cost is missing", "error");
		return false;
	}
	if(!delivery){
		popup("delivery in days is missing", "error");
		return false;
	}
	var shipping_data = countryID + "|" + countyID + "|" + 	cityID + "|" + inaccessible + "|" + shipping_cost + "|" + delivery;
	parent.$('#shipping_data').val(shipping_data);
	parent.$.fancybox.close();
}

function displayWeight(){
	var total_weight = parseFloat(parent.$('#total_weight').val());
	if(total_weight){
		var weight_symbol = '<?php echo $parameters->getParameter("weight_symbol");?>';
		var weight = " (" + t("Βάρος") + ": " + Math.ceil(total_weight) + " " + weight_symbol + ")";
		$('.sc_header').append(weight);
	}
}


</script>
</head>
<body>
<div id="ajax_loading"></div>
<div class="sc_header"><?php echo t("Υπολογισμός κόστους αποστολής");?></div>
<table id="sc_table">
	<tr id="countries">
		<td class="sc_label"><?php echo t("Χώρα");?></td>
		<td>
		<select id="countryID" class="bt_listbox">
		<?php
		$queryLangID = ($langID != 1) ? 2 : $langID;
		$countries = $db->getRecords("select distinct mainID as id, title from countries, content_countries where active=1 and langID='$queryLangID' order by title");
		$valid_countries = $eshop->getShippingCountries();
		foreach($countries as $country){
			if(in_array($country->id, $valid_countries)){
			?>
			<option value="<?php echo $country->id;?>"<?php if($country->id == $sc_countryID) echo " selected";?>><?php echo $country->title;?></option>
			<?php
			}
		}
		?>
		</select>
		</td>
	</tr>
	<tr id="counties"<?php if(!$isGreekDestination) echo 'style="display:none;"';?>>
		<td class="sc_label"><?php echo t("Νομός");?></td>
		<td>
		<select id="countyID" class="bt_listbox">
			<option value=""<?php if(!$sc_countyID) echo " selected";?>>-- <?php echo t("Επιλέξτε Νομό");?> --</option>
		<?php
		$queryLangID = ($langID != 1) ? 2 : $langID;
		$counties = $db->getRecords("select distinct mainID as id, title from counties, content_counties where active=1 and langID='$queryLangID' order by title");
		foreach($counties as $county){
			?>
			<option value="<?php echo $county->id;?>"<?php if($county->id == $sc_countyID) echo " selected";?>><?php echo $county->title;?></option>
			<?php
		}
		?>		
		</select>
		</td>
	</tr>
	<tr id="cities"<?php if(!$isGreekDestination || !$sc_regionID) echo 'style="display:none;"';?>>
		<td class="sc_label" style="vertical-align: top; padding-top: 5px;">
		<?php echo t("Πόλη");?>
		<br><br><input type="checkbox" name="inaccessible" id="inaccessible" value="1" style="margin-top: 10px">
		</td>
		<td>
		<select id="cityID" class="bt_listbox">
			<option value=""<?php if(!$sc_cityID) echo " selected";?>>-- <?php echo t("Επιλέξτε πόλη");?> --</option>
		<?php
		if($sc_countyID){
			$queryLangID = ($langID != 1) ? 2 : $langID;
			$cities = $db->getRecords("select distinct mainID as id, title from cities as c, content_cities as cc  
													where c.active=1 and cc.langID='$queryLangID' 
													and c.id=cc.mainID  
													and countyID='$sc_countyID' 
													order by title");
			foreach($cities as $city){
				?>
				<option value="<?php echo $city->id;?>"<?php if($city->id == $sc_cityID) echo " selected";?>><?php echo $city->title;?></option>
				<?php
			}
		}
		?>		
		</select>	
		<br><br><span style="font-size:.9em; font-style:italic"><?php echo t("Η περιοχή μου δεν εμφανίζεται (άλλη δυσπρόσιτη περιοχή)");?></span>	
		</td>
	</tr>
	<tr id="shipping_cost" style="display:none">
		<td class="sc_label"><?php echo t("Έξοδα αποστολής");?>:</td>
		<td id="amount" data-amount="" style="font-size: 100%"></td>
	</tr>	
	<tr>
		<td>&nbsp;</td>
		<td>
		<!--<input type="button" id="get_shipping_cost" class="sc_button rainbow" style="color:white; display:none" value="<?php echo t("Υπολογισμός");?>">-->
		<input type="button" id="accept_shipping_cost" class="sc_button rainbow" style="color:white; display:none" value="<?php echo t("Αποδοχή");?>">
		<input onclick="parent.$.fancybox.close()" type="button" id="cancel_shipping_cost" class="sc_button sc_cancel" value="<?php echo t("Κλείσιμο");?>">
		<input type="hidden" id="selectedCityID" value="<?php echo $sc_cityID;?>">
		<input type="hidden" id="delivery" value="">
		</td>
	</tr>	
</table>
</body>
</html>
