<?php 
defined('CMS') or die("This file cannot run this way!");
class blog{

	private $blog = "blog";
	private $comments = "blogcomments";
	private $categories = "blogcategories";
	private $categoryFieldName = "blogCatID";
	
	function getBlogPosts($page=1, $catID=0, $month, $year, $userID, $all=false) {
		global $system;
		$categoryType = $this->getCategoryType();
		if($categoryType == "selectList") return $this->getBlogPostsByMultiCategories($page, $catID, $month, $year, $userID, $all);
		global $db;
		global $content;
		global $langID;
		$page=(int)$page;
		$catID=(int)$catID;
		$year=(int)$year;
		$userID = ($userID) ? (int)$userID : $this->getAuthor();
		$presults = $system->getPresults($this->blog);
		$startrecord= ($page * $presults) - $presults;
		$startrecord= ($startrecord < 0) ? 0 : $startrecord;
		$q = "select ".$this->blog.".*, 
		content_".$this->blog.".title, 
		content_".$this->blog.".minitext, 
		content_".$this->blog.".body 
		from ".$this->blog.", content_".$this->blog." 
		where ".$this->blog.".active=1 
		and content_".$this->blog.".langID=".$langID." 
		and ".$this->blog.".userID='".$userID."' 
		and content_".$this->blog.".mainID=".$this->blog.".id ";	
		if($catID) $q.="and ".$this->blog.".blogCatID='".$catID."' ";
		if($month && $year) $q.="and (FROM_UNIXTIME(".$this->blog.".published, '%m')='".$month."' and FROM_UNIXTIME(".$this->blog.".published, '%Y')='".$year."') ";
		if(!$all) $q.="order by ".$this->blog.".published desc LIMIT $startrecord, $presults";
		$posts = $db->getRecords($q);
		return (count($posts)) ? $posts : false;
	}
	
	function getBlogPostsByMultiCategories($page, $catID, $month, $year, $userID, $all) {
		global $system;
		global $db;
		global $content;
		global $langID;
		$sectionID = $system->getTableSectionID($this->blog);
		$fieldID = $system->getFieldID($this->categoryFieldName, $sectionID);
		$page=(int)$page;
		$catID=(int)$catID;
		$year=(int)$year;
		$userID = ($userID) ? (int)$userID : $this->getAuthor();
		$presults = $system->getPresults($this->blog);
		$startrecord= ($page * $presults) - $presults;
		$startrecord= ($startrecord < 0) ? 0 : $startrecord;
		$q = "select distinct ".$this->blog.".*, 
		content_".$this->blog.".title, 
		content_".$this->blog.".minitext, 
		content_".$this->blog.".body 
		from ".$this->blog.", content_".$this->blog.", selectlists  
		where ".$this->blog.".active=1 
		and ".$this->blog.".userID='".$userID."' 
		and content_".$this->blog.".mainID=".$this->blog.".id 
		and content_".$this->blog.".langID=".$langID." 
		and selectlists.sectionID='2505' 
		and selectlists.fieldID='1605' 
		and selectlists.itemID=".$this->blog.".id ";
		if($catID) $q.="and selectlists.optionID='".$catID."' ";	
		if($month && $year) $q.="and (FROM_UNIXTIME(".$this->blog.".published, '%m')='".$month."' and FROM_UNIXTIME(".$this->blog.".published, '%Y')='".$year."') ";
		if(!$all) $q.="order by ".$this->blog.".published desc LIMIT $startrecord, $presults";
		$posts = $db->getRecords($q);
		return (count($posts)) ? $posts : false;
	}	
	
	function getCategoryType(){
		global $db;
		$fieldVarName = $this->categoryFieldName;
		$type = $db->getRecord("select fieldType from `fields` where fieldVarName='$fieldVarName'")->fieldType;
		if($type != "selectMenu" && $type != "selectList") die("Invalid field type for category");
		return $type;
	}
			
	function getBlogPost($id){
		$id = (int)$id;
		if(!$id) return false;
		global $content;
		global $langID;
		return $content->getContentByID($this->blog, $id, "*", "*", $langID);
	}
	
	function getBlogComments($page=1, $postID){
		if(!(int)$postID) return false;
		global $db;
		global $system;
		global $langID;
		$presults = $system->getPresults($this->comments);
		$startrecord= ($page * $presults) - $presults;
		$startrecord= ($startrecord < 0) ? 0 : $startrecord;		
		$q = "select ".$this->comments.".*, 
		content_".$this->comments.".title, 
		content_".$this->comments.".body 
		from ".$this->comments.", content_".$this->comments." 
		where ".$this->comments.".active=1 
		and ".$this->comments.".postID='".$postID."' 
		and content_".$this->comments.".mainID=".$this->comments.".id 
		and content_".$this->comments.".langID=".$langID." 
		order by ".$this->comments.".published desc LIMIT $startrecord, $presults";
		$comments = $db->getRecords($q);
		return (count($comments)) ? $comments : false;
	}
	
	function getBlogCategories($postID=null){
		global $db;
		global $categories;
		global $langID;
		$categoryType = $this->getCategoryType($blog, $categoryFieldName);
		if($categoryType == "selectList") return $this->getBlogMultiCategories($postID);		
		$fieldName = $this->categoryFieldName;
		$q = "select distinct ".$this->categories.".*, 
		content_".$this->categories.".title 
		from ".$this->categories.", content_".$this->categories.", ".$this->blog." 
		where ".$this->categories.".active=1 
		and content_".$this->categories.".mainID=".$this->categories.".id 
		and content_".$this->categories.".langID=".$langID." 
		and ".$this->categories.".id=".$this->blog.".".$fieldName." ";  
		if($postID) $q.="and ".$this->blog.".id='".$postID."' ";
		$q.="order by ".$this->categories.".sort, content_".$this->categories.".title";
		$records = $db->getRecords($q);
		return (count($records)) ? $records : false;
	}
	
	function getBlogMultiCategories($postID){
		global $db;
		global $langID;
		$fieldName = $this->categoryFieldName;
		$q = "select distinct ".$this->categories.".*, 
		content_".$this->categories.".title 
		from ".$this->categories.", content_".$this->categories.", ".$this->blog.", selectlists  
		where ".$this->categories.".active=1 
		and content_".$this->categories.".mainID=".$this->categories.".id 
		and content_".$this->categories.".langID=".$langID." 
		and ".$this->categories.".id=selectlists.optionID ";
		if($postID) $q.="and ".$this->blog.".id='".$postID."' and selectlists.itemID=blog.id  ";
		$q.="order by ".$this->categories.".sort, content_".$this->categories.".title";
		$records = $db->getRecords($q);
		return (count($records)) ? $records : false;
	}		
	
	function getBlogArchive($year){
		global $db;
		global $langID;
		$currentYear = ((int)$year) ? (int)$year : date("Y");
		$q = "select distinct FROM_UNIXTIME(".$this->blog.".published, '%m') as month, 
		FROM_UNIXTIME(".$this->blog.".published, '%Y') as year,  ".$this->blog.".published 
		from ".$this->blog.", content_".$this->blog."  
		where FROM_UNIXTIME(".$this->blog.".published, '%Y')='".$currentYear."' 
		and ".$this->blog.".active=1 
		and content_".$this->blog.".mainID=".$this->blog.".id 
		and content_".$this->blog.".langID=".$langID." 		
		group by FROM_UNIXTIME(blog.published, '%m') 
		order by ".$this->blog.".published desc";
		$records = $db->getRecords($q);
		return (count($records)) ? $records : false;
	}
	
	function displayCategoryNames($postID){
		global $sef;
		if(!is_object($sef)) $sef = new sef();
		global $language;
		$records = $this->getBlogCategories($postID);
		$rows = count($records);
		$counter=0;
		foreach($records as $row){
			$url = 'index.php.php?section='.$this->blog.'&view=search&catID='.$row->id;
			$url = $sef->url($url, false);
			echo '<a href="'.$url.'" title="'.t("Όλα τα άρθρα στην κατηγορία").' \''.$this->getBlogCategoryName($row->id).'\'">'.$this->getBlogCategoryName($row->id).'</a>';
			$counter++;
			if($counter < $rows) echo " • ";
		}
	}
	
	function getBlogCategoryName($catID){
		global $langID;
		global $content;
		return $content->getValue("blogcategories", $catID, "title", $langID);
	}	
	
	function getBlogYears(){
		global $db;
		global $langID;
		$q = "select distinct FROM_UNIXTIME(published, '%Y') as year 
		from ".$this->blog.", content_".$this->blog." 
		where active=1 
		and content_".$this->blog.".mainID=".$this->blog.".id 
		and content_".$this->blog.".langID=".$langID." 		
		order by FROM_UNIXTIME(".$this->blog.".published, '%Y') desc";
		$records = $db->getRecords($q);
		return (count($records)) ? $records : false;
	}
	
	function getNumPosts($catID){
		global $db;
		global $langID;
		$table = $this->blog;
		if(!(int)$catID) return $db->getRecord("SELECT COUNT(*) as total FROM $table, content_$table where 
		content_".$table.".mainID=".$table.".id 
		and content_".$table.".langID=".$langID)->total;
		$posts = $this->getBlogPosts(null, $catID, null, null, null, true);
		$numOfPosts = count($posts);
		return ($numOfPosts) ? $numOfPosts : 0;
	}		
	
	function getTotalPosts($catID=0, $month, $year, $userID) {
		global $db;
		global $content;
		global $langID;
		$catID=(int)$catID;
		$year=(int)$year;
		$userID = ($userID) ? (int)$userID : $this->getAuthor();
		$q = "select ".$this->blog.".id 
		from ".$this->blog.", content_".$this->blog." where ".$this->blog.".active=1 
		and content_".$this->blog.".mainID=".$this->blog.".id 
		and content_".$this->blog.".langID=".$langID." 	
		and ".$this->blog.".userID='".$userID."' ";	
		if($catID) $q.="and ".$this->blog.".blogCatID='".$catID."' ";
		if($month && $year) $q.="and (FROM_UNIXTIME(".$this->blog.".published, '%m')='".$month."' and FROM_UNIXTIME(".$this->blog.".published, '%Y')='".$year."') ";
		$posts = $db->getRecords($q);
		return (count($posts));
	}
	
	function getTotalComments($postID) {
		if(!(int)$postID) return false;
		global $db;
		global $content;
		global $langID;
		$catID=(int)$catID;
		$year=(int)$year;
		$userID = ($userID) ? (int)$userID : $this->getAuthor();
		$q = "select distinct ".$this->comments.".id 
		from ".$this->comments.", content_".$this->blog.", ".$this->blog." where ".$this->comments.".active=1 
		and content_".$this->blog.".mainID=".$this->blog.".id 
		and content_".$this->blog.".langID=".$langID." 		
		and ".$this->comments.".postID='".$postID."' ";
		$comments = $db->getRecords($q);
		return (count($comments));
	}		
	
	
	function getAuthor(){
		global $db;
		return $db->getRecord("select id from users where active=1 limit 1")->id;
	}
	
	function getBlogPostAuthorName($postID){
		$section = $this->blog;
		global $content;
		$authorID = $content->getValue($section, $postID, "userID");
		return $content->getValue("users", $authorID, "title");
	}
	


} // end class
?>