<?php 
defined('CMS') or die("This file cannot run this way!");
class content{
	var $path = NULL;
	var $startDelimiter = "««";
	var $endDelimiter = "»»";
	var $returnValue = false;
	var $currencyCode;
	
	
	function __construct(){
		global $domainPath;
		$this->path = $domainPath.getFPath()."/mediabank/";
	}

	function recordExists($id, $table){
		if(!$table || !$id) return false;
		global $db;
		return $db->getNumRows("SELECT id from `$table` WHERE id='$id'") ? true : false;
	}
	
	function isActiveRecord($section, $id){
		if(!$section || !$id) return false;
		global $db;
		return $db->getRecord("SELECT active from `$section` WHERE id='$id'")->active == 1 ? true : false;		
	}

	function titleExists($title, $table){
		if(!$table || !$title) return false;
		global $db;
		global $langID;
		$q = "SELECT title from `content_$table` WHERE title='$title' and langID='$langID'";
		return $db->getNumRows($q) ? true : false;
	}
	
	
	function massContentDelete($delID, $section, $IDprefix="main", $forceDelete=false){
		if(!is_array($delID) || !$section) return false;
		if(!$forceDelete) $auth = new authentication(false);
		$isDeleted = false;
		if(count($delID)){
			foreach($delID as $id){
				if($this->removeContent($id, $section, $IDprefix, $forceDelete)) $isDeleted = true;
			}
		}
		return $isDeleted;
	}
	
	function removeContent($id, $section, $IDprefix="main", $forceDelete=false){
		if(!$id) return false;
		if(!$forceDelete) $auth = new authentication(true);
		global $db;	
		global $system;
		if($this->recordExists($id, $section)){
			$sectionID = $system->getTableSectionID($section);
			
			// if its a banner record, try to delete the banner image before the record's deletion
			if($section=="banners"){
				global $banners;
				$path = "../mediabank/banners/";
				$banner = $path.$banners->getBannerFilename($id);
				if(is_file($banner)){
					unlink($banner);
				}					
			}
			
			if($section == "users" && $_SERVER['SERVER_NAME'] != "localhost"){
				// check first if userID exists in order history
				$q = "select userID from `orders` where userID='$id'";
				$userExistsInOrdersHistory = $db->getNumRows($q);
				if($userExistsInOrdersHistory){
					global $messages;
					$messages->addError(t("Η διαγραφή χρηστών δεν επιτρέπεται.<br>Μπορείτε αν θέλετε να απενεργοποιήσετε χρήστες"));
					return false;
				}
			}			

			// continue to remove record					
			$db->query("DELETE FROM content_$section, $section USING content_$section INNER JOIN $section
			WHERE content_$section.".$IDprefix."ID=$section.id AND $section.id='$id'");
			$hasImagesAndFiles = $system->getSectionProperty($section, "hasAttachments");
			if($hasImagesAndFiles){
				$db->query("DELETE FROM content_images, images USING content_images INNER JOIN images
				WHERE content_images.imgID=images.id AND images.linkID='$id' AND images.sectionID='$sectionID'");
				$db->query("DELETE FROM content_files, files USING content_files INNER JOIN files
				WHERE content_files.fileID=files.id AND files.linkID='$id' AND files.sectionID='$sectionID'");
				$db->query("DELETE FROM content_videos, videos USING content_videos INNER JOIN videos
				WHERE content_videos.mainID=videos.id AND videos.linkID='$id' AND videos.sectionID='$sectionID'");						
			}
			
			// remove one to many relations
			$db->query("delete from `selectlists` where itemID='$id' AND sectionID='$sectionID' ");
			
			//remove aliases
			$isCategory = preg_match('/_categories$/', $section);
			$system->removeAlias($sectionID, $id, $isCategory);
			
			// remove enevts		   
			$db->query("DELETE FROM content_events, events USING content_events INNER JOIN events	
					   WHERE content_events.mainID=events.id AND content_events.url like '%id=$id%' ");	
					   
			// remove any comments
			$comments = $db->getRecords("select id from comments where articleID='$id' and sectionID='$sectionID'");
			foreach($comments as $comment){
				$commentID = $comment->id;
				$this->removeContent($commentID, "comments");
			}					   
					   
			// remove tags
			$this->removeTags($sectionID, $id);	
			
			// remove SEO tags
			$this->removeSEOTags($sectionID, $id);
			
			if($section == "users"){
				// remove permissions
				$db->query("DELETE FROM `content_permissions`, `permissions` 
				USING `content_permissions` 
				INNER JOIN `permissions`
				WHERE content_permissions.mainID=permissions.id AND permissions.userID='$id' ");
			}
			
			// remove any related content (CASCADE)
			$this->removeRelatedContent($sectionID, $id);
			if($section == "products"){
				$db->query("delete from `product_options_variants` where productID='$id'");
				$db->query("delete from `options` where productID='$id'");
				$db->query("delete from `options_exceptions` where productID='$id'");
				$db->query("delete from `features` where productID='$id'");
				$db->query("delete from `related_products` where productID='$id' or relatedID='$id'");
				$db->query("delete from `grouped_products` where productID='$id'");
			}
			if($section == "product_options"){
				$db->query("delete from `product_options_variants` where optionID='$id'");
				$db->query("delete from `options` where optionID='$id'");
				$q = "select id from `inventory` where combination like '%".$id."|%'";
				$items = $db->getRecords($q);
				foreach($items as $item){
					$combinationID = $item->id;
					$this->removeContent($combinationID, "inventory");
				}
				// manage exceptions
				$data = $this->createSerializeException($id);
				$q = "select id, combination from `options_exceptions` where combination like '%".$data."%'";
				$items = $db->getRecords($q);
				foreach($items as $item){
					$combination = unserialize($item->combination);
					$numOfPairs = count($combination);
					foreach($combination as $optionID=>$variantID){
						if($optionID == $id){
							$exceptionID = $item->id;
							$pair = $this->createSerializeException($optionID, $variantID);
							$string = str_replace($pair, NULL, $item->combination);
							if($numOfPairs > 1){ // update
								// reduce the array count index in the new serialized string ........................
								$replace = "a:".$numOfPairs;
								$replacement = "a:".($numOfPairs-1);
								$string = str_replace($replace, $replacement, $string);
								// .......................................................................................................
								$q = "update `options_exceptions`set combination='$string' where id='$exceptionID'";
								$db->query($q);
							}else{ // delete
								$db->query("delete from `options_exceptions` where id='$exceptionID'");
							}
						}
					}
				}
			}
			if($section == "product_features"){
				$db->query("delete from `features` where featureID='$id'");
			}
			if($section == "option_variants"){
				$db->query("delete from `product_options_variants` where variantID='$id'");
				$q = "select id from `inventory` where combination like '%|".$id."%'";
				$items = $db->getRecords($q);
				foreach($items as $item){
					$combinationID = $item->id;
					$this->removeContent($combinationID, "inventory");
				}
				// manage exceptions
				$optionID = $this->getValue("option_variants", $id, "optionID");
				$data = $this->createSerializeException($optionID, $id);
				$q = "select id, combination from `options_exceptions` where combination like '%".$data."%'";
				$items = $db->getRecords($q);
				foreach($items as $item){
					$combination = unserialize($item->combination);
					$numOfPairs = count($combination);
					foreach($combination as $optionID=>$variantID){
						if($variantID == $id){
							$exceptionID = $item->id;
							$pair = $this->createSerializeException($optionID, $variantID);
							$string = str_replace($pair, NULL, $item->combination);
							if($numOfPairs > 1){ // update
								// reduce the array count index in the new serialized string ........................
								$replace = "a:".$numOfPairs;
								$replacement = "a:".($numOfPairs-1);
								$string = str_replace($replace, $replacement, $string);
								// .......................................................................................................
								$q = "update `options_exceptions`set combination='$string' where id='$exceptionID'";
								$db->query($q);
							}else{ // delete
								$db->query("delete from `options_exceptions` where id='$exceptionID'");
							}
						}
					}
				}				
			}
			if($section == "feature_variants"){
				$db->query("delete from `features` where variantID='$id'");
			}			
			$isDeleted = true;
		}else{
			$isDeleted = false;
		}
	return $isDeleted;
	}
	
	function createSerializeException($optionID, $variantID=NULL){
		$optionID = (int)$optionID;
		if(empty($optionID)) return false;
		if((int)$variantID){
			$variantID = (string)$variantID;
			$data = array($optionID=>$variantID);
			$data = serialize($data);
			$data = str_replace("a:1:{", NULL, $data);
			$data = str_replace("}", NULL, $data);
		}else{
			$data = "i:".$optionID.";";
		}
		return $data;
	}	
	
	function removeRelatedContent($sectionID, $id){
		global $db;
		global $system;
		$sectionName = $system->getTableSectionName($sectionID);
		$sections = $db->getRecords("select id from sections");
		foreach($sections as $thisSection){
			$thisSectionID = $thisSection->id;
			$fields = $db->getRecords("select * from `fields` where tableSectionID='$thisSectionID'");
			foreach($fields as $field){
				if(($field->fieldType == "selectMenu" || $field->fieldType == "selectList") 
				&& $field->selectType == "flat" 
				&& $field->selectTableSectionName == $sectionName){
					$relatedSectionID = $system->getTableSectionID($field->selectTableSectionName);
					if($relatedSectionID == $sectionID){
						$targetSection = $system->getTableSectionName($field->tableSectionID);
						if($targetSection != "products"){ // prevent of products removal upon reletion
							$targetField = $field->fieldVarName;
							$q = "delete from `".$targetSection."` where `".$targetField."`=".$id;
							$db->query($q);
						}
					}
				}
			}			
		}
	}
			
	
	function massContentActivation($selectedID, $section, $activate=true){
		$activate = ($activate) ? 1 : 0;
		if(!is_array($selectedID) || !$section) return false;
		$auth = new authentication(false);
		global $system;
		$isPerformed = false;
		if(count($selectedID)){
			global $db;
			foreach($selectedID as $id){
				if($this->recordExists($id, $section)){
					$sectionID = $system->getTableSectionID($section);
					$db->query("UPDATE `$section` SET active=$activate WHERE $section.id='$id'");
					$isPerformed = true;
				}
			}
		}else{
			return false;
		}
		return $isPerformed;
	}	
	
	
	function massMediaBankDelete($delID){
		if(!is_array($delID)) return false;
		$auth = new authentication(false);
		$isDeleted = false;
		if(count($delID)){
			global $db;
			global $fileSystem;
			foreach($delID as $fileID){
				$ext = $fileSystem->getExtensionByFileTypeID($fileSystem->getFileTypeID($fileID));
				$fileToDelete1 = "images/".$fileID.".".$ext; // main image
				$fileToDelete2 = "medium/medium_".$fileID.".".$ext; // medium image
				$fileToDelete3 = "thumbs/small_".$fileID.".".$ext; // thumb image
				$fileToDelete4 = $fileID.".".$ext; // non image file
				$fileSystem->deleteFromMediabank($fileToDelete1);
				$fileSystem->deleteFromMediabank($fileToDelete2);
				$fileSystem->deleteFromMediabank($fileToDelete3);
				$fileSystem->deleteFromMediabank($fileToDelete4);				
				$db->query("DELETE FROM mediabank WHERE id='$fileID'");
				$db->query("DELETE FROM content_images, images USING content_images INNER JOIN images
				WHERE content_images.imgID=images.id AND images.bankID='$fileID'");
				$db->query("DELETE FROM content_files, files USING content_files INNER JOIN files
				WHERE content_files.fileID=files.id AND files.bankID='$fileID'");
			}
		}else{
			return false;
		}
	return $isDeleted;
	}
	
	
	function getSelectOptions($section, $fieldName, $sorted, $langID) {
		if(!$section || !$fieldName) return false;
		global $db;
		global $language;
		$langID = ($langID != NULL) ? $langID : $language->getCurrentLanguage();
		$sorted = ($sorted) ? $sorted : "content_".$section.".".$fieldName;
		$selected = " selected='selected'";
		$records = $db->getRecords("SELECT $section.id as id, content_$section.$fieldName as name 
								   from `$section`, content_$section 
								   where $section.id=content_$section.mainID 
								   and content_$section.langID='$langID' 
								   order by $sorted");
		foreach($records as $row){
			echo("<option value='".$row->id."' ".$selected.">".$row->name."</option>
");
			$selected = "";
		}
	}
	
		
	function getContentByID($section, $itemID, $fields, $multilingualFields, $langID, $inactive=false, $debug=false){
		$active = (!$inactive) ? " 1)" : " 1 or active=0)";
		if(!$langID){
			global $language;
			$langID = $language->getCurrentLanguage();
		}
		if(!$itemID || !$section) return false;
		if($fields == "*") $fields = array("*");
		if($multilingualFields == "*") $multilingualFields = array("*");
		if(!is_array($fields)) $fields = array();
		if(!is_array($multilingualFields)) $multilingualFields = array();
		if(!count($fields) && !count($multilingualFields)) die("no fields specified in $content->getContentByID() function");
		global $db;
		global $variables;
		global $system;
		$tableSectionID = $system->getTableSectionID($section);
		if(!count($multilingualFields)){
			if($fields[0] == "*"){
				$fields = $variables->getVarNamesByLanguage($tableSectionID, false);
				//add any special fields or system fields---------------------------------
				$fields[] = 'active';
				$fields[] = 'private';
				$fields[] = 'sort';
				$fields[] = 'alias';
				if($system->getSectionProperty($section, "hasGoogleMaps")){
					$fields[] = 'lat';
					$fields[] = 'lng';
					$fields[] = 'zoom';
				}
				if($system->getSectionProperty($section, "hasCategory")){
					$fields[] = 'catID';
				}
				// --------------------------------------------------------
			}
			$fields = array_unique($fields);
			foreach($fields as $field){
				$querypart.=$section.".".$field." as ".$field.", ";
			}
			$querypart = substr($querypart ,0 ,-2); // trim last comma and white-space
			$q = "select ".$querypart." from `".$section."` where ".$section.".id='".$itemID."'";
			if($debug) debug($q);
			return $db->getRecord($q);
		}else{ // we have multilingual fields as well
			if($fields[0] == "*"){
				$fields = $variables->getVarNamesByLanguage($tableSectionID, false);
				//add any special fields ---------------------------------
				$fields[] = 'active';
				$fields[] = 'private';
				$fields[] = 'sort';
				$fields[] = 'alias';				
				if($system->getSectionProperty($section, "hasGoogleMaps")){
					$fields[] = 'lat';
					$fields[] = 'lng';
					$fields[] = 'zoom';
				}
				if($system->getSectionProperty($section, "hasCategory")){
					$fields[] = 'catID';
				}
				// --------------------------------------------------------				
			}
			if($multilingualFields[0] == "*"){
				$multilingualFields = $variables->getVarNamesByLanguage($tableSectionID, true);
			}
			if(!count($fields)) $fields[0] = "id";
			$fields = array_unique($fields);
			foreach($fields as $field){
				$querypart.=$section.".".$field." as ".$field.", ";
			}
			foreach($multilingualFields as $multilingualField){
				if($multilingualField != "id"){ // exclude multilingual id to prevent conflict with main id
					$querypart.="content_".$section.".".$multilingualField." as ".$multilingualField.", ";
				}
			}			
			$querypart = substr($querypart ,0 ,-2); // trim last comma and white-space
			$q = "select ".$querypart." from `".$section."`, `content_".$section."` where ".$section.".id=".$itemID." and content_".$section.".mainID=".$section.".id and content_".$section.".langID='".$langID."' and (".$section.".active=".$active;
			if($debug) debug($q);
			return $db->getRecord($q);
		}
	}
	
	
	function getContent($section, $criteria, $fields, $multilingualFields, $langID, $sortedBy, $inactive=false, $debug=false){
		$criteria = ($criteria) ? $criteria : " 1 ";
		$active = (!$inactive) ? " 1)" : " 1 or active=0)";
		if(!$langID){
			global $language;
			$langID = $language->getCurrentLanguage();
		}
		if(!$section) return false;
		if($fields == "*") $fields = array("*");
		if($multilingualFields == "*") $multilingualFields = array("*");
		if(!is_array($fields)) $fields = array('id');
		if(!is_array($multilingualFields)) $multilingualFields = array('mainID');
		if(!count($fields) && !count($multilingualFields)) die("no fields specified in $content->getContent() function");
		global $db;
		global $variables;
		global $system;
		if(!$system->isTableSectionExists(NULL, $section)){
			return $this->getContentAlternative($section, $criteria, $fields, $multilingualFields, $langID, $sortedBy, $inactive, $debug);
		}
		$tableSectionID = $system->getTableSectionID($section);
		if(!count($multilingualFields)){
			if($fields[0] == "*"){
				$fields = $variables->getVarNamesByLanguage($tableSectionID, false);
				//add any special fields ---------------------------------
				$fields[] = 'active';
				$fields[] = 'private';
				$fields[] = 'sort';
				$fields[] = 'alias';				
				if($system->getSectionProperty($section, "hasGoogleMaps")){
					$fields[] = 'lat';
					$fields[] = 'lng';
					$fields[] = 'zoom';
				}
				if($system->getSectionProperty($section, "hasCategory")){
					$fields[] = 'catID';
				}
				// --------------------------------------------------------				
			}
			$fields = array_unique($fields);
			foreach($fields as $field){
				$querypart.=$section.".".$field." as ".$field.", ";
			}
			$querypart = substr($querypart ,0 ,-2); // trim last comma and white-space
			$q = "select distinct ".$section.".id, ".$querypart." from `".$section."` where content_".$section.".title <> '' and ".$criteria." and ".$section.".id=content_".$section.".mainID and (".$section.".active=".$active;
			if($sortedBy) $q.=" order by ".$sortedBy;
			if($debug) debug($q);
			return $db->getRecords($q);
		}else{ // we have multilingual fields as well
			if($fields[0] == "*"){
				$fields = $variables->getVarNamesByLanguage($tableSectionID, false);
				//add any special fields ---------------------------------
				$fields[] = 'active';
				$fields[] = 'private';
				$fields[] = 'sort';
				$fields[] = 'alias';				
				if($system->getSectionProperty($section, "hasGoogleMaps")){
					$fields[] = 'lat';
					$fields[] = 'lng';
					$fields[] = 'zoom';
				}
				if($system->getSectionProperty($section, "hasCategory")){
					$fields[] = 'catID';
				}
				// --------------------------------------------------------
			}
			if($multilingualFields[0] == "*"){
				$multilingualFields = $variables->getVarNamesByLanguage($tableSectionID, true);
			}
			if(!count($fields)) $fields[0] = "id";
			$fields = array_unique($fields);
			foreach($fields as $field){
				$querypart.=$section.".".$field." as ".$field.", ";
			}
			foreach($multilingualFields as $multilingualField){
				if($multilingualField != "id"){ // exclude multilingual id to prevent conflict with main id
					$querypart.="content_".$section.".".$multilingualField." as ".$multilingualField.", ";
				}
			}			
			$querypart = substr($querypart ,0 ,-2); // trim last comma and white-space
			$q = "select distinct ".$section.".id, ".$querypart." from `".$section."`, `content_".$section."` where content_".$section.".title <> '' and ".$criteria." and ".$section.".id=content_".$section.".mainID and content_".$section.".langID='".$langID."' and (".$section.".active=".$active;
			if($sortedBy) $q.=" order by ".$sortedBy;
			if($debug) debug($q);
			return $db->getRecords($q);
		}
	}
	
	function getContentAlternative($section, $criteria, $fields, $multilingualFields, $langID, $sortedBy, $inactive, $debug){
		if(is_file("library/views/alternative.php")){
			$alternative = view("alternative/getAlternativeContent", $section, $criteria, $fields, $multilingualFields, $langID, $sortedBy, $inactive, $debug);
			return $alternative;
		}else{
			return false;
		}
	}
	
	
	function getValue($section, $id, $field, $langID){
		global $language;
		if(empty($langID)) $langID = $language->getDefaultLanguage();
		global $system;
		$tableSectionID = $system->getTableSectionID($section);
		global $variables;
		$multilingual = (array_search($field, $variables->getVarNamesByLanguage($tableSectionID, true)) === false) ? false : true;
		$fields = ($multilingual) ? NULL : array($field);
		$multilingualFields = ($multilingual) ? array($field) : NULL;
		$row = $this->getContentByID($section, $id, $fields, $multilingualFields, $langID, true);
		return ($row->$field) ? $row->$field : false;
	}
	
	function getMultipleValues($section, $field, $itemID){
		/* to get multi values from parameters:	$content->getMultipleValues("system_settings", [parameter name], 1);*/
		global $db;
		global $system;
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // not an id, try if its a name
		if(!is_numeric($field)) $field = $system->getFieldID($field, $section); // not an id, try if its a name
		$sectionID = $section;
		$fieldID = $field;
		$q = "select distinct optionID from selectlists where sectionID='$sectionID' and fieldID='$fieldID' and itemID='$itemID'";
		$records = $db->getRecords($q);
		$values = array();
		foreach($records as $record){
			$values[] = $record->optionID;
		}
		$values = array_unique($values);
		return $values;
	}
	
	function getClosestLink($direction="next", $section, $itemID){
		global $db;
		global $system;
		global $categories;
		global $langID;
		$symbol = ($direction == "next") ? ">" : "<";
		$orderingType = ($direction == "next") ? "ASC" : "DESC";
		$hasSorting = $system->isMysqlFieldExists("sort", $section);
		if($hasSorting) $sort = $db->getRecord("select sort from `$section` where id='$itemID'")->sort;
		$hasCategory = $system->getSectionProperty($section, "hasCategory");
		if($hasCategory){
			$sectionID = $system->getTableSectionID($section);
			$q="select fieldType from `fields` where tableSectionID='$sectionID' and fieldVarName='catID'";
			$fieldType = $db->getRecord($q)->fieldType;
			$isMultiCategories = ($fieldType == "selectList");
			if($isMultiCategories){
				$catIDs = $categories->getMultiCategories($section, $itemID);
				if(!$catIDs) return false;
				$SL_sectionID = $sectionID;
				$SL_fieldID = $system->getFieldID('catID', $sectionID);			 
				$q="select distinct p.id, cp.title 
				from $section as p, content_$section as cp, selectlists as s 
				where p.active='1' 
				and s.sectionID='$SL_sectionID' 
				and s.fieldID='$SL_fieldID' 
				and s.itemID='$itemID' 
				and s.optionID IN (".implode(",", $catIDs).") 
				and p.id=cp.mainID 
				and cp.langID='$langID' 
				and p.id <> '$itemID' ";
				$q.="and p.id ".$symbol." '$itemID' order by p.id ".$orderingType." LIMIT 1";
			}else{
				$catID = $db->getRecord("select catID from $section where id='$itemID'")->catID;
				if(!$catID) return false;
				$q="select distinct p.id, cp.title 
				from $section as p, content_$section as cp 
				where p.active='1' 
				and p.catID='$catID' 
				and p.id=cp.mainID 
				and cp.langID='$langID' 
				and p.id <> '$itemID' ";
				$q.="and p.id ".$symbol." '$itemID' order by p.id ".$orderingType." LIMIT 1";
			}
		}else{ // plain section
			$q="select distinct p.id, cp.title 
			from $section as p, content_$section as cp 
			where p.active='1' 
			and p.id=cp.mainID 
			and cp.langID='$langID' 
			and p.id <> '$itemID' ";
			$q.="and p.id ".$symbol." '$itemID' order by p.id ".$orderingType." LIMIT 1";
		}
		$link = $db->getRecord($q);
		return $link;		
	}
	
	
	function getNumOfAttachments($tableSection, $linkID, $langID){
		global $language;
		$langID = (!empty($langID)) ? $langID : $language->getCurrentLanguage();		
		global $db;
		global $system;
		if(!is_numeric($tableSection)) $tableSection = $system->getTableSectionID($tableSection); // not an id, try if its a name
		if(!$tableSection || !$linkID) die("Missing parameters in \$content->getNumOfAttachments() function");
		$query = "(SELECT distinct images.id FROM images, content_images 
		WHERE images.linkID=".$linkID." 
		AND images.sectionID=".$tableSection." 
		and content_images.imgID=images.id 
		and content_images.langID=".$langID.")  
		UNION (SELECT distinct files.id FROM files, content_files, mediabank, filetypes  
		WHERE files.linkID=".$linkID." 
		AND files.sectionID=".$tableSection." 
		AND files.bankID=mediabank.id  
		AND mediabank.filetypeID=filetypes.id 
		AND filetypes.extension <> 'swf' 		
		and content_files.fileID=files.id 
		and content_files.langID=".$langID.")";
		return $db->getNumRows($query);
	}
	
	function getNumOfImages($tableSection, $linkID, $langID){
		global $language;
		$langID = (!empty($langID)) ? $langID : $language->getCurrentLanguage();		
		global $db;
		global $system;
		if(!is_numeric($tableSection)) $tableSection = $system->getTableSectionID($tableSection); // not an id, try if its a name
		if(!$tableSection || !$linkID) die("Missing parameters in \$content->getNumOfImages() function");
		$query = "SELECT distinct images.id FROM images, content_images 
		WHERE images.linkID=".$linkID." 
		AND images.sectionID=".$tableSection." 
		and content_images.imgID=images.id 
		and content_images.langID=".$langID;
		return $db->getNumRows($query);
	}
	
	function getNumOfFiles($tableSection, $linkID, $langID){
		global $language;
		$langID = (!empty($langID)) ? $langID : $language->getCurrentLanguage();		
		global $db;
		global $system;
		if(!is_numeric($tableSection)) $tableSection = $system->getTableSectionID($tableSection); // not an id, try if its a name
		if(!$tableSection || !$linkID) die("Missing parameters in \$content->getNumOfFiles() function");
		$query = "SELECT distinct files.id FROM files, content_files, mediabank, filetypes 
		WHERE files.linkID=".$linkID." 
		AND files.sectionID=".$tableSection." 
		AND files.bankID=mediabank.id  
		AND mediabank.filetypeID=filetypes.id 
		AND filetypes.extension <> 'swf' 
		and content_files.fileID=files.id 
		and content_files.langID=".$langID;
		return $db->getNumRows($query);
	}

	function getNumOfVideos($tableSection, $linkID, $langID){
		global $language;
		$langID = (!empty($langID)) ? $langID : $language->getCurrentLanguage();			
		global $db;
		global $system;
		if(!is_numeric($tableSection)) $tableSection = $system->getTableSectionID($tableSection); // not an id, try if its a name
		if(!$tableSection || !$linkID) die("Missing parameters in \$content->getNumOfVideos() function");
		$query = "SELECT videos.id FROM videos, content_videos 
		WHERE videos.linkID=".$linkID." 
		and videos.sectionID=".$tableSection." 
		and videos.id=content_videos.mainID 
		and content_videos.langID=".$langID;
		return $db->getNumRows($query);
	}
	
	function getImage($section, $linkID, $langID, $index){
		if(!is_numeric($index)){
			$index = ($index != 'default' && $index != 'slider' && $index != 'logo') ? 0 : $index;
		}
		global $language;
		$langID = (!empty($langID)) ? $langID : $language->getCurrentLanguage();		
		global $db;
		global $fileSystem;
		global $system;
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // not an id, try if its a name
		$sectionID = $section;
		$imgQuery = "select mediabank.id as id, mediabank.filetypeID as filetypeID from mediabank, images, content_images  
		where images.sectionID='$sectionID' 
		and images.linkID='$linkID' 
		and mediabank.id=images.bankID 
		and content_images.imgID=images.id 
		and content_images.langID='$langID'";
		if(!is_numeric($index)) {
			if($index == 'default') $imgQuery.=" and images.default=1";
			if($index == 'slider') $imgQuery.=" and images.slider=1";
			if($index == 'logo') $imgQuery.=" and images.logo=1";
			$imgQuery.=" limit 1";
			$image = $db->getRecord($imgQuery);
			$ext = $fileSystem->getExtensionByFileTypeID($image->filetypeID);
			return $image->id.".".$ext;
		}else{
			$images = $db->getRecords($imgQuery);
			$counter = 0;
			foreach($images as $image){
				$ext = $fileSystem->getExtensionByFileTypeID($image->filetypeID);
				if($counter == $index) {
					return $image->id.".".$ext;
				}
				$counter++;
			}
		}
		return false; // no image found for these criteria
	}
	
	function getImages($section, $linkID, $langID, $exclude){
		// $exclude has to be an array of attributes to excluded from query. For example: $exclude=array('default', 'logo', 'slider')
		global $language;
		$langID = (!empty($langID)) ? $langID : $language->getCurrentLanguage();		
		global $db;
		global $fileSystem;
		global $system;
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // not an id, try if its a name
		$sectionID = $section;
		$imgQuery = "select mediabank.id as id, mediabank.filetypeID as filetypeID from mediabank, images , content_images  
		where images.sectionID='$sectionID' 
		and images.linkID='$linkID' 
		and mediabank.id=images.bankID 
		and content_images.imgID=images.id 
		and content_images.langID='$langID'";
		if(is_array($exclude)){
			foreach($exclude as $attr){
				$imgQuery.=" and images.".$attr."<>1 ";
			}
		}
		$imgQuery.=" order by images.default DESC, images.sort ";
		$res = $db->getRecords($imgQuery);
		$images = array();
		foreach($res as $image){
			$ext = $fileSystem->getExtensionByFileTypeID($image->filetypeID);
			$images[] = $image->id.".".$ext;
		}
		return (count($images)) ? $images : false;
	}

	function getOtherImages($section, $linkID, $langID, $exclude){
		// $exclude is an array of attributes to be excluded from query. For example: $exclude=array('default', 'logo', 'slider')
		global $language;
		$langID = (!empty($langID)) ? $langID : $language->getCurrentLanguage();		
		global $db;
		global $fileSystem;
		global $system;
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // not an id, try if its a name
		$sectionID = $section;
		$imgQuery = "select distinct images.id as id from images, content_images  
		where images.sectionID='$sectionID' 
		and images.linkID='$linkID' 
		and content_images.imgID=images.id ";
		if(is_array($exclude)){
			foreach($exclude as $attr){
				$imgQuery.=" and images.".$attr."<>1 ";
			}
		}
		$imgQuery.=" order by images.sort ";
		$res = $db->getRecords($imgQuery);
		return (count($res)) ? $res : false;
		
	}	
	
	function getVideos($section, $itemID){
		global $langID;
		global $db;
		global $system;
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // not an id, try if its a name	
		$sectionID = $section;	
		$vq="SELECT videos.*, content_videos.title 
		FROM videos, content_videos 
		WHERE videos.linkID='$itemID' 
		and videos.sectionID='$sectionID' 
		and videos.id=content_videos.mainID 
		and content_videos.langID='$langID' 
		order by videos.sort";
		return $db->getRecords($vq);		
	}
		
	function getFiles($section, $itemID){
		global $langID;
		global $db;
		global $system;
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // not an id, try if its a name	
		$sectionID = $section;				
		$fq="SELECT distinct files.bankID as bankID, files.id as id 
		FROM files, content_files 
		WHERE files.linkID=".$itemID." 
		AND files.sectionID=".$sectionID." 
		and content_files.fileID=files.id 
		and content_files.langID=".$langID." order by files.sort";
		return $db->getRecords($fq);		
	}	
	
	function getFlashFiles($section, $itemID, $position="all"){
		global $langID;
		global $db;
		global $system;
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // not an id, try if its a name	
		$sectionID = $section;	
		if($position=="all" || (($position!="top") && ($position!="bottom"))){			
			$fq="SELECT distinct files.bankID as bankID, files.id as id, content_files.title  
			FROM files, content_files, mediabank, filetypes   
			WHERE files.linkID=".$itemID." 
			AND files.sectionID=".$sectionID." 
			AND files.bankID=mediabank.id  
			AND mediabank.filetypeID=filetypes.id 
			AND filetypes.extension = 'swf' 		
			and content_files.fileID=files.id 
			and content_files.langID=".$langID." order by files.sort";
		}
		if($position=="top"){			
			$fq="SELECT distinct files.bankID as bankID, files.id as id, content_files.title  
			FROM files, content_files, mediabank, filetypes   
			WHERE files.linkID=".$itemID." 
			AND files.sectionID=".$sectionID." 
			AND files.bankID=mediabank.id  
			AND mediabank.filetypeID=filetypes.id 
			AND filetypes.extension = 'swf' 
			AND content_files.title like '%|top' 		
			and content_files.fileID=files.id 
			and content_files.langID=".$langID." order by files.sort";
		}	
		if($position=="bottom"){			
			$fq="SELECT distinct files.bankID as bankID, files.id as id, content_files.title  
			FROM files, content_files, mediabank, filetypes   
			WHERE files.linkID=".$itemID." 
			AND files.sectionID=".$sectionID." 
			AND files.bankID=mediabank.id  
			AND mediabank.filetypeID=filetypes.id 
			AND filetypes.extension = 'swf' 
			AND content_files.title not like '%|top' 		
			and content_files.fileID=files.id 
			and content_files.langID=".$langID." order by files.sort";
		}	
		return $db->getRecords($fq);		
	}	
	
	function displayFlash($bankID, $attributes, $flashVars){
		$divID = rand();
		$flashDim = GetImageSize("mediabank/".$bankID.".swf");
		$w = $flashDim[0];
		$h = $flashDim[1];
		echo '<script type="text/javascript">'.PHP_EOL;
		echo 'var flashvars = {};'.PHP_EOL;
		if(is_array($flashVars)){
			if(count($flashVars)){
				foreach($flashVars as $key=>$value){
					if(!is_numeric($key))	echo 'flashvars.'.$key.' = "'.$value.'";'.PHP_EOL;
				}
			}
		}
		echo 'var attributes = {};'.PHP_EOL;
		if(is_array($attributes)){
			if(count($attributes)){
				foreach($attributes as $key=>$value){
					if(!is_numeric($key))	echo 'attributes.'.$key.' = "'.$value.'";'.PHP_EOL;
				}
			}
		}
		echo 'swfobject.embedSWF("mediabank/'.$bankID.'.swf", "'.$divID.'", "'.$w.'", "'.$h.'", "9", "js/swfobject/expressInstall.swf", flashvars, attributes);'.PHP_EOL;
		echo '</script>'.PHP_EOL;
		echo '<div id="'.$divID.'"></div>'.PHP_EOL;
	}
	
	function getVideoURL($videoProvider, $videoCode){
		global $protocol;
		if($videoProvider == "youtube") $url = $protocol."://www.youtube.com/embed/".$videoCode."?wmode=transparent&hl=en_GB&fs=1&rel=0";
		if($videoProvider == "vimeo") $url = $protocol."://player.vimeo.com/video/".$videoCode."?title=0&byline=0&portrait=0&hd_off=1";
		if($videoProvider == "dailymotion") $url = $protocol."://www.dailymotion.com/embed/video/".$videoCode."?hideInfos=1";
		return ($url) ? $url : false;
	}
	
	function getVideoThumb($videoProvider, $videoCode){
		global $protocol;
		if($videoProvider == "youtube"){
			$url = $protocol."://img.youtube.com/vi/".$videoCode."/2.jpg";
		}
		if($videoProvider == "vimeo"){
			$hash = unserialize(file_get_contents("http://vimeo.com/api/v2/video/".$videoCode.".php"));
			$url = $hash[0]['thumbnail_small']; 
		}	
		if($videoProvider == "dailymotion"){
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, "https://api.dailymotion.com/video/".$videoCode."?fields=thumbnail_medium_url");
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_TIMEOUT, 20);
			$results = curl_exec($ch);
			curl_close($ch);
			$results = json_decode($results);
			$url = $results->thumbnail_medium_url;			
		}	
		return $url;		
	}	
		
	
	function onTop($bgFile, $bgColor, $bgColorHover, $color, $colorHover, $borderColor, $indicator, $indicatorSize, $dblClick){
		$bgFile = (!empty($bgFile)) ? $bgFile : "none";		
		$bgColor = (!empty($bgColor)) ? $bgColor : "transparent";
		$color = (!empty($color)) ? $color : "#ccc";
		$borderColor = (!empty($borderColor)) ? $borderColor : "#ccc";
		$indicator = (!empty($indicator)) ? $indicator : "↑";	
		$indicatorSize = (!empty($indicatorSize)) ? $indicatorSize : "20px";
		if(!preg_match('/px$/', $indicatorSize) || !preg_match('/%$/', $indicatorSize)) $indicatorSize = (int)$indicatorSize."px";
		global $language;
		$dblClickCode = ($dblClick) ? "\$('html').dblclick(function(){
			\$('body,html').animate({scrollTop:0},400);
			});" : NULL;
		echo "<script>
		jQuery().ready(function(){
			\$(window).scroll(function(){
				if(\$(this).scrollTop() != 0){
					\$('#onTop').fadeIn();
					}else{
				\$('#onTop').fadeOut();
				}
			});";
		echo $dblClickCode;
		echo "\$('#onTop').click(function(){
			\$('body,html').animate({
				scrollTop:0
				},400);
			});
			\$('#onTop').hover(function(){
				\$(this).css({
					background: '".$bgFile." repeat scroll 0 0 ".$bgColorHover."',
					color: '".$colorHover."',
				});
			}, 
			function(){
				\$(this).css({
					background: '".$bgFile." repeat scroll 0 0 ".$bgColor."',
					color: '".$color."',
				});
			});
			\$('#onTop').css({
				background: '".$bgFile." repeat scroll 0 0 ".$bgColor."', 
				border: '1px solid ".$borderColor."', 
				color: '".$color."', 
				fontSize: '".$indicatorSize."'
			});
		});
		</script>";

		echo "<div id='onTop' title='".$language->getText("Αρχή της σελίδας")."'>".$indicator."</div>";

	}
	
	function getImageDescription($imageFilename, $linkID, $section, $langID){
		global $db;
		global $system;
		$pieces = explode(".", $imageFilename); // drop extension if any
		$bankID = $pieces[0];
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // not an id, try if its a name	
		$sectionID = $section;			
		if(!$bankID || !$linkID || !$sectionID) return false;
		if(!$langID) {
			global $language;
			$langID = $language->getCurrentLanguage();
		}
		$q="select content_images.description as description 
		from content_images, images 
		where images.bankID='$bankID' 
		and images.sectionID='$sectionID' 
		and images.linkID='$linkID' 
		and content_images.imgID=images.id 
		and content_images.langID='$langID' ";
		$description = $db->getRecord($q)->description;
		return ($description) ? nl2br($description) : false;
	}
	
	function displayThumbnail($imageFile, $thumbViewportWidth=187, $thumbViewportHeight=187, $link, $expandImage=true, $fancybox=false, $scale=true){
		$imageFile = (is_file($imageFile)) ? $imageFile : "images/no_image.png";
		$foundThumb = $imageFile != "images/no_image.png";
		if(!is_file($imageFile)) return false; // cannot find any image, giving up...
		if($expandImage){
			$imgDim = GetImageSize($imageFile);
			for($i=0; $i <100000; $i++){
				// delay
			};			
			$w = $imgDim[0]; // actual width of entire thumbnail
			$h = $imgDim[1]; // actual height of entire thumbnail	
		}else{
			$w = $thumbViewportWidth;
			$h = $thumbViewportHeight; // actual height of entire thumbnail			
		}
		if($scale){
			global $parameters;
			$medium_image_width = $parameters->getParameter("medium_image_width");
			$factor = $medium_image_width / $thumbViewportWidth;
			if($factor >= 1){
				$w = (int)($w / $factor);
				$w = ($w < $thumbViewportWidth) ? $thumbViewportWidth : $w;
				$h = (int)($h / $factor);
				$h = ($h < $thumbViewportHeight) ? $thumbViewportHeight : $h;
			}
		}
		$padding = 8; // border widths of jQuery plugin
		$html = '<div data-factor="'.$factor.'" class="thumbWrapper" style="width: '.$thumbViewportWidth.'px; height: '.$thumbViewportHeight.'px">';
		$html.= '<div class="jOthumb_container" style="width: '.($thumbViewportWidth + $padding).'px; height: '.($thumbViewportHeight + $padding).'px">';
		if(!$foundThumb){
			$html.= '<div style="background: url('.$imageFile.') center center no-repeat; overflow:hidden; height:100%; "> ';
			$html.= '<a href="'.$link.'"> <img src="images/blank.gif" style="width:100%; height: 100%" alt="jOthumbPlaceholder"> </a> ';
			$html.= '</div>';
		}else{
			global $document;
			global $langID;
			global $id;
			global $catID;
			$sectionID = $document->sectionID;
			if(empty($langID)) return false;
			list($temp, $image) = explode("mediabank/medium/medium_", $imageFile);
			$imgDescription = $this->getImageDescription($image, $id, $sectionID, $langID);
			$fancyboxCode = ($fancybox) ? ' data-rel="fb" rel="fb-'.$fancybox.'" ' : NULL;
			$html.= '<div data-descr="jOthumb" style="width: '.$thumbViewportWidth.'px; height: '.$thumbViewportHeight.'px; visibility:hidden;">';
			$html.= '<a href="'.$link.'" '.$fancyboxCode.' title="'.$imgDescription.'"> <img data-descr="contents" src="'.$imageFile.'" style="max-width:'.$w.'px !important; width:'.$w.'px !important; height:'.$h.'px !important" alt="image"> </a>';
			$html.= '</div>';
		}
		$html.= '</div>';
		$html.= '</div>';
		echo $html; // show thumbnail
	}	
	
	function getHTMLtitle(){
		global $db;
		global $langID;
		$q="select title from content_system_settings where langID='$langID' LIMIT 1";
		return $db->getRecord($q)->title;
	}
	
	function displayFontAdjustments($direction="right"){
		echo "<div class=\"font_adjastments\" style=\"text-align:".$direction."\">";
		echo "<a class=\"font_increase\" href=\"javascript:void(0)\" onclick=\"increaseFont($(this).parent().parent())\" title=\"".t('Μεγαλύτερη γραμματοσειρά')."\"></a>";
		echo "<a class=\"font_reset\" href=\"javascript:void(0)\" onclick=\"resetFont($(this).parent().parent())\" title=\"".t('Κανονική γραμματοσειρά')."\"></a>";
		echo "<a class=\"font_decrease\" href=\"javascript:void(0)\" onclick=\"decreaseFont($(this).parent().parent())\" title=\"".t('Μικρότερη γραμματοσειρά')."\"></a>";
		echo "</div>";
	}
	
	function getPageLink($pageTitle, $section="pages", $view="render"){
		global $db;
		global $langID;
		$id = $db->getRecord("select mainID as id from content_$section where title='$pageTitle' and langID='$langID'")->id;
		$link = "index.php?section=".$section."&view=".$view."&id=".$id;
		return $link;
	}
	
	function parseLinks($string){
		global $sef;
		if(!is_object($sef)) $sef = new sef();
		global $variables;
		$string = chop($string);
		$startSymbol = $this->startDelimiter;
		$endSymbol = $this->endDelimiter;
		$offset = 0;
		$ended = false;
		while($ended === false){
			if(mb_stripos($string, $startSymbol, $offset) !== false){
				$start = mb_stripos($string, $startSymbol, $offset);
				$end = mb_stripos($string, $endSymbol, $start);
				$offset = $start + mb_strlen($startSymbol);
				$key = $variables->unicode_substr($string , $start+mb_strlen($startSymbol), $end - ($start+mb_strlen($startSymbol)));
				$links[$key] = $sef->url($key, false);
				if(preg_match('/^index\.php/', $key)) $string = str_replace($key, $sef->url($key, false), $string); // translate the key
			}else{
				$ended = true;
			}
		}
		return $string;
	}	
	
	function richText($text){
		// prepare any sef urls and filter text from tinyMCE Editor
		$text = $this->parseLinks($text); // parse value for links
		$text = str_replace("««", NULL, $text); // remove link start delimiter
		$text = str_replace("»»", NULL, $text); // remove link end delimiter			
		return stripslashes(str_replace("<br />", "<br>", str_replace("../mediabank", "mediabank", $text)));
	}
	
	function remove_html_comments($html){
		global $doNotRemoveHtmlComments;
		if($doNotRemoveHtmlComments) return $html; // do not remove comments if instructed so
		$html = preg_replace('/<!--(.|\s)*?-->/', '', $html); // remove self closed comments
		$html = preg_replace('/<!--(.|\s)*/', '', $html); // remove opened comments
		return $html;
	}		
	
	function addTags($tags, $section, $itemID, $langID){
		if($tags && !is_array($tags)) $tags = array($tags);
		if(!count($tags)) return false;
		global $db;
		global $system;
		global $variables;
		$saved = false;
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // make sure we have the sectionID and not the section name
		foreach($tags as $tag){
			if(empty($tag)) continue; // do not add empty tags
			$q = "select id from tags where tag='$tag' and sectionID='$section' and itemID='$itemID' and langID='$langID'";
			$tagID = $db->getRecord($q);
			if((int)$tagID) continue;
			// new tag lets save it
			$tag = $variables->filterQuotes($tag);
			$q="insert into tags (tag, sectionID, itemID, langID) values ('$tag','$section', '$itemID', '$langID')";
			$db->query($q);
			$saved = true;
		}
		return $saved;
	}
	
	function removeTags($section, $itemID){
		//removes all tags of $itemID in any languages in the given section
		global $db;
		global $system;	
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // make sure we have the sectionID and not the section name
		$q = "delete from tags where sectionID='$section' and itemID='$itemID'";
		$db->query($q);
	}
	
	function removeSEOTags($section, $itemID){
		//removes all SEO tags of $itemID in any languages in the given section
		global $db;
		global $system;	
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // make sure we have the sectionID and not the section name
		$q = "delete from seo where sectionID='$section' and itemID='$itemID'";
		$db->query($q);
	}	
	
	function getTags($section, $itemID, $langID){
		global $db;
		global $system;
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // make sure we have the sectionID and not the section name
		$q="select tag from tags where sectionID='$section' and itemID='$itemID' and langID='$langID'";
		$records = $db->getRecords($q);
		$tags = array();
		foreach($records as $record){
			if(!empty($record->tag)) $tags[] = $record->tag;
		}
		return (count($tags))? $tags : false;
	}
	
	function getRelatedContent($section, $itemID, $langID){
		global $db;
		global $system;
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // make sure we have the sectionID and not the section name
		$tags = $this->getTags($section, $itemID, $langID);	
		$ids = array();
		foreach($tags as $tag){
			$q="select itemID from tags where tag='$tag' and sectionID='$section' and langID='$langID' and itemID <> '$itemID'";
			$records = $db->getRecords($q);
			foreach($records as $record){
				$ids[] = $record->itemID;
			}			
		}
		$ids = array_unique($ids);
		if(count($ids)){
			$relatedContent = implode(",", $ids);
			$sectionName = $system->getTableSectionName($section); // get section name
			$q="select $sectionName.id, content_$sectionName.title 
			from $sectionName, content_$sectionName 
			where $sectionName.id=content_$sectionName.mainID 
			and $sectionName.active=1 
			and $sectionName.id in ($relatedContent) 
			and content_$sectionName.langID='$langID'";
			$items = $db->getRecords($q);
		}
		return (count($items)) ? $items : false;
	}
	
	function displaySiteMap(){
		global $db;
		global $sef;
		if(!is_object($sef)) $sef = new sef();
		global $langID;
		global $document;
		$sections = array("pages");
		$q = "select name from sections where systemProtected=0 and isMenu=0";
		$records = $db->getRecords($q);
		echo '<ul id="sitemap">';
		foreach($records as $record) $sections[] = $record->name;
		foreach($sections as $section){
			$view = ($section == "pages") ? "render" : "node";
			$p = $document->getTemplatePath();
			$fileToTest = $p."view_".$section."_".$view.".php";
			if(is_file($fileToTest)){ // include only content sections
				$q="select $section.id, $section.alias, content_$section.title from $section, content_$section where 
						content_$section.mainID = $section.id 
						and content_$section.langID='$langID' 
						and $section.active=1 and $section.private=1";
				$links = $db->getRecords($q);
				foreach($links as $link){
					if($link->alias != "sitemap" && !empty($link->title)){
						echo '<li><a data-id="'.$link->id.'" href="'.$sef->url("index.php?section=".$section."&view=".$view."&id=".$link->id."&langID=".$langID, false).'">'.$link->title.'</a></li>';
					}
				}
			}
		}
		echo '</ul>';
	}
	
	function displaySiteMapXML(){
		global $db;
		global $sef;
		if(!is_object($sef)) $sef = new sef();
		global $langID;
		global $document;
		global $domainPath;
		$sections = array("pages");
		$q = "select name from sections where systemProtected=0 and isMenu=0";
		$records = $db->getRecords($q);
		echo '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd">'.PHP_EOL;
		foreach($records as $record) $sections[] = $record->name;
		foreach($sections as $section){
			$view = ($section == "pages") ? "render" : "node";
			$p = $document->getTemplatePath();
			$fileToTest = $p."view_".$section."_".$view.".php";
			if(is_file($fileToTest)){ // include only content sections
				$q="select $section.id, $section.alias, content_$section.title from $section, content_$section where 
						content_$section.mainID = $section.id 
						and content_$section.langID='$langID' 
						and $section.active=1 and $section.private=1";
				$links = $db->getRecords($q);
				foreach($links as $link){
					if($link->alias != "sitemap"){
echo '<url>
<loc>'.htmlentities($domainPath.$sef->url("index.php?section=".$section."&view=".$view."&id=".$link->id."&langID=".$langID, false)).'</loc>
<changefreq>daily</changefreq>
</url>'.PHP_EOL;
					}
				}
			}
		}
		echo '<!--  Generated by Odyssey CMS  -->
</urlset>';
	}
	
	function getCurrencyLiveRate($requestedCurrencyCode){
		if($requestedCurrencyCode == "EUR") return 1;
		$this->currencyCode = $requestedCurrencyCode;
		$xml_parser= xml_parser_create();
		xml_set_element_handler($xml_parser, array($this, 'currency'), "");
		xml_parse($xml_parser, file_get_contents ("http://www.ecb.europa.eu/stats/eurofxref/eurofxref-daily.xml"));
		xml_parser_free($xml_parser);		
		return $this->returnValue;		
	}
	
	function currency($parser, $name, $attrs){ 
		if(!empty($attrs['RATE'])){
			$rate = $attrs['RATE'];
			$currencyCode = $attrs['CURRENCY'];	
			if($currencyCode == $this->currencyCode){
				$this->returnValue = (float)$rate;
				return;
			} 
		}
	}
	
	
				
} // end class
?>