<?php 
defined('CMS') or die("This file cannot run this way!");
class document{

	public $section;
	public $view;
	public $sectionID;
	public $template;
	public $modulesPath = "modules/";
	public $unzipPath = "uploads/unzip/";
	public $cssFilePath = "css/";
	public $jsFilePath = "js/";
	public $template_settings;
	private $content;
	private $data = array();
	private $appendMark = " | ";
	private $noJsFile = "inc_nojs.php";
	private $defaultIndex = "odyssey_index";	
	private $htmlTitle;
	private $admin;
	public $meta = array('<meta http-equiv="Content-Type" content="text/html; charset=utf-8">');
	public $styles = array();
	public $jsFiles = array('<script type="text/javascript" src="js/jquery.js"></script>');
	public $jsReady = array();
	public $bodyJs = array();
	public $loadedFiles = array();
	
	function __construct($section, $view, $admin=false) {
		global $system;
		global $db;		
		global $messages;
		global $variables;
		global $parameters;
		global $safeRequest;
		global $domain_name;
		global $currentVersion;
		global $sef;
		if(!is_object($sef)) $sef = new sef();
		global $language;
		$content = new content(); // new object in case of admin calls
		global $langID;

		$_REQUEST = array_merge($_GET, $_POST);
		$variables->getSafeVars(array_keys($_REQUEST));
		if(isset($_REQUEST['langID']) && empty($langID)){
			$langID = $language->getDefaultLanguage();
		}			
		$this->admin = $admin;
		$this->template = $this->getDefaultTemplate();
		if($admin){
			$this->admin = $admin;
			return; // for use methods from admin panel
		}
		$section = (!$section) ? $this->defaultIndex : $section;
		$givenSectionFound = $system->isTableSectionExists(NULL, $section, NULL);
		$this->section = ($givenSectionFound) ? $section : $this->defaultIndex;
		$view = ($view) ? $view : "list"; // if no view defined, try the list view
		$viewFile = $this->getTemplatePath()."view_".$this->section."_".$view.".php";
		if(!is_file($viewFile) && $view != "ipn") $view = $this->defaultIndex; // no default views found so try the index view
		$this->view = $view;
		
		// check for custom homepage
		$homePageURL = $parameters->getParameter('homepage');
		$queryVars = $variables->parseQuery(str_replace("index.php?", NULL, $homePageURL));
		$url_section = $queryVars['section'];
		if(!preg_match('/'.$_SERVER['QUERY_STRING'].'/', $queryVars)){  // if no custom redirecting is in progress
			$url_section_exists = $system->isTableSectionExists(NULL, $url_section, NULL);
			if($url_section == "odyssey_index" || !$url_section || !$givenSectionFound) $homePageURL = false;
		}
		if($section == $this->defaultIndex && $view == $this->defaultIndex && !empty($homePageURL) && $url_section_exists){
			?>
			<!DOCTYPE html>
            <html>
            <body>
            <script type="text/javascript">
			document.location.href="<?php echo getBase().$sef->url($homePageURL, false);?>";
            </script>
            </body>
            </html>
            <?php
			exit;
		}
		
		$this->template_settings = $this->getTemplateSettings();
		$safeRequest->section = $this->section;
		$safeRequest->view = $this->view;
		$this->content = ($this->view == $this->defaultIndex) ? $this->getTemplatePath()."view_".$this->section.".php" : $this->getTemplatePath()."view_".$this->section."_".$this->view.".php";
		if($_REQUEST['section'] && (!$givenSectionFound || !is_file($this->content))) $this->setErrors($givenSectionFound);
		if($system->isTableSectionExists(NULL, $this->section, NULL)) $this->sectionID = $system->getTableSectionID($this->section);	
		
		 // load override jquery if template provides one
		$templateJquery = $this->getTemplatePath().$this->jsFilePath."jquery.js";
		if(is_file($templateJquery)){
			$this->jsFiles = array('<script type="text/javascript" src="'.$templateJquery.'"></script>');
		}
				
		$this->setHtmlTitle($content->getHTMLtitle()); // basic translated HTML TITLE
		$this->controller();

		// set default meta tags
		$this->setMeta('<base href="'.getBase().'">');		
		$relativePath = $this->getTemplatePath().'images/fb_default.jpg';
		$defaultFBimage = getBase().$relativePath;
		if($safeRequest->id && $this->view == "node"){ // images for facebook sharing
			$fb_images = $content->getImages($this->section, $safeRequest->id, $langID);
			foreach($fb_images as $fb_image){
				$this->setMeta('<meta property="og:image" content="'.getBase().'mediabank/images/'.$fb_image.'">');
			}
			if(!$fb_images && is_file($relativePath)) $this->setMeta('<meta property="og:image" content="'.$defaultFBimage.'">'); // set default og:image if no other images found
		}else{
			if(is_file($relativePath)) $this->setMeta('<meta property="og:image" content="'.$defaultFBimage.'">');
		}
		$this->setMeta('<meta property="og:site_name" content="'.$parameters->getParameter('title').'">');
		$this->setMeta('<meta name="Generator" content="Odyshop e-Sales '.$currentVersion.' (http://odyssey.webpage.gr)">');
		$this->setMeta('<meta name="author" content="'.$domain_name.'">');
		$this->setMeta('<meta name="publisher" content="'.$domain_name.'">');
		
		// set global styles
		$cssGlobalFiles = array();
		$cssGlobalFilesTXT = $this->getTemplatePath()."globalCSSFiles.txt";
		if(is_file($cssGlobalFilesTXT)){
			$entries = file($cssGlobalFilesTXT);
			foreach($entries as $cssFile)  $cssGlobalFiles[] = trim($cssFile);
		}
		$this->setStyles($cssGlobalFiles);
		
		//set system and template ready js file
		$systemReadyFile = $this->jsFilePath."ready.js";
		$templateReadyFile = $this->getTemplatePath().$this->jsFilePath."ready.js";
		if(is_file($systemReadyFile)) $this->setJsReady(file_get_contents($systemReadyFile));
		if(is_file($templateReadyFile)) $this->setJsReady(file_get_contents($templateReadyFile));
		
		//set global js files
		$jsGlobalFiles = array();
		$jsGlobalFilesTXT = $this->getTemplatePath()."globalJsFiles.txt";
		if(is_file($jsGlobalFilesTXT)){
			$entries = file($jsGlobalFilesTXT);
			foreach($entries as $jsFile) $jsGlobalFiles[] = trim($jsFile);
		}
		$this->setJsFiles($jsGlobalFiles);
		
		$this->getTemplateHeadFiles();
		
		// set canonical link only after search and users pages exlusions
		if($this->view != "search" && $this->section != "users"){
			list($qs, $temp) = explode("session_data=", $_SERVER['QUERY_STRING']);
			$link = "index.php?".$qs;
			if($parameters->getParameter('sef')) $link = $sef->url($link, false);
			$this->setMeta('<link rel="canonical" href="'.getBase().$link.'" />');
		}

		//set template's dynamic js file
		$dynamicJS = "template_".$this->template.".js.php?langID=".$langID;
		$this->setJsFiles($dynamicJS);
				
		// set template's body js code (Google Analutics etc)
		$bodyJsFile = $this->getTemplatePath().$this->jsFilePath."bodyJs.js";
		if(is_file($bodyJsFile)) $this->setBodyJs(explode(PHP_EOL, file_get_contents($bodyJsFile)));
		if(preg_match('/'.$this->section.'/', $_SESSION['sectionCssFile'])) $this->setStyles($_SESSION['sectionCssFile']);

		//load active modules
		if($this->section == "pages") $pageID = $_REQUEST['id'];
		$sectionID = $system->getTableSectionID($this->section);
		$templateID = $this->getTemplateID();
		$this->sectionID = $sectionID;
		$modules = $db->getRecords("select selectlists.itemID 
		from selectlists, modules, slots  
		where (selectlists.optionID='$sectionID' or selectlists.optionID='$pageID') 
		and modules.id=selectlists.itemID 
		and slots.id=modules.slotID 
		and slots.templateID = '$templateID' 
		and modules.active=1");
		foreach($modules as $module){
			$itemID = $module->itemID;
			$extensionID = $db->getRecord("select moduleID from modules where id='$itemID'")->moduleID;
			$moduleName = $system->getExtensionName($extensionID);
			$this->loadModule($moduleName);
		}
		
		global $auth;
		$admin = ($auth->getAdminLevel() != -100) ? true : false;
		$safeRequest->admin = $admin;	
		$this->loadedFiles = array_unique($this->loadedFiles);
	}
	
	function controller(){
		global $safeRequest;
		global $messages;
		// import the filtered request variables to controller scope
		foreach($safeRequest as $key=>$value){
			${$key} = $value;
		}
		$view = $this->view;
		$controller_file = "controller/".$this->section.".php";
		$checkFile = "controller/_".$this->section.".php";
		$override_controller_file = "controller/override_".$this->section.".php";
		if(file_exists($checkFile ) && !file_exists($controller_file) && !is_file($override_controller_file)){ // auto controller
			require_once("controller/controller.php");
		}else{
			// try to load custom controller
			if(is_file($override_controller_file)){
				require_once($override_controller_file);
			}else{
				if(is_file($controller_file)){
					require_once($controller_file);
				}else{ // give up
					die("Unexpected error: No controller found!");
				}
			}
		}
	}
	
	function setErrors($givenSectionFound){
		global $messages;
		global $system;
		if(!$givenSectionFound) {
			$errorPage =getBase()."404.php";
			?>
			<script>document.location.href="<?php echo $errorPage;?>";</script>
			<?php
			exit;
			$messages->addError(t("Το συγκεκριμένο περιεχόμενο δεν βρέθηκε!"));
		}
		if(!$system->isTableSectionExists(NULL, $this->section, NULL)){
			if($this->section == $this->defaultIndex) {
				$error =  t("Δεν βρέθηκε η ενότητα αρχικής σελίδας")." [".$this->defaultIndex."]";
			}else{
				$error =  t("Επίσης δεν βρέθηκε και η ενότητα αρχικής σελίδας")." [".$this->defaultIndex."]";
			}
			if(!is_file($this->content)){
				$messages->addError($error);
				$messages->addError(t("με αποτέλεσμα να μην μπορεί να απεικονισθεί κάποιο περιεχόμενο!"));
			}else{
				if(!$givenSectionFound) $messages->addError(t("Το σύστημα σας μετέφερε στην αρχική σελίδα!"));
			}
		}
	}
	
	function getDefaultTemplate(){
		if(!$this->admin){
			$ip = $_SESSION['ip'];
			if(is_dir("mediabank")){
				$path = "mediabank/";
			}elseif(is_dir("../mediabank")){
				$path = "../mediabank/";	
			}elseif(is_dir("../../mediabank")){
				$path = "../../mediabank/";	
			}elseif(is_dir("../../../mediabank")){
				$path = "../../../mediabank/";
			}			
			$data = file($path."previewTemplate.txt");
			$data = $data[0];
			list($previewTemplate, $savedIP) = explode("~|~", $data);
			if($previewTemplate && $ip == $savedIP) return $previewTemplate;
		}
		$parameters = new parameters();
		global $db;
		global $messages;
		$error = false;
		$q = "select `name` from `templates` where active=1 LIMIT 1";
		$template = $db->getRecord($q)->name;
		if(!$template) die(t("Δεν βρέθηκε ενεργό πρότυπο εμφάνισης"));
		return $template;
	}
	
	function getTemplateSettings(){
		global $db;
		$templateName = $this->getDefaultTemplate();
		$settings_table = "template_settings_".$templateName;
		$q = "SHOW TABLES LIKE '$settings_table'";
		$settings_table_exists = ($db->getNumRows($q) == 1);
		if(!$settings_table_exists) return false;
		$q = "select * from `$settings_table`";
		return $db->getRecord($q);
	}
	
	function setHtmlTitle($title, $append=false){
		if($append){
			$title = $title.$this->appendMark;
			if(in_array($title, $this->htmlTitle)) return false;
			$this->htmlTitle = $title.$this->htmlTitle;
			return true;
		}else{
			if(in_array($title, $this->htmlTitle)) return false;
			$this->htmlTitle = $title;
			return true;
		}
	}
	
	function setMeta($meta){
		if(is_array($meta)){
			$success = false;
			foreach($meta as $entry){
				if(!$entry || in_array($entry, $this->meta)){
					 continue;
				}else{
					$this->meta[] = $entry;
					$success = true;
				}
			}
			return $success;
		}else{
			if(in_array($meta, $this->meta) || empty($meta)) return false;
			$this->meta[] = $meta;
			return true;
		}
	}
	
	function getMeta(){
		global $variables;
		// load favicon if exists
		$favicon = $this->getTemplatePath()."favicon.ico";
		if(is_file($favicon)){
			$fv = rand();
			$this->setMeta('<link rel="shortcut icon" href="'.$favicon.'?v='.$fv.'">');
		}
		// load any other meta tags
		// prepare HTML title
		if(preg_match('/^'.$this->appendMark.'$/', $this->htmlTitle)) $this->htmlTitle = substr($this->htmlTitle, 3);
		if(preg_match('/^ \| /', $this->htmlTitle)) $this->htmlTitle = $variables->unicode_substr($this->htmlTitle, 3);		
		$this->setMeta('<title>'.$this->htmlTitle.'</title>');
		// set priority to display first the charset and then the title
		$charset = array_shift($this->meta);
		$title = array_pop($this->meta);
		echo $variables->parseKeys($charset).PHP_EOL;
		echo $variables->parseKeys($title).PHP_EOL;
		// continue with any other meta tags
		foreach($this->meta as $entry){
			echo $variables->parseKeys($entry).PHP_EOL;
		}
	}	

	
	function setStyles($styles){
		global $singleModulesCss;
		global $singleModulesCssLoaded;
		if(is_array($styles)){
			$success = false;
			foreach($styles as $entry){
				list($entry, $condition) = explode("|", $entry);
				if($condition){
					$c1 = PHP_EOL."<!--[".$condition."]>".PHP_EOL;
					$c2 = PHP_EOL."<![endif]-->".PHP_EOL;
				}				
				$formatedEntry = $c1.'<link href="'.$entry.'" rel="stylesheet" type="text/css">'.$c2;
				$path_parts = pathinfo($entry);
				$css = $path_parts['basename'];
				if(!is_file($entry) || in_array($formatedEntry, $this->styles) || in_array($css, $singleModulesCssLoaded)){
					continue;
				}else{
					if(in_array($css, $singleModulesCss)) $singleModulesCssLoaded[] = $css;
					$this->styles[] = $formatedEntry;
					$this->loadedFiles[] = $entry;
					$success = true;
				}
			}
			return $success;			
		}else{
			list($styles, $condition) = explode("|", $styles);
			if($condition){
				$c1 = PHP_EOL."<!--[".$condition."]>".PHP_EOL;
				$c2 = PHP_EOL."<![endif]-->".PHP_EOL;
			}			
			$formatedEntry = $c1.'<link href="'.$styles.'" rel="stylesheet" type="text/css">'.$c2;
			$path_parts = pathinfo($styles);
			$css = $path_parts['basename'];	
			if(!is_file($styles) || in_array($formatedEntry, $this->styles) || in_array($css, $singleModulesCssLoaded)) return false;
			if(in_array($css, $singleModulesCss)) $singleModulesCssLoaded[] = $css;
			$this->styles[] = $formatedEntry;
			$this->loadedFiles[] = $styles;
			return true;
		}
	}	
	
	function getStyles(){
		foreach($this->styles as $entry){
			echo $entry.PHP_EOL;
		}
	}
	
	function setJsFiles($jsFiles){
		global $singleModulesJs;
		global $singleModulesJsLoaded;		
		if(is_array($jsFiles)){
			$success = false;
			foreach($jsFiles as $entry){
				list($entry, $condition) = explode("|", $entry);
				if($condition){
					$c1 = PHP_EOL."<!--[".$condition."]>".PHP_EOL;
					$c2 = PHP_EOL."<![endif]-->".PHP_EOL;
				}								
				$formatedEntry = $c1.'<script type="text/javascript" src="'.$entry.'"></script>'.$c2;
				$path_parts = pathinfo($entry);
				$js = $path_parts['basename'];				
				if((!is_file($entry) || in_array($formatedEntry, $this->jsFiles)) && !preg_match('/^http:\/\//', $entry) || in_array($js, $singleModulesJsLoaded)) {
					continue;
				}else{
					if(in_array($js, $singleModulesJs)) $singleModulesJsLoaded[] = $js;
					$this->jsFiles[] = $formatedEntry;
					$this->loadedFiles[] = $entry;
					$success = true;
				}
			}
			return $success;
		}else{
			list($jsFiles, $condition) = explode("|", $jsFiles);
			if($condition){
				$c1 = PHP_EOL."<!--[".$condition."]>".PHP_EOL;
				$c2 = PHP_EOL."<![endif]-->".PHP_EOL;
			}			
			$formatedEntry = $c1.'<script type="text/javascript" src="'.$jsFiles.'"></script>'.$c2;
			$path_parts = pathinfo($jsFiles);
			$js = $path_parts['basename'];		
			if(in_array($formatedEntry, $this->jsFiles) && !preg_match('/^http:\/\//', $jsFiles) || in_array($js, $singleModulesJsLoaded)) return false;	
			if(!is_file($jsFiles) && !preg_match('/^http:\/\//', $jsFiles) && (!preg_match('/\.js\.php/', $jsFiles))) return false;
			if(in_array($js, $singleModulesJs)) $singleModulesJsLoaded[] = $js;
			$this->jsFiles[] = $formatedEntry;
			$this->loadedFiles[] = $jsFiles;
			return true;
		}
	}	
	
	function getJsFiles(){
		foreach($this->jsFiles as $entry){
			if(!preg_match('/ready\.js/', $entry))	echo $entry.PHP_EOL;
		}	
	}
	
	function setJsReady($jsReady){
		$success = false;
		if(is_array($jsReady)){
			foreach($jsReady as $entry){
				if(empty($entry) || in_array($entry, $this->jsReady)) {
					continue;
				}else{
					$this->jsReady[] = $entry;
					$success = true;
				}
			}
			return $success;
		}else{
			if(empty($jsReady) || in_array($jsReady, $this->jsReady)) return false;
			$this->jsReady[] = $jsReady;
			return true;
		}
	}	
	
	function getJsReady(){
		global $variables;
		echo PHP_EOL.'<script type="text/javascript">'.PHP_EOL.'<!--'.PHP_EOL.'';		
		if(count($this->jsReady)){
			echo 'jQuery().ready(function(){'.PHP_EOL.'';
			foreach($this->jsReady as $entry)	echo $variables->parseKeys($entry).PHP_EOL;
			echo '});'.PHP_EOL;
		}
		$defaultJs = $this->jsFilePath."common.js.php";
		$parameters = new parameters();
		include("disableIE.php");
		if(is_file($defaultJs)) include($defaultJs); // append any dynamic js functions as inline functions
		echo '//-->'.PHP_EOL.'</script>'.PHP_EOL;
	}
	
	function setBodyJs($bodyJs){
		$success = false;
		if(is_array($bodyJs)){
			foreach($bodyJs as $entry){
				if(empty($entry) || in_array($bodyJs, $this->bodyJs)) {
					continue;
				}else{
					$this->bodyJs[] = $entry;
					$success = true;
				}
			}
			return $success;
		}else{
			if(empty($bodyJs) || in_array($bodyJs, $this->bodyJs)) return false;
			$this->bodyJs[] = $bodyJs;
			return true;				
		}
	}
	
	function getBodyJs(){
		global $variables;
		if(count($this->bodyJs)){
			if(count($this->bodyJs) == 1){
				if(preg_match('/^\/\/ bodyJs content/', $this->bodyJs[0])) return; // ignore the system comment of first line (   // bodyJs content   ) on an empty bodyJs file
			}
			echo PHP_EOL.'<script type="text/javascript">'.PHP_EOL.'<!--'.PHP_EOL.'';
			foreach($this->bodyJs as $entry){
				echo $variables->parseKeys($entry).PHP_EOL;
			}
			echo '//-->'.PHP_EOL.'</script>'.PHP_EOL;
		}
	}
	
	function setData($data){
		$varName = $this->getVarName($data);
		$this->data[$varName] = $data;
	}
	
	function getData($varName){
		return $this->data[$varName];
	}		
	
	function getNoScript(){
		$noscript_file = $this->noJsFile;
		if(is_file($noscript_file)) include($noscript_file);
	}
	
	function loadCSS($filename){
		if(!$filename || !is_file($filename) || !preg_match('/\.css$/', $filename)) return false;
		foreach($this->loadedFiles as $file){
			if(preg_match('/\.css$/', $file)){
				if($file == $filename) return false;
			}
		}
		// load the css file
		echo '<link href="'.$filename.'" rel="stylesheet" type="text/css">'.PHP_EOL;
		$this->loadedFiles[] = $filename;
		return true;
	}
	
	function loadJS($filename){
		if(!$filename || !is_file($filename) || !preg_match('/\.js$/', $filename)) return false;
		foreach($this->loadedFiles as $file){
			if(preg_match('/\.js$/', $file)){
				if($file == $filename) return false;
			}
		}
		// load the js file
		echo '<script type="text/javascript" src="'.$filename.'"></script>'.PHP_EOL;
		$this->loadedFiles[] = $filename;
		return true;
	}	
	
	function getContent(){	
		if(!is_file($this->content)) {
			global $messages;
			global $system;
			global $sef;
			if(!is_object($sef)) $sef = new sef();
			if(preg_match('/view_odyssey_index/', $this->content)) die ("Fatal Error: Odyssey Index View not found in template's folder");
			$messages->addError(t("Δεν βρέθηκε αρχείο απεικόνισης (View)"), true);
			?>
            <script>document.location.href="<?php $sef->url("index.php");?>";</script>
            <?php
			exit;
		}
		include($this->getTemplatePath()."index.php");	
	}
	
	function getVarName($var) {
		foreach($this as $var_name => $value) {
			if ($value === $var) {
				return $var_name;
			}
		}
		return false;
	}
	
	function getTemplatePath($template){
		$template = (empty($template)) ? $this->template : $template;
		$templateID = $this->getTemplateID($template);
		$template = ($templateID) ? $template : $this->template; // active template if no other specified
		return "templates/".$template."/";
	}	
	
	function getTemplateID($template){
		global $db;
		$template = ($template) ? $template : $this->template; // active template if no other specified
		$templateID = $db->getRecord("select id from templates where name='$template'")->id;
		return $templateID;
	}	
	
	function getModules($slot){
		global $db;
		if(!(int)$slot && $slot) $slot = $this->getSlotID($slot);
		if(!$slot) return false;
		$templateID = $this->getTemplateID();
		$q="select modules.* from modules, slots 
				where modules.active=1 
				and slots.id='$slot' 
				and modules.slotID=slots.id 
				and slots.templateID='$templateID' 
				and slots.active=1 order by sort";
		$modules = $db->getRecords($q);		
		return $modules;		
	}
	
	function getSlotID($slot, $template){
		global $db;
		$template = (empty($template)) ? $this->template : $template;
		$templateID = $this->getTemplateID($template);
		$template = ($templateID) ? $template : $this->template; // active template if no other specified
		$q = "select id from slots where name='$slot' and templateID=".$templateID;	
		return $db->getRecord($q)->id;
	}
	
	function getSlotName($slotID){
		global $db;
		$q = "select name from slots where id='$slotID'";		
		return $db->getRecord($q)->name;		
	}
	
	function hasModules($slotName){
		global $db;
		$slotID = $this->getSlotID($slotName);
		$q = "select id from modules where slotID='$slotID' and active=1";
		$records = $db->getRecords($q);
		return count($records) > 0;
	}
	
	function includeModules($slot, $header=NULL){
		global $system;
		global $db;
		global $langID;
		$modules = $this->getModules($slot);
		if(!$slot) return false;
		foreach($modules as $module){
			$excludedLanguages = explode("|", $module->excludedLanguages);
			if(in_array($langID, $excludedLanguages)) continue;
			$moduleID = $module->id;
			$moduleName = $system->getExtensionName($module->moduleID);
			$SL_sectionID = ($slot=="pages") ? $system->getTableSectionID("pages") : $system->getTableSectionID("modules");
			$SL_fieldID = ($slot=="pages") ? 0 : $system->getFieldID("sectionID", $SL_sectionID);
			$SL_itemID = $moduleID;
			$SL_optionID = $this->sectionID; // η τρέχουσα ενότητα
			$SL_query = "select id from selectlists 
			where sectionID='$SL_sectionID' 
			and fieldID='$SL_fieldID' 
			and itemID='$SL_itemID' ";
			if($slot != "pages"){
				$SL_query.= "and optionID='$SL_optionID'";
			}else{
				global $id; // page id
				$SL_query.= "and optionID='$id'";
			}	
			$displayThisModule = $db->getRecord($SL_query) || $slot == "admin_apps";

			if($displayThisModule){
				// first check any page exclusions
				if($this->section == "pages"){
					global $id; // page id	
					$SL_sectionID = $system->getTableSectionID("pages");
					$SL_query = "select id from selectlists 
					where sectionID='$SL_sectionID' 
					and fieldID='-1' 
					and itemID='$SL_itemID' 
					and optionID='$id'";
					$excludeThisModule = $db->getRecord($SL_query);
					//debug($excludeThisModule);
					if($excludeThisModule) continue; // this module has been excluded from this page
				}
				if($header) echo "<h1>".t($header)."</h1>";
				$filename = $moduleName.".php";
				$adminPath = ($this->admin) ? "../" : NULL;
				$systemPath = $adminPath.$this->modulesPath.$moduleName;
				$templateModulePath = $adminPath.$this->getTemplatePath().$this->modulesPath.$moduleName;
				$currentModuleID = $moduleID;
				$moduleFile = (is_file($templateModulePath."/".$filename)) ? $templateModulePath."/".$filename : $systemPath."/".$filename;
				include($moduleFile);				
				@include((is_file($templateModulePath."/actions.php")) ? $templateModulePath."/actions.php" : $systemPath."/actions.php");
			}
		}
	}
	
	function loadModule($moduleName){
		global $messages;
		$mainPath = $this->modulesPath;
		$xmlFile = $mainPath.$moduleName."_install.xml";
		if(!is_file($xmlFile)) {
			$messages->addError(t("Module «".$moduleName."» not found!" ));
			return;
		}
		$xml = simplexml_load_file($xmlFile); // open the module's install xml file
		$installType = $xml->attributes()->type;
		$protected = strval($xml->protected);
		$modulesDir = (!empty($protected)) ? $this->modulesPath.$moduleName."/" : $this->getTemplatePath().$this->modulesPath.$moduleName."/";
		$success = false;
		if($installType == "module"){ // make sure its the correct xml
			$success = true;
			foreach($xml->files->file as $node){
				if(strval($node)){ // ignore empty xml tags
					$type = $node->attributes()->type;
					$thisFile = strval($node);	
					if($type == "js"){
						$thisFile = 	$modulesDir.$this->jsFilePath.$thisFile;
						if($thisFile && !in_array($thisFile, $this->loadedFiles)){
							$this->loadedFiles[] = $thisFile;
							$this->setJsFiles((is_file($thisFile) && (preg_match('/.js$/', $thisFile))) ? $thisFile : NULL);
						}
					}
					if($type == "css"){
						$thisFile = 	$modulesDir.$this->cssFilePath.$thisFile;
						if($thisFile && !in_array($thisFile, $this->loadedFiles)){
							$this->loadedFiles[] = $thisFile;
							$this->setStyles((is_file($thisFile) && (preg_match('/.css$/', $thisFile))) ? $thisFile : NULL);
						}
					}							
				}
			}		
		}
		return $success;
	}
	
	function getTemplateHeadFiles(){
		global $messages;
		$success = false;
		$templatePath = $this->getTemplatePath();
		$xmlFile = $templatePath.$this->template."_install.xml";
		if(!is_file($xmlFile)) {
			$messages->addError("Template's XML file not found!");
			return;
		}	
		$actionsFile = $templatePath."actions.php";	
		if(is_file($actionsFile)) include($actionsFile);
		$xml = simplexml_load_file($xmlFile); // open the module's install xml file
		$installType = $xml->attributes()->type;
		if($installType == "template"){ // make sure its the correct xml
			foreach($xml->files->file as $node){
				if(strval($node)){ // ignore empty xml tags
					$type = $node->attributes()->type;
					$thisFile = strval($node);
					$success = true;
					if($type == "root" && $thisFile == "meta.txt"){
						$metaFile = $templatePath.$thisFile;
						if(is_file($metaFile)){
							$meta = file($metaFile);
							foreach($meta as $line){
								$this->setMeta(chop($line));
							}
						}
					}
					if($type == "js" && $node->attributes()->role == "common"){
						$thisFile = (preg_match('/^http:\/\//', $thisFile)) ? $thisFile : $templatePath.$this->jsFilePath.$thisFile;
						if($thisFile && !in_array($thisFile, $this->loadedFiles)){
							$nodeValue = strval($node);
							if(preg_match('/ready\.js/$', $nodeValue)){
								$this->setJsReady((preg_match('/.js$/', $thisFile)) ? file_get_contents($thisFile) : NULL);
							}elseif(strval($node) == "bodyJs.js"){
								// ignore bodyJs cause its been injected
							}else{ // continue to examine the file
								if($node->attributes()->condition){	 // conditional js file
									$this->setJsFiles((preg_match('/.js$/', $thisFile)) ? $thisFile.'|'.$node->attributes()->condition : NULL);
								}else{
									$this->setJsFiles((preg_match('/.js$/', $thisFile)) ? $thisFile : NULL);
								}
								$this->loadedFiles[] = $thisFile;								
							}
						}
					}
					if($type == "css" && $node->attributes()->role == "common"){
						$thisFile = (preg_match('/^http:\/\//', $thisFile)) ? $thisFile : $templatePath.$this->cssFilePath.$thisFile;
						if(preg_match('/overidde\.css$/', $thisFile)) continue;
						if(!in_array($thisFile, $this->loadedFiles)){
							$this->loadedFiles[] = $thisFile;
							if($node->attributes()->condition){	 // conditional css file
								$this->setStyles((preg_match('/.css$/', $thisFile)) ? $thisFile.'|'.$node->attributes()->condition : NULL);				
							}else{ // ordinary css file
								$this->setStyles((preg_match('/.css$/', $thisFile)) ? $thisFile : NULL);
							}
						}
					}							
				}
			}		
		}
		return $success;		
	}
	
	function manageUsers(){
		global $auth;
		global $document;
		$login = $auth->getLoginStatus();
		if($login != 2){
			?>
			<script type="text/javascript">
			<!--
			doUpdate();
			var userUpdateStatus = setInterval(doUpdate, 30000);
			function doUpdate(){
				$.ajax({
				  dataType: "json",
				  url: "updateUserStatus.php",
					success: function(data){
						$.each(data, function(key, val) {
							window.userStatus = val.status;
							//console.log(window.userStatus);
						});
						if(window.userStatus == "Access Denied"){
							clearInterval(userUpdateStatus);
							<?php
							if($document->view != "odyssey_index"){
								// logout and exit from any iframe
							?>
							window.top.location.href="index.php?logout=1";
							<?php
							}
							?>
						}
					}
				});		
			}
			-->
			</script>
			<?php	
		}else{
			?>
			<script type="text/javascript">
			<!--
			cleanUpUsers();
			var cleanUp = setInterval(cleanUpUsers, 30000);
			function cleanUpUsers(){
				$.ajax({
				  url: "cleanUpUsers.php",
					success: function(response){
						//console.log(response);
					}
				});		
			}
			-->
			</script>
			<?php	
		}		
	}
			
	function printDebug(){
		$parameters = new parameters();
		if(!$parameters->getParameter("debug")) {		
			return;
		}else{
		// debug is enabled...
		global $start_time;
		global $cache;
		global $allQueries;
		echo "<div id='debug_info'>";
		$end_time = microtime(true);
		$totaltime = ($end_time - $start_time); 
		$cacheEnabled = ($cache) ? "ON" : "OFF";
		echo "Database Cache: ".$cacheEnabled." • ";	
		echo "Total queries: ".$allQueries." • ";			
		echo "Script execution time: ". number_format($totaltime, 3). " seconds";
		echo "</div>";	
		}
	}
	

} // end class
?>