<?php 
defined('CMS') or die("This file cannot run this way!");
class eshop{
	
	function hasAccess($productID, $type) {
		global $auth;
		global $db;
		global $system;
		global $categories;
		$type = ($type) ? $type : "access_type";
		$userGroupID = $auth->getLoginStatus();
		$sectionID = $system->getTableSectionID("products");
		$fieldID = $system->getFieldID($type, $sectionID);
		$itemID = $productID;
		$optionID = $userGroupID;
		$q = "select itemID from `selectlists` where 
				sectionID='$sectionID' 
				and fieldID='$fieldID' 
				and itemID='$itemID' 
				and optionID='$optionID'";
		$userAccess = $db->getNumRows($q) > 0;
		if(!$userAccess) return false;
		// continue to check Category Access
		$catFieldID = $system->getFieldID("catID", $sectionID);
		$items = $db->getRecords("select optionID from selectlists where sectionID='$sectionID' and fieldID='$catFieldID' and itemID=$productID");
		foreach($items as $item){
			if(!$categories->hasAccess($item->optionID)) return false;
		}
		// finally check global prices access for this user group
		if($type == "show_price") return $this->hasPricesAccess();
		return true;
	}
	
	function hasPricesAccess(){
		global $content;
		global $auth;
		$userGroupID = $auth->getLoginStatus();
		$values = $content->getMultipleValues("system_settings", "access_prices", 1);
		if(in_array($userGroupID, $values)) return true;
		return false;
	}
	
	function getCurrency(){
		global $parameters;
		global $db;
		global $langID;
		$currencyID = $parameters->getParameter("currency");
		$q="select cc.title, c.* from currencies as c, content_currencies as cc where 
				cc.mainID=c.id 
				and c.id='$currencyID' 
				and cc.langID='$langID' 
				and c.active=1";
		$record = $db->getRecord($q);
		return $record;
	}
	
	function getCurrencyProperty($property){
		$currency = $this->getCurrency();
		if(property_exists($currency, $property)){
			return $currency->{$property};
		}
		return false;
	}
	
	function formatPrice($price, $html=true){
		$price = (float)$price;
		$currency = $this->getCurrency();
		$sign = $currency->sign;
		$code = $currency->code;
		if($html) $sign = '<meta itemprop="priceCurrency" content="'.$code.'" /><span class="currency_sign">'.$sign.'</span>';
		$start_position = (int)$currency->start_position;
		$decimals = $currency->decimal;
		$decimal_seperator = $currency->decimal_seperator;
		$thousands_seperator = $currency->thousands_seperator;
		$value = number_format($price, $decimals, $decimal_seperator, $thousands_seperator);
		if($html) $value = '<span class="amount" itemprop="price">'.$value.'</span>';
		if($start_position){
			return $sign.$value;
		}else{
			return $value.$sign;
		}
	}
	
	function displayRating($productID, $userID=false){
		$productID = (int)$productID;
		if(empty($productID)) return false;
		global $db;
		global $parameters;
		global $sef;
		if(!is_object($sef)) $sef = new sef();
		if(!$parameters->getParameter("rating")) return false;
		$q="select rate from comments where articleID='$productID'";
		$numOfRates = $db->getNumRows($q);
		if(!$numOfRates) return false;
		if(!$userID){
			$q = "select sum(rate) as total from comments where articleID='$productID'";
			$totalRates = $db->getRecord($q)->total;
			$value = round($totalRates / $numOfRates);
		}else{
			$q = "select rate from comments where articleID='$productID' and userID='$userID'";
			$value = $db->getRecord($q)->rate;
		}
        echo '<a id="rating" target="_top" href="'.$sef->url("index.php?section=products&view=node&id=".$productID."&tab=reviews#commentsStart", false).'">';
		for($idx=1; $idx<=5; $idx++){
			$class = ($idx <= $value) ? " star_small_active" : NULL;
        	echo '<span class="star_small'.$class.'"></span>';
		}
		echo '</a>';
		return true;
	}
		
	function getProductOptionVariants($productID, $optionID, $langID=NULL, $onlyIDs=false){
		if(empty($productID)) return false;
		global $db;
		if(empty($langID)) global $langID;		
		if($onlyIDs){
			$q = "select distinct pov.variantID as variantID   
					from product_options_variants as pov, option_variants as ov where 
					pov.optionID='$optionID' 
					and pov.variantID=ov.id 
					and pov.productID='$productID'  
					and pov.active=1 
					and ov.active=1 
					order by pov.sort";	
		}else{
			$q = "select distinct pov.variantID as variantID, 
					cov.title as title, 
					pov.variants_modifier as modifier, 
					pov.variants_modifier_type as type 
					from product_options_variants as pov, option_variants as ov, content_option_variants as cov where 
					pov.optionID='$optionID' 
					and pov.variantID=ov.id 
					and pov.productID='$productID' 
					and cov.langID='$langID' 
					and cov.mainID=ov.id 
					and pov.active=1 
					and ov.active=1 
					order by pov.sort";	
			
		}
		$variants = $db->getRecords($q);
		if($onlyIDs){
			$variantIDs = array();
			foreach($variants as $variant){
				$variantIDs[] = $variant->variantID;
			}
		}		
		return ($onlyIDs) ? $variantIDs : $variants;					
	}
	
	function getProductExeptionsIDs($productID){
		global $db;
		$exceptionsIDs = array();
		$q = "select combination from options_exceptions where productID='$productID'";
		$records = $db->getRecords($q);
		foreach($records as $record){
			$exceptionsIDs[] = unserialize($record->combination);
		}
		return $exceptionsIDs;
	}
	
	function getAllCombinations($productID){
		global $db;
		$optionsIDs = $this->getProductOptions($productID, NULL, true);
		if(!function_exists("getCombinationsArray")){
			function getCombinationsArray($arrays, $i = 0){
				if(!isset($arrays[$i])) return array();
				if($i == count($arrays) - 1) return $arrays[$i];
				$tmp = getCombinationsArray($arrays, $i + 1);
				$result = array();
				foreach($arrays[$i] as $v){
					foreach($tmp as $t){
						$result[] = is_array($t) ? array_merge(array($v), $t) : array($v, $t);
					}
				}
				return $result;
			}	
		}
		$options_data = array();
		foreach($optionsIDs as $optionID){
			$option_data = array();
			$q = "select distinct ov.id from product_options_variants as pov, option_variants as ov where 
					pov.optionID='$optionID' 
					and pov.variantID=ov.id 
					and pov.productID='$productID' 
					and pov.active=1  
					order by pov.sort";
			$combination_variants = $db->getRecords($q);
			foreach($combination_variants as $vRow){
				$option_data[] = $optionID."|".$vRow->id;
			}
			if(count($option_data)) $options_data[] = $option_data;			
		}
		$allCombinations = getCombinationsArray($options_data);
		$combinations = array();
		foreach($allCombinations as $combination){
			$temp = array();
			foreach($combination as $item){
				list($optionID, $variantID) = explode("|", $item);
				$temp[$optionID] = $variantID;
			}
			$combinations[] = $temp;
		}		
		return $combinations;
	}
	
	function getAllowableCombination($productID, $exceptions){
		$allCombinations = $this->getAllCombinations($productID); 
		if(!count($allCombinations)) return array(); // no allowable combination for emprty combinations;		
		$forbidden = array();
		foreach($allCombinations as $key=>$combination){
			sort($combination);
			$allCombinations[$key] = $combination; // save the new order of sorting			
			foreach($exceptions as $exception){	
				sort($exception);
				if($combination === $exception) $forbidden[] = $exception;
			}			
		}
		if(count($forbidden) == count($allCombinations)) return array(); // no allowable combination found;
		foreach($allCombinations as $combination){
			if(!in_array($combination, $forbidden)) $possible_return = $combination;
				$counter = 0;	
				foreach($combination as $variantID){
					foreach($forbidden as $forbiddenItem){
						foreach($forbiddenItem as $forbiddenID){
							if($forbiddenID == $variantID) $counter++;
						}						
					}
				}
				if(!$counter) return $combination; // return a combination containing no variants from forbidden combinations
		}
		// try to return any other combination containing at least one allowable variant or an empty array if no such combination found
		return (count($possible_return)) ? $possible_return : array();
	}
	
	function getProductVariantsIDs($productID){
		$allCombinations = $this->getAllCombinations($productID);	
		$variants = array();
		foreach($allCombinations as $combination){
			foreach($combination as $optionID=>$variantID) $variants[] = $variantID;
		}
		return array_unique($variants);		
	}
			
	function getProductExclusions($productID, $selectedOptions, $exceptions){
		global $content;
		global $langID;
		global $db;
		$optionsIDs = $this->getProductOptions($productID, $langID, true);		
		if(empty($exceptions) || empty($selectedOptions) || empty($optionsIDs)) return array();
		if(!count($selectedOptions)) return array();
		$combinations = $excluded = array();
		foreach($exceptions as $exception) $combinations[] = array_diff($exception, $selectedOptions); 
		foreach($combinations as $variants){
			if(count($variants) == 1){
				$optionID = key($variants);
				$excluded[$optionID][] = $variants[$optionID];
			}
		}
		return $excluded;
	}
		
	function isVariantExcluded($variantID, $excludedVariants){
		foreach($excludedVariants as $setOfExcluded){
			if(in_array($variantID, $setOfExcluded)) return true;
		}
		return false;
	}
	
	function getProductCode($productID, $combination){
		if(!$productID) return false;
		global $db;
		global $content;
		global $langID;
		$defaultCode = $content->getValue("products", $productID, "code", $langID);	
		if($combination){
			$combinations = explode("_", $combination);
			$q = "select code from inventory where productID='$productID' ";
			foreach($combinations as $combination){
				$q.="and combination like '%".$combination."%' ";
			}
			$code = $db->getRecord($q)->code;			
		}
		return ($code) ? $code : $defaultCode;
	}
	
	function getProductImage($productID, $combination){
		if(!$productID) return false;
		global $db;
		global $content;
		global $langID;
		$defaultImage = $content->getImage("products", $productID, $langID, 'default');
		$defaultImage = ($defaultImage == ".") ? false: $defaultImage;
		if($combination){ // lets see if a specific image for this combination exists
			$combinations = explode("_", $combination);
			$q = "select image from inventory where productID='$productID' ";
			foreach($combinations as $combination){
				$q.="and combination like '%".$combination."%' ";
			}
			$combinationImage = $db->getRecord($q)->image;
			$image = $combinationImage;
			if(!$image){ // try to get variant's image
				foreach($combinations as $combination){
					list($optionID, $variantID) = explode("|", $combination);
					$hasImage = $content->getValue("product_options", $optionID, "has_image", $langID);
					if($hasImage){
						$q = "select image from product_options_variants where productID='$productID' and optionID='$optionID' and variantID='$variantID'";
						$image = $db->getRecord($q)->image;
						return $image;
					}	
				}
				return $defaultImage;
			}else{
				return $image;
			}
		}else{
			return $defaultImage;			
		}
	}
	
	function calculateDiscount($productID, $price, $quantity=1){
		if(!$productID || !$price) return false;
		global $db;
		global $auth;
		$userGroupID = $auth->getLoginStatus();
		$q="select quantity, value, type from quantity_discounts where productID='$productID' and users_typeID='$userGroupID' order by quantity";
		$discounts = $db->getRecords($q);
		foreach($discounts as $discount){
			$discount_quantity = $discount->quantity;
			$discount_value = $discount->value;
			$discount_type = $discount->type;
			if($discount_type == "A" && $quantity >= $discount_quantity){
				$modified_price = 0;
				$modified_price -= (float)$discount_value;
			}
			if($discount_type == "P" && $quantity >= $discount_quantity){
				$modified_price = 0;
				$modified_price -= (float)($discount_value * ($price / 100));
			}			
		}
		return $price + $modified_price;
	}
	
	function getProductPrice($productID, $combination, $quantity=1){
		if(!$productID) return false;
		global $db;
		global $content;
		global $langID;
		$basePrice = $content->getValue("products", $productID, "price", $langID);
		$price = (float)$basePrice;
		if(!$combination){
			$price = $this->calculateDiscount($productID, $price, $quantity);
			return $price;
		}
		$combinations = explode("_", $combination);
		foreach($combinations as $combination){
			list($optionID, $variantID) = explode("|", $combination);	
			$q = "select variants_modifier, variants_modifier_type, image from product_options_variants where 
					optionID='$optionID' 
					and variantID='$variantID' 
					and productID='$productID' ";
			$record = $db->getRecord($q);	
			$modifier = (float)$record->variants_modifier;
			if(!empty($modifier)){
				$type = $record->variants_modifier_type;
				if($type == "A"){
					$price+= $modifier;
				}
				if($type == "P"){
					$modified_price= $modifier * ($basePrice / 100);
					$price+= $modified_price;
				}				
			}
		}
		$price = $this->calculateDiscount($productID, $price, $quantity);
		return $price;
	}
	
	function getVat($amount, $vat){
		if(!$vat) return 0;
		return ($amount * $vat) / 100;
	}
	
	function includeVat($amount, $vat){
		$amount+= $this->getVat($amount, $vat);
		return (float)$amount;
	}
	
	function removeVat($amount, $vat){
		if(!$vat) return (float)$amount;
		$factor = 1 + ($vat / 100);
		$amount = $amount / $factor;
		return (float)$amount;
	}	
	
	function roundToNextHalf($number){
		$denominator = 2;
		$x = $number * $denominator;
		$x = ceil($x);
		$x = $x / $denominator;
		return $x;
	}
	
	function applyShippingDiscount($price){
		global $parameters;
		$percent_factor = $parameters->getParameter("percent_factor");
		$percent_factor = (float)$percent_factor;
		return $price + ($price*(($percent_factor)/100));
	}
	
	function getProductWeight($productID, $combination){
		if(!$productID) return false;
		global $db;
		global $content;
		global $langID;
		$baseWeight = $content->getValue("products", $productID, "weight", $langID);
		$baseWidth = $content->getValue("products", $productID, "width", $langID);
		$baseHeight = $content->getValue("products", $productID, "height", $langID);
		$baseDepth = $content->getValue("products", $productID, "depth", $langID);
		$weight = (float)$baseWeight;
		$width = (float)$baseWidth;
		$height = (float)$baseHeight;
		$depth = (float)$baseDepth;
		$volumetricWeight = ($depth * $width * $height) / 5000;
		if(!$combination){
			$weight = ($volumetricWeight > $weight) ? $volumetricWeight : $weight;
			return $weight;
		}
		$combinations = explode("_", $combination);
		foreach($combinations as $combination){
			list($optionID, $variantID) = explode("|", $combination);	
			$q = "select variants_weight_modifier, variants_weight_modifier_type from product_options_variants where 
					optionID='$optionID' 
					and variantID='$variantID' 
					and productID='$productID' ";
			$record = $db->getRecord($q);	
			$modifier = (float)$record->variants_weight_modifier;
			if(!empty($modifier)){
				$type = $record->variants_weight_modifier_type;
				if($type == "A"){
					$weight+= $modifier;
				}
				if($type == "P"){
					$modified_weight= $modifier * ($baseWeight / 100);
					$weight+= $modified_weight;
				}				
			}
		}
		$weight = ($volumetricWeight > $weight) ? $volumetricWeight : $weight;
		return $weight;
	}	
	
	function getShippingCountries(){
		global $system;
		$SL_sectionID = $system->getTableSectionID("system_settings");
		$SL_fieldID = $system->getFieldID("shipping_countries", $SL_sectionID);
		$SL_itemID = 1; // system settings record
		global $db;
		$records = $db->getRecords("select optionID from selectlists where sectionID='$SL_sectionID' and fieldID='$SL_fieldID' and itemID='$SL_itemID'");
		$countries = array();
		foreach($records as $record){
			$countries[] = $record->optionID;
		}
		return $countries;
	}
			
	function productOptions($id){
		global $safeRequest;
		$combination = $safeRequest->combination;
		$options = $this->getProductOptions($id);	
		if(count($options)){
			$combinations = explode("_", $combination);
			$exceptions = $this->getProductExeptionsIDs($id);
			$selectedOptions = $this->getAllowableCombination($id, $exceptions);
			$excludedVariants = $this->getProductExclusions($id, $selectedOptions, $exceptions);			
			if(count($selectedOptions)){
				?>
        <div id="qv_options">
				<?php
				foreach($options as $option){
					$optionID = $option->id;
					$optionTitle = $option->title;
					$optionVariants = $this->getProductOptionVariants($id, $optionID);
					if(count($optionVariants)){
				?>
        	<div class="qv_block">
        		<span class="qv_label"><?php echo $optionTitle;?>: </span>
                <span class="qv_value">
                <select name="option_<?php echo $optionID;?>_<?php echo $id;?>" id="option_<?php echo $optionID;?>_<?php echo $id;?>" class="qv_listbox interactive_option">
						<?php
						foreach($optionVariants as $optionVariant){
							$variantID = $optionVariant->variantID;
							$isVariantExcluded = (empty($selectedOptions)) ? true : $this->isVariantExcluded($variantID, $excludedVariants);
							if($isVariantExcluded){
								$excludedVariants[$optionID] = array(); // remove to prevent re-checking this variantID							
							}else{
								$selected = (in_array($variantID, $selectedOptions)) ? " selected" : NULL;
								$variantTitle = $optionVariant->title;								
								?>
						<option value="<?php echo $variantID;?>"<?php echo $selected;?>><?php echo $variantTitle;?></option>
								<?php
							}
						}
						?>
                </select>
                </span>
			</div>
				<?php
					}
				}
				?>
        </div>
        <?php
			}
		}		
	}
	
	function getProductOptions($productID, $langID=NULL, $onlyIDs=false){
		if(empty($productID)) return false;
		global $content;
		global $system;
		global $db;
		if(empty($langID)) global $langID;
        $productCategoriesArray = $content->getMultipleValues("products", "catID", $productID);
		$productCategoriesArray = array_unique($productCategoriesArray);		
        $productCategories = implode(",", $productCategoriesArray);
		if(empty($productCategories)) return false;
        $SL_sectionID = $system->getTableSectionID('product_options');
        $SL_fieldID = $system->getFieldID('related_categories', $SL_sectionID);
		if($onlyIDs){
			$q = "select distinct po.id 
					from product_options as po, 
					options as o, 
					selectlists as s  
					where po.active=1 
					and o.active=1 
					and o.optionID=po.id 
					and o.productID='$productID' 
					and s.sectionID='$SL_sectionID' 
					and s.fieldID='$SL_fieldID' 
					and s.itemID=po.id 
					and s.optionID IN (".$productCategories.") order by o.sort";
		}else{
			$q = "select distinct po.id, cpo.title 
					from product_options as po, 
					content_product_options as cpo, 
					options as o, 
					selectlists as s  
					where po.id=cpo.mainID 
					and cpo.langID='$langID' 
					and po.active=1 
					and o.active=1 
					and o.optionID=po.id 
					and o.productID='$productID' 
					and s.sectionID='$SL_sectionID' 
					and s.fieldID='$SL_fieldID' 
					and s.itemID=po.id 
					and s.optionID IN (".$productCategories.") order by o.sort";
		}
		$options = $db->getRecords($q);
		if($onlyIDs){
			$optionsIDs = array();
			foreach($options as $option){
				$optionsIDs[] = $option->id;
			}
		}
		return ($onlyIDs) ? $optionsIDs : $options;		
	}
	
	
	function getCategoryImage($catID){
		global $categories;
		$categoryImage = $categories->getCategoryImage($catID, "products");
		if($categoryImage) return "mediabank/".$categoryImage;
		// try to find an image from product of this category
		global $db;
		global $system;
		global $content;
		global $langID;
		$sectionID = $system->getTableSectionID("products");
		$fieldID = $system->getFieldID("catID", $sectionID);
		$q = "select p.id from products p, selectlists s where (s.sectionID='$sectionID' and s.fieldID='$fieldID' and s.itemID=p.id and s.optionID='$catID')";
		$products = $db->getRecords($q);
		foreach($products as $product){
			$id = $product->id;
			$image = $content->getImage("products", $id, $langID, 0);
			if($image && $image != ".") return "mediabank/medium/medium_".$image;
		}
		return "images/no_image.png";
	}
		
	function displayBreadcrumb($title, $separator=" » "){
		global $section;
		if(empty($section)) return; // nothing to show		
		global $sef;
		if(!is_object($sef)) $sef = new sef();
		global $system;
		global $content;
		global $document;
		global $langID;
		global $view;
		global $id;
		global $catID;
		global $variables;
		$catID = ($catID) ? $catID : $document->catID;		
		echo '<a class="breacrumb_link" href="'.$sef->url("index.php", false).'">'.t("Αρχική Σελίδα", $langID, "breadcrumb").'</a>';  // basic home breadcrumb		
		$hasCategory = $system->getSectionProperty($section, "hasCategory");
		if($section == "pages" && $id){
			$breadcrumbTitle = ($title) ? $title : $content->getValue("pages", $id, "title", $langID);
			$breadcrumbTitle = mb_ucfirst($variables->toLower($breadcrumbTitle));
			echo '<span class="breacrumb_separator">'.$separator.'</span><span class="breadcrumb_leaf">'.$breadcrumbTitle.'</span>';
			return;
		}
		if($section == "users" && $view){
			if($view == "payments"){
				$breadcrumbTitle = t("Αποτελέσματα"). " ".$document->payment_method_title." ";
			}else{
				$breadcrumbTitle = ($title) ? t($title) : t("Χρήστες", $langID, "breadcrumb")." - ".$view;
			}
			$breadcrumbTitle = mb_ucfirst($variables->toLower($breadcrumbTitle));
			echo '<span class="breacrumb_separator">'.$separator.'</span><span class="breadcrumb_leaf">'.$breadcrumbTitle.'</span>';
			return;
		}
		// check for content section
		$hasContent = is_file("controller/_".$section.".php") || is_file("controller/".$section.".php");
		if($hasContent){
			$tableSectionID = $system->getTableSectionID($section);
			$sectionTitle = $system->getTableSectionTitle($tableSectionID);
			$sectionTitle = mb_ucfirst($variables->toLower($sectionTitle));
			$sectionTitle = str_replace(array("Προϊοντα", "Αρθρα"), array("Προϊόντα", "Άρθρα"), $sectionTitle); // διόρθωση τονούμενων στα system sections
			$sectionLink = $sef->url("index.php?section=".$section."&view=list&langID=".$langID, false);
			echo '<span class="breacrumb_separator">'.$separator.'</span><a class="breacrumb_link" href="'.$sectionLink.'">'.$sectionTitle.'</a>';
			if($hasCategory){
				global $categories;
				$hasMultiCategories = ($catID == "0");
				if($hasMultiCategories && !empty($id)){
					$cats = $categories->getMultiCategories($section, $id);
					if(count($cats)) $catID = $cats[0];
				}
				$catPath = $categories->getPath($catID, $section.'_categories');
				foreach($catPath as $node){
					$categoryName = $categories->getCategoryName($node, "content_".$section."_categories", $langID);
					$catLink = $sef->url("index.php?section=".$section."&view=list&catID=".$node, false);
					echo '<span class="breacrumb_separator">'.$separator.'</span><a class="breacrumb_link" href="'.$catLink.'">'.$categoryName.'</a>';
				}
				$categoryName = $categories->getCategoryName($catID, "content_".$section."_categories", $langID);
				$categoryName = mb_ucfirst($variables->toLower($categoryName));
				if($categoryName){
					$catLink = $sef->url("index.php?section=".$section."&view=list&catID=".$catID, false);
					echo '<span class="breacrumb_separator">'.$separator.'</span><a class="breacrumb_link" href="'.$catLink.'">'.$categoryName.'</a>';
				}
				if(empty($id)){ // subcategory leaf
					$breadcrumbTitle = ($title) ? $title : NULL;
				}else{ // content leaf
					$breadcrumbTitle = ($title) ? $title : $content->getValue($section, $id, "title", $langID);
				}
				if($breadcrumbTitle){
					$breadcrumbTitle = mb_ucfirst($variables->toLower($breadcrumbTitle));
					echo '<span class="breacrumb_separator">'.$separator.'</span><span class="breadcrumb_leaf">'.$breadcrumbTitle.'</span>';
				}
				return;
			}else{ // other content section
				if($id){
					$breadcrumbTitle = ($title) ? $title : $content->getValue($section, $id, "title", $langID);
					$breadcrumbTitle = mb_ucfirst($variables->toLower($breadcrumbTitle));
					echo '<span class="breacrumb_separator">'.$separator.'</span><span class="breadcrumb_leaf">'.$breadcrumbTitle.'</span>';
					return;
				}
			}
		}		
	}
		
	function getProductIDs($catID){
		global $db;
		global $langID;
		if($catID){
			global $system;
			$sectionID = $system->getTableSectionID("products");						
			$fieldID = $system->getFieldID("catID", $sectionID);
			$q = "select distinct p.id as id from products as p, content_products as cp, selectlists as s  
					where p.active=1 
					and p.id=cp.mainID 
					and cp.langID='$langID' 
					and (s.sectionID='$sectionID' and s.fieldID='$fieldID' and s.itemID=p.id and s.optionID='$catID') LIMIT 100";
		}else{
			$q = "select distinct p.id as id from products as p, content_products  as cp 
					where p.active=1 
					and p.id=cp.mainID 
					and cp.langID='$langID' LIMIT 100";			
		}				
		$records = $db->getRecords($q);
		$IDs = array();
		foreach($records as $record){
			$productID = $record->id;
			if($this->hasAccess($productID)){
				$IDs[] = $productID;
			}
		}
		$IDs = implode(",", $IDs);
		return $IDs;
	}
	
	function getBrands($catID){
		global $db;
		global $langID;
		global $userID;
		global $auth;
		global $system;
		$userID = $auth->getLoginStatus();		
		$sectionID = $system->getTableSectionID("products");
		$fieldID = $system->getFieldID("catID", $sectionID);
		$fieldID2 = $system->getFieldID("access_type", $sectionID);
		if($catID){
			$q="select distinct p.brandID as id, p.id as productID, cm.title from products as p, content_manufacturers as cm, selectlists as s  
				where p.brandID=cm.mainID 
				and cm.langID='$langID' 
				and (s.sectionID='$sectionID' and s.fieldID='$fieldID' and s.itemID=p.id and s.optionID='$catID') 
				group by p.brandID 
				having count(p.id) = (select count(id) as sid from selectlists as s where s.sectionID='$sectionID' and s.fieldID='$fieldID2' and s.itemID=p.id and s.optionID='$userID') 
				order by cm.title";
		}else{
			$q="select distinct p.brandID as id, cm.title from products as p, content_manufacturers as cm, selectlists as s  
				where p.brandID=cm.mainID 
				and cm.langID='$langID' 
				and (s.sectionID='$sectionID' and s.fieldID='$fieldID2' and s.itemID=p.id and s.optionID='$userID')  
				order by cm.title";
		}	 
		$records = $db->getRecords($q);
		return $records;
	}
	
	function getProductsByFilters($variantIDs){
		if(empty($variantIDs)) return false;
		global $db;
		$q="select productID
		from features
		where variantID in (".$variantIDs.")
		group by productID
		having
			count(distinct featureID) =
			(select count(distinct featureID) from feature_variants where id in (".$variantIDs."))";
		$records = $db->getRecords($q);
		foreach($records as $record){
			$productIDs[] = $record->productID;
		}
		$productIDs = implode(",", $productIDs);
		return $productIDs;	
	}	
	
	function getRegion($countyID){
		global $db;
		$regionID = $db->getRecord("select regionID from counties where id='$countyID'")->id;
		return $regionID;
	}
	
	function getCombinationAsString($productID, $combination, $langID){
		global $db;
		$titles = array();
		$title = "";
		$options = $this->getProductOptions($productID, $langID);	
		if(count($options)){
			$combinations = explode("_", $combination);
			$counter = 0;			
			foreach($options as $option){
				list($selectedOptionID, $selectedVariantID) = explode("|", $combinations[$counter]);
				$counter++;				
				$optionID = $option->id;
				$q = "select distinct pov.variantID as variantID, 
						cov.title as title, 
						pov.variants_modifier as modifier, 
						pov.variants_modifier_type as type 
						from product_options_variants as pov, option_variants as ov, content_option_variants as cov where 
						pov.optionID='$optionID' 
						and pov.variantID=ov.id 
						and pov.productID='$productID' 
						and cov.langID='$langID' 
						and cov.mainID=ov.id 
						order by pov.sort";
				$optionVariants = $db->getRecords($q);
				if(count($optionVariants)){
					$optionTitle = $option->title;
					$title.=$optionTitle.": ";
					$variantTitles = array();
					foreach($optionVariants as $optionVariant){
						$variantID = $optionVariant->variantID;
						if($selectedVariantID == $variantID) $variantTitles[] = $optionVariant->title;
					}
					$title.=implode(", ",$variantTitles);
				}
				if($title) $titles[] = $title;
				$title="";
			}
		}
		$titles = implode(", ", $titles);
		return $titles;		
	}
	
	function saveOrder($order=false, $payment_status=false){
		global $db;
		global $content;
		global $dates;
		global $variables;
		global $categories;
		global $parameters;
		global $basket;
		global $langID;
		$order = ($order) ? $order : $_SESSION['order'];
		$order_data = new stdClass(); // store order data to pass them to the emails notification method
		$_SESSION['order']->orderID = NULL; // reset any previous value
		$_SESSION['order_errors'] = array(); // reset any previous errors
		if(!count($order)){
			$_SESSION['order_errors'][] = t("Δεν βρέθηκε η παραγγελία");
			return false; // no order to process
		}
		$basketItems = $order->basketItems;
		if(!count($basketItems)){
			$_SESSION['order_errors'][] = t("Δεν βρέθηκε η παραγγελία");
			return false; // no order to process
		}
		$customerName = $order->billing_fullname;
		if(!$customerName){
			$_SESSION['order_errors'][] = t("Δεν βρέθηκε το όνομα του πελάτη"); 
			return false; // cannot process the order
		}
		$customer_email = $order->billing_email;
		if(!$customer_email){
			$_SESSION['order_errors'][] = t("Δεν βρέθηκε το e-mail του πελάτη"); 
			return false; // cannot process the order
		}

		// store every successfull query id, to clean up if something will go wrong
		// we need session arrays to be used by $this->deleteLastOrder() method
		$_SESSION['orders_ids'] = array();
		$_SESSION['content_orders_ids'] = array();
		$_SESSION['order_products_ids'] = array();
		$_SESSION['content_order_products_ids'] = array();
		
		$isInstock = $order->isInstock;
		$isInstock = $order->payment_method;
		$userID = $order->userID;	
		$total = $order->total;
		$shipping = $order->checkout_shipping;	
		$shipping_cost = $order->shipping_cost;
		$payment_method = $order->payment_method;	
		$order_data->userID = $userID;	
		$order_data->cod = $order->cod;
		$order_data->shipping_cost = $shipping_cost;	
		$order_data->payment_method = $payment_method;
		$order_data->checkout_shipping = $shipping;	
		$catID = ($_SESSION['loginLevel'] == 5) ? 2 : 1; // 2=χονδρική και 1=λιανική
		$retailCustomer = $content->getValue("users_types", 4, "title", $langID);
		$wholesaleCustomer = $content->getValue("users_types", 5, "title", $langID);
		$order_data->customerType = ($catID == 5) ? $wholesaleCustomer : $retailCustomer;
		$order_date = time();
		$order_data->order_date = $order_date;
		$doc_type = $order->doc_type;
		$order_data->doc_type = $doc_type;
		$order_data->customer_email = $customer_email;
		if($isInstock && (!$payment_status || $payment_status == "Pending")) $status = 1; /* Απλήρωτη */
		if($isInstock && $payment_status == "Completed") $status = 2; /* Πληρωμένη */
		if(!$isInstock && (!$payment_status || $payment_status == "Pending")) $status = 4; /* Απλήρωτη (σε αναμονή προϊόντων) */
		if(!$isInstock && $payment_status == "Completed") $status = 5; /* Πληρωμένη (σε αναμονή προϊόντων) */
		$order_data->status = $status;
		$comments = stripslashes($order->checkout_comments);
		$order_data->comments = $comments;
		$orderTitle = $variables->filterQuotes($customerName." | ".$dates->makeDatefromTimestamp($order_date));
		$alias = $variables->toLatin($orderTitle);
		$billing_details = "<b>".$customerName."</b><br>";
		$billing_details.= $order->billing_address."<br>";
		$billing_details.= $order->billing_city.", ".$order->billing_zip_code."<br>";
		$queryLangID = ($langID != 1) ? 2 : $langID;
		$billing_details.= $content->getValue("countries", $order->billing_countryID, "title", $queryLangID)."<br>";
		$billing_details.= '<a href="mailto:'.$order->billing_email.'">'.$order->billing_email.'</a><br>';
		$billing_details.= $order->billing_phone."<br>";
		if($order->same_address != "yes"){
			$shipping_details = "<b>".$order->shipping_fullname."</b><br>";
			$shipping_details.= $order->shipping_address."<br>";
			$shipping_details.= $order->shipping_city.", ".$order->shipping_zip_code."<br>";
			$shipping_details.= $content->getValue("countries", $order->shipping_countryID, "title", $langID)."<br>";
			if($order->shipping_email) $shipping_details.= '<a href="mailto:'.$order->shipping_email.'">'.$order->shipping_email.'</a><br>';
			$shipping_details.= $order->shipping_phone."<br>";	
		}else{
			$shipping_details = $billing_details;
		}
		if($doc_type == "invoice"){
			$billing_details.= "<br><b>[Στοιχεία τιμολόγησης]</b><br>";
			$billing_details.= $order->billing_compName."<br>";
			$billing_details.= $order->billing_occupation."<br>";
			$billing_details.= t("ΑΦΜ").": ".$order->billing_afm."<br>";
			$billing_details.= t("ΔΟΥ").": ".$order->billing_doy."<br>";
		}
		$billing_details = $variables->filterQuotes($billing_details);
		$shipping_details = $variables->filterQuotes($shipping_details);
		$order_data->billing_details = $billing_details;
		$order_data->shipping_details = $shipping_details;
		$email = $order->billing_email;
		$cart = base64_encode(serialize($basketItems));
		
		// save order
		if(!$db->query("insert into `orders` (active, private, sort, alias, catID, userID, email, order_date, total, total_vat, discount, status, doc_type, shipping, shipping_cost, payment_method, billing_details, shipping_details, comments, cart) values (1, 1, 0, '$alias', '$catID', '$userID', '$email', '$order_date', '$total', '$total_vat', '0', '$status', '$doc_type', '$shipping', '$shipping_cost', '$payment_method', '$billing_details', '$shipping_details', '$comments', '$cart')")){
			$_SESSION['order_errors'][] = "The `orders` db query failed";			
		}else{
			$orderID = $db->lastID();
			$_SESSION['orders_ids'][] = $orderID;
			$order_data->orderID = $orderID;
			$LRecords = $db->getRecords("SELECT * FROM languages WHERE active=1 ");	
			foreach($LRecords as $Lrow) { // save the same title in all active languages
				$extension = ($Lrow->extension) ? $Lrow->extension : '_gr';
				$languageID = $Lrow->id;
				if(!$db->query("insert into `content_orders` (mainID, langID, title) values ('$orderID', '$languageID', '$orderTitle')")){
					$_SESSION['order_errors'][] = "The `content_orders".$extension."` db query failed";
				}else{
					$_SESSION['content_orders_ids'][] = $db->lastID();
				}
			}
		}
		if($orderID){
			// save the products of this order
			$order_data->items = array(); // for storing basket items details
			$include_vat = (int)$parameters->getParameter("include_vat");
			$total_vat = 0;
			foreach($basketItems as $basketItem){
				if(!empty($userID)){ // registered user
					$productID = $basketItem->productID;
					$combination = $basketItem->combination;
					$quantity = $basketItem->quantity;				
				}else{ // session basket
					list($uid, $productID, $quantity, $combination) = explode("~|~", $basketItem);
				}
				$order_data->items['product'.$productID] = new stdClass(); // create an object for this product's data
				$product = $content->getContentByID("products", $productID, array('price', 'instock', 'code', 'vat'), array('title'), $langID);
				$vat = ($product->vat) ? $content->getValue("fpa_cat", $product->vat, "percent", $langID) : 0;
				$price = $this->getProductPrice($productID, $combination, $quantity);			
				$total_vat += ($this->getVat($price, $vat)) * $quantity;				
				if($include_vat) $price = $this->includeVat($price, $vat);	
				$instock = $product->instock;
				$weight = $this->getProductWeight($productID, $combination);
				$temp = $content->getValue("products", $productID, "title", $langID);
				$order_data->items['product'.$productID]->price = $price;
				$order_data->items['product'.$productID]->quantity = $quantity;
				$order_data->items['product'.$productID]->code = $product->code;
				$alias = $variables->toLatin($temp);	
				if(!$db->query("insert into `order_products` (active, private, sort, alias, orderID, productID, weight, price) values (1, 1, 0, '$alias', '$orderID', '$productID', '$weight', '$price')")){
					$_SESSION['order_errors'][] = "The `order_products` db query failed";
				}else{
					$lastID = $db->lastID();
					$_SESSION['order_products_ids'][] = $lastID;
					foreach($LRecords as $Lrow) { // save the product title in all active languages
						$extension = ($Lrow->extension) ? $Lrow->extension : '_gr';
						$languageID = $Lrow->id;
						${'productTitle'.$extension} = $content->getValue("products", $productID, "title", $languageID);
						$combinationTitle = $this->getCombinationAsString($productID, $combination, $languageID);
						if($combinationTitle) ${'productTitle'.$extension}.= " | ".$combinationTitle;
						if($langID == $languageID) $order_data->items['product'.$productID]->productTitle = ${'productTitle'.$extension}; // store product title in current language for email notifications
						$productTitle = $variables->filterQuotes(${'productTitle'.$extension});
						if(!$db->query("insert into `content_order_products` (mainID, langID, title) values ('$lastID', '$languageID', '$productTitle')")){
							$_SESSION['order_errors'][] = "The `content_order_products".$extension."` db query failed";
						}else{
							$_SESSION['content_order_products_ids'][] = $db->lastID();
						}
					}
				}
			}
			$order_data->total_vat = $total_vat;
			$q = "update `orders` set total_vat='$total_vat' where id='$orderID'";
			$db->query($q); // update the total VAT now, because we had not the value before on first saving the order
		}		
		if(count($_SESSION['order_errors'])){ // something went wrong in queries
			//cleanup any entered records for this order
			$this->deleteLastOrder();
			return false;									
		}
		
		// email notifications
		$notifications = $this->sendOrderNotifications($order_data, $payment_status);
		if(!$notifications){
			// something wend wrong during the mailing task and the order must be canceled
			// usually the error messages have been set from sendOrderNotifications method
			if(!count($_SESSION['order_errors'])) $_SESSION['order_errors'][] = "Error sending the notifications emails";
			//cleanup any entered records for this order
			$this->deleteLastOrder();
			return false;												
		}
		
		// order saved
		$basket->clearBasket(); // clear cart's content
		$_SESSION['order']->orderID = $orderID; // for any payment method except online payments
		return true;
	}
	
	function sendOrderNotifications($order, $payment_status){
		if(!count($order)){
			$_SESSION['order_errors'][] = "System error: Order object is null or empty in sendOrderNotifications method";
			return false;
		}
		// mail to administrator
		global $langID; // current language
		global $content;
		global $variables;
		global $parameters;
		global $language;
		global $domain_name;
		$defaultLanguageID = $language->getDefaultLanguage(); // default language for this e-shop;
		$include_vat = (int)$parameters->getParameter("include_vat");
		$email_address = $parameters->getParameter("email"); // main email for this e-shop needed for notifications
		$customer_email = $order->customer_email; // customer email needed for notifications
		$orderID = $order->orderID;
		$hasShipping = ($order->checkout_shipping == "yes");
		$sc = $order->shipping_cost;
		$shipping_method = ($hasShipping) ? t("Αποστολή με υπηρεσία Courier", $defaultLanguageID) :  t("Παραλαβή από το κατάστημα", $defaultLanguageID);		
		$shipping_cost = (!empty($order->shipping_cost)) ? $this->formatPrice($order->shipping_cost) : t("Δωρεάν", $defaultLanguageID);
		$order_status = $content->getValue("order_statuses", $order->status, "title", $defaultLanguageID);
		$doc_type_name = ($order->doc_type == "invoice") ? t("Τιμολόγιο", $defaultLanguageID) : t("Απόδειξη λιανικής", $defaultLanguageID);
		$comments = $order->comments;
		
		// mail to administrator
		$mailID = md5(rand());
		$headers = "Reply-To: ".$email_address." <".$email_address.">\n"; 
		$headers.= "Return-Path: ".$email_address." <".$email_address.">\n"; 
		$headers.= "From: ".$email_address." <".$email_address.">\n";
		$headers.= "Organization: Odyshop e-Sales\n"; 
		$headers.= "Message-ID: <".$mailID."@".$_SERVER['SERVER_NAME'].">\n";
		$headers.= "MIME-Version: 1.0\n";
		$headers.= "Content-Type: text/html; charset=utf-8\n";
		
		$subject="Order from e-shop: ".$domain_name." | Order ID #".$orderID;
		$msg = '';
		$msg.= '<!doctype html>'.PHP_EOL;
		$msg.= '<html>'.PHP_EOL;
		$msg.= '<head>'.PHP_EOL;
		$msg.= '<meta http-equiv="content-type" content="text/html; charset=UTF-8">'.PHP_EOL;
		$msg.= '</head>'.PHP_EOL;						
		$msg.= '<body>'.PHP_EOL;
		$msg.= '<h2>'.t("Νέα παραγγελία", $defaultLanguageID).'</h2>'.PHP_EOL;
		$msg.= '<p>'.PHP_EOL;
		$msg.= t("Κωδικός παραγγελίας", $defaultLanguageID).' #'.$orderID.'<br>'.PHP_EOL;
		$msg.= t("Ημερομηνία παραγγελίας", $defaultLanguageID).' : '.date('d-m-Y', $order->order_date).'<br><br>'.PHP_EOL;
		$msg.= '</p>'.PHP_EOL;
		$msg.= '<h3>'.t("Στοιχεία πελάτη", $defaultLanguageID).'</h3>'.PHP_EOL;
		$msg.= '<p>'.PHP_EOL;		
		if(!empty($order->userID)) $msg.= 'user ID : '.$order->userID.'<br>'.PHP_EOL;
		$msg.= nl2br(str_replace("[Στοιχεία τιμολόγησης]", t("Στοιχεία τιμολόγησης"), $order->billing_details)).'<br>'.PHP_EOL;
		$msg.= '</p>'.PHP_EOL;
		$msg.= '<h3>'.t("Διεύθυνση αποστολής", $defaultLanguageID).'</h3>'.PHP_EOL;
		$msg.= '<p>'.PHP_EOL;		
		$msg.= nl2br($order->shipping_details).'<br><br>'.PHP_EOL;
		$msg.= '</p>'.PHP_EOL;
		$msg.= '<h3>'.t("Στοιχεία παραγγελίας", $defaultLanguageID).'</h3>'.PHP_EOL;
		$msg.= '<p>'.PHP_EOL;
		$msg.= t("Κατηγορία", $defaultLanguageID).' : '.$order->customerType.'<br>'.PHP_EOL;
		$msg.= t("Μέθοδος πληρωμής", $defaultLanguageID).' : '.$this->getPaymentMethodProperty("title", $order->payment_method, $defaultLanguageID).'<br>'.PHP_EOL;
		if($order->payment_method == "paypal"){	
			if(!$payment_status){
				$msg.= '<br>'.t("Η πληρωμή μέσω PayPal απέτυχε").'<br>'.PHP_EOL;
				$msg.= t("Θα πρέπει να επικοινωνήσετε με τον πελάτη για να επιβεβαιώσετε την παραγγελία").'<br>'.PHP_EOL;
				$msg.= t("Αν δεν επιβεβαιωθεί η παραγγελία, θα πρέπει να αλλάξετε την κατάσταση της σε «Ακυρωμένη» από την διαχείριση των παραγγελιών στον πίνακα διαχείρισης του e-shop").'<br>'.PHP_EOL;
			}		
			if($payment_status == "Completed"){
				$msg.= '<br>'.t("Η πληρωμή μέσω PayPal επιβεβαιώθηκε επιτυχώς").'<br>'.PHP_EOL;
				$msg.= t("Συνιστάται να το επιβεβαιώσετε και εσείς από τον πίνακα διαχείρισης του λογαριασμού σας στο PayPal").'<br>'.PHP_EOL;
			}
			if($payment_status == "Pending"){
				$msg.= '<br>'.t("Η πληρωμή μέσω PayPal επιβεβαιώθηκε με κατάσταση «Pending»").'<br>'.PHP_EOL;
				$msg.= t("Συνιστάται να το επιβεβαιώσετε και εσείς από τον πίνακα διαχείρισης του λογαριασμού σας στο PayPal").'<br>'.PHP_EOL;
				$msg.= t("Όταν επιβεβαιωθεί η πληρωμή, θα πρέπει να αλλάξετε την κατάσταση της σε «Πληρωμένη» από την διαχείριση των παραγγελιών στον πίνακα διαχείρισης του e-shop").'<br>'.PHP_EOL;
			}			
		}		
		$msg.= t("Είδος παραστατικού", $defaultLanguageID).' : '.$doc_type_name.'<br>'.PHP_EOL;
		$msg.= t("Τρόπος παραλαβής προϊόντων", $defaultLanguageID).' : '.$shipping_method.'<br>'.PHP_EOL;
		$msg.= t("Κατάσταση παραγγελίας", $defaultLanguageID).' : '.$order_status.'<br>'.PHP_EOL;
		if($comments) $msg.= "<br>".t("Σχόλια", $defaultLanguageID).' :<br>'.nl2br($comments).'<br>'.PHP_EOL;
		$msg.= '</p>'.PHP_EOL;
		
		$msg.= '<h3>'.t("Προϊόντα", $defaultLanguageID).'</h3>'.PHP_EOL;
		$msg.= '<table width="100%">'.PHP_EOL;
		$msg.= '<tr><td><b>'.t("Ονομασία προϊόντος", $defaultLanguageID).'</b></td><td><b>'.t("Κωδικός", $defaultLanguageID).'</b></td><td><b>'.t("Ποσότητα", $defaultLanguageID).'</b></td><td><b>'.t("Τιμή", $defaultLanguageID, "product").'</b></td><td><b>'.t("Σύνολο", $defaultLanguageID).'</b></td></tr>'.PHP_EOL;
		$total = 0;
		foreach($order->items as $item){
			$price = (float)$item->price;
			$quantity = (int)$item->quantity;
			$subtotal = $price * $quantity;
			$total+= $subtotal;
			$msg.= '<tr>'.PHP_EOL;
			$msg.= '<td>'.$variables->filterQuotes($item->productTitle).'</td><td>'.$item->code.'</td><td>'.$quantity.'</td><td>'.$this->formatPrice($price).'</td><td>'.$this->formatPrice($subtotal).'</td>'.PHP_EOL;
			$msg.= '</tr>'.PHP_EOL;
		}
		if(!$include_vat) $total+= $order->total_vat;
		$total_vat_formated = $this->formatPrice($order->total_vat);
		$include_vat_text = ($include_vat) ? " (".t("συμπεριλαμβάνεται").")" : NULL;
		$msg.= '<tr><td colspan="5">&nbsp;</td></tr>'.PHP_EOL; // empty row
		$msg.= '<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td><b>'.t("Συνολικό ΦΠΑ").$include_vat_text.' : </b>&nbsp;&nbsp;</td><td><b>'.$total_vat_formated.'</b></td></tr>'.PHP_EOL;		
		if($sc){
			$total+= $sc;
			$msg.= '<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td><b>'.t("Έξοδα αποστολής", $defaultLanguageID).'</b></td><td>'.$this->formatPrice($sc).'</td></tr>'.PHP_EOL;
		}		
		if(!empty($order->cod) && $order->payment_method == "cod"){
			$total+= $order->cod;
			$msg.= '<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td><b>'.t("Έξοδα αντικαταβολής", $defaultLanguageID).'</b></td><td>'.$this->formatPrice($order->cod).'</td></tr>'.PHP_EOL;
		}
		$msg.= '<tr><td colspan="5">&nbsp;</td></tr>'.PHP_EOL; // empty row
		$msg.= '<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td><b>'.t("Συνολικό κόστος", $defaultLanguageID).' : </b>&nbsp;&nbsp;</td><td><b>'.$this->formatPrice($total).'</b></td></tr>'.PHP_EOL;
		$msg.= '</table>'.PHP_EOL;
		$msg.= '</body>'.PHP_EOL;		
		$msg.= '</html>'.PHP_EOL;
		
		if(!@mail($email_address, $subject, $msg, $headers)){
			$_SESSION['order_errors'][] = "Could not send the notification to the administrator's email address [".$email_address."]";
			return false;
		}
				
		// mail to customer (html version)
		// declare current selected language for customer
		$shipping_method = ($hasShipping) ? t("Αποστολή με υπηρεσία Courier", $langID) :  t("Παραλαβή από το κατάστημα", $langID);		
		$shipping_cost = (!empty($order->shipping_cost)) ? $this->formatPrice($order->shipping_cost) : t("Δωρεάν", $langID);
		$order_status = $content->getValue("order_statuses", $order->status, "title", $langID);
		$doc_type_name = ($order->doc_type == "invoice") ? t("Τιμολόγιο", $langID) : t("Απόδειξη λιανικής", $langID);
		
		$mailID = md5(rand());
		$headers = "Reply-To: ".$email_address." <".$email_address.">\n"; 
		$headers.= "Return-Path: ".$email_address." <".$email_address.">\n"; 
		$headers.= "From: ".$email_address." <".$email_address.">\n";
		$headers.= "Organization: Odyshop e-Sales\n"; 
		$headers.= "Message-ID: <".$mailID."@".$_SERVER['SERVER_NAME'].">\n";
		$headers.= "MIME-Version: 1.0\n";
		$headers.= "Content-Type: text/html; charset=utf-8\n";		
		
		$subject="Your Order from : ".$domain_name." | Order ID #".$orderID." | HTML version";
		$msg = '';
		$msg.= '<!doctype html>'.PHP_EOL;
		$msg.= '<html>'.PHP_EOL;
		$msg.= '<head>'.PHP_EOL;
		$msg.= '<meta http-equiv="content-type" content="text/html; charset=UTF-8">'.PHP_EOL;
		$msg.= '</head>'.PHP_EOL;						
		$msg.= '<body>'.PHP_EOL;
		$msg.= '<h2>'.t("Η παραγγελία σας").'</h2>'.PHP_EOL;
		$msg.= '<p>'.PHP_EOL;
		$msg.= t("Κωδικός παραγγελίας").' #'.$orderID.'<br>'.PHP_EOL;
		$msg.= t("Ημερομηνία παραγγελίας").' : '.date('d-m-Y', $order->order_date).'<br><br>'.PHP_EOL;
		$msg.= '</p>'.PHP_EOL;
		$msg.= '<h3>'.t("Τα στοιχεία σας").'</h3>'.PHP_EOL;
		$msg.= '<p>'.PHP_EOL;		
		$msg.= nl2br(str_replace("[Στοιχεία τιμολόγησης]", t("Στοιχεία τιμολόγησης"), $order->billing_details)).'<br>'.PHP_EOL;
		$msg.= '</p>'.PHP_EOL;
		$msg.= '<h3>'.t("Διεύθυνση αποστολής").'</h3>'.PHP_EOL;
		$msg.= '<p>'.PHP_EOL;		
		$msg.= nl2br($order->shipping_details).'<br><br>'.PHP_EOL;
		$msg.= '</p>'.PHP_EOL;
		$msg.= '<h3>'.t("Στοιχεία παραγγελίας").'</h3>'.PHP_EOL;
		$msg.= '<p>'.PHP_EOL;
		$paymentMethodDescription = $this->getPaymentMethodProperty("description", $order->payment_method, $langID);
		if($order->payment_method == "cod" || $order->payment_method == "upon_request"){
			$msg.= $content->richText($paymentMethodDescription).'<br><br>'.PHP_EOL;
		}
		if($order->payment_method == "bank_deposit"){
			$bank_accounts = $content->getContent("bank_accounts", NULL, "*", "*", $langID);					
			if(!count($bank_accounts)){
				$msg.= t("Δεν βρέθηκαν καταχωρημένοι τραπεζικοί λογαριασμοί")."!<br>".PHP_EOL;
				$msg.= t("Παρακαλούμε επικοινωνήστε μαζί μας ώστε να αναφέρετε αυτό το σφάλμα").".<br><br>".PHP_EOL;				
			}else{
				$msg.= t("Για να ολοκληρώσετε την αγορά σας, παρακαλούμε καταθέστε το συνολικό ποσό της παραγγελίας")."<br>".PHP_EOL;	
				if(count($bank_accounts) > 1)	{
					$msg.= t("σε κάποιο από τους ακόλουθους τραπεζικούς λογαριασμούς").":<br>".PHP_EOL;
				}else{
					$msg.= t("στον ακόλουθο τραπεζικό λογαριασμό").":<br>".PHP_EOL;
				}
				$msg.= "<ul>".PHP_EOL;
				foreach($bank_accounts as $bank_account){
					$msg.= "<li>".PHP_EOL;
					$msg.= "<b>".$bank_account->title."</b><br>".PHP_EOL;
					$msg.= "IBAN : ".$bank_account->iban."<br>".PHP_EOL;
					$msg.= t("Δικαιούχος")." : ".$bank_account->owner."<br>".PHP_EOL;
					$msg.= "</li>".PHP_EOL;
				}
				$msg.= "</ul>".PHP_EOL;
				$msg.= t("Μετά την ολοκλήρωση της πληρωμής, θα πρέπει να μας αποστείλετε το αποδεικτικό της τραπεζικής κατάθεσης με e-mail ή fax").".<br>".PHP_EOL;
				$msg.= t("Αποστολή αποδεικτικού κατάθεσης στο")." <a href='mailto:".$customer_email."'>".$customer_email."</a><br><br>".PHP_EOL;
			}
		}
		if($order->payment_method == "paypal"){	
			if(!$payment_status){
				$msg.= '<br>'.t("Η πληρωμή σας μέσω PayPal απέτυχε").'!<br>'.PHP_EOL;
				$msg.= t("Θα επικοινωνήσουμε μαζί σας για να επιβεβαιώσετε την παραγγελία σας και να ορίσουμε εναλλακτική μέθοδο πληρωμής").'.<br>'.PHP_EOL;
			}		
			if($payment_status == "Completed"){
				$msg.= '<br>'.t("Η πληρωμή μέσω PayPal ήταν επιτυχής").'!<br>'.PHP_EOL;
			}
			if($payment_status == "Pending"){
				$msg.= '<br>'.t("Η πληρωμή σας μέσω PayPal επιβεβαιώθηκε με κατάσταση «Pending»").'.<br>'.PHP_EOL;
				$msg.= t("Αυτή η κατάσταση είναι συνήθως προσωρινή").'.<br>'.PHP_EOL;				
				$msg.= t("Αν δεν μπορέσουμε να επιβεβαιώσουμε αυτή την πληρωμή, θα επικοινωνήσουμε μαζί σας για να επιβεβαιώσετε την παραγγελία σας και να ορίσουμε εναλλακτική μέθοδο πληρωμής").'.<br>'.PHP_EOL;
			}			
		}		
		$msg.= t("Είδος παραστατικού").' : '.$doc_type_name.'<br>'.PHP_EOL;
		$msg.= t("Τρόπος παραλαβής προϊόντων").' : '.$shipping_method.'<br>'.PHP_EOL;
		if($comments) $msg.= "<br>".t("Σχόλια", $defaultLanguageID).' :<br>'.nl2br($comments).'<br>'.PHP_EOL;
		$msg.= '</p>'.PHP_EOL;
		
		$msg.= '<h3>'.t("Προϊόντα").'</h3>'.PHP_EOL;
		$msg.= '<table width="100%">'.PHP_EOL;
		$msg.= '<tr><td><b>'.t("Ονομασία προϊόντος").'</b></td><td><b>'.t("Κωδικός").'</b></td><td><b>'.t("Ποσότητα").'</b></td><td><b>'.t("Τιμή", "product").'</b></td><td><b>'.t("Σύνολο").'</b></td></tr>'.PHP_EOL;
		$total = 0;
		foreach($order->items as $item){
			$price = (float)$item->price;
			$quantity = (int)$item->quantity;
			$subtotal = $price * $quantity;
			$total+= $subtotal;
			$msg.= '<tr>'.PHP_EOL;
			$msg.= '<td>'.$variables->filterQuotes($item->productTitle).'</td><td>'.$item->code.'</td><td>'.$quantity.'</td><td>'.$this->formatPrice($price).'</td><td>'.$this->formatPrice($subtotal).'</td>'.PHP_EOL;
			$msg.= '</tr>'.PHP_EOL;
		}
		if(!$include_vat) $total+= $order->total_vat;
		$total_vat_formated = $this->formatPrice($order->total_vat);
		$include_vat_text = ($include_vat) ? " (".t("συμπεριλαμβάνεται").")" : NULL;
		$msg.= '<tr><td colspan="5">&nbsp;</td></tr>'.PHP_EOL; // empty row
		$msg.= '<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td><b>'.t("Συνολικό ΦΠΑ").$include_vat_text.' : </b>&nbsp;&nbsp;</td><td><b>'.$total_vat_formated.'</b></td></tr>'.PHP_EOL;		
		if($sc){
			$total+= $sc;
			$msg.= '<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td><b>'.t("Έξοδα αποστολής").'</b></td><td>'.$this->formatPrice($sc).'</td></tr>'.PHP_EOL;
		}		
		if(!empty($order->cod) && $order->payment_method == "cod"){
			$total+= $order->cod;
			$msg.= '<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td><b>'.t("Έξοδα αντικαταβολής").'</b></td><td>'.$this->formatPrice($order->cod).'</td></tr>'.PHP_EOL;
		}
		$msg.= '<tr><td colspan="5">&nbsp;</td></tr>'.PHP_EOL; // empty row
		$msg.= '<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td><b>'.t("Συνολικό κόστος").' : </b>&nbsp;&nbsp;</td><td><b>'.$this->formatPrice($total).'</b></td></tr>'.PHP_EOL;
		$msg.= '</table>'.PHP_EOL;
		$msg.= '</body>'.PHP_EOL;		
		$msg.= '</html>'.PHP_EOL;
		
		if(!@mail($customer_email, $subject, $msg, $headers)){
			$_SESSION['order_errors'][] = "Could not send the notification to the customer's e-mail address [".$customer_email."]";
			return false;			
		};
		
		
		// mail to customer (plain text version)
		$mailID = md5(rand());
		$headers = "Reply-To: ".$email_address." <".$email_address.">\n"; 
		$headers.= "Return-Path: ".$email_address." <".$email_address.">\n"; 
		$headers.= "From: ".$email_address." <".$email_address.">\n";
		$headers.= "Organization: Odyshop e-Sales\n"; 
		$headers.= "Message-ID: <".$mailID."@".$_SERVER['SERVER_NAME'].">\n";
		$headers.= "MIME-Version: 1.0\n";
		$headers.= "Content-Type: text; charset=utf-8\n";		
		
		$subject="Your Order from : ".$domain_name." | Order ID #".$orderID." | Plain text version";
		$msg = '';
		$msg.= t("Κωδικός παραγγελίας").' #'.$orderID.PHP_EOL;
		$msg.= t("Ημερομηνία παραγγελίας").' : '.date('d-m-Y', $order->order_date).PHP_EOL;
		$msg.= PHP_EOL.t("Τα στοιχεία σας").PHP_EOL.PHP_EOL;
		$billing_details = str_replace("<br>", PHP_EOL, $order->billing_details);
		$msg.= strip_tags($billing_details).PHP_EOL.PHP_EOL;
		$msg.= PHP_EOL.t("Διεύθυνση αποστολής").PHP_EOL.PHP_EOL;
		$shipping_details = str_replace("<br>", PHP_EOL, str_replace("[Στοιχεία τιμολόγησης]", t("Στοιχεία τιμολόγησης"), $order->billing_details));
		$msg.= strip_tags($shipping_details).PHP_EOL.PHP_EOL;
		$msg.= PHP_EOL.t("Στοιχεία παραγγελίας").PHP_EOL.PHP_EOL;
		$paymentMethodDescription = $this->getPaymentMethodProperty("description", $order->payment_method, $langID);
		if($order->payment_method == "cod" || $order->payment_method == "upon_request"){
			$msg.= strip_tags($content->richText($paymentMethodDescription)).PHP_EOL.PHP_EOL;
		}
		if($order->payment_method == "bank_deposit"){
			$bank_accounts = $content->getContent("bank_accounts", NULL, "*", "*", $langID);					
			if(!count($bank_accounts)){
				$msg.= t("Δεν βρέθηκαν καταχωρημένοι τραπεζικοί λογαριασμοί").PHP_EOL;
				$msg.= t("Παρακαλούμε επικοινωνήστε μαζί μας ώστε να αναφέρετε αυτό το σφάλμα").PHP_EOL.PHP_EOL;				
			}else{
				$msg.= t("Για να ολοκληρώσετε την αγορά σας, παρακαλούμε καταθέστε το συνολικό ποσό της παραγγελίας").PHP_EOL;	
				if(count($bank_accounts) > 1)	{
					$msg.= t("σε κάποιο από τους ακόλουθους τραπεζικούς λογαριασμούς").": ".PHP_EOL;
				}else{
					$msg.= t("στον ακόλουθο τραπεζικό λογαριασμό").": ".PHP_EOL.PHP_EOL;
				}
				foreach($bank_accounts as $bank_account){
					$msg.= $bank_account->title.PHP_EOL;
					$msg.= "IBAN : ".$bank_account->iban.PHP_EOL;
					$msg.= t("Δικαιούχος")." : ".$bank_account->owner.PHP_EOL.PHP_EOL;
				}
				$msg.= t("Μετά την ολοκλήρωση της πληρωμής, θα πρέπει να μας αποστείλετε το αποδεικτικό της τραπεζικής κατάθεσης με e-mail ή fax").".".PHP_EOL;
				$msg.= t("Αποστολή αποδεικτικού κατάθεσης στο")." ".$customer_email.PHP_EOL.PHP_EOL;
			}
		}
		if($order->payment_method == "paypal"){	
			if(!$payment_status){
				$msg.= PHP_EOL.t("Η πληρωμή σας μέσω PayPal απέτυχε").'!'.PHP_EOL;
				$msg.= t("Θα επικοινωνήσουμε μαζί σας για να επιβεβαιώσετε την παραγγελία σας και να ορίσουμε εναλλακτική μέθοδο πληρωμής").'.'.PHP_EOL;
			}		
			if($payment_status == "Completed"){
				$msg.= PHP_EOL.t("Η πληρωμή μέσω PayPal ήταν επιτυχής").'!'.PHP_EOL;
			}
			if($payment_status == "Pending"){
				$msg.= PHP_EOL.t("Η πληρωμή σας μέσω PayPal επιβεβαιώθηκε με κατάσταση «Pending»").'.'.PHP_EOL;
				$msg.= t("Αυτή η κατάσταση είναι συνήθως προσωρινή").'.'.PHP_EOL;				
				$msg.= t("Αν δεν μπορέσουμε να επιβεβαιώσουμε αυτή την πληρωμή, θα επικοινωνήσουμε μαζί σας για να επιβεβαιώσετε την παραγγελία σας και να ορίσουμε εναλλακτική μέθοδο πληρωμής").'.'.PHP_EOL;
			}			
		}
		$msg.= t("Είδος παραστατικού").' : '.$doc_type_name.PHP_EOL;
		$msg.= t("Τρόπος παραλαβής προϊόντων").' : '.$shipping_method.PHP_EOL;
		if($comments) $msg.= PHP_EOL.t("Σχόλια", $defaultLanguageID).' :'.PHP_EOL.$comments.PHP_EOL.PHP_EOL;
		
		$msg.= PHP_EOL.t("Προϊόντα").PHP_EOL.PHP_EOL;
		$total = 0;
		foreach($order->items as $item){
			$price = (float)$item->price;
			$quantity = (int)$item->quantity;
			$subtotal = $price * $quantity;
			$total+= $subtotal;
			$msg.= $variables->filterQuotes($item->productTitle).PHP_EOL;
			$msg.= t("Κωδικός").": ".$item->code.PHP_EOL;
			$msg.= t("Ποσότητα").": ".$quantity.PHP_EOL;
			$msg.= t("Τιμή", $langID, "product").": ".strip_tags($this->formatPrice($price)).PHP_EOL;
			$msg.= t("Σύνολο").": ".strip_tags($this->formatPrice($subtotal)).PHP_EOL.PHP_EOL;
		}
		if(!$include_vat) $total+= $order->total_vat;
		$total_vat_formated = strip_tags($this->formatPrice($order->total_vat));
		$include_vat_text = ($include_vat) ? " (".t("συμπεριλαμβάνεται").")" : NULL;
		$msg.= PHP_EOL.PHP_EOL;
		$msg.= t("Συνολικό ΦΠΑ").$include_vat_text.' : '.$total_vat_formated.PHP_EOL;		
		if($sc){
			$total+= $sc;
			$msg.= t("Έξοδα αποστολής").' : '.strip_tags($this->formatPrice($sc)).PHP_EOL;
		}		
		if(!empty($order->cod) && $order->payment_method == "cod"){
			$total+= $order->cod;
			$msg.= t("Έξοδα αντικαταβολής").' : '.strip_tags($this->formatPrice($order->cod)).PHP_EOL;
		}
		$msg.= PHP_EOL.PHP_EOL;
		$msg.= t("Συνολικό κόστος").' : '.strip_tags($this->formatPrice($total)).PHP_EOL;
		
		@mail($customer_email, $subject, $msg, $headers); // don't check for success, the html version has been sent successfully
		
		return true;
	}
	
	function getPaymentMethodProperty($property, $system_name, $langID){
		global $variables;
		$methods = $this->getPaymentMethods();
		$property = ($property == "title") ?  "paymentMethodTitle" : $property;
		$property = ($property == "description") ?  "paymentMethodDescription" : $property;
		foreach($methods as $method){
			if($method->paymentMethodSystemName == $system_name){
				$value = $variables->restoreModuleValue($method->{$property});
			}
		}
		return $value;				
	}	
	
	function getPaymentMethods(){
		global $document;
		global $db;
		global $variables;
		$slotID = $document->getSlotID("payments");
		$q = "select `params` from modules where slotID='$slotID' order by sort";
		$modules = $db->getRecords($q);
		$payment_methods = array();
		foreach($modules as $module){
			$params = explode(PHP_EOL, $module->params);
			$payment_method = new stdClass();
			foreach($params as $param){
				list($key, $value) = explode("=", $param);
				if($key == "paymentMethodSystemName" 
				|| $key == "paymentMethodTitle" 
				|| $key == "paymentMethodDescription" 
				|| $key == "paypalEmail" 
				|| $key == "onlinePayment"){
					$value = str_replace("__EMPTY__", NULL,$value );
					if($key == "paymentMethodDescription"){
						$payment_method->$key = htmlspecialchars_decode($variables->restoreModuleValue($value));
					}else{
						$payment_method->$key = $value;
					}
					// legacy
					if($key == "paymentMethodSystemName") $payment_method->system_name = $value;
					if($key == "paymentMethodTitle") $payment_method->title = t($value);
					if($key == "paymentMethodDescription") $payment_method->description = htmlspecialchars_decode($variables->restoreModuleValue($value));
					
				}
			}
			$payment_methods[] = $payment_method;
		}
		return $payment_methods;
	}
	
	function getPaymentMethodsByType($type = "online"){
		$methods = $this->getPaymentMethods();
		$payment_methods = array();
		$online_payment = ($type == "online");
		foreach($methods as $method){
			if($method->onlinePayment) $payment_methods[] = $method->paymentMethodSystemName;
		}
		return $payment_methods;
	}
	
	function deleteLastOrder(){
		global $db;
		foreach($_SESSION['orders_ids'] as $id){
			$db->query("delete from `orders` where id='$id'");
		}
		foreach($_SESSION['content_orders_ids'] as $id){
			$db->query("delete from `content_orders` where id='$id'");
		}
		foreach($_SESSION['order_products_ids'] as $id){
			$db->query("delete from `order_products` where id='$id'");
		}
		foreach($_SESSION['content_order_products_ids'] as $id){
			$db->query("delete from `content_order_products` where id='$id'");
		}
		// reset session arrays
		$_SESSION['orders_ids'] = array();
		$_SESSION['content_orders_ids'] = array();
		$_SESSION['order_products_ids'] = array();
		$_SESSION['content_order_products_ids'] = array();		
	}
	
	function createPaypalToken($order){
		global $variables;
		if(!$order) die("Fatal Error: No order object found for paypal token creation");
		$order = base64_encode(serialize($order));
		global $db;
		$d = date("d-m-Y");
		$token = md5(rand());
		// first try to cleanup
		$db->query("delete from `paypal_tokens` where order_date <> '$d'");
		// add the token to database
		$q = "insert into `paypal_tokens` (`token`, `order_date`, `order`) values('$token', '$d', '$order')";
		if($db->query($q)){
			return $token; // success, so return the token value
		}else{
			return false;
		}
	}
	
	function getOrderByPaypalToken($token){
		global $db;
		$q = "select `order` as o from `paypal_tokens` where token='".$token."'";
		$res = $db->getRecord($q);
		$order = $res->o;
		if($order){
			$order = unserialize(base64_decode($order));
			return $order;
		}else{
			return false;
		}
	}	
	
	/*********************************** Legacy **********************************************/	
	
	function getProductsListingTitle(){
		echo view("products/getListingTitle");
	}
	
	function displayFilters($catID){
		echo view("products/getFilters", $catID);
	}
	
	function productsPagination($hasDetails){
		$hasDetails = ($hasDetails != "bottom");
		echo view("utilities/getPagination", $hasDetails);
	}
	
	function sortingBar(){
		echo view("products/getSortingBar");
	}
	
	function getListingProductData($product){
		$data = view("products/getData", $product);
		return $data;
	}
	
	function displayOrderErrors(){
		echo view("orders/getErrors");
	}
	
	/*********************************** Legacy **********************************************/	
	


} // end class
?>