<?php 
defined('CMS') or die("This file cannot run this way!");
class fileSystem{
	var $path = null;
	var $ext = null;
	
	
	function __construct(){
		global $domainPath;
		$this->path = $domainPath.getFPath()."/mediabank/";		
	}
	
   
	function getExtensionByFileName($fileName){
         $i = strrpos($fileName,".");
         if (!$i) return "";
         $l = strlen($fileName) - $i;
         $this->ext = substr($fileName,$i+1,$l);
         return strtolower($this->ext);
   }
   
   
	function getExtensionByFileTypeID($fileTypeID){
		global $db;
		$row = $db->getRecord("SELECT extension FROM filetypes WHERE id='$fileTypeID' ");
		return $row->extension;
   }   
   
	function isValidExtension($ext){
		if(!$ext) return false;
		global $db;
		$q = "SELECT id FROM filetypes WHERE extension='$ext' ";
		$numRows = $db->getNumRows($q);
		if ($numRows){
			$row = $db->getRecord($q);
			return $row->id;
		}else{
			return false;
		}
   }
   
   
   function isImageExtension($ext){
	   $ext = strtolower($ext);
	   return ($ext == "jpg" || $ext == "jpeg" || $ext == "gif" || $ext == "png");
   }
   
   function getMediabankTitle($mediabankID){
	  global $db;
	  $row = $db->getRecord("select title from mediabank where id='$mediabankID' "); 
	  $title = $row->title;
	  return $title;
   }
   
   function getFileTypeIDByExtension($extension){
	global $db;
	$row = $db->getRecord("select id from filetypes where extension='$extension' ");
	$fileTypeID = $row->id;
	return ($fileTypeID) ? $fileTypeID : false;
   } 
   
   
   function getFileTypeID($mediabankID){
	global $db;
	$row = $db->getRecord("select filetypeID from mediabank where id='$mediabankID' ");
	$fileTypeID = $row->filetypeID;
	return ($fileTypeID) ? $fileTypeID : false;
   }
   
   function getImageID($mediaBankID){
	$pieces = explode(".", $mediaBankID); // drop extension if any exists
	$bankID = $pieces[0];
	global $db;
	$row = $db->getRecord("select id from images where bankID='$bankID' ");
	$id = $row->id;
	return ($id) ? $id : false;
	   
   }
 
	function getBankID($imgID){
		$imgID = (int)$imgID;
		global $db;
		$q = "select bankID from images where id=".$imgID;
		$row = $db->getRecord($q);
		$bankID = $row->bankID;		
		return ($bankID) ? $bankID : false;		
	}  
   
	function isImage($mediaBankID){
		global $db;
		$q = "SELECT filetypes.extension FROM filetypes, mediabank 
						   WHERE mediabank.id='$mediaBankID' and mediabank.filetypeID=filetypes.id";
		$row = $db->getRecord($q);
		$ext = strtolower($row->extension);
		return ($ext == "jpg" || $ext == "jpeg" || $ext == "png" || $ext == "gif");
	}
   
   
   function delete($filename){
	   if(is_file($filename)){
			//chmod($filename, 0777);
			if(unlink($filename)){
				return true;
			}else{
				return false;
			}
		}else{
			return false;
		}
   }
   
   
	function getFileTitle($type, $attachmentID, $linkID, $bankID, $langID){
		global $language;
		$langID = ($langID != null) ? $langID : $language->getCurrentLanguage();		
		global $db;
		if($type=="images"){
			$q = "select content_images.title 
							  from images, content_images 
							  where images.bankID='$bankID' 
							  and images.id='$attachmentID' 
							  and images.linkID='$linkID' 
							  and content_images.imgID=images.id 
							  and content_images.langID='$langID'";
			$row = $db->getRecord($q);
			return $row->title;
		}else{
			$q = "select content_files.title 
							   from files, content_files 
							   where files.bankID='$bankID' 
							   and files.id='$attachmentID' 
							   and files.linkID='$linkID' 
							   and content_files.fileID=files.id 
							   and content_files.langID='$langID'";
			$row = $db->getRecord($q);
			return $row->title;
		}
	}
   
   
	 function getImageExtensionByName($baseName){
		if(@fopen($baseName.".jpg", "r")){return "jpg";}
		if(@fopen($baseName.".jpeg", "r")){return "jpeg";}
		if(@fopen($baseName.".gif", "r")){return "gif";}
		if(@fopen($baseName.".png", "r")){return "png";}
		return false;
	 }
	 
	 
	 function getFileBaseName($filename){
		$pieces = pathinfo($filename);
		return str_replace(".".$pieces['extension'],"", $pieces['basename']);	 
	}
	
	
	function getFilePath($filename){
		$pieces = pathinfo($filename);
		return $pieces['dirname'];	 
	}
	
	function getCurrentDir($filename){
		$filePath = $this->getFilePath($filename);
		$dirs = explode(DIRECTORY_SEPARATOR, $filePath);
		return array_pop($dirs);
	}
	
	
	function deleteUploadedFiles($fileID, $path){
		$path = ($path) ? $path : "uploads/";
		$fileTypeID = $this->getFileTypeID($fileID);
		$ext = $this->getExtensionByFileTypeID($fileTypeID);
		$fileToDelete1 = $path.$fileID.".".$ext;
		$fileToDelete2 = $path."medium/medium_".$fileID.".".$ext;
		$fileToDelete3 = $path."thumbs/small_".$fileID.".".$ext;
		error_reporting(0);
		$this->delete($fileToDelete1);
		$this->delete($fileToDelete2);
		$this->delete($fileToDelete3);
		error_reporting(E_ERROR | E_PARSE);
	}
	
	function copyToMediabank($sourceFile, $destinationFile){
		$destinationFile = str_replace("admin/", NULL, $destinationFile);
		$destinationFile = str_replace("../../../", NULL, $destinationFile);
		$destinationFile = str_replace("../../", NULL, $destinationFile);
		$destinationFile = str_replace("../", NULL, $destinationFile);
		if(is_dir("mediabank")){
			$destinationFile = "mediabank/".$destinationFile;
		}elseif(is_dir("../mediabank")){
			$destinationFile = "../mediabank/".$destinationFile;	
		}elseif(is_dir("../../mediabank")){
			$destinationFile = "../../mediabank/".$destinationFile;	
		}elseif(is_dir("../../../mediabank")){
			$destinationFile = "../../../mediabank/".$destinationFile;
		}	
		if(copy($sourceFile, $destinationFile)){
		  chmod($destinationFile, 0775);
		  return true;
		}else{
		  return false;
		}
	}
	
	function deleteFromMediabank($filename){
		$filename = str_replace("admin/", NULL, $filename);
		$filename = str_replace("../../../", NULL, $filename);	
		$filename = str_replace("../../", NULL, $filename);
		$filename = str_replace("../", NULL, $filename);
		if(is_dir("mediabank")){
			$filename = "mediabank/".$filename;
		}elseif(is_dir("../mediabank")){
			$filename = "../mediabank/".$filename;	
		}elseif(is_dir("../../mediabank")){
			$filename = "../../mediabank/".$filename;	
		}elseif(is_dir("../../../mediabank")){
			$filename = "../../../mediabank/".$filename;
		}		
		return unlink($filename);
	}
	
	function unzip($file, $admin=false){
		$document = new document(NULL, NULL, true);
		$unziped = array();
		$zip = zip_open($file);
		$path = ($admin) ? "../".$document->unzipPath : $document->unzipPath;
		if(!is_dir($path)) mkdir($path);
		if(is_resource($zip)){
		$DIRECTORY_SEPARATOR = "/";
			while(($zip_entry = zip_read($zip)) !== false){
				if(strpos(zip_entry_name($zip_entry), $DIRECTORY_SEPARATOR) !== false){
					$last = strrpos(zip_entry_name($zip_entry), $DIRECTORY_SEPARATOR);
					$dir = substr(zip_entry_name($zip_entry), 0, $last);
					$file = substr(zip_entry_name($zip_entry), strrpos(zip_entry_name($zip_entry), $DIRECTORY_SEPARATOR)+1);
					if(!is_dir($path.$dir)){
						if(!@mkdir($path.$dir, 0777, true)) return false;
					}
					if(strlen(trim($file)) > 0){
						$return = @file_put_contents($path.zip_entry_name($zip_entry), zip_entry_read($zip_entry, zip_entry_filesize($zip_entry))) or die("Unable to uncompress contents of zip file (relative paths mode)");
						if($return === false) return false;
						$unziped[] = zip_entry_name($zip_entry);
					}
				}else{
					file_put_contents($path.zip_entry_name($zip_entry), zip_entry_read($zip_entry, zip_entry_filesize($zip_entry))) or die("Unable to uncompress contents of zip file (root path mode)");
					$unziped[] = zip_entry_name($zip_entry);
				}
			}
		}
		return (count($unziped)) ? $unziped : false;
	}
	
	function create_zip($files = array(), $destination = '', $path = true, $overwrite = false){
		if(file_exists($destination) && !$overwrite) return false;
		$valid_files = array();
		if(is_array($files)) {
			foreach($files as $file) {
				if(file_exists($file)) {
					$valid_files[] = $file;
				}
			}
		}
		if(count($valid_files)) {
			$zip = new ZipArchive();
			if($zip->open($destination, $overwrite ? ZIPARCHIVE::OVERWRITE : ZIPARCHIVE::CREATE) !== true) {
				return false;
			}
			foreach($valid_files as $file) {
				$new_filename = (!$path) ? substr($file, strrpos($file, '/') + 1) : $file; // strip path or keep it
				$zip->addFile($file, $new_filename);
			}
			$zip->close();
			return file_exists($destination);
		}else{
			return false;
		}
	}	 
	
	function isEmptyDir($dir){
		if(!preg_match('/\/$/', $dir)) $dir.="/";		
		if(!is_dir($dir)) return false;
		return (count(glob($dir."*")) === 0 );
	}
	
	function removeDirectory($directory){
		if(substr($directory,-1) == '/'){
			$directory = substr($directory,0,-1);
		}
		if(!file_exists($directory) || !is_dir($directory)){
			return FALSE;
		}elseif(!is_readable($directory)){
			return FALSE;
		}else{
			$handle = opendir($directory);
			while (FALSE !== ($item = readdir($handle))){
				if($item != '.' && $item != '..'){
					$path = $directory.'/'.$item;
					chmod($path, 0777);
					if(is_dir($path)){
						$this->removeDirectory($path);
					}else{
						unlink($path);
					}
				}
			}
			closedir($handle);
			chmod($directory, 0777);
			rmdir($directory);
			return TRUE;
		}
	}
	
	function moveDirectory($src,$dst){ 
		$dir = opendir($src); 
		@mkdir($dst); 
		while(false !== ($file = readdir($dir))){ 
			if(($file != '.') && ($file != '..')) { 
				if(is_dir($src . '/' . $file)){ 
					$this->moveDirectory($src . '/' . $file,$dst . '/' . $file); 
				}else{ 
					$source = $src . '/' . $file;
					$destination = $dst . '/' . $file;
					copy($source, $destination); 
				} 
			} 
		} 
		closedir($dir); 
	} 
	
} // end class
?>