<?php 
defined('CMS') or die("This file cannot run this way!");
class pagination{
	
	public $presults;
	public $numRows;
	public $hasDetails;
	public $detailsPrinted;
	public $presultsSelectionDisplayed;	
	public $qstring;
	public $page;
	public $lastPage;
	public $offset;
	public $leftOffset;
	public $rightOffset;
   
	function __construct($numRows, $hasDetails, $presults=NULL){
		$parameters = new parameters();
		global $system;
		global $section;
		$presults = ($_GET['presults']) ? $_GET['presults'] : $presults;
		$this->presults = ($presults) ? (int)$presults : (int)$system->getPresults($section);
		$this->prange = $parameters->getParameter('prange');
		$this->hasDetails = $hasDetails;
		$this->qstring = $this->buildQueryString($qstring);
		$this->numRows = $numRows;
		$this->page = ($_GET['ppage']) ? (int)$_GET['ppage'] : 1;
		$this->lastPage = ceil($this->numRows / $this->presults);
		$this->page = ($this->page > $this->lastPage) ? $this->lastPage : $this->page;
		$this->offset = $this->prange;
		$this->leftOffset = (($this->page - $this->offset) > 0) ? $this->offset : $this->page - 1;
		$this->rightOffset = (($this->page + $this->offset) < $this->lastPage ) ? $this->offset : $this->lastPage - $this->page;
		$this->presultsSelectionDisplayed = false;
	}
	
	
	function printDetails(){
		global $language;
		if(!$this->hasDetails) return false; // print nothing!
			$rWord = ($this->numRows > 1) ? $this->numRows.' '.t('καταχωρημένες εγγραφές') : $this->numRows.' '.t('καταχωρημένη εγγραφή');
			echo "<div class='pages'><div>".$rWord."</div> <div>(".t('σελίδα')." ".$this->page." ".t('από')." ".$this->lastPage.")</div></div><!-- div.pages -->" ;
	}
		
	
	function printPages(){
		global $document;		
		if($this->numRows <= $this->presults){
			if($this->hasDetails){
				$this->printDetails();
				$this->detailsPrinted = true;
				$this->presultsSelection();
			}
			return false; // no need for pagination
		}
		global $section;
		global $view;
		global $language;
		global $db;
		global $sef;
		if(!is_object($sef)) $sef = new sef();
		global $id;
		echo PHP_EOL."<div class='pagination_wrapper'>";
		if(!$this->detailsPrinted){
			$this->printDetails();
			$this->detailsPrinted = true;
			if($this->numRows <= $this->presults){
				 if(!$this->presultsSelectionDisplayed){
					 $this->presultsSelection();
					 $this->presultsSelectionDisplayed = true;
				 }
				 echo "</div>";
				 return; // no need for pagination
			}			
		}
	
		echo("<div class='pagination clearfix'>
		<ol>");
		if($this->page > 1) {
			if($this->page > 2) {
				$url = basename($_SERVER['SCRIPT_NAME'])."?".$this->qstring;
				echo "<li class='pagination_start'>
				<a data-params='".$this->qstring."' href='".$sef->url($url, false)."' title='".t('πρώτη σελίδα')."' class='ir'>".t('πρώτη σελίδα')."</a>
				</li>";
			}
			$p = $this->page-1;
			$url = basename($_SERVER['SCRIPT_NAME'])."?ppage=".$p.$this->qstring;
			echo "<li class='pagination_previous' rel='previous'>
			<a data-params='&ppage=".$p.$this->qstring."' href='".$sef->url($url, false)."' title='".t('προηγούμενη σελίδα')."' class='ir'>".t('προηγούμενη σελίδα')."</a>
			</li>";
		}
		for($n = $this->page - $this->leftOffset; $n < $this->page; $n++){
			$url = basename($_SERVER['SCRIPT_NAME'])."?ppage=".$n.$this->qstring;	
			echo "<li><a data-params='&ppage=".$n.$this->qstring."' class='numbers' title='".t("μετάβαση στη σελίδα")." ".$n."' href='".$sef->url($url, false)."'>".$n."</a></li>";
		}
		echo "<li class='current'>".$this->page."</li>";
		$p = $this->page+1;
		for($n = $p; $n <= $this->page + $this->rightOffset; $n++){
			$url = basename($_SERVER['SCRIPT_NAME'])."?ppage=".$n.$this->qstring;
			echo "<li><a data-params='&ppage=".$n.$this->qstring."' class='numbers' title='".t("μετάβαση στη σελίδα")." ".$n."' href='".$sef->url($url, false)."'>".$n."</a></li>";
		}
		if($this->page < $this->lastPage) {
			$url = basename($_SERVER['SCRIPT_NAME'])."?ppage=".$p.$this->qstring;
			echo "<li class='pagination_next' rel='next'>
			<a data-params='&ppage=".$p.$this->qstring."' href='".$sef->url($url, false)."' title='".t('επόμενη σελίδα')."' class='ir'>".t('επόμενη σελίδα')."</a>
			</li>";
			if($this->page < $this->lastPage-1){
				$url = basename($_SERVER['SCRIPT_NAME'])."?ppage=".$this->lastPage.$this->qstring;
				echo "<li class='pagination_end'>
				<a data-params='&ppage=".$this->lastPage.$this->qstring."' href='".$sef->url($url, false)."' title='".t('τελευταία σελίδα')."' class='ir'>".t('τελευταία σελίδα')."</a>
				</li>";
			}
		}
		echo("</ol>
		</div><!-- div.pagination -->");
		 if(!$this->presultsSelectionDisplayed){
			 $this->presultsSelection();
			 $this->presultsSelectionDisplayed = true;
		 }			
		echo("</div>");
		return true;
	}
	
	private function presultsSelection(){
		if(!$this->hasDetails) return;
		global $section;
		global $view;
		global $language;
		global $db;
		global $sef;
		if(!is_object($sef)) $sef = new sef();
		global $id;
		global $parameters;
		global $langID;
		if(empty($langID)) $langID = $language->getDefaultLanguage();		
		$bordered = ($this->numRows >= $this->presults) ? "bordered" : "";
		$pr = ($_GET['presults']) ? $_GET['presults'] : $this->presults;
		$qs = str_replace("&amp;presults=".$pr, NULL, $this->qstring);
		$sefEnabled = $parameters->getParameter("sef");
		$params = ($sefEnabled) ? 'section='.$section.'&view='.$view.'&id='.$id.'&langID='.$langID.'&' : NULL;
		echo('
		<script>
		function getSEFURL(elm){
			var url = "index.php?'.$params.'presults=" + $(\'#presults\').val() + "'.$qs.'";
			jQuery.ajax({
				type: "POST",
				url: "getSefURL.php",
				data: "url=" + encodeURIComponent(url),
				async: false,
				success: function(sefURL){
					//console.log(sefURL);
					document.location.href = sefURL;
				}
			});
		}
		</script>
		<div class="presults_numbers '.$bordered.'" >
		'.t('εμφάνιση').' 
		<select id="presults" name="presults" onchange="getSEFURL(this)">');
		$numbers = $db->getRecords("select presults_numbers.id, content_presults_numbers.title 
							from presults_numbers, content_presults_numbers 
							where content_presults_numbers.mainID=presults_numbers.id 
							and content_presults_numbers.langID='1' order by CAST(content_presults_numbers.title AS UNSIGNED)");
		foreach($numbers as $numbersRow){
			$n = (int)$numbersRow->title;
			$selected = ($this->presults == $n) ? " selected" : "";
			echo('<option value="'.$n.'" '.$selected.'>'.$n.'</option>');
		}
		echo('</select> '.t('εγγραφών ανά σελίδα').'
		</div>
		');
		
	}
	
	private function buildQueryString($qstring){
		global $safeRequest;
		$pSafeRequest = (array)$safeRequest;
		$get= array_keys($_GET);
		$qs="&amp;";
		for($i=0; $i < sizeof($get); $i++){
			if($get[$i]){
				$get[$i] = trim($get[$i]);
				$value = NULL;
				if(array_key_exists($get[$i], $pSafeRequest) && $get[$i] != "ppage"){
					$value = $pSafeRequest[$get[$i]];
				}
				if(!$value && $get[$i] != "ppage"){
					// try if a global var exists
					global ${$get[$i]};
					$value = ${$get[$i]};
				}
				if($value) $qs.=$get[$i]."=".$value."&amp;";
			}
		}
		if(!preg_match('/presults=/', $qs))	$qs.="presults=".$this->presults."&amp;";
		return rtrim($qs, "&amp;");
	}
		


}// end class

?>