<?php

// this is a payment method file that will be included in library/views/orders.php
// Method is paypal

global $langID;
global $document;
global $content;
global $eshop;
global $variables;
global $paypalURL;
global $paypal_email;
global $domain_name;	
$basketItems = $_SESSION['order']->basketItems;
$userID = $_SESSION['order']->userID;
$shippingCost = $document->shippingCost;
?>
<div class="order_msg">
	<b><?php echo t("Επιλέξατε να πληρώσετε την αξία της παραγγελίας μέσω PayPal");?></b>
	<br><br>
<?php 
if(!$paypalURL || !$paypal_email){
	$_SESSION['order_errors'][] = t("Δυστυχώς παρουσιάστηκε κάποιο πρόβλημα με τις σχετικές ρυθμίσεις και προσωρινά δεν είναι δυνατή η πληρωμή με αυτή τη μέθοδο");
	echo view("orders/getErrors");
}else{
	$custom_paypal_button_image = $document->getTemplatePath()."images/paypal_button.gif";
	$paypal_button_image = (is_file($custom_paypal_button_image)) ? $custom_paypal_button_image : "images/paypal_button.gif";
	echo t("Κάντε κλικ στο ακόλουθο κουμπί πληρωμής, για να μεταφερθείτε στο ασφαλές περιβάλλον του PayPal και να ολοκληρώσετε την πληρωμή σας");
	$currencyCode = $eshop->getCurrencyProperty("code");
	$currencyCode = ($currencyCode) ? $currencyCode : "EUR"; // default currency code
	$paypal_token = $eshop->createPaypalToken($_SESSION['order']);
	$saved_order = $eshop->getOrderByPaypalToken($paypal_token); // verify saved order object
	if(!$paypal_token || empty($saved_order)){
		$_SESSION['order_errors'][] = "System error: Problem creating paypal token or retrieving saved order object";
		echo view("orders/getErrors");
	}else{
?>
	<form action="<?php echo $paypalURL;?>" method="post" charset="UTF-8" class="paypal_form">
		<input name="cmd" type="hidden" value="_cart">
		<input name="upload" type="hidden" value="1">
		<input name="business" type="hidden" value="<?php echo $paypal_email;?>">
		<input name="currency_code" type="hidden" value="<?php echo $currencyCode;?>">
		<?php
		$counter = 0;
		foreach($basketItems as $basketItem){
			if($userID){ // registered client
				$productID = $basketItem->productID;
				$combination = $basketItem->combination;
				$quantity = $basketItem->quantity;			
			}else{ // session basket
				list($uid, $productID, $quantity, $combination) = explode("~|~", $basketItem);
			}
			$product = $content->getContentByID("products", $productID, array('id', 'price', 'vat'), array('title'), $langID);
			$productTitle = $product->title;
			$combinationTitle = $eshop->getCombinationAsString($productID, $combination, $langID);
			if($combinationTitle) $productTitle.= " | ".$combinationTitle;				
			$vat = ($product->vat) ? $content->getValue("fpa_cat", $product->vat, "percent", $langID) : 0;
			$price = $eshop->getProductPrice($productID, $combination, $quantity);
			if($include_vat) $price = $eshop->includeVat($price, $vat);
			if($productTitle && $price && $quantity){
				$counter++;
				$productTitle = $variables->filterQuotes($productTitle);
			?>
		<input name="item_name_<?php echo $counter;?>" type="hidden" value="<?php echo $productTitle;?>">
		<input name="amount_<?php echo $counter;?>" type="hidden" value="<?php echo $variables->makePrice($price);?>">
		<input name="quantity_<?php echo $counter;?>" type="hidden" value="<?php echo $quantity;?>">
		<?php
			}
		}
		if($counter){
			if(!empty($shippingCost)){
		?>	
		<input type=hidden name="handling_cart" value="<?php echo $variables->makePrice($shippingCost);?>">
			<?php
			}
			?>
		<input name="custom" type="hidden" value="<?php echo $paypal_token."|".$userID;?>">				
		<input name="notify_url" type="hidden" value="http://www.<?php echo $domain_name;?>/index.php?section=users&view=ipn&langID=<?php echo $langID;?>">
		<input name="return" type="hidden" value="http://www.<?php echo $domain_name;?>/index.php?section=users&view=paypalOK&langID=<?php echo $langID;?>&userID=<?php echo $userID;?>">
		<input name="cancel_return" type="hidden" value="http://www.<?php echo $domain_name;?>/index.php?section=users&view=paypalERROR&langID=<?php echo $langID;?>">
		<input name="image_url" type="hidden" value="http://www.<?php echo $domain_name."/".$document->getTemplatePath();?>images/logo-for-paypal.png">
		<input name="submit" type="image" src="http://<?php echo $domain_name."/".$paypal_button_image;?>" alt="Pay with PayPal">
	</form>	
		<?php
		}else{
			$_SESSION['order_errors'][] = "Cannot render PayPal form. No valid item found in shopping cart";
			echo view("orders/getErrors");				
		}
	}
}
?>
</div>			
