<?php 
defined('CMS') or die("This file cannot run this way!");
class sef{
	
	private $sefVars = array("id", "catID", "month", "year", "page");
	
	function isAliasExists($alias, $id, $sectionID){
		global $langID;
		global $db;
		$q = "select aliases.id from aliases, content_aliases 
		where aliases.itemID <> '$id' 
		and content_aliases.mainID=aliases.id 
		and content_aliases.title='$alias' 
		and content_aliases.langID='$langID' 
		and aliases.sectionID='$sectionID'";
		$numRows = $db->getNumRows($q);
		return ($numRows) ? true : false;
	}	
	
	function isCategoryAliasExists($section){
		global $db;
		$dbName = $db->getdbName();
		$tableName = $this->getCategoriesTableName($section);
		$q = "SELECT TABLE_NAME 	 
		FROM information_schema.COLUMNS 
		WHERE 
		    TABLE_SCHEMA = '$dbName' 
		AND TABLE_NAME = '$tableName' 
		AND COLUMN_NAME = 'alias'";
		$tableName =  $db->getRecord($q)->TABLE_NAME;
		return ($tableName) ? $tableName : false;
	}
			
	
	function getCategoriesTableName($section){
		global $db;
		if(!$section) global $section;
		$dbName = $db->getdbName();
		$tableName = $section."_categories"; // try classic name
		$q = "SELECT table_name
		FROM information_schema.tables
		WHERE table_schema = '$dbName'
		AND table_name = '$tableName'";
		$name = $db->getRecord($q)->table_name;
		if($name) return $name;
		$tableName = $section."categories"; // try without underscore as custom categories table
		$q = "SELECT table_name
		FROM information_schema.tables
		WHERE table_schema = '$dbName'
		AND table_name = '$tableName'";
		$name = $db->getRecord($q)->table_name;
		return ($name) ? $name : false;		
	}
	
	function getActualAlias($alias){
    if(empty($alias)) return NULL;
		global $db;
		global $system;
		global $langID;
		global $section;
		$sectionID = $system->getTableSectionID($section);
		$q = "select aliases.alias as alias 
		from aliases, content_aliases 
		where aliases.id=content_aliases.mainID 
		and content_aliases.title='$alias' 
		and aliases.sectionID='$sectionID'";
		$alias = $db->getRecord($q)->alias;
		return $alias;
	}
	
	function getAliasByRecord($id, $sectionID, $isCategory='0'){
		global $db;
		global $langID;
		$q = "select content_aliases.title as alias from aliases, content_aliases 
		where content_aliases.mainID=aliases.id 
		and aliases.itemID='$id' 
		and content_aliases.langID='$langID' 
		and aliases.isCategory='$isCategory' 
		and aliases.sectionID='$sectionID'";
		$aliases = $db->getRecords($q);
		foreach($aliases as $alias){
			$theAlias = $alias->alias;
		}
		return $theAlias; // return last item
	}
	
	function url($url, $display=true){
		global $db;
		global $system;
		global $language;
		$parameters = new parameters();
		$originalURL = $url;
		$hasQueryString = preg_match('/\?/', $url);
		$querySymbol = ($hasQueryString) ? "&" : "?";
		if(preg_match('/^javascript:/', $url) || preg_match('/(http|https):\/\//', $url) || !$parameters->getParameter("sef")){
			$langID = $language->getCurrentLanguage();
			if(preg_match('/^index.php/', $url) && !preg_match('/langID=/', $url)) $url = $url.$querySymbol."langID=".$langID;
			if($display) {
				 echo $url;
				 return;
			}else{
				return $url;
			}			
		}
		$originalURL = $url;
		$base = getBase();
		$url = str_replace($base, NULL, $url);
		$url = str_replace("&amp;", "&", $url);
		list($script, $qs) = explode("?", $url);
		if(preg_match('/\&/', $qs)){ // query string has more than one vars
			$queryParameters = explode("&", $qs);
		}else{ // single var in query string
			$queryParameters = array(); 
			$queryParameters[] = $qs;
		}
		$completeSEF =count($queryParameters) > 1;
		$qs = "";		
		$foundLanguage = false;
		foreach($queryParameters as $part){
			list($key, $value) = explode("=", $part);
			${$key} = $value;
			if($key == "section"){ 
				$section = $value;
				$sectionKey = $key;
				continue;
			}
			if($key == "view"){ 
				$view = $value;
				continue;
			}			
			if($key == "langID"){ 
				$foundLanguage = true;
			}else{
				if(!in_array($key, $this->sefVars) && $value) $qs.=$key."=".$value."&";
			}
		}
		$langID = (!empty($langID)) ? $langID : $language->getCurrentLanguage();
		if(!$language->isLanguageActive($langID)) $langID = $language->getDefaultLanguage();
		$languageExtension = str_replace("_", null, $language->getLanguageExtension($langID));
		if($sectionKey != "section" || !$completeSEF){
			$url = "index.php?langID=".$langID;
			if($parameters->getParameter("sef")) $url = $languageExtension."/";
			if($display){
				echo $url;
				return;
			}else{
				return $url;
			}
		}
		if(!$parameters->getParameter("sef")){
			if(preg_match('/\?/', $originalURL)) {
				$url = ($foundLanguage) ? $originalURL : $originalURL."&langID=".$langID;
			}else{
				$url = ($foundLanguage) ? $originalURL : $originalURL."?langID=".$langID;
			}
			if($system->getSectionProperty($section, "hasCategory") && $id){ // only for items that belong to categories
				$catID = $db->getRecord("select catID from $section where id='$id'")->catID;
				if($catID) $url.="&catID=".$catID;
			}
			if($display){
				echo $url;
				return;
			}else{
				return $url;
			}			
		}
		$qs = rtrim($qs, "&"); // remove trailing &
		$varsPath = $languageExtension."/".$section."/".$view;
		$url = $varsPath; // set default sefurl
		$sectionID = $system->getTableSectionID($section);
		if($id){ // item
			if($section == "pages") $varsPath = $languageExtension."/pages"; // custom page
			$alias = $this->getAliasByRecord($id, $sectionID, 0);
			$url = $varsPath."/".$alias;
		}
		if(isset($catID) && !$id){ // category
			$catTable = $this->getCategoriesTableName($section);
			$alias = $this->getAliasByRecord($catID, $sectionID, 1);
			$aliasPath = null;
			if(preg_match('/_categories$/', $catTable)){ // system category table, try to identify the category path
				global $categories;
				$path = $categories->getPath($catID, $catTable);
				foreach($path as $node){
					$aliasPath.= $this->getAliasByRecord($node, $sectionID, 1)."/";
				}
				$url = $varsPath."/categories/".$aliasPath.$alias;
			}
			$url = $varsPath."/categories/".$aliasPath.$alias;
		}
		if((int)$month && (int)$year){ // archive
			$url = $varsPath."/archive/".$month."/".$year;
		}
		$url = str_replace("odyssey_index/odyssey_index", null, $url);
		if($qs && $sectionKey == "section") $url.= "?".$qs;
		if(preg_match('/[^\x00-\x80]+/', $url)){
			$url = $originalURL;
			if(!preg_match('/langID=/', $url)){
				if(preg_match('/\?/', $url)) {
					$url.= "&langID=".$langID;
				}else{
					$url.= "?langID=".$langID;
				}
			}
			if($system->getSectionProperty($section, "hasCategory") && $id){ // only for items that belong to categories
				if(!preg_match('/catID=/', $url)){
					$catID = $db->getRecord("select catID from $section where id='$id'")->catID;
					if($catID){
						if(preg_match('/\?/', $url)) {
							$url.= "&catID=".$catID;
						}else{
							$url.= "?catID=".$catID;
						}	
					}
				}
			}
		}
		if($display) {
			 echo $url;
		}else{
			return $url;
		}									
	}
	
	
	
} // end class
?>