<?php 
defined('CMS') or die("This file cannot run this way!");
class service{
	
	private $callback;
		
	function __construct(){
		$numOfArguments = func_num_args();
		if(!$numOfArguments){
			trigger_error("Service called without arguments");
			return false;
		}
		$args = func_get_args();
		$path = array_shift($args);
		list($service_name, $method) = explode("/", $path);
		if(!$service_name || !$method){
			trigger_error("Service or/and method missing in service call");
			return false;			
		}
		$classFile = "library/services/".$service_name."/".$service_name.".php";
		if(!is_file($classFile)){
			trigger_error("Service Class file does not exist");
			return false;			
		}
		require_once($classFile);
		$thisService = $this->createService($service_name);
		$callback = call_user_func_array(array($thisService, $method), $args);
		$this->callback = $callback;
	}
	
	public function getServiceData(){
		return $this->callback;
	}
	
	function createService($class){
		$reflector = new ReflectionClass($class);
		$properties = $reflector->getProperties();
		$defaults = $reflector->getDefaultProperties();
			   
		$serealized = "O:" . strlen($class) . ":\"$class\":".count($properties) .':{';
		foreach ($properties as $property){
			$name = $property->getName();
			if($property->isProtected()){
					$name = chr(0) . '*' .chr(0) .$name;
				} elseif($property->isPrivate()){
					$name = chr(0)  . $class.  chr(0).$name;
				}
				$serealized .= serialize($name);
				if(array_key_exists($property->getName(),$defaults) ){
					$serealized .= serialize($defaults[$property->getName()]);
				} else {
					$serealized .= serialize(null);
				}
			}
		$serealized .="}";
		return unserialize($serealized);
	}


} // end class
?>