<?php 
defined('CMS') or die("This file cannot run this way!");
class view{
	
	private $callback;
		
	function __construct(){
		$numOfArguments = func_num_args();
		if(!$numOfArguments){
			trigger_error("View called without arguments");
			return false;
		}
		$args = func_get_args();
		$path = array_shift($args);
		list($view_name, $method) = explode("/", $path);
		if(!$view_name || !$method){
			trigger_error("Service or/and method missing in view call");
			return false;			
		}
		$classFile = "library/views/".$view_name.".php";
		if(!is_file($classFile)){
			trigger_error("Service Class file does not exist");
			return false;			
		}
		require_once($classFile);
		$thisView = $this->createView($view_name);
		$callback = call_user_func_array(array($thisView, $method), $args);
		$this->callback = $callback;
	}
	
	public function getViewData(){
		return $this->callback;
	}
	
	function createView($class){
		$reflector = new ReflectionClass($class);
		$properties = $reflector->getProperties();
		$defaults = $reflector->getDefaultProperties();
		$serealized = "O:" . strlen($class) . ":\"$class\":".count($properties) .':{';
		foreach ($properties as $property){
			$name = $property->getName();
			if($property->isProtected()){
					$name = chr(0) . '*' .chr(0) .$name;
				} elseif($property->isPrivate()){
					$name = chr(0)  . $class.  chr(0).$name;
				}
				$serealized .= serialize($name);
				if(array_key_exists($property->getName(),$defaults) ){
					$serealized .= serialize($defaults[$property->getName()]);
				} else {
					$serealized .= serialize(null);
				}
			}
		$serealized .="}";
		return unserialize($serealized);
	}


} // end class
?>