<?php

class products extends view{
	
	// Available all properties and methods of service class
	
	function getFilters($catID){
		ob_start();
		global $db;
		global $langID;
		global $eshop;
		global $parameters;	
		global $content;	
		global $categories;
		global $system;
		global $document;
		global $safeRequest;
		// first display keyword search and categories
		$elmID = "filter_search";
		$activeCats = implode(",", $categories->getActiveCategoriesIDs("products_categories"));
		?>
		<a class="filter_group filter_group_opened" href="javascript:void(0)" onclick="toggleFilter(this, '<?php echo $elmID;?>')"><?php echo t("Αναζήτηση");?></a>
		<div class="filter_contents" id="<?php echo $elmID;?>">
			<input id="keyword" type="text" name="keyword" value="<?php echo $safeRequest->keyword;?>" class="listbox search_products" placeholder="<?php echo t("Λέξη ή φράση κλειδί");?>...">
            <select id="catID" name="catID" class="listbox search_product_categories" onchange="submitProductSearch()" data-default="<?php echo $catID;?>">
            <option value=""><?php echo t("Όλες οι κατηγορίες");?></option>
			<?php echo $categories->getCategoriesForSelect(0, 0, false, "products_categories", $catID);?>
            </select> 
			<script>
			/* NAMESPACE for products list ***************************************/
			;PRODUCTS_LIST = {	
				activeCats	: [<?php echo $activeCats;?>],	
				inArray		: function(needle, haystack) {
					var length = haystack.length;
					for(var i = 0; i < length; i++) {
						if(haystack[i] == needle) return true;
					}
					return false;
				}
				
			};				
			/* NAMESPACE for products list ***************************************/
			$(document).ready(function(){
				$('#catID option, #catID optgroup').each(function(){
					if($(this).prop("tagName") == "OPTGROUP"){
						if(!PRODUCTS_LIST.inArray($(this).attr("data-catid"), PRODUCTS_LIST.activeCats)) $(this).hide();
					}
					if($(this).prop("tagName") == "OPTION" && $(this).attr("value")){
						if(!PRODUCTS_LIST.inArray($(this).attr("value"), PRODUCTS_LIST.activeCats)) $(this).hide();
					}					
				});
			});
			</script>
			<input class="rainbow submit_product_search" type="button" onclick="submitProductSearch()" value="<?php echo t("Αναζήτηση");?>">			
		</div>
		<?php
		// add price range slider
		
		$prices = $safeRequest->prices;
		$min_price = $document->min_price;
		$max_price = $document->max_price;
		if(!$prices) $min_price = 0;
		$include_vat = (int)$parameters->getParameter("include_vat");
		$vat = $content->getValue("fpa_cat", $parameters->getParameter("default_vat"), "percent", $langID);
		if(!$max_price){
			$q="select max(price) as max_price from products";
			$record = $db->getRecord($q);
			$max_price = $record->max_price;
		}
		$prices_array = explode("|", $prices);
		$min_value = ($prices_array[0]) ? $prices_array[0] : $min_price;
		$max_value = ($prices_array[1]) ? $prices_array[1] : $max_price;
		if($include_vat){
			$min_price = floor($eshop->includeVat($min_price, $vat));
			$max_price = ceil($eshop->includeVat($max_price, $vat));
			$min_value = floor($eshop->includeVat($min_value, $vat));
			$max_value = ceil($eshop->includeVat($max_value, $vat));			
		}
		
		$show_price_slider = !empty($max_price);
		if($show_price_slider){
			$currency_sign = $eshop->getCurrencyProperty("sign");
			$elmID = "filter_prices";
		?>
		<a class="filter_group filter_group_opened" href="javascript:void(0)" onclick="toggleFilter(this, '<?php echo $elmID;?>')"><?php echo t("Τιμή");?></a>
		<div class="filter_contents" id="<?php echo $elmID;?>" style="padding-bottom: 25px">		
			<p style="padding: 0 10px;">
			<input 
			class="rainbow_color price_range" 
			type="text" 
			id="min_amount" 
			data-default="<?php echo $min_price;?>" 
			onkeypress="return event.charCode >= 48 && event.charCode <= 57" 
			onchange="restrictMinPrice(this, '<?php echo $min_price;?>')">
			   - 
			<input 
			class="rainbow_color price_range" 
			type="text" 
			id="max_amount" 
			data-default="<?php echo $max_price;?>" 
			onkeypress="return event.charCode >= 48 && event.charCode <= 57" 
			onchange="restrictMaxPrice(this, '<?php echo $max_price;?>')">
			<?php echo $currency_sign;?> 
			</p>	
			<div style="padding: 0 10px;">	
				<div id="price_range"></div>
			</div>
			<link href="css/ui/jquery-ui-slider.css" rel="stylesheet" type="text/css">
			<script>
				$(function() {
					$("#price_range").slider({
						range: true,
						min: <?php echo $min_price;?>,
						max: <?php echo $max_price;?>,
						values: [ <?php echo $min_value;?>, <?php echo $max_value;?> ],
						slide: function(event, ui){
							$("#min_amount").val(ui.values[0]);
							$("#max_amount").val(ui.values[1]);
						},
						change: function(event, ui){
							var params = $('#qstring').val() + getFilters();
							updateProducts(params);
						}						
					});
					$("#min_amount").val($("#price_range").slider("values", 0));
					$("#max_amount").val($("#price_range").slider("values", 1));
				});
			</script>
		</div>		
		<?php
		}
		// check for brands
		global $brands;
		global $brandID; // in case of search term
		$brands_array = explode("|", $brands);
		if($brandID){
			$brands_array[] = $brandID;
			$brands_array = array_unique($brands_array);
		}
		$brands_records = $eshop->getBrands($catID);
		
		if(count($brands_records)){
			$elmID = "filter_brands";
			global $auth;
			$userID = $auth->getLoginStatus();		
			?>
			<a class="filter_group filter_group_opened" href="javascript:void(0)" onclick="toggleFilter(this, '<?php echo $elmID;?>')"><?php echo t("Κατασκευαστής", $langID, "filters");?></a>
			<ul class="filter_contents" id="<?php echo $elmID;?>">
			<?php
			$sectionID = $system->getTableSectionID("products");					
			$fieldID = $system->getFieldID("catID", $sectionID);
			$fieldID2 = $system->getFieldID("access_type", $sectionID);			
			foreach($brands_records as $brand){
				$thisBrandID = $brand->id;
				if(empty($catID)){
					$q = "select count(p.id) as numOfProducts from products as p, selectlists as s where p.brandID='$thisBrandID' 
					and (s.sectionID='$sectionID' and s.fieldID='$fieldID2' and s.itemID=p.id and s.optionID='$userID') and p.price > 0";
				}else{
					$q="select count(p.id) as numOfProducts from products as p, selectlists as s  
							where p.brandID='$thisBrandID'  and p.price > 0 
							and (s.sectionID='$sectionID' and s.fieldID='$fieldID' and s.itemID=p.id and s.optionID='$catID') 
							group by p.id 
							having count(p.id) = (select count(id) as sid from selectlists as s where s.sectionID='$sectionID' and s.fieldID='$fieldID2' and s.itemID=p.id and s.optionID='$userID')";
				}
				$numOfProducts = $db->getRecord($q)->numOfProducts;
				if($numOfProducts){
				?>
				<li>
				<input type="checkbox" class="filter_switch" data-type="brand" data-value="<?php echo $thisBrandID;?>"<?php if(in_array($thisBrandID, $brands_array)) echo " checked";?>>
				<span class="rainbow_color"><?php echo $brand->title;?>&nbsp;&nbsp;(<?php echo $numOfProducts;?>)</span>
				</li>
				<?php
				}
			}
			?>
			</ul>
			<?php
		}
		
		// procceed to product variants
		global $variants;
		$IDs = $eshop->getProductIDs($catID);
		if($IDs){
			$variants_array = explode("|", $variants);		
			$q = "select distinct pf.id as featureID, pf.alias as elmID, cpf.title from product_features as pf, content_product_features as cpf, features as f  
					where f.productID IN (".$IDs.") 
					and f.featureID = pf.id 
					and cpf.mainID = pf.id 
					and cpf.langID = '$langID'";		
			$features = $db->getRecords($q);
			foreach($features as $feature){
				$elmID = $feature->elmID;
				?>
				<a id="a<?php echo $elmID;?>" class="filter_group filter_group_opened" href="javascript:void(0)" onclick="toggleFilter(this, '<?php echo $elmID;?>')"><?php echo $feature->title;?></a>
				<ul class="filter_contents" id="<?php echo $elmID;?>">
				<?php				
				$featureID = $feature->featureID;
				$q = "select distinct fv.id as variantID, cfv.title from feature_variants as fv, content_feature_variants as cfv, features as f  
						where f.productID IN (".$IDs.") 
						and f.featureID = fv.featureID 
						and f.featureID = '$featureID' 
						and cfv.mainID = fv.id 
						and cfv.langID = '$langID'";	
				$variants_records = $db->getRecords($q);
				
				foreach($variants_records as $variant){
					$variantID = $variant->variantID;
					$q = "select count(productID) as numOfProducts from features where variantID='$variantID' and productID IN (".$IDs.")";
					$numOfProducts = $db->getRecord($q)->numOfProducts;
					if($numOfProducts){
					?>
					<li>
					<input type="checkbox" class="filter_switch" data-type="variant" data-value="<?php echo $variantID;?>"<?php if(in_array($variantID, $variants_array)) echo " checked";?>>
					<span class="rainbow_color"><?php echo $variant->title;?>&nbsp;&nbsp;(<?php echo $numOfProducts;?>)</span>
					</li>
					<?php
					}
				}			
				?>
				</ul>
				<?php								
			}
		}
		?>
		<div id="reset_filters"><a class="rainbow_color reset_filters" href="javascript: void(0)" onclick="resetProductFilters()"><?php echo t("Επαναφορά φίλτρων");?></a></div>
		<?php
		return ob_get_clean();		
	}
	
	function getSortingBar(){
		global $safeRequest;
		$custom_order = ($safeRequest->custom_order) ? $safeRequest->custom_order : 2; // default alphabetically sorting
		$qs = "&section=products&view=list&custom_order=".$custom_order; 
		if($safeRequest->catID) $qs.= "&catID=".$safeRequest->catID;
		$qs.= "&presults=".$safeRequest->presults."&ppage=".$safeRequest->ppage;
		$html = '<div id="sorting_bar">';
		$html.= '<span>'.t("Ταξινόμηση").' </span>';
		$html.= '<select class="listbox" id="custom_order" data-presults="'.$safeRequest->presults.'" data-page="'.$safeRequest->ppage.'" data-catID="'.$safeRequest->catID.'">';
		$selected = ($custom_order == 1) ? ' selected' : NULL;
		$html.= '<option value="1"'.$selected.'>'.t("νεότερα προϊόντα").'</option>';
		$selected = ($custom_order == 2) ? ' selected' : NULL;
		$html.= '<option value="1"'.$selected.'>'.t("αλφαβητικά").'</option>';
		$selected = ($custom_order == 3) ? ' selected' : NULL;
		$html.= '<option value="1"'.$selected.'>'.t("τιμή (αύξουσα)").'</option>';
		$selected = ($custom_order == 4) ? ' selected' : NULL;
		$html.= '<option value="1"'.$selected.'>'.t("τιμή (φθίνουσα)").'</option>';
		$selected = ($custom_order == 5) ? ' selected' : NULL;
		$html.= '<option value="1"'.$selected.'>'.t("δημοφιλέστερα").'</option>';								
		$html.= '</select>';
		$html.= '<input type="hidden" id="qstring" value="'.$qs.'">';
		$html.= '</div>';
		return $html;		
	}

	function getData($item){
		if(!is_object($item)) return false;
		global $langID;
		global $parameters;
		global $content;
		global $variables;
		global $eshop;
		global $sef;
		if(!is_object($sef)) $sef = new sef();
		$data = new stdClass();
		$include_vat = (int)$parameters->getParameter("include_vat");
		$hasAccess = $eshop->hasAccess($item->id);
		if(!$hasAccess) return false; // don't display it
		$data->hasPriceAccess = $eshop->hasAccess($item->id, "show_price");
		$vat = $content->getValue("fpa_cat", $item->vat, "percent", $langID);
		$data->title = $item->title;
		$data->id = $item->id;
		$IDs = $document->IDs;
		$data->brandID = $item->brandID;
		$data->code = $item->code;
		$data->min_order = $item->min_order;			
		$data->inventory_type = $item->inventory_type;
		if($data->inventory_type == "1"){
			$data->availability = (!empty($item->instock)) ? t("Σε Απόθεμα") : t("Μη Διαθέσιμο");
			if($data->inventory_type == "2" && empty($item->instock)) $data->availability = t("Μη διαθέσιμο σε αυτό τον συνδυασμό");
			$data->availability_class = (!empty($item->instock)) ? " qv_green" : " qv_red";
		}
		$max_chars = $parameters->getParameter("max_chars");
		$data->description = $variables->getMinitext($item->description, $max_chars);
		$data->promo_text = $item->promo_text;	
		$data->min_order = $item->min_order;				
		$defaultImage = $content->getImage("products", $data->id, $langID, 'default');
		if($defaultImage != "."){ // if a default image exists for this record
			$imageFile = "mediabank/medium/medium_".$defaultImage;
		}else{
			$imageFile = $p."images/no_image.png";
		}
		$data->image = $imageFile;	 // default image
		$data->images = $content->getImages("products", $data->id, $langID, array('default', 'logo', 'slider'));
		if(!$data->images) $data->images = array();
		if($defaultImage != ".") array_unshift($data->images, $defaultImage); // prepend default image to the begining of the images array		
		$data->link = $sef->url("index.php?section=products&view=node&id=".$data->id."&set=".$IDs, false);
		$data->quick_view_link = "quick_view.php?id=".$data->id."&set=".$IDs."&langID=".$langID;
		$list_price = (float)$item->list_price;
		$price = (float)$item->price;
		$data->hasPriceAccess = $eshop->hasAccess($data->id, "show_price");
		if(!empty($list_price) && $data->hasPriceAccess){
			$data->save_percent = (int)(100 - (100*($price / $list_price)));
		}
		if($include_vat) $price = $eshop->includeVat($price, $vat);
		if($include_vat) $list_price = $eshop->includeVat($list_price, $vat);
		$data->vat = $vat;
		$data->list_price = $list_price;
		$data->price = $price;		
		$data->formated_list_price = $eshop->formatPrice($data->list_price);
		$data->formated_price = $eshop->formatPrice($data->price);		
		return $data;
	}
	
	function getCategoryData($item){
		if(!is_object($item)) return false;
		global $parameters;
		global $variables;
		global $eshop;
		global $sef;
		if(!is_object($sef)) $sef = new sef();
		$data = new stdClass();
		$data->id= $item->id;
		$data->title = $item->title;
		$mt = $item->minitext;
		$max_chars = $parameters->getParameter('max_chars');
		$limit = $max_chars - mb_strlen($data->title, 'utf-8');
		$limit = ($limit > 0 ) ? $limit : 0;
		$minitext = (mb_strlen($mt, 'utf-8') > $limit) ? $variables->unicode_substr($mt, 0 , $limit)."..." : $mt;
		$data->minitext = ($minitext == "...") ? NULL : $minitext;
		$data->image = $eshop->getCategoryImage($data->id);
		$data->link = $sef->url("index.php?section=products&view=list&catID=".$data->id, false);	
		return $data;		
	}	
	
	function getSetLayout(){
		ob_start();	
		global $langID;
		global $safeRequest;
		global $document;
		global $sef;
		if(!is_object($sef)) $sef = new sef();	
		$set = $safeRequest->set;
		$id = $safeRequest->id;
		$items = explode(",", $set);
		$idx = array_search($id, $items);
		$numOfItems = count($items);
		$prev_class = ($idx > 0) ? "qvpn qv_prev" : "qvpn qv_prev_disabled";
		$next_class = ($idx < ($numOfItems - 1)) ? "qvpn qv_next" : "qvpn qv_next_disabled";		
		$script_name = basename($_SERVER['SCRIPT_NAME'], '.php');
		if($script_name == "index"){ // we need sef urls
			$prev_link = ($idx > 0) ? 
			$sef->url("index.php?section=products&view=node&id=".$items[$idx-1]."&langID=".$langID."&set=".$set, false) 
			: "javascript:void(0)";
			$next_link = ($idx < ($numOfItems - 1)) ? 
			$sef->url("index.php?section=products&view=node&id=".$items[$idx+1]."&langID=".$langID."&set=".$set, false) 
			: "javascript:void(0)";
		}else{ // quick_view or other custom script
			$prev_link = ($idx > 0) ? 
			$script_name.".php?section=products&view=node&id=".$items[$idx-1]."&langID=".$langID."&set=".$set
			: "javascript:void(0)";
			$next_link = ($idx < ($numOfItems - 1)) ? 
			$script_name.".php?section=products&view=node&id=".$items[$idx+1]."&langID=".$langID."&set=".$set 
			: "javascript:void(0)";			
		}
		if($numOfItems > 1){
		?>
		<div id="qv_set">
			<a class="<?php echo $prev_class;?>" href="<?php echo $prev_link;?>"></a>
			<span class="qv_set_text"><?php echo "&nbsp;&nbsp;".($idx+1)."&nbsp;&nbsp;".t("από")."&nbsp;&nbsp;".$numOfItems."&nbsp;&nbsp;";?></span>
			<a class="<?php echo $next_class;?>" href="<?php echo $next_link;?>"></a>
		</div>
		<?php	
		}else{
		?>
		<div style="height: 40px"></div> <!-- use as spacer -->
		<?php			
		}
		return ob_get_clean();		
	}	
		
	function getBasketControls($item){
		if(!is_object($item)) return false;
		ob_start();	
		global $parameters;
		global $content;
		global $eshop;
		global $safeRequest;
		$hasPriceAccess = $eshop->hasAccess($item->id, "show_price");
		$include_vat = $parameters->getParameter("include_vat");
		if($parameters->getParameter("basket_enabled") && $hasPriceAccess && (float)$item->price){
			$quantity = ((int)$item->min_order) ? $item->min_order: 1;
			$vat = $content->getValue("fpa_cat", $item->vat, "percent", $langID);
		?>
            <div class="qv_block" style="margin-top: 15px;">
                <span class="qv_label" style="padding-top: 8px"><?php echo t("Ποσότητα");?>: </span>
                <span class="qv_value">
                	<span class="quantity_controls">
                        <a id="quantity_plus" class="quantity_control qv_plus" href="javascript:increaseQuantity('#quantity')"></a>
                        <input type="text" name="quantity" id="quantity" class="quantity" value="<?php echo $quantity;?>" 
                        onkeypress='return event.charCode >= 48 && event.charCode <= 57' 
                        onkeyup="if($(this).val() == '0') $(this).val('1');" 
						onchange="calculatePrice('<?php echo $item->id;?>')">
                        <a id="quantity_minus" class="quantity_control qv_minus" href="javascript:decreaseQuantity('#quantity', '<?php echo $quantity;?>')"></a>
                    </span>
                </span>
            </div>
            <div class="qv_block" style="margin: 40px 0 10px 0;">
                <span class="qv_value">
            	    <input type="hidden" name="combination" id="combination" value="<?php echo $safeRequest->combination;?>">
                	<input type="button" class="add_to_cart rainbow" value="<?php echo t("ΠΡΟΣΘΗΚΗ ΣΤΟ ΚΑΛΑΘΙ");?>" onclick="javascript:addToBasket()">
                    <a class="add_to_wish_list" href="javascript:addToBasket('wishlist')"><?php echo t("Προσθήκη στη λίστα αγαπημένων");?></a>
                </span>
            </div>            
        <?php
		}else{
			?>
             <div class="qv_block" style="margin: 40px 0 10px 0;">
                <span class="qv_value">
            	    <input type="hidden" name="combination" id="combination" value="<?php echo $safeRequest->combination;?>">
                    <a class="add_to_wish_list" href="javascript:addToBasket('wishlist')"><?php echo t("Προσθήκη στη λίστα αγαπημένων");?></a>
                </span>
            </div>             
            <?php
		}
		?>
			<input type="hidden" name="include_vat" id="include_vat" value="<?php echo $include_vat;?>">
            <input type="hidden" name="vat" id="vat" value="<?php echo $vat;?>">
			<div id="ajax_loading"></div>
		<?php
		return ob_get_clean();		
	}
	
	function getTabs(){
		global $document;
		?>
		<div id="tabs">
			<div class="responsive-tabs">	
			<?php $document->includeModules("tabs"); ?>
			</div>
			<div></div>
			<script type="text/javascript">
			jQuery().ready(function(){
				RESPONSIVEUI.responsiveTabs(); 
				$('.responsive-tabs-wrapper').show();
				$('#tabs').show();
			});
			</script>	
		</div>		
		<?php
	}
	
	function getListingTitle(){
		global $document;
		global $safeRequest;
		global $langID;
		$section = $document->section;
		$sectionID = $document->sectionID;	
		$catID = $safeRequest->catID;	
		if($catID){
			global $categories;
			$title = $categories->getCategoryName($catID, "content_".$section."_categories", $langID); 
		}else{
			global $system;
			$sectionName = t($system->getTableSectionTitle($sectionID));
			$title = (is_numeric($catID) && $catID==0) ? $sectionName.  " - ". t("ΚΑΤΗΓΟΡΙΕΣ") : $sectionName;
		}
		return $title;
	}	
	


} // end class
?>