<?php
//define this module's name and path
$mn = "odyshop_homepage_products";
include("modules/modules.php");

/*
Available variables:
All system classes
All request variables
$p (the template path)
$mp (the module path)
$sufixID (id sufix for this module's divs)
*/

$marginTop = ($moduleParameters['marginTop'] == "__EMPTY__" || empty($moduleParameters['marginTop'])) ? 0 : $moduleParameters['marginTop'];
$marginRight = ($moduleParameters['marginRight'] == "__EMPTY__" || empty($moduleParameters['marginRight'])) ? 0 : $moduleParameters['marginRight'];
$marginBottom = ($moduleParameters['marginBottom'] == "__EMPTY__" || empty($moduleParameters['marginBottom'])) ? 0 : $moduleParameters['marginBottom'];
$marginLeft = ($moduleParameters['marginLeft'] == "__EMPTY__" || empty($moduleParameters['marginLeft'])) ? 0 : $moduleParameters['marginLeft'];
$paddingTop = ($moduleParameters['paddingTop'] == "__EMPTY__" || empty($moduleParameters['paddingTop'])) ? 0 : $moduleParameters['paddingTop'];
$paddingRight = ($moduleParameters['paddingRight'] == "__EMPTY__" || empty($moduleParameters['paddingRight'])) ? 0 : $moduleParameters['paddingRight'];
$paddingBottom = ($moduleParameters['paddingBottom'] == "__EMPTY__" || empty($moduleParameters['paddingBottom'])) ? 0 : $moduleParameters['paddingBottom'];
$paddingLeft = ($moduleParameters['paddingLeft'] == "__EMPTY__" || empty($moduleParameters['paddingLeft'])) ? 0 : $moduleParameters['paddingLeft'];
$useModuleContainer = ($moduleParameters['useModuleContainer'] == "__EMPTY__" || empty($moduleParameters['useModuleContainer'])) ? 0 : (int)$moduleParameters['useModuleContainer'];
$widthInPixels = ($moduleParameters['widthInPixels'] == "__EMPTY__" || empty($moduleParameters['widthInPixels'])) ? null : (int)$moduleParameters['widthInPixels'];

if(empty($marginTop) && empty($marginRight) && empty($marginBottom) && empty($marginLeft)){
	$Mmargin = "0";
}else{
	$Mmargin = $marginTop." ".$marginRight." ".$marginBottom." ".$marginLeft." ";
}
if(empty($paddingTop) && empty($paddingRight) && empty($paddingBottom) && empty($paddingLeft)){
	$Mpadding = "0";
}else{
	$Mpadding = $paddingTop." ".$paddingRight." ".$paddingBottom." ".$paddingLeft." ";
}

$cssContent = $moduleParameters["cssContent"];
$groupOfProducts = (int)$moduleParameters["groupOfProducts"];
$showHeader = ($moduleParameters['showHeader'] == "__EMPTY__" || empty($moduleParameters['showHeader'])) ? false : true;

$q = "select cpg.title from content_product_groups as cpg, product_groups as pg where cpg.langID='1' and cpg.mainID=pg.id and pg.id='$groupOfProducts' and pg.active=1";
$moduleHeader = $db->getRecord($q)->title;
if(!$moduleHeader){
	$messages->addError("Error in «Products Carousel module»:<br>No product group defined");
	$messages->printErrorMessages();
	return;
}
$q="select productID from grouped_products where groupID='$groupOfProducts'";
$pIDs = $db->getRecords($q);
$IDs = array();
foreach($pIDs as $record){
	$hasAccess = $eshop->hasAccess($record->productID);
	if($hasAccess) $IDs[] = $record->productID;
}
if(!count($IDs)){
	// exit module in silent mode
	return;	
}
$IDs = implode(",", $IDs);
$q = "select p.id, cp.title, p.price, p.list_price, p.vat from products as p, content_products as cp where p.id IN (".$IDs.") and cp.mainID=p.id and cp.langID='$langID'";
$products = $db->getRecords($q);
if(!count($products)){
	$messages->addError("Error in «Products Carousel module»:<br>The defined products cannot be found");
	$messages->printErrorMessages();
	return;
}
// sort ids
$IDs = array();
foreach($products as $product) $IDs[] = $product->id;
$IDs = implode(",", $IDs);


if($useModuleContainer ){
?>
<div id="<?php echo $mn.$sufixID;?>" data-editable="editable">
<?php
}
?>

<style  type="text/css">
<?php
if($useModuleContainer ){
	?>
#<?php echo $mn.$sufixID;?>{
	<?php 
	$alignRule = ($moduleParameters['moduleAlign'] == "center") ? "text-align" : "float";
	echo $alignRule.": ".$moduleParameters['moduleAlign'].";".PHP_EOL;
	?>
	margin : <?php echo $Mmargin;?>;
	padding : <?php echo $Mpadding;?>;
<?php
if($widthInPixels){
	?>
	width: <?php echo $widthInPixels;?>px;
	<?php 
}	

if($moduleParameters['moduleAlign'] && $moduleParameters['moduleHR']){ // there are system parameters...

if($moduleParameters['moduleHR'] == "top" || $moduleParameters['moduleHR'] == "bottom"){
?>
	border-<?php echo $moduleParameters['moduleHR'];?> : 1px solid black;
<?php 
}
}
?>
}
<?php
}
if($cssContent){ // include custom css only if cssContent has been found
	echo $variables->restoreModuleValue($cssContent);
}
?>
</style>

<script type="text/javascript">
jQuery(document).ready(function($) {
	$('.hpwrapper').on("mouseover", function(){
		$(this).find(".quick_view").show();
	}).on("mouseout", function(){
		$(this).find(".quick_view").hide();
	});
	
	$('.quick_view').fancybox({
		width : 800,
		height: 700,
		maxHeight : 700,
		type : 'iframe',
		arrows: false,
		modal: true,
		helpers : {
			overlay : {
				css : {
					'background' : 'rgba(0, 0, 0, 0.8)'
				}
			},
			title: null
		}
	});		
});
</script>

<div class="homepage_products">
	<?php
    if($showHeader){
    ?>
    <h2><?php echo t($moduleHeader);?></h2>
    <?php
	}
	?>    
    <div class="group">
    <?php
	$include_vat = (int)$parameters->getParameter("include_vat");
	foreach($products as $product){
		$vat = $content->getValue("fpa_cat", $product->vat, "percent", $langID);
		$title = $product->title;
		$productID = $product->id;
		$defaultImage = $content->getImage("products", $productID, $langID, 'default');
		if($defaultImage != "."){ // if a default image exists for this record
			$imageFile = "mediabank/medium/medium_".$defaultImage;
			$foundThumb = true;			
		}else{
			$imageFile = $p."images/no_image.png";
		}	
		$link = $sef->url("index.php?section=products&view=node&id=".$productID."&set=".$IDs, false);
		$show_price = $product->show_price;
		$price = (float)$product->price;	
		if($include_vat) $price = $eshop->includeVat($price, $vat);
		$list_price = (float)$product->list_price;	
		if($include_vat) $list_price = $eshop->includeVat($list_price, $vat);
		$hasPriceAccess = $eshop->hasAccess($productID, "show_price");
	?>
    
    	<div class="grid-4 hpwrapper">
        	<div class="hpbordered">
            <?php
			if(!empty($list_price) && $hasPriceAccess){
				$save_percent = (int)(100 - (100*($price/$list_price)));
			?>
            <div class="hpsave_price"><?php echo t("Κερδίζετε", $langID, "save_image")." ".$save_percent;?>%</div>
            <?php
			}
			?>
            	<a href="<?php echo $link;?>"><img src="<?php echo $imageFile;?>"></a>
            </div>
            <div class="hpfooter">
                <a class="hptitle" href="<?php echo $link;?>" title="<?php echo htmlspecialchars($title);?>"><?php echo $title;?></a>
                <div class="hpdisplay_rating"><?php $eshop->displayRating($productID); ?></div>
                <a class="quick_view rainbow" href="quick_view.php?id=<?php echo $productID;?>&set=<?php echo $IDs;?>&langID=<?php echo $langID;?>"><?php echo t("ΜΕ ΜΙΑ ΜΑΤΙΑ");?></a>
                <?php
                if($hasPriceAccess){
                ?>
                <div class="hpprices">
                    <span class="hplist_price">
                    <?php
                    if((float)$list_price) echo $eshop->formatPrice($list_price)."<br>";
                    ?>
                    </span>
                    <span class="hpprice">
                    <?php
                    if((float)$price)  echo $eshop->formatPrice($price);
                    ?>            
                    </span>
                </div>
                <?php
                }
                ?>
            </div>
        </div>
    <?php
	}
	?>
	</div>
</div>


<?php
if($useModuleContainer ){
?>
</div> <!-- end module's div -->
<?php 
}
?>
