<?php
/*
Odyssey view file
Filename must be like "view_sectionName.php"
Reference to controller variables must be in form $this->varName

Use $p for template path, for example $p/images/logo.png
*/


// *****************************************************************************

$autoView = false; // Warning! You need to set this to false in order to use your custom view below

// *****************************************************************************

if($autoView){ // you may change this above, setting it as false in order to use your default view starting below
	
	include("view.php");
	
}else{ // you custom layout starts here!!!

	global $langID;
	global $parameters;
	global $catID;
	$section = $this->section;
	$sectionID = $this->sectionID;
	if($catID){
		$title = $categories->getCategoryName($catID, "content_".$section."_categories", $langID); 
	}else{
		$sectionName = t($system->getTableSectionTitle($sectionID));
		$title = (is_numeric($catID) && $catID==0) ? $sectionName.  " - ". t("ΚΑΤΗΓΟΡΙΕΣ") : $sectionName;
	}
	
		
	
	
?>
<div class="inner_content">
<div id="breadcrumb"><?php $eshop->displayBreadcrumb(); ?></div>
<h2><?php echo $title;?></h2>
<?php

	
	$messages->printSystemMessages();
	if($this->numOfAllItems || $this->hasSubcategories){
		if(!$this->hasSubcategories){ // no pagination for categories listing
			$vars = 'catID,presults';
			$pagination = new pagination($this->maxrows, true, $vars, $presults);
			$pagination->printPages(); 
			echo "<div style='height:20px'></div>";
		}
		$items = $this->items;
		foreach($items as $item){
			$id= $item->id;
			$title = $item->title;
			$mt = $item->minitext;
			$max_chars = $parameters->getParameter('max_chars');
			$limit = $max_chars - mb_strlen($title, 'utf-8');
			$limit = ($limit > 0 ) ? $limit : 0;
			$minitext = (mb_strlen($mt, 'utf-8') > $limit) ? $variables->unicode_substr($mt, 0 , $limit)."..." : $mt;
			$minitext = ($minitext == "...") ? null : $minitext;
			$catName = $categories->getCategoryName($item->catID, "content_".$section."_categories", $langID);	
			$defaultImage = ($this->hasSubcategories) ? $categories->getCategoryImage($id, $sectionID) : $content->getImage($section, $id, $langID, 'default');
			$imgDescription = ($this->hasSubcategories) ? NULL : $content->getImageDescription($defaultImage, $id, $sectionID, $langID);
			$foundThumb = false;
			if($defaultImage != "." || $this->hasSubcategories){ // if a default image exists for this record
				$imageFile = ($this->hasSubcategories) ? "mediabank/".$defaultImage : "mediabank/medium/medium_".$defaultImage;
				$foundThumb = true;			
			}else{
				$imageFile = "images/no_image.png";
			}
			$link = ($this->hasSubcategories) 
						? 
						$sef->url("index.php?section=".$section."&view=list&catID=".$id, false) 
						: 
						$sef->url("index.php?section=".$section."&view=node&id=".$id, false);	
			?>
        <div class="listing">
        <?php 
		$content->displayThumbnail($imageFile, 240, $thumbViewportHeight=150, $link, true); 
		?>
            <div class="article_listing_container">
            <h3><a href="<?php echo $link;?>"><?php echo $title;?></a></h3>
            <div class="minitext"><?php echo $minitext; ?></div>
            <div class="more"><a href="<?php echo $link;?>"><?php echo t('περισσότερα');?></a></div>
            <?php  ?>
            </div>
		</div>
        <div class="clearfix"></div>
	<?php
		}
		?>
		<div style='height:40px'></div>
		<?php
		$pagination = new pagination($this->maxrows, false, $vars, $presults);
		$pagination->printPages();															
	}
}
?>
</div>
