<?php
/*
Odyssey auto view file
Reference to controller variables must be in form $this->varName because it will be included in the template folder
*/

global $langID;
$section = $this->section;
$view = $this->view;
$sectionID = $system->getTableSectionID($section);
global $protocol;


// -------------------------------------------------------------------------------------- start list, search
if($view == "list" || $view == "search"){
	if($view == "list"){
		if($catID){
			$title = $categories->getCategoryName($catID, "content_".$section."_categories", $langID); 
		}else{
			$sectionName = t($system->getTableSectionTitle($sectionID));
			$title = (is_numeric($catID) && $catID==0) ? $sectionName.  " - ". t("ΚΑΤΗΓΟΡΙΕΣ") : $sectionName;
		}
	}else{
		$isDataSubmited = false;
		global $safeRequest;
		foreach($safeRequest as $key=>$value){ // check if there are specific variables that must pass to the view
			if(preg_match('/submit/i', $key)) {
				$isDataSubmited = true;
				break;
			}
		}
		if($this->countyID) $isDataSubmited = true;	
		$title = (empty($isDataSubmited) || !$this->numOfAllItems) ? t("ΑΝΑΖΗΤΗΣΗ") : t("ΑΠΟΤΕΛΕΣΜΑΤΑ ΑΝΑΖΗΤΗΣΗΣ") ;		
	}
	?>

	<h1 class="autoView"><?php echo $title;?></h1>
	<?php
	$messages->printSystemMessages();

	if($this->numOfAllItems || $this->hasSubcategories){
		
		//$vars = implode(",", $this->controllerVars);
		
		//$presults=1; // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		
		//$pagination = new pagination($this->maxrows, true, $this->presults);
		//$pagination->printPages(); 
		echo view("utilities/getPagination", true);
		?>
		<ul id="autoView">
		<?php
		$items = $this->items;
		$counter = 0;
		foreach($items as $item){
			$id= $item->id;
			$title = $item->title;
			$mt = $item->minitext;
			$max_chars = $parameters->getParameter('max_chars');
			$limit = $max_chars - mb_strlen($title, 'utf-8');
			$limit = ($limit > 0 ) ? $limit : 0;
			$minitext = (mb_strlen($mt, 'utf-8') > $limit) ? $variables->unicode_substr($mt, 0 , $limit)."..." : $mt;
			$minitext = ($minitext == "...") ? null : $minitext;
			$catName = $categories->getCategoryName($item->catID, "content_".$section."_categories", $langID);	
			$defaultImage = ($this->hasSubcategories) ? $categories->getCategoryImage($id, $sectionID) : $content->getImage($section, $id, $langID, 'default');
			$imgDescription = ($this->hasSubcategories) ? NULL : $content->getImageDescription($defaultImage, $id, $sectionID, $langID);
			$foundThumb = false;
			if($defaultImage != "." || $this->hasSubcategories){ // if a default image exists for this record
				$imageFile = ($this->hasSubcategories) ? "mediabank/".$defaultImage : "mediabank/medium/medium_".$defaultImage;
				$foundThumb = true;			
			}else{
				$imageFile = "images/no_image.png";
			}
			$imgDim = GetImageSize($imageFile);
			$w = $imgDim[0];
			$h = $imgDim[1];
			$link = ($this->hasSubcategories) 
						? 
						$sef->url("index.php?section=".$section."&view=list&catID=".$id, false) 
						: 
						$sef->url("index.php?section=".$section."&view=node&id=".$id, false);	
			?>
        <div class="autoViewArticleWrapper">
        <?php 
		$content->displayThumbnail($imageFile, 150, 150, $link); 
		?>
            <div class="autoViewArticleTextWrapper">
            <a href="<?php echo $link;?>"><?php echo $title;?></a>
            <br>
            <?php echo $minitext; ?>
            <br>
            <a href="<?php echo $link;?>"><?php echo t('περισσότερα');?></a>
            </div>
		</div>
	<?php
			$counter++;
			if(!($counter % 2)) echo "<div class='clear'></div>";
		}		
		?>
		</ul>
		<div style="clear:left"></div>
		<?php
		echo view("utilities/getPagination", false);
		//$pagination = new pagination($this->maxrows, false, $presults);
		//$pagination->printPages();															
	}
	
		
}
// -------------------------------------------------------------------------------------- end list, search



// -------------------------------------------------------------------------------------- start search form
if($view == "search"){
?>
<form action="" method="get">
<input name="section" type="hidden" value="<?php echo $section;?>">
<input name="view" type="hidden" value="<?php echo $view;?>">
<input name="langID" type="hidden" value="<?php echo $langID;?>">
<div id="autoViewSearchForm" class="formTable" <?php if($this->doNotPassData) echo 'style="margin-bottom:100px"';?>>

    <div style="margin: 0 auto;" class="form_container">
        <div class="formLabel left"><?php echo t("Αναζήτηση για");?>:</div>
        <div><input class="autoViewTextbox" name="keyword" type="text" value="<?php echo $this->keyword;?>"></div>
    </div>

	<?php
	if(count($this->searchForCategories)){
	?>
    <div style="margin: 0 auto;" class="form_container">
        <div class="formLabel left"><?php echo t("Στην κατηγορία");?>:</div>
        <div>
		<select name="catID" class="autoViewListbox">
		<option value=""><?php echo t("Όλες οι κατηγορίες");?></option>
		<?php echo $categories->getCategoriesForSelect(0, 0, false, $section."_categories", $catID);?>
		</select>        
        </div>
    </div>    
	<?php
	}
	
	if(count($this->searchForSections)){
		foreach($this->searchForSections as $field){
			
			$fpq = "select `selectTableSectionName` from `fields` where `fieldVarName`='$field'";
			$dataSection = $db->getRecord($fpq)->selectTableSectionName;
			$dsq = "select $dataSection.id, content_$dataSection.title 
			from $dataSection, content_$dataSection 
			where $dataSection.active=1 
			and content_$dataSection.mainID=$dataSection.id and
			content_$dataSection.langID='$langID' 
			order by content_$dataSection.title LIMIT 0, 5000"; // maximum 5000 records in case a big section has been selected!!!
			$sectionRecords = $db->getRecords($dsq);
			$fieldDescription = $system->getFieldDescription($field, $sectionID);
			if($fieldDescription){
	?>
    <div style="margin: 0 auto;" class="form_container">
        <div class="formLabel left"><?php echo $fieldDescription;?>:</div>
        <div>
		<select name="<?php echo $field;?>" class="autoViewListbox">
		<option value="">--- <?php echo t("Επιλέξτε");?> ---</option>
		<?php
		foreach($sectionRecords as $sectionRecord){
		?>
		<option value="<?php echo $sectionRecord->id;?>" <?php if($sectionRecord->id == $this->$field) echo " selected";?>><?php echo $sectionRecord->title;?></option>	
		<?php
		}
		?>
		</select>
        
        </div>
    </div>
        	
	<?php
			}
		}
	}	
	
		
	if(count($this->searchForDates)){
		foreach($this->searchForDates as $field){
			$fieldDescription = $system->getFieldDescription($field, $sectionID);
			if($fieldDescription && $field != "eventDate"){
				if($this->{$field."_from"}) $this->{$field."_from"} = $dates->makeTimestamp($this->{$field."_from"});
				if ($this->{$field."_to"}) $this->{$field."_to"} = $dates->makeTimestamp($this->{$field."_to"});
	?>
    <div style="margin: 0 auto;" class="form_container">
        <div class="formLabel left">[<?php echo t($fieldDescription);?>]<br>
<?php echo t("από");?>:</div>
        <div><input class="autoViewTextbox date_picker" style="width:100px" name="<?php echo $field;?>_from" id="<?php echo $field;?>_from" type="text" value="<?php if($this->{$field."_from"}) echo $dates->makeDatefromTimestamp($this->{$field."_from"});?>"></div>
    </div>
    
    <div style="margin: 0 auto;" class="form_container">
        <div class="formLabel left">[<?php echo t($fieldDescription);?>]<br>
<?php echo t("έως");?>:</div>
        <div><input class="autoViewTextbox date_picker" style="width:100px" name="<?php echo $field;?>_to" id="<?php echo $field;?>_to" type="text" value="<?php if($this->{$field."_to"}) echo $dates->makeDatefromTimestamp($this->{$field."_to"});?>"></div>
    </div>    
	<?php
			}
		}
	}
	
	if(count($this->searchForNumbers)){
		foreach($this->searchForNumbers as $field){
			$fieldDescription = $system->getFieldDescription($field, $sectionID);
			if($fieldDescription){
	?>
    <div style="margin: 0 auto;" class="form_container">
        <div class="formLabel left">[<?php echo t($fieldDescription);?>] <?php echo t("από");?>:</div>
        <div><input class="autoViewTextbox" style="width:100px" name="<?php echo $field;?>_from" id="<?php echo $field;?>_from" type="text" value="<?php echo $this->{$field."_from"};?>"></div>
    </div>
    
    <div style="margin: 0 auto;" class="form_container">
        <div class="formLabel left">[<?php echo t($fieldDescription);?>] <?php echo t("έως");?>:</div>
        <div><input class="autoViewTextbox" style="width:100px" name="<?php echo $field;?>_to" id="<?php echo $field;?>_to" type="text" value="<?php echo $this->{$field."_to"};?>"></div>
    </div>    
	<?php
			}
		}
	}	

	
	if(count($this->searchForFlags)){
		foreach($this->searchForFlags as $field){
			$fieldDescription = $system->getFieldDescription($field, $sectionID);
			if($fieldDescription){
	?>
    <div style="margin: 0 auto;" class="form_container">
    <div style="float:left; margin: 4px 5px 0 0">
    <input name="<?php echo $field;?>" type="checkbox" value="1" <?php if(!empty($this->$field)) echo " checked";?>>
    </div>
    <div class="formLabel left">
    <?php echo $fieldDescription;?>
    </div>
    </div>    	
	<?php
			}
		}
	}	
	?>
    <div style="margin: 20px auto; display:table">
        <input name="submitSearch" type="submit" class="autoViewFormButton" value="<?php echo t("Αναζήτηση");?>">
    </div>    		
</div>
</form>
<?php		
}
// -------------------------------------------------------------------------------------- end search form



// -------------------------------------------------------------------------------------- start node
if($view == "node"){
	
$item = $this->item;


if($id){ 
	if($item->catID) $catName = $categories->getCategoryName($item->catID, "content_".$section."_categories", $langID);	
	$title = $item->title;
}else{
	$messages->addError(t("Δεν βρέθηκε το id της εγγραφής"));
	$title = t("ΣΦΑΛΜΑ");
}
$auth = new authentication(false);
$login = $auth->getLoginStatus() != 2;
if((!$login ||$login==1) && !$item->private) {
	if(!$messages->hasErrors) $messages->addError(t("Τα δικαιώματα που έχετε ως απλό μέλος δεν σας επιτρέπουν να έχετε πρόσβαση σε αυτό το άρθρο..."));
	$title = t("ΣΦΑΛΜΑ");
}
?>
<div class="group" style="margin: 0 5px;">
    <div class="grid-12">
		<h2><?php echo $title;?></h2>
<?php 
$messages->printSystemMessages();

if(!$messages->hasErrors){
	$defaultImage = $content->getImage($section, $id, $langID, 'default');
	$imgDescription = $content->getImageDescription($defaultImage, $id, $sectionID, $langID);
	$images = $content->getImages($section, $id, $langID, array('default', 'logo', 'slider'));	
	$hasImages = $images !== false;
	$logoImage = $content->getImage($section, $id, $langID, 'logo');	
	$hasFiles = $content->getNumOfFiles($sectionID, $id, $langID);
	$hasVideos = $content->getNumOfVideos($sectionID, $id, $langID);
	$lat = (!$lat) ? $item->lat : $lat;
	$lng = (!$lng) ? $item->lng : $lng;
	$zoom = ($item->zoom) ? $item->zoom : 6;
	$hasMap = ($lat && $lng);	
	if($lat == "37.98413" && $lng == "23.72808" && $zoom == 6) $hasMap = false;	
	if($logoImage != "."){ // if a logo image exists for this record
	?>
	<div style="text-align:center; margin: 20px 0">
	<img src="mediabank/medium/medium_<?php echo $logoImage;?>" alt="logo">
	</div>
	<?php 
	}	
	if($defaultImage != "."){ // if a default image exists for this record
	?>
	<div style="text-align:center; margin: 20px 0">
	<a href="mediabank/images/<?php echo $defaultImage;?>" data-rel="fb" title="<?php echo $imgDescription;?>" rel="fb-<?php echo $id;?>"><img class="zoomable" src="mediabank/medium/medium_<?php echo $defaultImage;?>" alt="image"></a>
	</div>
	<?php 
	}
	
	$frecords = $db->getRecords("select fieldVarName, fieldDescription, fieldType, selectType, selectTableSectionName, isMainTitle
												from `fields` 
												where tableSectionID='$sectionID' 
												and access='0' 
												and autoView='1' 
												order by sort");		
	foreach($frecords as $field){

		$fieldVarName = $field->fieldVarName;
		if($field->fieldType == "richTextarea"){
			if(!empty($item->$fieldVarName)){
				$bodyText = strip_tags($item->$fieldVarName);
				$bodyText = trim($bodyText);
				if(!empty($bodyText)) $content->displayFontAdjustments("right");				
				?>
				<div class="autoViewContent" id="article"><?php echo $content->richText($item->$fieldVarName);?></div>
				<?php
			}
			$displayedVideos = false;
			$videoGallery = $this->getModules("video_gallery");
			if(count($videoGallery)){
				$this->includeModules("video_gallery");
			}else{
				if($hasVideos && !$displayedVideos){
					$videos = $content->getVideos($sectionID, $id);
					foreach($videos as $video){
						$videoTitle = $video->title;
						$videoCode = $video->videoCode;
						$videoProvider = $video->provider;
						$videoURL = $content->getVideoURL($videoProvider, $videoCode);
						?>
				<div style="margin-top:20px;">
					<iframe width="400" height="260" src="<?php echo $videoURL;?>" style="border:none"></iframe>
				</div>
				<div style="color: grey; margin:6px auto 30px"><?php echo $videoTitle;?></div>
				<?php
					}
					$displayedVideos = true;
				}
			}
		}
		if($field->fieldType == "textarea"){
			if(!empty($item->$fieldVarName)){
				if($fieldVarName != "minitext"){	
				$fieldDescription = $system->getFieldDescription($fieldVarName, $sectionID);		
				?>
				<div class="autoViewContent autoViewPlainText">
				<div class="autoViewPlainTextLabel"><?php echo $fieldDescription;?></div>
				<?php echo stripslashes($item->$fieldVarName);?>
				</div>
				<?php
				}
			}
		}	
		if($field->fieldType == "textfield" || $field->fieldType == "int" || $field->fieldType == "decimal"){
			if(!empty($item->$fieldVarName) && $fieldVarName != "title"){
				$fieldDescription = $system->getFieldDescription($fieldVarName, $sectionID);
				?>
<div style="padding:10px 10px 4px 10px">
				<?php
				if($fieldVarName != "subtitle"){
				?>
				<b><?php echo t($fieldDescription); ?> : </b>
				<?php
				}
				if($fieldVarName == "price"){
					echo $eshop->formatPrice($item->$fieldVarName)."&nbsp;";
				}else{
					if($fieldVarName == "subtitle") echo "<div style='font-weight:bold; text-align:center'>";
					echo $item->$fieldVarName;
					if($fieldVarName == "subtitle") echo "</div>";
				}
				?>
</div>
				<?php
			}
		}	
		
		if(($field->fieldType == "date") && ($fieldVarName != "eventDate")){
			if(!empty($item->$fieldVarName)){
				$fieldDescription = $system->getFieldDescription($fieldVarName, $sectionID);		
				?>
				<div style="padding:10px 10px 4px 10px">
				<b><?php echo t($fieldDescription); ?> : </b>
				<?php
				echo $dates->makeDateFromTimestamp($item->$fieldVarName);
				?>
				</div>
				<?php
			}
		}
		
		if($field->fieldType == "colorpicker"){
			if(!empty($item->$fieldVarName)){
				$fieldDescription = $system->getFieldDescription($fieldVarName, $sectionID);		
				?>
				<div style="padding:10px 10px 4px 10px">
				<b><?php echo t($fieldDescription); ?> : </b>
				<div style="display:inline-block; width:40px; border: 1px solid grey; background-color:#<?php echo $item->$fieldVarName;?>">&nbsp;</div>
				</div>
				<?php
			}
		}	
		
		if($field->fieldType == "selectMenu"){
			if($field->selectType == "category"){
				if(!empty($item->$fieldVarName)){
					$fieldDescription = $system->getFieldDescription($fieldVarName, $sectionID);		
					?>
					<div style="padding:10px 10px 4px 10px">
					<b><?php echo t($fieldDescription); ?> : </b>
					<?php
					echo $categories->getCategoryName($item->$fieldVarName, "content_".$section."_categories", $langID);	
					?>
					</div>
					<?php
				}
			}
			if($field->selectType == "flat"){
				if(!empty($item->$fieldVarName)){
					$fieldDescription = $system->getFieldDescription($fieldVarName, $sectionID);
					$dataSource = $field->selectTableSectionName;
					?>
					<div style="padding:10px 10px 4px 10px">
					<b><?php echo t($fieldDescription); ?> : </b>
					<?php
					echo $content->getValue($dataSource, $item->$fieldVarName, 'title', $langID);
					?>
					</div>
					<?php
				}
			}			
		}	
		
		if($field->fieldType == "selectList"){
			if($field->selectType == "category"){
					$fieldDescription = $system->getFieldDescription($fieldVarName, $sectionID);	
					$catIDs = $categories->getMultiCategories($sectionID, $id);	
					?>
					<div style="padding:10px 10px 4px 10px;">
					<div class="autoViewMultiCategories"><?php echo t($fieldDescription); ?></div>
					<?php
					$cat_section=$section."_categories";
					$counter=0;
					foreach($catIDs as $cat){
						$counter++;
						$cat_path = $categories->getPath($cat, $cat_section);
					?>
					<div class="branch<?php if($counter < count($catIDs)){echo "_multiple";}?>">
					<span class="cat_path_line">
					<?php
						foreach($cat_path as $node) echo $categories->getCategoryName($node, "content_".$cat_section, $langID)." > ";
						echo $categories->getCategoryName($cat, "content_".$cat_section, $langID);
						?>
					</span>
					</div>
					<?php
					}
					?>
					</div>
					<?php
			}
			if($field->selectType == "flat"){
					$fieldDescription = $system->getFieldDescription($fieldVarName, $sectionID);	
					$IDs = $categories->getMultiCategories($sectionID, $id);	
					?>
					<div style="padding:10px 10px 4px 10px">
					<div class="autoViewMultiCategories"><?php echo t($fieldDescription); ?></div>
					<?php
					$dataSource=$field->selectTableSectionName;
					foreach($IDs as $thisID){
					?>
					<div class="branch">
					<span class="cat_path_line">
					<?php
					echo $content->getValue($dataSource, $thisID, 'title', $langID);
					?>
					</span>
					</div>
					<?php
					}
					?>
					</div>
					<?php
			}			
		}	
		
		if($field->fieldType == "checkbox"){
			if(!empty($item->$fieldVarName)){
				$fieldDescription = $system->getFieldDescription($fieldVarName, $sectionID);		
				?>
				<div style="padding:10px 10px 4px 10px">
				<b><?php echo t($fieldDescription); ?> : </b>
				<?php echo t("ναι");?>
				</div>
				<?php
			}
		}	
		
	} // end fields loop
	
	// ------------------------------------------- custom code -------------------------------------------
  
	$customfile = $this->getTemplatePath()."/autoview.php";
	if(is_file($customfile))	include($customfile);

	// ------------------------------------------end custom code ----------------------------------------	
	
	$this->includeModules("related_images");
	$this->includeModules("related_files");
	




if($item->lat != "37.98413" && $item->lat != "23.72808" && $item->zoom != "6" && !empty($item->lat) && !empty($item->lng) && !empty($item->zoom)){ //
?>
<div style="clear:left; margin-top:20px">
<?php
$this->includeModules("auto_view_google_map");
?>
</div>
<?php
}

$relatedContent = $content->getRelatedContent($sectionID, $id, $langID);
if(is_array($relatedContent)){
	?>
	<h3 style="background-color: grey; color:white; padding: 5px 20px; margin-bottom:20px"><?php echo t("Σχετικές δημοσιεύσεις");?></h3>	
	<ul class="autoViewRelatedContent" style="clear:left">
	<?php
	foreach($relatedContent as $thisItem){
		?>
		<li><a href="<?php $sef->url("index.php?section=".$section."&view=node&id=".$thisItem->id."");?>"><?php echo $thisItem->title;?></a></li>
		<?php
	}
	?>
	</ul>
	<?php
}
?>
<div style="margin:30px 0 20px">&nbsp;</div>
<?php
$messages->importSessionMessages();
$messages->printSystemMessages();
if($item->title){
	$this->includeModules("fb_comments");
	$this->includeModules("comments");
}	
?>
	<div style="text-align:right; margin-top:15px"><a class="autoViewLinkButton" href="javascript:void(0)" onclick="window.history.back();"><?php echo t('επιστροφή'); ?></a></div>    
	<?php
}
?>
</div>
</div>
<?php
echo("&nbsp;"); // do not remove	
}
// -------------------------------------------------------------------------------------- end node



?>
